
(* CMSCAN.PAS: created 4-5-1993 at  8:25 pm
   by Lex Version 2.0, Copyright (c) 1989 Albert Graef, all rights reserved *)

{$I SWITCHES.INC}
{ $Id: cmscan.l 1.3 1993/03/19 17:47:00 Ricki Exp $ }
unit cmscan;
{ command line handling }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@rwthi3.informatik.rwth-aachen.de
}

{
        $Log: cmscan.l $
        Revision 1.3  1993/03/19  17:47:00  Ricki
        fixed a little syntax error

        Revision 1.2  1993/03/19  17:44:51  Ricki
        *** empty log message ***

        Revision 1.1  1993/01/21  18:52:16  Ricki
        Initial revision
}

interface

  uses
    strings,
    lexlib,
    dos;

  const
    version = '$Id: cmscan.l 1.3 1993/03/19 17:47:00 Ricki Exp $';
    maxcmcount = 64;

  type
    cmdstring = string[127]; { = comstr }

  function cmcount: byte;
  function cmstr(i: byte): cmdstring;
  function cmline: cmdstring;
    {
      cmcount   = paramcount
      cmstr     = paramstr
      cmline    returns the whole command line; note: leading and trailing
                whitespaces are trimmed
    }

implementation

  procedure addchar(c: char); forward;
  procedure endparam; forward;
  procedure addnum(n: string); forward;

  function input: char; forward;
  procedure unput(c: char); forward;

  var
    n: byte; { =cmcount+1 }
    start,len: array [1..maxcmcount] of byte;

    cmdptr: ^cmdstring;
    cmdstr,unquoted: cmdstring;
    p,l: byte;

const	dflt	= 2;

const	str1	= 4;

const	str2	= 6;


const yylnl=#10;
const yylbufsize = 255;
const yylsstate0 : System.integer = 0;
var yylsstate : System.integer absolute yylsstate0;
const yylastate0 : System.integer = 0;
var yylastate : System.integer absolute yylastate0;
var yylreturn : System.boolean; yyltok : System.integer;
var yytext : string[yylbufsize];
var yyleng : Byte absolute yytext;
var yyleng0 : Byte;
procedure begin_(s : System.integer);
  begin yylsstate := s end;
procedure return(tok : System.integer);
  begin yylreturn := true; yyltok := tok end;
procedure yymore;
  begin yyleng0 := yyleng end;
procedure yyless(n : System.integer);
  begin
    while yyleng>n do begin unput(yytext[yyleng]); dec(yyleng) end
  end;
procedure echo;
  var i : System.integer;
  begin
    for i := 1 to yyleng do output(yytext[i])
  end;
procedure reject; forward;
procedure yylaction(yylrule : System.integer);

begin case yylrule of
0: ;
1:addnum(yytext);
2:addchar('''');
3:addchar('"');
4:addchar('!');
5:endparam;
6:begin_(str1);
7:begin_(str2);
8:begin_(dflt);
9:addchar('''');
10:begin_(dflt);
11:addchar('"');
12:addchar(yytext[1]);
13:addchar(yytext[1]);
14:addchar(yytext[1]);
end(*case*);
end(*yylaction*);

const yylrules = 14;
const yylstates = 26;
const yyltrans = 163;
const yylmatch_base : array [-1..yylstates] of System.integer = (
  1,
  1,1,1,1,1,1,1,1,1,2,
  4,5,6,8,10,11,12,14,15,16,
  18,19,20,21,22,23,24);
const yylmatch_entries = 23;
const yylmatch : array [0..yylmatch_entries] of System.integer = (0,
  12,5,12,5,12,7,12,6,12,13,
  13,8,13,14,14,10,14,4,3,2,
  1,9,11);
const yylendpos_base : array [-1..yylstates] of System.integer = (
  1,
  1,1,1,1,1,1,1,1,1,2,
  4,5,6,8,10,11,12,14,15,16,
  18,19,20,21,22,23,24);
const yylendpos_entries = 23;
const yylendpos : array [0..yylendpos_entries] of System.integer = (0,
  12,5,12,5,12,7,12,6,12,13,
  13,8,13,14,14,10,14,4,3,2,
  1,9,11);
const yylstop : array [0..yylstates] of System.boolean = (
  FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,TRUE,
  FALSE,FALSE,FALSE,TRUE,TRUE,TRUE,FALSE,FALSE,TRUE,FALSE,
  FALSE,TRUE,TRUE,TRUE,FALSE,TRUE,TRUE);
const yylbase : array [0..yylstates] of System.integer = (
  -32,-31,3,6,8,10,17,19,21,-255,
  12,14,46,-255,-255,-255,71,-35,-255,96,
  -29,-255,-255,-255,106,-255,-255);
const yyldefault : array [0..yylstates] of System.integer = (
  -1,-1,9,9,15,15,18,18,-1,-1,
  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
  -1,-1,-1,-1,-1,-1,-1);
{$define yyltrans}
const yylnext : array [1..yyltrans] of System.integer = (
  8,8,-1,25,26,-1,-1,-1,-1,-1,
  -1,10,11,-1,10,11,-1,-1,-1,-1,
  11,11,11,11,-1,-1,-1,-1,-1,-1,
  -1,-1,-1,-1,10,12,13,10,12,13,
  16,14,16,11,14,11,17,-1,17,19,
  20,19,20,21,22,-1,-1,-1,-1,23,
  -1,-1,-1,-1,-1,-1,-1,-1,24,24,
  24,24,24,24,24,24,24,24,21,22,
  -1,-1,-1,-1,23,-1,-1,-1,-1,-1,
  -1,-1,-1,24,24,24,24,24,24,24,
  24,24,24,21,22,-1,-1,-1,-1,23,
  -1,-1,-1,-1,-1,-1,-1,-1,24,24,
  24,24,24,24,24,24,24,24,21,22,
  -1,-1,-1,-1,23,-1,-1,-1,-1,-1,
  -1,-1,-1,24,24,24,24,24,24,24,
  24,24,24,24,24,24,24,24,24,24,
  24,24,24);
const yylcheck : array [1..yyltrans] of System.integer = (
  0,1,2,17,20,3,-1,4,-1,5,
  -1,2,2,-1,3,3,6,4,7,5,
  10,10,11,11,-1,-1,6,-1,7,-1,
  -1,-1,-1,-1,2,2,2,3,3,3,
  4,2,5,10,3,11,4,-1,5,6,
  6,7,7,8,8,-1,-1,-1,-1,8,
  -1,-1,-1,-1,-1,-1,-1,-1,8,8,
  8,8,8,8,8,8,8,8,12,12,
  -1,-1,-1,-1,12,-1,-1,-1,-1,-1,
  -1,-1,-1,12,12,12,12,12,12,12,
  12,12,12,16,16,-1,-1,-1,-1,16,
  -1,-1,-1,-1,-1,-1,-1,-1,16,16,
  16,16,16,16,16,16,16,16,19,19,
  -1,-1,-1,-1,19,-1,-1,-1,-1,-1,
  -1,-1,-1,19,19,19,19,19,19,19,
  19,19,19,24,24,24,24,24,24,24,
  24,24,24);


var yylstate, yylrule, yylrule0, yylpos, yylpos0 : System.integer;
var yylends, yylmatches : array [0..yylrules] of System.integer;
procedure reject;
  var r : System.integer;
  begin
    yylrule0 := 0; yylpos0 := yylpos; yyleng0 := yyleng;
    for r := 1 to yylrules do
      if ((yylmatches[r]=yylmatches[yylrule]) and (r>yylrule) or
          (yylmatches[r]<yylmatches[yylrule])) and
         (yylmatches[r]>yylmatches[yylrule0]) then
        yylrule0 := r;
    if yylpos0<yylmatches[yylrule0] then
      while yylpos0<yylmatches[yylrule0] do
        begin
          inc(yyleng0); yytext[yyleng0] := input; inc(yylpos0)
        end
    else
      while yylpos0>yylmatches[yylrule0] do
        begin
          unput(yytext[yyleng0]); dec(yyleng0); dec(yylpos0)
        end
  end(*reject*);
function yylterm : System.boolean;
  var i, s1, isc : System.integer; c : System.char;
  begin
    inc(yylpos);
    if succ(yyleng)=yylbufsize then if yyloverflow then halt(1);
    if yylmatch_base[pred(yylstate)]<yylmatch_base[yylstate] then
      begin
        yylrule := yylmatch[yylmatch_base[pred(yylstate)]];
        for i := yylmatch_base[pred(yylstate)] to pred(yylmatch_base[yylstate]) do
          yylmatches[yylmatch[i]] := yylpos
      end;
    if yylendpos_base[pred(yylstate)]<yylendpos_base[yylstate] then
      begin
        for i := yylendpos_base[pred(yylstate)] to pred(yylendpos_base[yylstate]) do
          yylends[yylendpos[i]] := yylpos
      end;
    if (yyleng=yylbufsize) or yylstop[yylstate] then begin yylterm := System.true; exit end;
    c := input;
    {$ifdef yyltrans}
    isc := yylbase[yylstate]+System.ord(c);
    if (isc<1) or (isc>yyltrans) or (yylcheck[isc]<>yylstate) then
      s1 := yyldefault[yylstate]
    else
      s1 := yylnext[isc];
    {$else}
      s1 := yyldefault[yylstate]
    {$endif}
    if s1=-1 then
      begin
        yylterm := System.true;
        unput(c)
      end
    else
      begin
        yylterm := System.false;
        inc(yyleng); yytext[yyleng] := c;
        yylstate := s1
      end
  end(*yylterm*);
procedure yylback;
  var c : System.char;
  begin
    while yylpos>yylends[yylrule] do
      begin dec(yylpos); unput(yytext[yyleng]); dec(yyleng) end;
    if yylpos=1 then
      begin
        (* take default action *)
        yylpos0 := 0; yylrule0 := 0; c := input;
        if (c=#0) or (c=yylnl) then yylastate := 0 else yylastate := 1;
        if c<>#0 then output(c)
        else if yywrap then begin yylsstate := 0; return(0) end
      end
    else
      begin
        c := yytext[yyleng];
        yyleng0 := 0; yylpos0 := 0; yylrule0 := 0;
        yylaction(yylrule);
        if (c=#0) or (c=yylnl) then yylastate := 0 else yylastate := 1
      end
  end(*yylback*);
function yylex : System.integer;
  begin
    yylmatches[0] := 1; yylends[0] := 1;
    yylreturn := System.false;
    yyleng0 := 0; yylpos0 := 0; yylrule0 := 0;
    repeat
      yyleng := yyleng0; yylpos := yylpos0; yylrule := yylrule0;
      if yylpos=0 then
        begin
          (* initialize match table, end position table, and DFA state: *)
          fillChar(yylmatches[1],28,#0);
          fillChar(yylends[1],28,#0);
          yylstate := yylsstate+yylastate;
          while not yylterm do ;
        end;
      yylback;
    until yylreturn;
    yylex := yyltok
  end(*yylex*);



  {local} procedure addchar(c: char);
  { appends c to unquoted and increments the current length }
  begin
    unquoted := unquoted+c;
    inc(l)
  end;

  {local} procedure endparam;
  { ends construction of the current string }
  begin
    if (n>0) then begin
      start[n] := length(unquoted)-l+1;
      len[n] := l
    end;
    inc(n); l := 0
  end;

  {local} procedure addnum(n: string);
  { adds the character whose code is in n to unquoted }
  var
    z: longint;
    b: array [0..3] of char absolute z;
    code: integer;
  begin
    val(copy(n,2,255),z,code);
    if (code<>0) then z := 0;
    { add from the most significant non-null byte }
    if (b[3]=#0) then begin
      if (b[2]=#0) then begin
        if (b[1]=#0) then addchar(b[0])
        else begin
          addchar(b[1]); addchar(b[0])
        end
      end else begin
        addchar(b[2]); addchar(b[1]); addchar(b[0])
      end
    end else begin
      addchar(b[3]); addchar(b[2]); addchar(b[1]); addchar(b[0])
    end
  end;

  {local} function input: char;
  { redefinition for lex: read from cmdstr, not stdin }
  begin
    inc(p);
    if (p>length(cmdstr)) then input := #0
                          else input := cmdstr[p]
  end;

  {local} procedure unput(c: char);
  { redefinition for lex: go back one character in cmdstr }
  begin if (p>0) then dec(p) end;

  function cmcount: byte;
  begin cmcount := n-1 end;

  function cmstr(i: byte): cmdstring;
  begin
    if (i=0) then
      cmstr := paramstr(0)
    else if (i>0) and (i<=n) then
      cmstr := copy(unquoted,start[i],len[i])
    else
      cmstr := ''
  end;

  function cmline;
  begin cmline := cmdstr end;

begin
  { get the whole command line and remove leading and trailing whitespace }
  cmdptr := ptr(prefixseg,$80); cmdstr := cmdptr^;
  cmdstr := headtrim(cmdstr,whitespace);
  cmdstr := tailtrim(cmdstr,whitespace);

  { initialization }
  unquoted := '';
  n := 1;
  l := 0;
  p := 0;
  begin_(dflt);

  if (cmdstr<>'') then begin
    { parse the command line }
    if (yylex=0) then {};

    { terminate the last parameter }
    endparam
  end
end.
