{$I SWITCHES.INC}
{ $Id: lt.pas 1.3 1993/04/05 20:00:03 Ricki Exp $ }
Unit LT;
{ linear transformations }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@pool.informatik.rwth-aachen.de
}

{
        $Log: lt.pas $
        Revision 1.3  1993/04/05  20:00:03  Ricki
        address change

        Revision 1.2  1993/03/19  17:39:58  Ricki
        *** empty log message ***

        Revision 1.1  1993/01/22  00:55:30  Ricki
        Initial revision
}

Interface

  const
    pversion = '$Id: lt.pas 1.3 1993/04/05 20:00:03 Ricki Exp $';

  Procedure LTTransformationRR(X,Y,I,J: Real; Var A,B: Real);
  Procedure LTTransformationRI(X,Y: Real; I,J: longint; Var A,B: Real);
  Procedure LTTransformationIR(X,Y: longint; I,J: Real; Var A,B: Real);
  Procedure LTTransformationII(X,Y,I,J: longint; Var A,B: Real);
    {
      All procedures compute two values A and B so that the interval
      [X,Y] is linear transformed to the interval [I,J], ie. for all
      v in [X,Y] is  w:=A*v+B  the corresponding value in [I,J].
    }

Implementation

  {local} Function Float(I: longint): Real;
  Begin Float := I End;

  {local} Function EQ(X,Y: Real): Boolean;
  Const Eps: Real = 1.0E-6;
  Begin EQ := Abs(X-Y)<Eps End;

  Procedure LTTransformationRR(X,Y,I,J: Real; Var A,B: Real);
  Begin
    if (eq(x,y)) then begin
      a := 0.0;
      b := x
    end else begin
      a := (j-i)/(y-x);
      b := i-a*x
    end
  End;

  Procedure LTTransformationRI(X,Y: Real; I,J: longint; Var A,B: Real);
  Begin LTTransformationRR(X,Y,Float(I),Float(J),A,B) End;

  Procedure LTTransformationIR(X,Y: longint; I,J: Real; Var A,B: Real);
  Begin LTTransformationRR(Float(X),Float(Y),I,J,A,B) End;

  Procedure LTTransformationII(X,Y,I,J: longint; Var A,B: Real);
  Begin LTTransformationRR(Float(X),Float(Y),Float(I),Float(J),A,B) End;

End.
