{$I SWITCHES.INC}
{ $Id: ptr2src.pas 1.3 1993/04/05 20:00:45 Ricki Exp $ }
program ptr2src;
{ Generate source code from POINTERS.DAT }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@pool.informatik.rwth-aachen.de
}

{
        $Log: ptr2src.pas $
        Revision 1.3  1993/04/05  20:00:45  Ricki
        address change

        Revision 1.2  1993/03/19  17:43:26  Ricki
        *** empty log message ***

}

uses
  standard,
  strings,
  numbers,
  mouse;

const
  pversion = '$Id: ptr2src.pas 1.3 1993/04/05 20:00:45 Ricki Exp $';
  ptrfilename = 'POINTERS.DAT';

  pasfilename = 'POINTERS.INC';
  hexfilename = 'POINTERS.HEX';
  cfilename   = 'POINTERS.H';

type
  str16 = string[16];
  stringfield = array [0..15] of str16;

var
  f: text;
  opas,ohex,oc: text;

  line,name: string;
  p,i: byte;
  code: integer;
  r: pointerrec;
  c: stringfield;
  dummy: char;

  procedure str2rec(c: stringfield; var r: pointerrec);
  var
    i,j: integer;
    cm,sm: word;
  begin
    For i:=0 to 15 do Begin
      CM := 0; SM := 0;
      For j:=0 to 15 do Begin
        CM := CM shl 1; SM := SM shl 1;
        If (Pos(C[i][j+1],'%&')>0) Then CM := Succ(CM);
        If (Pos(C[i][j+1],'#&')>0) Then SM := Succ(SM)
      End;
      r.buf[i]:=CM; r.buf[i+16]:=SM
    End;
  end;

  procedure pasprolog(var o: text);
  begin
    writeln(o,'const');
  end;
  procedure cprolog(var o: text);
  begin
  end;
  procedure hexprolog(var o: text);
  begin
  end;

  procedure pasepilog(var o: text);
  begin
  end;
  procedure hexepilog(var o: text);
  begin
  end;
  procedure cepilog(var o: text);
  begin
  end;

  function readline(var f: text; var line: string): boolean;
  begin
    while (not eof(f)) do begin
      readln(f,line);
      line := headtrim(tailtrim(line,whitespace),whitespace);
      if (line<>'') and (line[1]<>'*') then begin
        readline := true;
        exit
      end
    end;
    readline := false
  end;

  procedure printpas(var o: text; c: stringfield; r: pointerrec);
  var
    i: integer;
  begin
    writeln(o,'  Ptr',name,': mouse.PointerRec = (');
    writeln(o,'    x: ',r.x,'; y: ',r.y,';');
    write  (o,'    buf: (');
    for i:=0  to 7  do write(o,'$',hexw(r.buf[i]),',');
    writeln(o);
    write  (o,'          ');
    for i:=8  to 15 do write(o,'$',hexw(r.buf[i]),',');
    writeln(o);
    write  (o,'          ');
    for i:=16 to 23 do write(o,'$',hexw(r.buf[i]),',');
    writeln(o);
    write  (o,'          ');
    for i:=24 to 30 do write(o,'$',hexw(r.buf[i]),',');
    writeln(o,'$',hexw(r.buf[31]),')');
    writeln(o,'  );');

    writeln(o)
  end;

  procedure printc(var o: text; c: stringfield; r: pointerrec);
  var
    i: integer;
  begin
    writeln(o,'#define Ptr',name,'Map_width 16');
    writeln(o,'#define Ptr',name,'Map_height 16');
    writeln(o,'#define Ptr',name,'Map_x_hot (unsigned int)',r.x);
    writeln(o,'#define Ptr',name,'Map_y_hot (unsigned int)',r.y);

    writeln(o,'static char Ptr',name,'Map_bits[] = {');
    write  (o,'   ');
    for i:=0  to 7  do write(o,'0x',hexb(hi(r.buf[i])),',0x',hexb(lo(r.buf[i])),',');
    writeln(o);
    write  (o,'   ');
    for i:=8  to 14 do write(o,'0x',hexb(hi(r.buf[i])),',0x',hexb(lo(r.buf[i])),',');
    i := 15; write(o,'0x',hexb(hi(r.buf[i])),',0x',hexb(lo(r.buf[i])),'};');
    writeln(o);

    writeln(o,'#define Ptr',name,'Mask_width 16');
    writeln(o,'#define Ptr',name,'Mask_height 16');

    writeln(o,'static char Ptr',name,'Mask_bits[] = {');
    write  (o,'   ');
    for i:=16 to 23 do write(o,'0x',hexb(hi(r.buf[i])),',0x',hexb(lo(r.buf[i])),',');
    writeln(o);
    write  (o,'   ');
    for i:=24 to 30 do write(o,'0x',hexb(hi(r.buf[i])),',0x',hexb(lo(r.buf[i])),',');
    i := 31; write(o,'0x',hexb(hi(r.buf[i])),',0x',hexb(lo(r.buf[i])),'};');
    writeln(o);

    writeln(o)
  end;

  procedure printhex(var o: text; c: stringfield; r: pointerrec);
  var
    i: integer;
  begin
    writeln(o,name);
    writeln(o,r.x,' ',r.y);
    for i:=0  to 7  do write(o,hexw(r.buf[i]),' ');
    writeln(o);
    for i:=8  to 15 do write(o,hexw(r.buf[i]),' ');
    writeln(o);
    for i:=16 to 23 do write(o,hexw(r.buf[i]),' ');
    writeln(o);
    for i:=24 to 31 do write(o,hexw(r.buf[i]),' ');
    writeln(o);

    writeln(o);
  end;

begin
  {$i-} assign(f,ptrfilename); reset(f); {$i+}
  if (ioresult<>0) then err('Cannot open '+ptrfilename);

  {$i-} assign(opas,pasfilename); rewrite(opas); {$i+}
  if (ioresult<>0) then err('Cannot open '+pasfilename);

  {$i-} assign(oc,cfilename); rewrite(oc); {$i+}
  if (ioresult<>0) then err('Cannot open '+cfilename);

  {$i-} assign(ohex,hexfilename); rewrite(ohex); {$i+}
  if (ioresult<>0) then err('Cannot open '+hexfilename);

  { write possible constant parts }
  pasprolog(opas);
  hexprolog(ohex);
  cprolog  (oc);

  { loop over the input file }
  while (readline(f,name)) do begin

    { get x and y }
    if (not readline(f,line)) then err('Unexpected eof after '+name);
    p := pos(' ',line);
    val(copy(line,1,p-1),r.x,code);
    if (code=0) then val(copy(line,p+1,255),r.y,code);
    if (code<>0) or (abs(r.x)>16) or (abs(r.y)>16) then
      err('Illegal "x y" after '+name);

    { get 16 lines with the shape }
    for i:=0 to 15 do begin
      readln(f,dummy,c[i],dummy);
      if (length(c[i])<16) then
        err('Illegal image line #'+numstr(i)+' after '+name)
    end;

    { create words from the string field }
    str2rec(c,r);

    { output the result }
    printpas(opas,c,r);
    printhex(ohex,c,r);
    printc(oc,c,r)
  end;

  { write possible constant parts }
  pasepilog(opas);
  hexepilog(ohex);
  cepilog  (oc);

  { close files }
  close(f);
  close(opas);
  close(ohex);
  close(oc);

end.
