head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.04.05.19.58.46;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.03.19.17.31.08;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.22.00.55.26;	author Ricki;	state Exp;
branches;
next	;


desc
@full keyboard access
@

1.3
log
@address change
@
text
@{$I SWITCHES.INC}
{ $Id: keyboard.pas 1.2 1993/03/19 17:31:08 Ricki Exp $ }
unit keyboard;
{ full keyboard access }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de


  This unit is based on the unit Keyboard, which can be found
  in the DRCPAS10 package by

  David R. Conrad,17 Nov 92
  David_Conrad@@mts.cc.wayne.edu
  dave@@michigan.com

  at SIMTEL in the directory msdos/turbopas. I removed the
  screensaver facility.
}

{
   Note: because of the auto-detection of the enhanced ROM BIOS and use
   of appropriate function numbers, these routine will work on original
   PC's and XT's and also allow full access to all features of enhanced
   keyboards, e.g. F11 & F12
}

{
        $Log: keyboard.pas $
        Revision 1.2  1993/03/19  17:31:08  Ricki
        new procedure 'readstring'

        Revision 1.1  1993/01/22  00:55:26  Ricki
        Initial revision
}

interface

  const
    pversion = '$Id: keyboard.pas 1.2 1993/03/19 17:31:08 Ricki Exp $';

    { for testing shift key status }
    RIGHTSHIFT = $01;
    LEFTSHIFT  = $02;
    CTRLKEY    = $04;
    ALTKEY     = $08;
    SCROLLLOCK = $10;
    NUMLOCK    = $20;
    CAPSLOCK   = $40;
    INSTOGGLE  = $80;

    { these constants are only for enhanced keyboards }
    LEFTCTRL   = $0100;
    LEFTALT    = $0200;
    RIGHTCTRL  = $0400;
    RIGHTALT   = $0800;
    SCROLLDOWN = $1000;
    NUMDOWN    = $2000;
    CAPSDOWN   = $4000;
    SYSRQDOWN  = $8000;

    { for setting the delay rate }
    delay250   = 0;
    delay500   = 1;
    delay750   = 2;
    delay1000  = 3;

    { for setting the repeat rate }
    fastkey    = $00;
    defaultkey = $0C;
    slowkey    = $1F;

  var
    scancode,asciival: char; { see readkey, keypressed }

  function readkey: char;
  function keypressed: boolean;
  function shiftkeys: word;
  function enhanced: boolean;
  procedure typematic(kbddelay,repeatrate: byte);
  function pushkey(ch: char): boolean;
  procedure clearkeys;
  procedure waitkey;
    {
      readkey    get key press, wait for one if necessary; returns #0,
                 then scan code for extended keys, just like CRT.readkey;
                 note: also puts ascii value and scan code in asciival and
                 scancode
      keypressed tell whether any keystrokes are waiting; has a key been
                 pressed?; note: if a key has been pressed, puts ascii value
                 and scan code of key in asciival and scancode,allowing:
                         if (keypressed) and (asciival=#27) then ....
                 This does not remove the keystroke from the typeahead buffer
      shiftkeys  get shift key state: upper byte only valid with enhanced
                 keyboard
      enhanced   tell whether an enhanced keyboard BIOS is present
      typematic  set the typematic delay and repeat rate on an enhanced
                 keyboard
      pushkey    push a keystroke back into the typeahead buffer;
                 note: the contents of the scancode variable are used for
                 the scan code of the key; if the scan code matters, place
                 it in that variable prior to calling this routine;
                 note: will return false if the typeahead buffer is full
                 or if no enhanced BIOS present
      clearkeys  clear the typeahead buffer
      waitkey    wait for a keypress
    }

  procedure readstring(row,col,maxl: byte; prm: string; var s: string;
                       var esc: boolean);
  {
    readstring	reads a complete string from the keyboard with the following
    		arguments:
		row,col		screen position
                maxl		maximum input length
                prm		prompt
                s		IN: preset value; OUT: return value
                esc		input aborted?
  }

implementation

  uses
    dostools,
    dos,
    crt;

  const
    kbdint = $16;

  var
    second: char;
    readfunc,pressfunc,shiftfunc: byte;

  function readkey: char;
  var
    r: registers;
  begin
    if (second<>#0) then begin
      readkey := second;
      second := #0;
    end else begin
      initregisters(r);
      r.ah := readfunc;
      intr(kbdint,r);
      if(r.al=$E0) and (r.ah<>0) then r.al := 0;
      readkey := char(r.al);
      asciival := char(r.al);
      scancode := char(r.ah);
      if (r.al=0) then second := char(r.ah)
    end
  end;

  function keypressed: boolean;
  var
    r: registers;
  begin
    if second<>#0 then
      keypressed := true
    else begin
      initregisters(r);
      r.ah := pressfunc;
      intr(kbdint,r);
      if(r.al = $E0) and(r.ah <> 0) then r.al := 0;
      if(r.flags AND FZero) = FZero then
        keypressed := false
      else begin
        keypressed := true;
        asciival := char(r.al);
        scancode := char(r.ah);
      end;
    end;
  end;

  function shiftkeys: word;
  var
    r: registers;
  begin
    initregisters(r);
    r.ah := shiftfunc;
    intr(kbdint,r);
    shiftkeys := r.ax;
  end;

  function enhanced: boolean;
  var
    r: registers;
    a: byte;
  begin
    initregisters(r);
    r.ah := $02;
    intr(kbdint,r);
    a := NOT r.al;
    r.ah := $12;
    r.al := a;
    intr(kbdint,r);
    enhanced := a <> r.al;
  end;

  procedure typematic(kbddelay,repeatrate: byte);
  var
    r: registers;
  begin
    initregisters(r);
    r.ah := $03;
    r.al := $05;
    if kbddelay > delay1000 then kbddelay := delay250;
    if repeatrate > slowkey then repeatrate := fastkey;
    r.bh := kbddelay;
    r.bl := repeatrate;
    intr(kbdint,r);
  end;

  function pushkey(ch: char): boolean;
  var
    r: registers;
  begin
    initregisters(r);
    r.ah := $05;
    r.al := $01;
    r.cl := byte(ch);
    r.ch := byte(scancode);
    intr(kbdint,r);
    pushkey := r.al = 0;
  end;

  procedure clearkeys;
  begin
    while keypressed do if readkey = #0 then if readkey = #0 then;
  end;

  procedure waitkey;
  begin
    if readkey = #0 then if readkey = #0 then;
  end;

  procedure readstring(row,col,maxl: byte; prm: string; var s: string;
                       var esc: boolean);
  const
    filler = #250;
  var
    c: char;
    p,l: byte;
    ex: boolean;
    fstr: string;
    insmode: boolean;
  begin
    { init }
    esc := false;                    { init esc status }
    s := copy(s,1,maxl);             { restrict the default to maxl }
    insmode := true;                 { start in insert mode }
    fillchar(fstr[1],maxl,filler);   { used to fill the empty input space }
    fstr[0] := chr(maxl);
    l := length(s);                  { init the current length }
    p := l+1;                        { init the current cursor position }
    gotoxy(col,row);                 { write prompt + default }
    write(prm,copy(s+fstr,1,maxl));
    inc(col,length(prm));            { set col to the start of the input }
    gotoxy(col+p-1,row);             { go there }
    if (maxl=0) then exit;           { exit if nothing else to do }

    { input loop }
    ex := false;
    repeat
      c := readkey;
      case c of
        #0: case readkey of
          #75: { <-- } if (p>1) then begin
            dec(p); write(^H);
          end;
          #77: { --> } if (p<=l) then begin
            gotoxy(col+p,row); inc(p)
          end;
          #83: { delete character at p } if (p<=l) then begin
            dec(l); delete(s,p,1);
            write(copy(s,p,maxl),filler);
            gotoxy(col+p-1,row)
          end;
          #79: { goto end } if (p<=l) then begin
            p := l+1; gotoxy(col+p-1,row)
          end;
          #71: { goto pos1 } if (p>1) then begin
            p := 1; gotoxy(col+p-1,row)
          end;
          #82: { toggle insert/overwrite mode } insmode := not insmode;
          else ;
        end;
        ^C,#27: { escape from input } begin
          esc := true; gotoxy(1,row)
        end;
        ^M: { regular input end } begin
          ex := true; gotoxy(1,row)
        end;
        ^H: { delete character p-1 } if (p>1) then begin
          dec(p); dec(l); delete(s,p,1);
          write(^H,copy(s,p,maxl),filler);
          gotoxy(col+p-1,row)
        end;
        ^Y: { delete string, start at 1 } begin
          gotoxy(col,row); write(fstr:maxl);
          l := 0; p := 1; s := '';
          gotoxy(col,row)
        end;
        else { regular input } if (p<=maxl) then begin
          { insert mode? }
          if (insmode) then begin
            s := copy(s,1,p-1)+c+copy(s,p,maxl); s := copy(s,1,maxl);
            l := length(s);
            write(copy(s,p,maxl)); inc(p);
            gotoxy(col+p-1,row)
          end else begin
            { append? }
            if (p=l+1) then begin
              s := s+c; write(c); inc(l); inc(p)
            end else begin
              s[p] := c; write(c); inc(p)
            end
          end
        end
      end
    until (esc) or (ex)
  end;

begin
  second := #0;
  if (enhanced) then begin
    readfunc  := $10;
    pressfunc := $11;
    shiftfunc := $12
  end else begin
    readfunc  := $00;
    pressfunc := $01;
    shiftfunc := $02
  end
end.
@


1.2
log
@new procedure 'readstring'
@
text
@d2 1
a2 1
{ $Id: KEYBOARD.PAS 1.1 1993/01/22 00:55:26 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d43 4
a46 1
        $Log: KEYBOARD.PAS $
d54 1
a54 1
    pversion = '$Id: KEYBOARD.PAS 1.1 1993/01/22 00:55:26 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id$ }
d43 3
a45 1
        $Log$
d51 1
a51 1
    pversion = '$Id$';
d120 12
d136 2
a137 1
    dos;
d246 87
@

