head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.04.05.20.00.25;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.03.19.17.43.18;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.22.00.54.56;	author Ricki;	state Exp;
branches;
next	;


desc
@check status of parallel printers connected to LPTx
@

1.3
log
@address change
@
text
@{$I SWITCHES.INC}
{ $Id: lpt.pas 1.2 1993/03/19 17:43:18 Ricki Exp $ }
unit lpt;
{ check status of parallel printers connected to LPTx }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de


  This unit is based on the unit DosTools, which can be found
  in the DRCPAS10 package by

  David R. Conrad, 17 Nov 92
  David_Conrad@@mts.cc.wayne.edu
  dave@@michigan.com

  at SIMTEL in the directory msdos/turbopas.
}

{
        $Log: lpt.pas $
        Revision 1.2  1993/03/19  17:43:18  Ricki
        *** empty log message ***

}

interface

  const
    pversion = '$Id: lpt.pas 1.2 1993/03/19 17:43:18 Ricki Exp $';

    { status codes }
    PrnNotBusy = $80;
    PrnAck     = $40;
    PrnNoPaper = $20;
    PrnSelect  = $10;
    PrnIOError = $08;
    PrnTimeout = $01;

  Function PrnOnline(n: Byte): Boolean;
  Function PrnReady(n: Byte): Boolean;
  Function PrnStatus(n: Byte): Byte;
  Function PrnErrStr(Err: Byte): String;
    {
      PrnOnline   Is LPTn online?
      PrnReady    Is LPTn ready to accept output (not busy or error)?
      PrnStatus   returns status of LPTn with undefined bits masked off
      PrnErr      attempt to produce error message from status of printer
    }

implementation

  uses
    dostools,
    dos;

  Function PrnOnline(n: Byte): Boolean;
  var
    reg: Registers;
  begin
    initregisters(reg);
    reg.ah := 2;
    reg.dx := pred(n);
    Intr($17,reg);
    PrnOnline :=(reg.ah AND PrnSelect) = PrnSelect;
  end;

  Function PrnReady(n: Byte): Boolean;
  var
    reg: Registers;
  begin
    initregisters(reg);
    reg.ah := 2;
    reg.dx := pred(n);
    Intr($17,reg);
    PrnReady :=
     ((reg.ah AND (PrnNotBusy OR PrnSelect)) = (PrnNotBusy OR PrnSelect))
      and ((reg.ah AND (PrnIOError AND PrnNoPaper AND PrnTimeout)) = 0)
  end;

  Function PrnStatus(n: Byte): Byte;
  var
    reg: Registers;
  begin
    initregisters(reg);
    reg.ah := 2;
    reg.dx := pred(n);
    Intr($17,reg);
    PrnStatus :=(reg.ah AND $F9) { mask off the two unused bits }
  end;

  Function PrnErrStr(Err: Byte): String;
  begin
    if ((Err AND PrnNoPaper)=PrnNoPaper) then PrnErrStr := 'Out of Paper'
    else if ((Err AND PrnTimeout)=PrnTimeout) then PrnErrStr := 'Timeout'
    else if ((Err AND PrnSelect)=0) then PrnErrStr := 'Off Line'
    else if ((Err AND PrnIOError)=PrnIOError) then PrnErrStr := 'I/O Error'
    else if ((Err AND PrnNotBusy)=0) then PrnErrStr := 'Busy'
    else PrnErrStr := ''
  end;

end.
@


1.2
log
@*** empty log message ***
@
text
@d2 1
a2 1
{ $Id: LPT.PAS 1.1 1993/01/22 00:54:56 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d35 4
a38 1
        $Log$
d44 1
a44 1
    pversion = '$Id: LPT.PAS 1.1 1993/01/22 00:54:56 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id$ }
d34 4
d41 1
a41 1
    pversion = '$Id$';
@

