head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.04.05.20.00.30;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.03.19.17.42.14;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.22.00.54.49;	author Ricki;	state Exp;
branches;
next	;


desc
@various string handling procedures
@

1.3
log
@address change
@
text
@{$I SWITCHES.INC}
{ $Id: strings.pas 1.2 1993/03/19 17:42:14 Ricki Exp $ }
unit strings;
{ various string handling procedures }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de


  Many procedures in this unit are derived from the unit Tools,
  which can be found in the DRCPAS10 package by

  David R. Conrad, 17 Nov 92
  David_Conrad@@mts.cc.wayne.edu
  dave@@michigan.com

  at SIMTEL in the directory msdos/turbopas.
}

{
        $Log: strings.pas $
        Revision 1.2  1993/03/19  17:42:14  Ricki
        some bugfixes
        new procedures cspecial, sprintf

        Revision 1.1  1993/01/22  00:54:49  Ricki
        Initial revision
}

interface

  const
    pversion = '$Id: strings.pas 1.2 1993/03/19 17:42:14 Ricki Exp $';

  type
    charset = set of char;

  const
    whitespace: charset = [#9,#10,#12,#13,' ',#255];

  var
    blanks: string; { 255 * ' '}
    allchars: string; { [i] --> chr(i) }

  { --- case conversion }
  function lowcase(c: char): char;
  function upcase(c: char): char;
  function flip(c: char): char;
  function strlowcase(s: string): string;
  function strupcase(s: string): string;
  function strflip(s: string): string;
    {
      lowcase    A --> a (incl )
      upcase     a --> A
      flip       a --> A --> a
      strlowcase ABC --> abc
      strupcase  abc --> ABC
      strflip    AbC --> aBc
    }

  { --- elementary string modifications }
  function trim(s: string; cs: charset): string;
  function headtrim(s: string; cs: charset): string;
  function tailtrim(s: string; cs: charset): string;
  function printable(s: string): string;
  procedure reverse(var s: string);
    {
      trim       kills all characters contained in cs from s
      headtrim   kills only leading characters
      tailtrim   kills only trailing characters
      trimupcase combination of trim and upcase (good for comparisons)
      printable  replaces non-printable characters by a printable string,
                 like #9 --> <^I>  or #193 --> <M-A>
      reverse  eg. abc --> cba
    }

  { --- tabulator insertion/deletion }
  function entab(s: string; tw: byte): string;
  function detab(s: string; tw: byte): string;
  function quotedentab(s: string; tw: byte): string;
  function quoteddetab(s: string; tw: byte): string;
  function headentab(s: string; tw: byte): string;
  function headdetab(s: string; tw: byte): string;
    {
      entab       replaces all spaces by tabs, if possible
      detab       replaces all tabs by spaces
      quotedentab as entab, not changing quoted parts (ie. 'xxx' or "xxx")
      quoteddetab as detab, not changing quoted parts
      leadentab   as entab, replacing only leading spaces
      leaddetab   as detab, replacing only leading tabs
    }

  { --- substring substitution }
  procedure substone(s1,s2: string; var s: string);
  procedure substall(s1,s2: string; var s: string);
  procedure cspecial(var s: string);
    {
      substone  replaces the first occurence of s1 in s by s2
      substall  as substone, replacing all occurences
      cspecial  replaces the C special characters by their ASCII
                equivalents. Supported are \b \n \t \r \f \\ \' \0 \ddd
    }

  { --- rotation }
  function rot13(c: char): char;
  function rot13str(s: string): string;
    {
      rot13    rotate the alphabet by 13 chars: nopqrstuvwxyzabcdefghijklm
      rot13str rot13 for a string (encrypts and decrypts it)
    }

  { --- miscellanous procedures }
  function conststr(c: char; n: byte): string;
  function minpos(cs: charset; s: string): byte;
    {
      conststr returns a string consisting of n c's
      minpos   returns the position of the first char from cs in s
    }

  procedure sprintf(var s: string; control: string;
                    var a0,a1,a2,a3,a4);
  {
    C-style sprintf. Places the arguments a0..a4 into s following the
    format elements contained in control. sprintf calls cspecial first
    to substitute the C-style special characters (see above)

    Note:
    -----
    The  e  (and therefore also the  g)  format do not work 100% correctly.

    Syntax Description:
    -------------------
    Each control element starts with %. At the end of the element stands
    the character that controls the conversion. Between them the following
    characters may occur one after one:

      A - makes the output left-aligned in the output field

      A number defining the minimal field width. The argument will be printed
      with this minimal width and longer, if necessary. If the argument is
      shorter than minw, the field is filled up from the left side (if - was
      specified, from the right). Normally spaces are used for this; if the
      field width starts with a 0, 0's are used.

      A . to separate minw from another number.

      A number which defines how much characters of the argument are to be
      printed or how much decimal places shall appear after the comma in the
      case of real or double numbers.

      The character l which says that the argument is longint/double instead
      of integer/real.

    The conversion is defined with the following characters (*=my extension):

      b* The argument is printed as a decimal number. Valid arguments are
         byte variables.

      d  The argument is printed as a decimal number. Valid arguments are
         integer and longint (with l) variables.

      o  The argument is printed as an octal number (without a leading 0).
         Valid arguments are integer and longint (with l) variables.

      x  The argument is printed as an hex number (without a leading 0x or $).
         Valid arguments are integer and longint (with l) variables.

      u  The argument is printed as an unsigned decimal number. Valid
         arguments are integer and longint (with l) variables.

      c  The argument is printed as a single character. Valid arguments are
         char variables.

      s  The argument is printed as a string. Valid arguments are string
         variables. NOTE: C-type strings, which are terminated by #0, are
         not supported!

      e  The argument is printed in the form [-]m.nnnnnnE[+ -]xx. Valid
         arguments are real and double (with l) variables. Default length
         of nnnnnn is 6.

      f  The argument is printed in the form [-]mmm.nnnnnn. Valid arguments
         are real and double (with l) variables. Default length of nnnnnn
         is 6.

      g  The shorter alternative of e and f is chosen.

    There are also X,E, and G, but they are currently the same as x,e, and g
  }

implementation

  uses
    numbers;

  var
    i: byte;

  function lowcase(c: char): char;
  begin
    if (c in ['A'..'Z']) then lowcase := chr(ord(c)+ord('a')-ord('A'))
    else case c of
      '': lowcase := '';
      '': lowcase := '';
      '': lowcase := '';
      '': lowcase := '';
      '': lowcase := '';
      '': lowcase := '';
      '': lowcase := '';
      '': lowcase := '';
      else lowcase := c
    end
  end;

  function upcase(c: char): char;
  begin
    if (c in ['a'..'z']) then upcase := system.upcase(c)
    else case c of
      '': upcase := '';
      '': upcase := '';
      '': upcase := '';
      '': upcase := '';
      '': upcase := '';
      '': upcase := '';
      '': upcase := '';
      '': upcase := '';
      else upcase := c
    end
  end;

  function flip(c: char): char;
  begin
    if (c in ['a'..'z']) then flip := system.upcase(c)
    else if (c in ['A'..'Z']) then flip := chr(ord(c)+ord('a')-ord('A'))
    else case c of
      '': flip := '';
      '': flip := '';
      '': flip := '';
      '': flip := '';
      '': flip := '';
      '': flip := '';
      '': flip := '';
      '': flip := '';
      '': flip := '';
      '': flip := '';
      '': flip := '';
      '': flip := '';
      '': flip := '';
      '': flip := '';
      '': flip := '';
      '': flip := '';
      else flip := c
    end
  end;

  function strlowcase(s: string): string;
  var
    i: byte;
  begin
    for i:=1 to length(s) do s[i] := lowcase(s[i]);
    strlowcase := s
  end;

  function strupcase(s: string): string;
  var
    i: byte;
  begin
    for i:=1 to length(s) do s[i] := upcase(s[i]);
    strupcase := s
  end;

  function strflip(s: string): string;
  var
    i: byte;
  begin
    for i:=1 to length(s) do s[i] := flip(s[i]);
    strflip := s
  end;

  function trim(s: string; cs: charset): string;
  var
    i,l: integer;
  begin
    i := 1; l := length(s);
    while (i<=l) do begin
      if (s[i] in cs) then begin
        delete(s,i,1);
        dec(l)
      end else inc(i)
    end;
    trim := s
  end;

  function headtrim(s: string; cs: charset): string;
  var
    l: integer;
  begin
    l := length(s);
    while (l>=1) and (s[1] in cs) do begin
      delete(s,1,1);
      dec(l)
    end;
    headtrim := s
  end;

  function tailtrim(s: string; cs: charset): string;
  var
    l: integer;
  begin
    l := length(s);
    while (l>=1) and (s[l] in cs) do begin
      delete(s,l,1);
      dec(l)
    end;
    tailtrim := s
  end;

  function printable(s: string): string;
  label
    eow;
  var
    i,j,l: integer;
  begin
    i := 1; j := 0; l := length(s);
    while (i<=l) do begin
      if (s[i]=#127) then begin
        if (j>=254) then goto eow;
        inc(j); printable[j] := '^';
        inc(j); printable[j] := '?';
      end else if (s[i]<#32) then begin
        if (j>=254) then goto eow;
        inc(j); printable[j] := '^';
        inc(j); printable[j] := chr(ord('A')+ord(s[i])-1)
      end else if (s[i]>#127) then begin
        if (j>=252) then goto eow;
        inc(j); printable[j] := 'M';
        inc(j); printable[j] := '-';
        s[i] := chr(ord(s[i]) and 127);
        { goon with the eighth bit not set }
        dec(i)
      end else begin
        if (j>=255) then goto eow;
        inc(j); printable[j] := s[i]
      end;
      inc(i)
    end;
    eow: printable[0] := chr(j);
  end;

  procedure reverse(var s: string);
  var
    c: char;
    i,l: byte;
  begin
    l := length(s);
    for i:=1 to (l div 2) do begin
      c := s[i];
      s[i] := s[l-i+1];
      s[l-i+1] := c
    end
  end;

  function entab(s: string; tw: byte): string;
  var
    j,p,b,i: byte;
  begin
    { preset logical position and blank counter }
    p := 0; b := 0; j := 0;
    { loop over s }
    for i:=1 to length(s) do begin
      { case1: blank }
      if (s[i]=' ') then begin
        inc(p);
        { reached a tab stop? }
        if (p mod tw=0) then begin
          { found more than one blank before tab stop? }
          if (b>0) then begin
            { replace blanks by tab }
            inc(j); entab[j] := #9;
            b := 0; p := 0;
          end else begin
            { tab is not necessary, insert space }
            inc(j); entab[j] := ' '
          end
        { increment blank counter }
        end else inc(b)
      { case2: tab }
      end else if (s[i]=#9) then begin
        { insert it - do not insert blanks before tab }
        inc(j); entab[j] := #9;
        b := 0; p := 0
      { case3: neither blank nor tab }
      end else begin
        inc(p);
        while (b>0) do begin
          inc(j); entab[j] := ' ';
          dec(b)
        end;
        inc(j); entab[j] := s[i]
      end
    end;
    { do not forget trailing blanks }
    while (b>0) do begin
      inc(j); entab[j] := ' ';
      dec(b)
    end;
    { set the length byte }
    entab[0] := chr(j)
  end;

  function detab(s: string; tw: byte): string;
  var
    i: byte;
    j,l: integer;
  begin
    j := 0;
    for i:=1 to length(s) do begin
      inc(j);
      if (s[i]=#9) then begin
        l := tw*((j-1) div tw)+tw;
        if (l>255) then l := 255;
        while (j<l) do begin
          detab[j] := ' ';
          inc(j)
        end;
        detab[j] := ' '
      end else detab[j] := s[i]
    end;
    detab[0] := chr(j)
  end;

  function quotedentab(s: string; tw: byte): string;
  const
    q1 = '''';
    q2 = '"';
  var
    j,p,b,i,state: byte; { state: 0=start, 1=quote1, 2=quote2 }
  begin
    { preset logical position and blank counter }
    p := 0; b := 0; j := 0;
    state := 0;
    { loop over s }
    for i:=1 to length(s) do case state of
      0: begin
        { case1: blank }
        if (s[i]=' ') then begin
          inc(p);
          { reached a tab stop? }
          if (p mod tw=0) then begin
            { found more than one blank before tab stop? }
            if (b>0) then begin
              { replace blanks by tab }
              inc(j); quotedentab[j] := #9;
              b := 0; p := 0;
            end else begin
              { tab is not necessary, insert space }
              inc(j); quotedentab[j] := ' '
            end
          { increment blank counter }
          end else inc(b)
        { case2: tab }
        end else if (s[i]=#9) then begin
          { insert it - do not insert blanks before tab }
          inc(j); quotedentab[j] := #9;
          b := 0; p := 0
        { case3: neither blank nor tab }
        end else begin
          inc(p);
          while (b>0) do begin
            inc(j); quotedentab[j] := ' ';
            dec(b)
          end;
          inc(j); quotedentab[j] := s[i];
          { set new state, if necessary }
          if (s[i]=q1) then state := 1
          else if (s[i]=q2) then state := 2
        end
      end;
      1: begin
        inc(p);
        while (b>0) do begin
          inc(j); quotedentab[j] := ' ';
          dec(b)
        end;
        inc(j); quotedentab[j] := s[i];
        { set new state, if necessary }
        if (s[i]=q1) then state := 0
      end;
      2: begin
        inc(p);
        while (b>0) do begin
          inc(j); quotedentab[j] := ' ';
          dec(b)
        end;
        inc(j); quotedentab[j] := s[i];
        { set new state, if necessary }
        if (s[i]=q2) then state := 0
      end
    end;
    { do not forget trailing blanks }
    while (b>0) do begin
      inc(j); quotedentab[j] := ' ';
      dec(b)
    end;
    { set the length byte }
    quotedentab[0] := chr(j)
  end;

  function quoteddetab(s: string; tw: byte): string;
  const
    q1 = '''';
    q2 = '"';
  var
    i,state: byte; { state: 0=start, 1=quote1, 2=quote2 }
    j,l: integer;
  begin
    j := 0; state := 0;
    for i:=1 to length(s) do case state of
      0: begin
        inc(j);
        if (s[i]=#9) then begin
          l := tw*((j-1) div tw)+tw;
          if (l>255) then l := 255;
          while (j<l) do begin
            quoteddetab[j] := ' ';
            inc(j)
          end;
          quoteddetab[j] := ' '
        end else begin
          quoteddetab[j] := s[i];
          { set new state, if necessary }
          if (s[i]=q1) then state := 1
          else if (s[i]=q2) then state := 2
        end
      end;
      1: begin
        inc(j); quoteddetab[j] := s[i];
        if (s[i]=q1) then state := 0
      end;
      2: begin
        inc(j); quoteddetab[j] := s[i];
        if (s[i]=q2) then state := 0
      end
    end;
    quoteddetab[0] := chr(j)
  end;

  function headentab(s: string; tw: byte): string;
  var
    i,j,p,l,n: byte;
    ex: boolean;
  begin
    { loop until end of line or the first char not equal blank/tab found }
    i := 1; p := 1; l := length(s); ex := false;
    while (i<=l) and (not ex) do case s[i] of
      ' ': begin inc(p); inc(i) end;
      #9: begin p := 1+tw*(1+(p div tw)); inc(i) end;
      else ex := true
    end;
    { fill in p div tw tabs }
    n := p div tw;
    j := 0; while (j<n) do begin
      inc(j); headentab[j] := #9
    end;
    { fill up with blanks }
    n := (p-1) mod tw;
    while (n>0) do begin
      inc(j); headentab[j] := ' ';
      dec(n)
    end;
    { copy the rest of the line }
    while (i<=l) do begin
      inc(j); headentab[j] := s[i];
      inc(i)
    end;
    headentab[0] := chr(j)
  end;

  function headdetab(s: string; tw: byte): string;
  var
    i,l: byte;
    j,p: integer;
    ex: boolean;
  begin
    { loop until end of line or the first char not equal blank/tab found }
    i := 1; p := 1; l := length(s); ex := false;
    while (i<=l) and (not ex) do case s[i] of
      ' ': begin inc(p); inc(i) end;
      #9: begin p := 1+tw*(1+(p div tw)); inc(i) end;
      else ex := true
    end;
    { fill in p-1 blanks }
    if (p>255) then p := 255;
    j := 0; while (j<p-1) do begin
      inc(j); headdetab[j] := ' '
    end;
    { copy the rest of the line }
    while (i<=l) do begin
      inc(j); headdetab[j] := s[i];
      inc(i)
    end;
    headdetab[0] := chr(j)
  end;

  procedure substone(s1,s2: string; var s: string);
  var
    i1: integer;
  begin
    i1 := pos(s1,s);
    if (i1>0) then begin
      delete(s,i1,length(s1));
      insert(s2,s,i1)
    end
  end;

  procedure substall(s1,s2: string; var s: string);
  var
    i1,i2,w1,w2: byte;
  begin
    i1 := length(s1); i2 := length(s2);
    w1 := 1;
    while (w1<=length(s)+1-i1) do begin
      w2 := pos(s1,copy(s,w1,255))+w1-1;
      if (w2=w1-1) then exit
      else begin
        delete(s,w2,i1);
        insert(s2,s,w2);
        w1 := w2+i2
      end
    end
  end;

  function rot13(c: char): char;
  begin
    if (not (c in ['A'..'Z','a'..'z'])) then rot13 := c
    else if c in ['A'..'M','a'..'m'] then rot13 := chr(ord(c)+13)
    else rot13 := chr(ord(c)-13)
  end;

  function rot13str(s: string): string;
  var
    i: byte;
  begin
    for i:=1 to length(s) do s[i] := rot13(s[i]);
    rot13str := s
  end;

  function conststr(c: char; n: byte): string;
  var
    s: string;
  begin
    s[0] := chr(n);
    fillchar(s[1],n,c);
    conststr := s
  end;

  function minpos(cs: charset; s: string): byte;
  var
    i: byte;
  begin
    for i:=1 to length(s) do begin
      if (s[i] in cs) then begin minpos := i; exit end
    end;
    minpos := 0
  end;

  procedure cspecial(var s: string);
  var
    v: longint;
    i: byte;
  begin
    i := 1;
    while (i<length(s)) do begin
      if (s[i]='\') then begin
        case s[i+1] of
          'b': begin s[i] :=  #8; delete(s,i+1,1); inc(i) end;
          't': begin s[i] :=  #9; delete(s,i+1,1); inc(i) end;
          'n': begin s[i] := #10; delete(s,i+1,1); inc(i) end;
          'f': begin s[i] := #12; delete(s,i+1,1); inc(i) end;
          'r': begin s[i] := #13; delete(s,i+1,1); inc(i) end;
          '0'..'9': begin
            if (i+2<length(s)) and ('0'<=s[i+2]) and (s[i+2]<='9')
            		       and ('0'<=s[i+3]) and (s[i+3]<='9')
                               and (oval(copy(s,i+1,3),v))
                               and (v<256) then begin
              s[i] := chr(v); delete(s,i+1,3)
            end else if (s[i+1]='0') then begin
	      s[i] := #0; delete(s,i+1,1); inc(i)
            end else begin
              s[i] := s[i+1]; delete(s,i+1,1); inc(i)
            end
          end;
          else begin s[i] := s[i+1]; delete(s,i+1,1); inc(i) end;
        end
      end else inc(i)
    end
  end;

  procedure sprintf(var s: string; control: string;
                    var a0,a1,a2,a3,a4);
  const
    maxval = 4; { a0...a4 }
  var
    minw,maxo,n,p: byte;
    v: longint;
    left,fill0,long: boolean;
    hs,hs2: string;

    procedure pad;
    { fills hs up with spaces or 0's depending on minw, left, and fill0 }
    begin
      if (left) then begin
        if (fill0) then while (length(hs)<minw) do hs := hs+'0'
                   else while (length(hs)<minw) do hs := hs+' '
      end else begin
        if (fill0) then while (length(hs)<minw) do hs := '0'+hs
                   else while (length(hs)<minw) do hs := ' '+hs
      end;
    end;

    function fmtb(var a): string;
    var
      b: byte absolute a;
    begin str(b,hs); pad; fmtb := hs
    end;

    function fmtd(var a): string;
    var
      i: integer absolute a;
    begin str(i,hs); pad; fmtd := hs
    end;

    function fmtdl(var a): string;
    var
      i: longint absolute a;
    begin str(i,hs); pad; fmtdl := hs
    end;

    function fmto(var a): string;
    var
      i: integer absolute a;
    begin
      hs := octw(abs(i));
      while (hs[1]='0') and (length(hs)>1) do delete(hs,1,1);
      if (i<0) then hs := '-'+hs;
      pad; fmto := hs
    end;

    function fmtol(var a): string;
    var
      i: longint absolute a;
    begin
      hs := octl(abs(i));
      while (hs[1]='0') and (length(hs)>1) do delete(hs,1,1);
      if (i<0) then hs := '-'+hs;
      pad; fmtol := hs
    end;

    function fmtx(var a): string;
    var
      i: integer absolute a;
    begin
      hs := hexw(abs(i));
      while (hs[1]='0') and (length(hs)>1) do delete(hs,1,1);
      if (i<0) then hs := '-'+hs;
      pad; fmtx := hs
    end;

    function fmtxl(var a): string;
    var
      i: longint absolute a;
    begin
      hs := hexl(abs(i));
      while (hs[1]='0') and (length(hs)>1) do delete(hs,1,1);
      if (i<0) then hs := '-'+hs;
      pad; fmtxl := hs
    end;

    function fmtu(var a): string;
    var
      i: integer absolute a;
    begin str(abs(i),hs); pad; fmtu := hs
    end;

    function fmtul(var a): string;
    var
      i: longint absolute a;
    begin str(abs(i),hs); pad; fmtul := hs
    end;

    function fmtc(var a): string;
    var
      c: char absolute a;
    begin hs := c; pad; fmtc := hs
    end;

    function fmts(var a): string;
    var
      s: string absolute a;
    begin
      hs := copy(s,1,maxo);
      pad; fmts := hs
    end;

    function fmte(var a): string;
    var
      r: real absolute a;
    begin
      if (maxo=255) then maxo := 6;
      str(r:maxo,hs); pad; fmte := hs
    end;

    function fmtel(var a): string;
    var
      r: double absolute a;
    begin
      if (maxo=255) then maxo := 6;
      str(r:maxo,hs); pad; fmtel := hs
    end;

    function fmtf(var a): string;
    var
      r: real absolute a;
    begin
      if (maxo=255) then maxo := 6;
      str(r:0:maxo,hs); pad; fmtf := hs
    end;

    function fmtfl(var a): string;
    var
      r: double absolute a;
    begin
      if (maxo=255) then maxo := 6;
      str(r:0:maxo,hs); pad; fmtfl := hs
    end;

  begin
    cspecial(control);
    n := 0;
    s := '';
    repeat
      { copy all until % from control to s }
      p := pos('%',control); if (p=0) then p := 1+length(control);
      s := s+copy(control,1,p-1);
      delete(control,1,p);

      { if there is something left, parse the control string }
      if (control<>'') then begin
        { if the first character is not one of [-0-9.ldoxucsefg], %c means
          c itself }
        if not (control[1] in
           ['-','0'..'9','.','b','l','d','o','x','u','c','s','e','f','g']) then
          s := s+control[1]
        else begin
          { a leading - makes the output leftaligned }
          left := (control[1]='-');
          if (left) then delete(control,1,1);

          { if the next char is '0', the output is filled with leading 0s }
          fill0 := (control[1]='0');
          if (fill0) then delete(control,1,1);

          { if the next is a number, it is a min field width }
          p := 1; while (control[p]>='0') and (control[p]<='9') do inc(p);
          if (p=1) then minw := 0
          else begin
            if (not ival(copy(control,1,p-1),v)) then minw := 0
                                                 else minw := v;
            delete(control,1,p-1)
          end;

          { if the next is a '.', a max output width follows }
          if (control[1]='.') then begin
            delete(control,1,1);
            p := 1; while (control[p]>='0') and (control[p]<='9') do inc(p);
            if (p=1) then maxo := 255
            else begin
              if (not ival(copy(control,1,p-1),v)) then maxo := 0
                                                   else maxo := v;
              delete(control,1,p-1)
            end
          end else maxo := 255;

          { the next may be 'l' for longs }
          long := (control[1]='l');
          if (long) then delete(control,1,1);

          { now comes the control character finally }
          case control[1] of
            'b': case n of
              0: s := s+fmtb(a0);
              1: s := s+fmtb(a1);
              2: s := s+fmtb(a2);
              3: s := s+fmtb(a3);
              4: s := s+fmtb(a4);
            end;
            'd': case n of
              0: if (long) then s := s+fmtdl(a0) else s := s+fmtd(a0);
              1: if (long) then s := s+fmtdl(a1) else s := s+fmtd(a1);
              2: if (long) then s := s+fmtdl(a2) else s := s+fmtd(a2);
              3: if (long) then s := s+fmtdl(a3) else s := s+fmtd(a3);
              4: if (long) then s := s+fmtdl(a4) else s := s+fmtd(a4);
            end;
            'o': case n of
              0: if (long) then s := s+fmtol(a0) else s := s+fmto(a0);
              1: if (long) then s := s+fmtol(a1) else s := s+fmto(a1);
              2: if (long) then s := s+fmtol(a2) else s := s+fmto(a2);
              3: if (long) then s := s+fmtol(a3) else s := s+fmto(a3);
              4: if (long) then s := s+fmtol(a4) else s := s+fmto(a4);
            end;
            'x','X': case n of
              0: if (long) then s := s+fmtxl(a0) else s := s+fmtx(a0);
              1: if (long) then s := s+fmtxl(a1) else s := s+fmtx(a1);
              2: if (long) then s := s+fmtxl(a2) else s := s+fmtx(a2);
              3: if (long) then s := s+fmtxl(a3) else s := s+fmtx(a3);
              4: if (long) then s := s+fmtxl(a4) else s := s+fmtx(a4);
            end;
            'u': case n of
              0: if (long) then s := s+fmtul(a0) else s := s+fmtu(a0);
              1: if (long) then s := s+fmtul(a1) else s := s+fmtu(a1);
              2: if (long) then s := s+fmtul(a2) else s := s+fmtu(a2);
              3: if (long) then s := s+fmtul(a3) else s := s+fmtu(a3);
              4: if (long) then s := s+fmtul(a4) else s := s+fmtu(a4);
            end;
            'c': case n of
              0: s := s+fmtc(a0);
              1: s := s+fmtc(a1);
              2: s := s+fmtc(a2);
              3: s := s+fmtc(a3);
              4: s := s+fmtc(a4);
            end;
            's': case n of
              0: s := s+fmts(a0);
              1: s := s+fmts(a1);
              2: s := s+fmts(a2);
              3: s := s+fmts(a3);
              4: s := s+fmts(a4);
            end;
            { the 'e' and 'g' formats do not work 100% correctly }
            'e','E': case n of
              0: if (long) then s := s+fmtel(a0) else s := s+fmte(a0);
              1: if (long) then s := s+fmtel(a1) else s := s+fmte(a1);
              2: if (long) then s := s+fmtel(a2) else s := s+fmte(a2);
              3: if (long) then s := s+fmtel(a3) else s := s+fmte(a3);
              4: if (long) then s := s+fmtel(a4) else s := s+fmte(a4);
            end;
            'f': case n of
              0: if (long) then s := s+fmtfl(a0) else s := s+fmtf(a0);
              1: if (long) then s := s+fmtfl(a1) else s := s+fmtf(a1);
              2: if (long) then s := s+fmtfl(a2) else s := s+fmtf(a2);
              3: if (long) then s := s+fmtfl(a3) else s := s+fmtf(a3);
              4: if (long) then s := s+fmtfl(a4) else s := s+fmtf(a4);
            end;
            'g','G': case n of
              0: if (long) then begin
                hs2 := fmtel(a0);
                hs  := fmtfl(a0);
                if (length(hs)<=length(hs2)) then s := s+hs else s := s+hs2
              end;
              1: if (long) then begin
                hs2 := fmtel(a1);
                hs  := fmtfl(a1);
                if (length(hs)<=length(hs2)) then s := s+hs else s := s+hs2
              end;
              2: if (long) then begin
                hs2 := fmtel(a2);
                hs  := fmtfl(a2);
                if (length(hs)<=length(hs2)) then s := s+hs else s := s+hs2
              end;
              3: if (long) then begin
                hs2 := fmtel(a3);
                hs  := fmtfl(a3);
                if (length(hs)<=length(hs2)) then s := s+hs else s := s+hs2
              end;
              4: if (long) then begin
                hs2 := fmtel(a4);
                hs  := fmtfl(a4);
                if (length(hs)<=length(hs2)) then s := s+hs else s := s+hs2
              end;
            end;
            else s := s+'*** %-Error ***'
          end;

          { delete the final control character and take the next value
            in the next run }
          delete(control,1,1);
          inc(n)
        end
      end
    until (control='') or (n=maxval);
    s := s+control
  end;

begin
  blanks := conststr(' ',255);
  allchars[0] := #255;
  for i:=1 to 255 do allchars[i] := chr(i)
end.
@


1.2
log
@some bugfixes
new procedures cspecial, sprintf
@
text
@d2 1
a2 1
{ $Id: STRINGS.PAS 1.1 1993/01/22 00:54:49 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d35 5
a39 1
        $Log: STRINGS.PAS $
d47 1
a47 1
    pversion = '$Id: STRINGS.PAS 1.1 1993/01/22 00:54:49 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id$ }
d35 3
a37 1
        $Log$
d43 1
a43 1
    pversion = '$Id$';
d53 1
d106 1
d108 4
a111 2
      substone replaces the first occurence of s1 in s by s2
      substall as substone, replacing all occurences
d130 71
d203 6
d216 5
a220 5
      '': lowcase := '';
      '': lowcase := '';
      '': lowcase := '';
      '': lowcase := '';
      '': lowcase := '';
d232 5
a236 5
      '': upcase := '';
      '': upcase := '';
      '': upcase := '';
      '': upcase := '';
      '': upcase := '';
d620 4
a623 2
    delete(s,i1,length(s1));
    insert(s2,s,i1)
d634 1
a634 1
      if (w2=w1-1) then w1 := 255
d677 327
d1005 3
a1007 1
  blanks := conststr(' ',255)
@

