head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.04.05.20.00.07;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.03.19.17.40.06;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.22.00.55.08;	author Ricki;	state Exp;
branches;
next	;


desc
@formatted text output to text files
@

1.3
log
@address change
@
text
@{$I SWITCHES.INC}
{ $Id: textfmt.pas 1.2 1993/03/19 17:40:06 Ricki Exp $ }
unit textfmt;
{ formatted text output to text files }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: textfmt.pas $
        Revision 1.2  1993/03/19  17:40:06  Ricki
        in blockset mode the first 10 random numbers are skipped
          because they don't please me

        Revision 1.1  1993/01/22  00:55:08  Ricki
        Initial revision
}

interface

  uses
    strings;

  const
    pversion = '$Id: textfmt.pas 1.2 1993/03/19 17:40:06 Ricki Exp $';

  type
    Tfmtmode = (m_left,m_right,m_center,m_block);

    procedure findent(var f: text; i: byte);
    procedure fmode(var f: text; m: Tfmtmode);
    procedure fwidth(var f: text; w: byte);
    procedure fwrite(var f: text; s: string);
    procedure fwriteln(var f: text; s: string);
    procedure fflushln(var f: text);
    procedure fignore(var f: text; s: string);
    procedure fwr1te(var f: text; s: string);
    procedure fwr1teln(var f: text; s: string);
      {
        findent  sets indentation to i characters; flushes the buffer
        fmode    sets formatting mode; flushes the buffer
        fwidth   sets the output width; flushes the buffer
        fwrite   adds s to the output
        fwriteln adds s+crlf to the output
        fflushln flushes the buffer w/crlf
        fignore  flushes the buffer and copies s unformatted to the output
        fwr1te   adds s to the output w/o indentation
        fwr1teln adds s+crlf to the output w/o indentation
      }

implementation

  var
    { these global variables are the memory of this unit }
    outl: byte;
    out: string;
    width: byte;
    ind: byte;
    mode: Tfmtmode;

  {local} procedure newline;
  begin out := copy(blanks,1,ind); outl := ind end;

  {local} procedure outline(var f: text; s: string; last: boolean);
  { output s according mode. last is true, if the line is the last
    of a paragraph. this line must not be blockset }
  var
    ins,i,n: integer;
    pf,add: array [0..256] of integer;

    procedure allpos(s: string);
    var
      p: byte;
    begin
      n := 0; pf[0] := ind;
      delete(s,1,ind);
      p := pos(' ',s);
      while (p>0) do begin
        inc(n);
        pf[n] := pf[n-1]+p;
        delete(s,1,p);
        p := pos(' ',s)
      end;
      pf[n+1] := length(s)+pf[n]+1
    end;

  begin
    case mode of
      m_left: writeln(f,s);
      m_right: writeln(f,s:width);
      m_center: writeln(f,s:((width+length(s)) div 2));
      m_block: if (last) then writeln(f,s)
      else begin
        { calc the position of all blanks in the line and reset the
          addition count array. if no spaces are found, simply output the
          line w/o applying the blockset algorithm }
        allpos(s);
        if (n>0) then begin
          {randomize;}
          { skip the first 10 random numbers because they don't please me }
          for i:=1 to 100 do if (random(n)>0) then;
          for i:=1 to n do add[i] := 0;
          { calc space addition randomly until the line is filled up }
          ins := width-length(s);
          while (ins>0) do begin
            inc(add[1+random(n)]);
            dec(ins)
          end;
          { perform space addition from right to left to preserve the indices }
          for i:=n downto 1 do insert(copy(blanks,1,add[i]),s,pf[i])
        end;
        writeln(f,s)
      end
    end
  end;

  procedure fwidth(var f: text; w: byte);
  begin
    fflushln(f);
    if (w>0) and (ind>w) then w := ind;
    width := w
  end;

  procedure findent(var f: text; i: byte);
  begin
    if (i>width) then i := width;
    if (outl=ind) then begin
      outl := i;
      out := copy(blanks,1,i)
    end;
    ind := i
  end;

  procedure fmode(var f: text; m: Tfmtmode);
  begin
    fflushln(f); mode := m
  end;

  procedure fwrite(var f: text; s: string);
  var
    i,ls: byte;
  begin
    if (width=0) then write(f,s) else begin
      { replace tabs in s by spaces }
      s := detab(s,8);

      { loop }
      repeat
        ls := length(s);

        { trim leading whitespace }
        i := 1; while (i<=ls) and (s[i] in whitespace) do inc(i);
        delete(s,1,i-1); dec(ls,i-1);

        { trim trailing whitespace }
        i := ls; while (i>0) and (s[i] in whitespace) do dec(i);
        delete(s,i+1,255); ls := i;

        { goon only, if sth. is left }
        if (ls=0) then exit;

        { add a space to s, if it is not at the beginning of the line }
        if (outl>ind) then begin s := ' '+s; inc(ls) end;

        { determine how much may be added to out w/o overriding width }
        i := width+1-outl;
        if (i>ls) then i := ls else begin
          while (i>0) and (not (s[i] in whitespace)) do dec(i);
          while (i>0) and (s[i] in whitespace) do dec(i)
        end;

        { special case: outl is ind and nothing may be added --> overflow
          --> don't care about white spaces }
        if (outl=ind) and (i=0) then i := width-outl;

        { add to out and remove from s }
        out := out+copy(s,1,i); inc(outl,i);
        delete(s,1,i); dec(ls,i);

        { show line, if sth. has been cut }
        if (ls>0) then begin
          outline(f,out,false);
          newline
        end else exit

      until (false)
    end
  end;

  procedure fwr1te(var f: text; s: string);
  var
    i,ls: byte;
    first: boolean;
  begin
    { since this procedure opens a new paragraph, anything currently
      buffered is flushed. remove the indentation }
    fflushln(f);
    out := ''; outl := 0; first := true;

    if (width=0) then write(f,s) else begin
      { replace tabs in s by spaces }
      s := detab(s,8);

      { loop }
      repeat
        ls := length(s);

        { trim leading whitespace for all follow-up lines }
        if (not first) then begin
          i := 1; while (i<=ls) and (s[i] in whitespace) do inc(i);
          delete(s,1,i-1); dec(ls,i-1)
        end;

        { trim trailing whitespace, leave leading ws intact }
        i := ls; while (i>0) and (s[i] in whitespace) do dec(i);
        delete(s,i+1,255); ls := i;

        { goon only, if sth. is left }
        if (ls=0) then exit;

        { determine how much may be added to out w/o overriding width }
        i := width+1-outl;
        if (i>ls) then i := ls else begin
          while (i>0) and (not (s[i] in whitespace)) do dec(i);
          while (i>0) and (s[i] in whitespace) do dec(i)
        end;

        { special case: outl is 0 and nothing may be added --> overflow
          --> don't care about white spaces }
        if (outl=0) and (i=0) then i := width-outl;

        { add to out and remove from s }
        out := out+copy(s,1,i); inc(outl,i);
        delete(s,1,i); dec(ls,i);

        { show line, if sth. has been cut }
        if (ls>0) then begin
          outline(f,out,false);
          newline
        end else exit;

        first := false

      until (false)
    end
  end;

  procedure fflushln(var f: text);
  begin
    if (outl>ind) then begin
      outline(f,out,true);
      newline
    end
  end;

  procedure fwriteln(var f: text; s: string);
  begin
    if (width=0) then writeln(f,s) else begin
      fwrite(f,s);
      outline(f,out,true);
      newline
    end
  end;

  procedure fwr1teln(var f: text; s: string);
  begin
    if (width=0) then writeln(f,s) else begin
      fwr1te(f,s);
      outline(f,out,true);
      newline
    end
  end;

  procedure fignore(var f: text; s: string);
  begin
    if (width=0) then writeln(f,s) else begin
      fflushln(f);
      writeln(f,s)
    end
  end;

begin
  outl := 0;
  out := '';
  width := 79;
  ind := 0;
  mode := m_left
end.
@


1.2
log
@in blockset mode the first 10 random numbers are skipped
  because they don't please me
@
text
@d2 1
a2 1
{ $Id: TEXTFMT.PAS 1.1 1993/01/22 00:55:08 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 5
a29 1
        $Log: TEXTFMT.PAS $
d40 1
a40 1
    pversion = '$Id: TEXTFMT.PAS 1.1 1993/01/22 00:55:08 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id$ }
d25 3
a27 1
        $Log$
d36 1
a36 1
    pversion = '$Id$';
a104 1
        {randomize;}
d110 3
@

