head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.04.05.20.01.08;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.03.19.17.34.51;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.22.00.54.38;	author Ricki;	state Exp;
branches;
next	;


desc
@various calculations concerning times
@

1.3
log
@address change
@
text
@{$I SWITCHES.INC}
{ $Id: times.pas 1.2 1993/03/19 17:34:51 Ricki Exp $ }
unit Times;
{ various calculations concerning times }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: times.pas $
        Revision 1.2  1993/03/19  17:34:51  Ricki
        new function time2sstr

        Revision 1.1  1993/01/22  00:54:38  Ricki
        Initial revision
}

interface

  const
    pversion = '$Id: times.pas 1.2 1993/03/19 17:34:51 Ricki Exp $';

  type
    timestring = string[12]; { eg. hh:mm:ss.dd }

  {
  function validtime(day,month,year: integer): boolean;
  procedure adddays(var day,month,year: integer; add: longint);
  procedure dayinyear2dmy(year,diy: integer; var day,month: integer);
  function daydiff(d1,m1,y1,d2,m2,y2: integer): longint;
  }
    {
      validdate     returns whether a date is ok; accounts for the
                    reformation and leap years; valid dates may be in
                    the range 1/1/1..9/2/1752,9/14/1752..12/31/2999
      adddays       computes day,month,year for an addition of add days;
                    note: add may be negative; note: adddays does also
                    work when the reformation date Sep 1752 is stepped over
      dayinyear2dmy computes day,month from the given day_in_year diy
      daydiff       computes the difference d1.m1.y1-d2.m2.y2 in days;
                    note: the difference may (of course) be negative;
                    note: daydiff does also work if the reformation date
                    Sep 1752 is stepped over
    }

  function time2str(hour,minute,second,hundreds: integer): timestring;
  function time2sstr(hour,minute,second: integer): timestring;
  function time2ampm(hour,minute,second: integer): timestring;
  function curtime: timestring;
  function curampm: timestring;
    {
      time2str      returns a string hh:mm:ss.dd
      time2sstr     returns a string hh:mm:ss
      time2ampm     returns a string hh:mm:ss am/pm (American)

      curtime       returns a string hh:mm:ss.dd
      curampm       returns a string hh:mm:ss am/pm (American)
    }

implementation

  uses
    numbers,
    dos;

  function time2str(hour,minute,second,hundreds: integer): timestring;
  begin
    time2str := zerostr(hour,2)    +':'+
                zerostr(minute,2)  +':'+
                zerostr(second,2)  +'.'+
                zerostr(hundreds,2)
  end;

  function time2sstr(hour,minute,second: integer): timestring;
  begin
    time2sstr := zerostr(hour,2)    +':'+
                 zerostr(minute,2)  +':'+
                 zerostr(second,2)
  end;

  function time2ampm(hour,minute,second: integer): timestring;
  begin
    if (hour>11) then
      time2ampm := zerostr(hour,2)    +':'+
                   zerostr(minute,2)  +':'+
                   zerostr(second,2)  +' pm'
    else
      time2ampm := zerostr(hour,2)    +':'+
                   zerostr(minute,2)  +':'+
                   zerostr(second,2)  +' am'
  end;

  function curtime: timestring;
  var
    h,m,s,d: word;
  begin
    gettime(h,m,s,d);
    curtime := time2str(h,m,s,d)
  end;

  function curampm: timestring;
  var
    h,m,s,d: word;
  begin
    gettime(h,m,s,d);
    curampm := time2ampm(h,m,s)
  end;

end.
@


1.2
log
@new function time2sstr
@
text
@d2 1
a2 1
{ $Id: TIMES.PAS 1.1 1993/01/22 00:54:38 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 4
a28 1
        $Log: TIMES.PAS $
d36 1
a36 1
    pversion = '$Id: TIMES.PAS 1.1 1993/01/22 00:54:38 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id$ }
d25 3
a27 1
        $Log$
d33 1
a33 1
    pversion = '$Id$';
d59 1
d65 1
d84 7
@

