head	1.4;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.4
date	93.04.11.17.21.32;	author Ricki;	state Exp;
branches;
next	1.3;

1.3
date	93.03.31.19.23.25;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.03.19.17.15.58;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.03.09.12.43.16;	author Ricki;	state Exp;
branches;
next	;


desc
@Advanced SET command
@

1.4
log
@inserted missing 'pversion' declaration
@
text
@{$I SWITCHES.INC}
{ $Id: aset.pas 1.3 1993/03/31 19:23:25 Ricki Exp $ }
program aset;
{ Advanced SET command }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: aset.pas $
        Revision 1.3  1993/03/31  19:23:25  Ricki
        update to new email address

        Revision 1.2  1993/03/19  17:15:58  Ricki
        *** empty log message ***

        Revision 1.1  1993/03/09  12:43:16  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  strings,
  numbers,
  standard,
  dates,
  times,
  files,
  math,
  outcon,
  outstd,
  options,
  cmscan,
  keyboard,
  LexLib,
  YaccLib,
  tsuntenv,tsuntg,tsunth,tsuntk,
  crt,
  dos;

const
  pversion = '$Id: aset.pas 1.3 1993/03/31 19:21:24 Ricki Exp $';

  func = 'Advanced SET command';
  year = '1992,1993';
  desn = 'ASET/2';
  desv = '1.0';
  opts = 'ef:hHnprv*'; ropt = 'e:f:hHn:p:r:v*:';

  boochar: array [boolean] of char = ('0','1');
  dfactor = pi/180.0;
  rfactor = 180.0/pi;
  rprompt = '> ';

  {$I aseto.def} { opcodes }

type
  Pstrg = ^string;
  Ttype = (t_string,t_real,t_integer,t_boolean); { DO NOT CHANGE THE ORDER,
                                                   because it implies: Each
                                                   boolean's an integer,
                                                   each integer's a real,
                                                   each real's a string }
  Tvalue = record
    vs: string;
    vi: longint;
    vr: real;
    vb: boolean
  end;

  Tcmp = (cmp_eq,cmp_ne,cmp_lt,cmp_le,cmp_gt,cmp_ge);
  Tboo = (boo_and,boo_or,boo_nand,boo_nor,boo_xor);

var
  excode: word;
  stack: array [1..pmax] of Pstrg;
  vr1,vr2,vr3,vr4: Tvalue;
  p,i,Sn: integer;
  fname,cmd: string;
  f: text;
  opt_r,opt_n,opt_e,opt_p,opt_f: boolean;
  nopt,nnam: byte;
  debug: boolean;
  lineno: longint;

  {--- replacements for lexlibs and yacclibs procedures ---------------------}
  function input: char;
  begin
    inc(p);
    if (p>length(cmd)) then input := #0
                       else input := cmd[p]
  end;

  procedure unput(c: char);
  begin if (p>0) then dec(p) end;

  procedure yymsg(msg : string);
  begin
    if (lineno>0) then warn(msg+' in line '+numstr(lineno))
                       else warn(msg)
  end;

  {--- general purpose procedures -------------------------------------------}
  procedure Passign(var p: Pstrg; s: string);
  { assign s to p^, getting memory for it }
  begin
    { check if there's enough RAM available }
    if (maxavail<1+length(s)) then err('Heap overflow');
    { get mem and store string }
    getmem(p,1+length(s));
    p^ := s
  end;

  function vtype(s: string; var vr: Tvalue): Ttype;
  { determine the type of s, evaluating its representations }
  var
    cl,cr: integer;
  begin
    { determine all possible values that s represents }
    vr.vs := s;                         { string value }
    val(s,vr.vr,cr);                    { real value }
    val(s,vr.vi,cl);                    { integer value }

    { determine the type of s and simulate the other values, if necessary }
    if (cl<>0) then begin
      if (cr<>0) then begin
        vtype := t_string;
        vr.vr := 0.0;
        vr.vi := 0;
        vr.vb := false
      end else begin
        vtype := t_real;
        vr.vi := round(vr.vr);
        vr.vb := (vr.vi<>0)
      end
    end else begin
      vr.vb := (vr.vi<>0);
      if (vr.vi=0) or (vr.vi=1) then vtype := t_boolean
                                else vtype := t_integer
    end
  end;

  function mintype(t1,t2: Ttype): Ttype;
  { determine the minmum of t1 and t2 }
  begin
    if (t1<t2) then mintype := t1 else mintype := t2
  end;

  procedure scandate(d: string; var day,month,year: word; var ok: boolean);
  { recognized: dd.mm.yyyy, mm-dd-yyyy, mm/dd/yyyy }
    procedure subscan(d: string; c: char; var w1,w2,w3: word; var ok: boolean);
    var
      p,code: integer;
    begin
      ok := false;
      p := pos(c,d); if (p<2) then exit;
      val(copy(d,1,p-1),w1,code); if (code<>0) then exit;
      d := copy(d,p+1,255);
      p := pos(c,d); if (p<2) then exit;
      val(copy(d,1,p-1),w2,code); if (code<>0) then exit;
      val(copy(d,p+1,255),w3,code); if (code<>0) then exit;
      ok := true
    end;
  begin
    subscan(d,'-',month,day,year,ok);
    if (ok) then begin
      ok := validdate(day,month,year);
      exit
    end;
    subscan(d,'/',month,day,year,ok);
    if (ok) then begin
      ok := validdate(day,month,year);
      exit
    end;
    subscan(d,'.',day,month,year,ok);
    if (ok) then begin
      ok := validdate(day,month,year);
      exit
    end
  end;

  procedure rep2(fn,s1,s2: string);
  var
    vr: Tvalue;
  begin
    writeln(conout,'       Evaluate intrinsic function ',fn);
    case vtype(s1,vr) of
      t_string : write(conout,'       Strg');
      t_real   : write(conout,'       Real');
      t_integer: write(conout,'       Intg');
      t_boolean: write(conout,'       Bool')
    end;
    writeln(conout,' arg #1 is (''',vr.vs,''';',
                                    numrstr(vr.vr),';',
                                    vr.vi,';',
                                    vr.vb,')');
    case vtype(s2,vr) of
      t_string : write(conout,'       Strg');
      t_real   : write(conout,'       Real');
      t_integer: write(conout,'       Intg');
      t_boolean: write(conout,'       Bool')
    end;
    writeln(conout,' arg #2 is (''',vr.vs,''';',
                                    numrstr(vr.vr),';',
                                    vr.vi,';',
                                    vr.vb,')');
  end;

  procedure rep1(fn,s1: string);
  var
    vr: Tvalue;
  begin
    writeln(conout,'       Evaluate intrinsic function ',fn);
    case vtype(s1,vr) of
      t_string : write(conout,'       Strg');
      t_real   : write(conout,'       Real');
      t_integer: write(conout,'       Intg');
      t_boolean: write(conout,'       Bool')
    end;
    writeln(conout,' arg #1 is (''',vr.vs,''';',
                                    numrstr(vr.vr),';',
                                    vr.vi,';',
                                    vr.vb,')')
  end;

  {--- the procedure which does the work :-) --------------------------------}
  procedure setenv(t,v: string);
  { perform a SET t=v command }
  var
    code: byte;
    vr: Tvalue;
  begin
    t := strupcase(t);
    if (opt_n) then code := 0
    else begin
      { delete the old value if any, to save env space }
      tsuntenv.setenv(t+'=',code);
      { set the new value }
      if (code=0) then tsuntenv.setenv(t+'='+v,code)
    end;
    case code of
      0: begin
        { echo? }
        if (opt_p) then writeln(stdout,t,'=',v);
        { set errorlevel? }
	if (opt_e) then begin
          { determine the data type of v }
	  case vtype(v,vr) of
            t_boolean,t_integer,t_real: begin
	      vr.vi := abs(vr.vi);
              if (vr.vi>255) then excode := 255
              		     else excode := vr.vi
            end;
            t_string: begin
              if (vr.vs='') then excode := 0
              		    else excode := ord(vr.vs[1])
            end
          end;
          { echo? }
          if (opt_p) then writeln(stdout,'ERRORLEVEL=',excode);
        end
      end;
      1: yymsg('Syntax error executing "SET '+t+'='+v+'"');
      2: yymsg('Out of environment space');
      3: yymsg('Missed the variable or the environment')
    end
  end;

  {--- help and option handling ---------------------------------------------}
  {$i aset.i1}
  {$i aset.i2}

  procedure help1;
  begin
    header(desv,year,func);
    aseti1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    aseti2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  {--- option handling ------------------------------------------------------}
  procedure pre_op;
  begin
    opt_r := false; opt_e := false; opt_f := false;
    opt_p := false; opt_n := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  procedure proc_op;
  var
    i: byte;
  begin
    setlazy(true);
    parse(ropt,nopt,nnam);
    if (nopt+nnam=0) then help1;
    for i:=1 to nopt do begin
      case getopt(i) of
	'e': if (optarg<>'') then err('Combined options not allowed')
			     else opt_e := true;
        'f': begin opt_f := true; fname := optarg end;
	'n': if (optarg<>'') then err('Combined options not allowed')
			     else opt_n := true;
	'p': if (optarg<>'') then err('Combined options not allowed')
			     else opt_p := true;
	'r': if (optarg<>'') then err('Combined options not allowed')
			     else opt_r := true;

        'h': help1;
        'H': help2;
        'v': version;
	'*': if (optarg<>'') then err('Combined options not allowed')
			     else debug := true
      end
    end
  end;

  procedure post_op;
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    if (opt_f) and (opt_e) then err('-f and -e are mutually exclusive');
    if (opt_n) and (not opt_e) then opt_p := true
  end;

  {--- evaluation procedures ------------------------------------------------}
  function f_add(s1,s2: string): string;
  begin
    if (debug) then rep2('+',s1,s2);
    case mintype(vtype(s1,vr1),vtype(s2,vr2)) of
      t_boolean,t_integer: f_add := numstr(vr1.vi+vr2.vi);
      t_real:              f_add := numrstr(vr1.vr+vr2.vr);
      t_string:            f_add := vr1.vs+vr2.vs
    end
  end;

  function f_sub(s1,s2: string): string;
  var
    s: string;
  begin
    if (debug) then rep2('-',s1,s2);
    case mintype(vtype(s1,vr1),vtype(s2,vr2)) of
      t_boolean,t_integer: f_sub := numstr(vr1.vi-vr2.vi);
      t_real:              f_sub := numrstr(vr1.vr-vr2.vr);
      t_string: begin
        s := vr1.vs;
        substall(vr2.vs,'',s);
        f_sub := s
      end
    end
  end;

  function f_mult(s1,s2: string): string;
  begin
    if (debug) then rep2('*',s1,s2);
    case mintype(vtype(s1,vr1),vtype(s2,vr2)) of
      t_boolean,t_integer: f_mult := numstr(vr1.vi*vr2.vi);
      t_real:              f_mult := numrstr(vr1.vr*vr2.vr);
      t_string:            f_mult := '?'
    end
  end;

  function f_div(s1,s2: string): string;
  begin
    if (debug) then rep2('div',s1,s2);
    case mintype(vtype(s1,vr1),vtype(s2,vr2)) of
      t_boolean,t_integer,t_real: if (vr2.vi<>0) then f_div := numstr(vr1.vi div vr2.vi)
                                                 else f_div := '?';
      t_string:                   f_div := '?'
    end
  end;

  function f_rdiv(s1,s2: string): string;
  begin
    if (debug) then rep2('/',s1,s2);
    case mintype(vtype(s1,vr1),vtype(s2,vr2)) of
      t_boolean,t_integer,t_real: f_rdiv := numrstr(vr1.vr/vr2.vr);
      t_string:                   f_rdiv := '?'
    end
  end;

  function f_mod(s1,s2: string): string;
  begin
    if (debug) then rep2('mod',s1,s2);
    case mintype(vtype(s1,vr1),vtype(s2,vr2)) of
      t_boolean,t_integer,t_real: f_mod := numstr(vr1.vi mod vr2.vi);
      t_string:                   f_mod := '?'
    end
  end;

  function f_pot(s1,s2: string): string;
  begin
    if (debug) then rep2('^',s1,s2);
    if (vtype(s1,vr1)=t_string) then f_pot := '?'
    else case vtype(s2,vr2) of
      t_boolean,t_integer: f_pot := numrstr(ipot(vr1.vr,vr2.vi));
      t_real:              if (eq(vr1.vr,0.0)) then  f_pot := '0'
      			   else if (vr1.vr<0.0) then f_pot := '?'
			   else f_pot := numrstr(pot(vr1.vr,vr2.vr));
      t_string:            f_pot := '?'
    end
  end;

  function f_compare(s1,s2: string; cmp: Tcmp): string;
  begin
    if (debug) then rep2('[Compare #'+numstr(ord(cmp))+']',s1,s2);
    case mintype(vtype(s1,vr1),vtype(s2,vr2)) of
      t_boolean,t_integer: case cmp of
        cmp_eq: f_compare := boochar[vr1.vi= vr2.vi];
        cmp_ne: f_compare := boochar[vr1.vi<>vr2.vi];
        cmp_lt: f_compare := boochar[vr1.vi< vr2.vi];
        cmp_le: f_compare := boochar[vr1.vi<=vr2.vi];
        cmp_gt: f_compare := boochar[vr1.vi> vr2.vi];
        cmp_ge: f_compare := boochar[vr1.vi>=vr2.vi];
      end;
      t_real: case cmp of
        cmp_eq: f_compare := boochar[    eq(vr1.vr,vr2.vr)];
        cmp_ne: f_compare := boochar[not eq(vr1.vr,vr2.vr)];
        cmp_lt: f_compare := boochar[not eq(vr1.vr,vr2.vr) and (vr1.vr<vr2.vr)];
        cmp_le: f_compare := boochar[    eq(vr1.vr,vr2.vr) or  (vr1.vr<vr2.vr)];
        cmp_gt: f_compare := boochar[not eq(vr1.vr,vr2.vr) and (vr1.vr>vr2.vr)];
        cmp_ge: f_compare := boochar[    eq(vr1.vr,vr2.vr) or  (vr1.vr>vr2.vr)];
      end;
      t_string: case cmp of
        cmp_eq: f_compare := boochar[vr1.vs= vr2.vs];
        cmp_ne: f_compare := boochar[vr1.vs<>vr2.vs];
        cmp_lt: f_compare := boochar[vr1.vs< vr2.vs];
        cmp_le: f_compare := boochar[vr1.vs<=vr2.vs];
        cmp_gt: f_compare := boochar[vr1.vs> vr2.vs];
        cmp_ge: f_compare := boochar[vr1.vs>=vr2.vs];
      end;
    end
  end;

  function f_boolean(s1,s2: string; boo: Tboo): string;
  begin
    if (debug) then rep2('[Logical #'+numstr(ord(boo))+']',s1,s2);
    case mintype(vtype(s1,vr1),vtype(s2,vr2)) of
      t_boolean: case boo of
        boo_and : f_boolean := boochar[vr1.vb and     vr2.vb];
        boo_or  : f_boolean := boochar[vr1.vb or      vr2.vb];
        boo_nand: f_boolean := boochar[vr1.vb and not vr2.vb];
        boo_nor : f_boolean := boochar[vr1.vb or not  vr2.vb];
        boo_xor : f_boolean := boochar[vr1.vb xor     vr2.vb]
      end;
      t_integer: case boo of
        boo_and : f_boolean := numstr(vr1.vi and     vr2.vi);
        boo_or  : f_boolean := numstr(vr1.vi or      vr2.vi);
        boo_nand: f_boolean := numstr(vr1.vi and not vr2.vi);
        boo_nor : f_boolean := numstr(vr1.vi or not  vr2.vi);
        boo_xor : f_boolean := numstr(vr1.vi xor     vr2.vi)
      end;
      t_real,t_string: f_boolean := '?'
    end
  end;

  function f_minus(s: string): string;
  begin
    if (debug) then rep1('unary -',s);
    case vtype(s,vr1) of
      t_boolean,t_integer: f_minus := numstr(-vr1.vi);
      t_real:              f_minus := numrstr(-vr1.vr);
      t_string:            f_minus := strflip(vr1.vs)
    end
  end;

  function f_not(s: string): string;
  begin
    if (debug) then rep1('not',s);
    case vtype(s,vr1) of
      t_boolean:       f_not := boochar[not vr1.vb];
      t_integer:       f_not := numstr(not vr1.vi);
      t_real,t_string: f_not := '?'
    end
  end;

  {--- support procedures for generic functions -----------------------------}
  procedure Spush(s: string);
  { push s on the stack }
  begin
    inc(Sn); if (Sn>pmax) then
      err('Stack overflow: too many function arguments');
    Passign(stack[Sn],s)
  end;

  function Spop: string;
  { return the uppermost string from the stack, #0, if none }
  begin
    if (Sn=0) then Spop := #0
    else begin
      Spop := stack[Sn]^;
      freemem(stack[Sn],1+length(stack[Sn]^));
      dec(Sn)
    end
  end;

  function Sget(i: integer): string;
  { read the i-th value from the stack without deleting it. i=Sn is the
    topmost string. #0, if none }
  begin
    if (i<=0) or (i>Sn) then Sget := #0
                        else Sget := stack[i]^
  end;

  procedure Sput(i: integer; s: string);
  { write the i-th value of the stack, which must already exist. i=Sn is the
    topmost string. No action, if i illegal }
  begin
    if (i>0) and (i<=Sn) then begin
      freemem(stack[i],1+length(stack[i]^));
      Passign(stack[i],s)
    end
  end;

  procedure Skill;
  { kills the stack and sets Sn=0 }
  begin
    while (Sn>0) do begin
      freemem(stack[Sn],1+length(stack[Sn]^));
      dec(Sn)
    end
  end;

  function check(fn: integer): boolean;
  { return true, if the arguments on the stack fit to the definition of fn }
  var
    typ: string;
    i: integer;
    vr: Tvalue;
  begin with ops[fn] do begin
    if (debug) then begin
      writeln(conout,'       Evaluate function ',name,
                     ' (mina=',mina,', maxa=',maxa,', atyp=',atyp,')');
      for i:=1 to Sn do begin
        case vtype(Sget(i),vr) of
          t_string : write(conout,'       Strg');
          t_real   : write(conout,'       Real');
          t_integer: write(conout,'       Intg');
          t_boolean: write(conout,'       Bool')
        end;
        writeln(conout,' arg #',i,' is (''',vr.vs,''';',
                                            numrstr(vr.vr),';',
                                            vr.vi,';',
                                            vr.vb,')')
      end
    end;

    check := false;

    if (Sn<mina) or (Sn>maxa) then exit;

    { if not all types are specified, duplicate the last character of typ
      so that it is applied to all remaining arguments }
    typ := atyp;
    if (length(typ)<maxa) then begin
      fillchar(typ[1+length(typ)],maxa-length(typ),typ[length(typ)]);
      typ[0] := chr(maxa)
    end;

    { check argument types }
    for i:=1 to sn do case vtype(Sget(i),vr) of
      t_integer: if (pos(typ[i],'irs')=0) then exit;
      t_real: if (pos(typ[i],'rs')=0) then exit;
      t_string: if (pos(typ[i],'s')=0) then exit
    end;

    check := true
  end end;

  procedure get4;
  { get the uppermost (up to) 4 values from the stack and store them
    in vr1..v4 - vr4 (..or 3,2,1) storing the stack top }
  begin
    if (Sn=0) then exit else if (vtype(Sget(Sn-0),vr1)=t_string) then ;
    if (Sn=1) then exit else if (vtype(Sget(Sn-1),vr2)=t_string) then ;
    if (Sn=2) then exit else if (vtype(Sget(Sn-2),vr3)=t_string) then ;
    if (Sn=3) then exit else if (vtype(Sget(Sn-3),vr4)=t_string) then ;
  end;

  function str2drive(var s: string): byte;
  { check if a string contains a valid drive spec and return the appropriate
    byte value, 255 on error }
  begin
    str2drive := 255;
    if (length(s)=0) then exit;
    s[1] := upcase(s[1]);
    if (s[1]<'A') or (s[1]>'Z') then exit;
    if (length(s)>1) and (s[2]<>':') then exit;
    str2drive := ord(s[1])+1-ord('A')
  end;

  function getdrive: char;
  { return the character specifying the current drive, ? on error }
  var
    s: string;
  begin
{$IFDEF DEBUG}{$i-}{$ENDIF}
    getdir(0,s);
{$IFDEF DEBUG}{$i+}{$ENDIF}
    if (ioresult<>0) then getdrive := '?'
                     else getdrive := s[1]
  end;

{$IFDEF DEBUG}{$i-}{$ENDIF}
  function uniquename(dir: pathstr): pathstr;
  { return a unique name in directory dir, '?' on error }
  const
    maxtries = 10;
  var
    i,tries: integer;
    s: namexstr;
    f: file;
    ok: boolean;
  begin
    tries := 0; s := '00000000.TMP';
    { append a \ to dir, if necessary }
    if (dir<>'') then
      if (dir[length(dir)]<>'\') then dir := dir+'\';
    { try for at most maxtries times to create a unique filename }
    repeat
      inc(tries);
      randomize;
      for i:=1 to 8 do s[i] := chr(random(9)+ord('0'));
      assign(f,dir+s); reset(f,1);
      ok := (ioresult=2); { file not found }
      if (not ok) then begin
        close(f);
        { exit if somethings wrong }
        if (ioresult<>0) then tries := maxtries
      end
    until (ok) or (tries=maxtries);
    if (not ok) then uniquename := '?'
                else uniquename := dir+s
  end;
{$IFDEF DEBUG}{$i+}{$ENDIF}

  function config_search(start: string; var str: string): integer;
  { looks for start (eg. 'DEVICE=') in CONFIG.SYS at the beginning of all
    lines, then for str somewhere behind and returns the line number (0,
    if start*str not found). If str could be found, it is replaced by the
    contents of the line after start. start and str may not contain spaces! }
  var
    c: char;
    found: boolean;
    f: text;
    l: integer;
    i,j: byte;
    s,sv: string;
  begin
    { determine the boot drive (where CONFIG.SYS should be) }
    c := upcase(bootdrfn);
    if (c<'A') or (c>'Z') then { try C: } c := 'C';
{$IFDEF DEBUG}{$i-}{$ENDIF}
    assign(f,c+':\CONFIG.SYS'); reset(f);
{$IFDEF DEBUG}{$i+}{$ENDIF}
    if (ioresult<>0) then begin
      { try C: } c := 'C';
{$IFDEF DEBUG}{$i-}{$ENDIF}
      assign(f,c+':\CONFIG.SYS'); reset(f)
{$IFDEF DEBUG}{$i+}{$ENDIF}
    end;
    if (ioresult<>0) then config_search := 0
    else begin
      start := strupcase(start); str := strupcase(str);
      found := false; l := 0;
      while (not eof(f)) and (not found) do begin
        readln(f,s); inc(l);
        sv := strupcase(trim(s,[' ']));
        found := (copy(sv,1,length(start))=start)
             and ( (str='') or (pos(str,sv)>0) )
      end;
      close(f);
      if (found) then begin
        { count the whitespaces in s until the length of start }
        i := 1; j := 1;
        while (i<=length(start)) do begin
          if (s[i] in whitespace) then inc(j);
          inc(i)
        end;
	{ return the relevant part of the string }
        str := copy(s,j+length(start),255);
        config_search := l
      end else config_search := 0
    end
  end;

  procedure config_sys(searchfor: string; var s: string);
  { looks for searchfor (eg. 'BUFFERS=') in CONFIG.SYS and returns in s
    the string following searchfor. s='', if error or not found }
  begin s := ''; if (config_search(searchfor,s)<>0) then ;
  end;

  function words(l: string): word;
  { returns the number of words in l }
  var
    i,len: integer;
    w: word;
  begin
    i := 1; len := 0; w := 0;
    while (i<=length(l)) do begin
      if (l[i]=' ') or (l[i]=#9) then begin
        if (len>0) then begin inc(w); len := 0 end
      end else inc(len);
      inc(i)
    end;
    if (len>0) then inc(w);
    words := w
  end;

  function pickword(l: string; n: word): string;
  { returns the n-th word from l, '' if none }
  var
    i,len: integer;
  begin
    i := 1; len := 0;
    while (i<=length(l)) do begin
      if (l[i]=' ') or (l[i]=#9) then begin
        if (len>0) then begin
          if (n=1) then begin pickword := copy(l,i-len,len); exit end;
          dec(n); len := 0;
        end
      end else inc(len);
      inc(i)
    end;
    if (len>0) and (n=1) then pickword := copy(l,i-len,len)
                         else pickword := ''
  end;

  {--- evaluation procedure for generic functions ---------------------------}
  function f_generic(fn: integer): string;
  { returns ? on error (in the most cases) }
  var
    i1,i2: longint;
    d1: integer;
    w1,w2,w3,w4: word;
    b1: boolean;
    c1: char;
    s1: byte;
    r1,r2: real;
    dt: datetime;
    z1: string;
    f1: text;
  begin
    { the special case function() is treated as function w/o args }
    if (Sn=1) and (Sget(1)='') then Skill;

    { check arguments and get the first (up to) 4 }
    if (not check(fn)) then begin
      f_generic := '?';
      exit
    end;
    get4;

    { eval function }
    case fn of

{----------------------------------------------------------------------------}
{				MATH FUNCTIONS				     }
{----------------------------------------------------------------------------}
{-->} OP_ABS: f_generic := numrstr(abs(vr1.vr));
{-->} OP_ARCCOS,OP_ACOS: begin
        if (eq(abs(vr1.vr),1.0)) then  f_generic := '0'
        else if (abs(vr1.vr)>1.0) then f_generic := '?'
        			  else f_generic := numrstr(arccos(vr1.vr))
      end;
{-->} OP_ARCSIN,OP_ASIN: begin
        if (eq(vr1.vr,1.0)) then       f_generic := numrstr(0.5*pi)
        else if (eq(vr1.vr,-1.0)) then f_generic := numrstr(-0.5*pi)
        else if (abs(vr1.vr)>1.0) then f_generic := '?'
        			  else f_generic := numrstr(arcsin(vr1.vr))
      end;
{-->} OP_ARCTAN,OP_ATAN: f_generic := numrstr(arctan(vr1.vr));
{-->} OP_ARCCOSD,OP_ACOSD: begin
        if (eq(abs(vr1.vr),1.0)) then  f_generic := '0'
        else if (abs(vr1.vr)>1.0) then f_generic := '?'
        			  else f_generic := numrstr(rfactor*arccos(vr1.vr))
      end;
{-->} OP_ARCSIND,OP_ASIND: begin
        if (eq(vr1.vr,1.0)) then       f_generic := '90'
        else if (eq(vr1.vr,-1.0)) then f_generic := '-90'
        else if (abs(vr1.vr)>1.0) then f_generic := '?'
        			  else f_generic := numrstr(rfactor*arcsin(vr1.vr))
      end;
{-->} OP_ARCTAND,OP_ATAND: f_generic := numrstr(rfactor*arctan(vr1.vr));
{-->} OP_COS: f_generic := numrstr(cos(vr1.vr));
{-->} OP_COSD: f_generic := numrstr(cos(dfactor*vr1.vr));
{-->} OP_COSH: f_generic := numrstr(0.5*(exp(vr1.vr)+exp(-vr1.vr)));
{-->} OP_E: f_generic := numrstr(exp(1.0));
{-->} OP_EPS: f_generic := numrstr(eps);
{-->} OP_EVEN: f_generic := boochar[not odd(vr1.vi)];
{-->} OP_EXP: f_generic := numrstr(exp(vr1.vr));
{-->} OP_FAC: begin
        i1 := 1;
        if (vr1.vi<0)
          then while (vr1.vi<0) do begin i1 := i1*vr1.vi; inc(vr1.vi) end
          else while (vr1.vi>1) do begin i1 := i1*vr1.vi; dec(vr1.vi) end;
        f_generic := numstr(i1)
      end;
{-->} OP_FRAC: f_generic := numrstr(frac(vr1.vr));
{-->} OP_INT,OP_TRUNC: f_generic := numrstr(int(vr1.vr));
{-->} OP_LN: begin
        if (vr1.vr<0.0) or (eq(vr1.vr,0.0)) then f_generic := '?'
        else f_generic := numrstr(ln(vr1.vr))
      end;
{-->} OP_LOG: begin
        { error cases }
        if (vr1.vr<eps) or (vr2.vr<eps)
        or (eq(vr2.vr,1.0)) then f_generic := '?'
        else begin
          if (eq(vr1.vr,1.0)) then f_generic := '0'
                              else f_generic := numrstr(ln(vr1.vr)/ln(vr2.vr))
        end
      end;
{-->} OP_ODD: f_generic := boochar[odd(vr1.vi)];
{-->} OP_PI: f_generic := numrstr(pi);
{-->} OP_RANDOM,OP_RND: begin
        Randomize;
        if (Sn=0) then f_generic := numrstr(random)
        else if (vr1.vi<0) then f_generic := '0'
        else begin
	  if (vr1.vi>65535) then w1 := 65535
	     		    else w1 := vr1.vi;
	  f_generic := numstr(random(w1))
        end
      end;
{-->} OP_ROUND: f_generic := numrstr(round(vr1.vr));
{-->} OP_SIGN,OP_SGN: if (eq(vr1.vr,0.0)) then  f_generic := '0'
                      else if (vr1.vr>0.0) then f_generic := '1'
                                           else f_generic := '-1';
{-->} OP_SIN: f_generic := numrstr(sin(vr1.vr));
{-->} OP_SIND: f_generic := numrstr(sin(dfactor*vr1.vr));
{-->} OP_SINH: f_generic := numrstr(0.5*(exp(vr1.vr)-exp(-vr1.vr)));
{-->} OP_SQR: f_generic := numrstr(sqr(vr1.vr));
{-->} OP_SQRT: begin
	if (eq(vr1.vr,0.0)) then  f_generic := '0'
        else if (vr1.vr<0.0) then f_generic := '?'
        		     else f_generic := numrstr(sqrt(vr1.vr))
      end;
{-->} OP_TAN: begin
        r1 := cos(vr1.vr);
        if (eq(r1,0.0)) then f_generic := '?'
        		else f_generic := numrstr(sin(vr1.vr)/r1)
      end;
{-->} OP_TAND: begin
        r1 := cos(dfactor*vr1.vr);
        if (eq(r1,0.0)) then f_generic := '?'
        		else f_generic := numrstr(sin(dfactor*vr1.vr)/r1)
      end;
{-->} OP_TANH: f_generic := numrstr((exp(vr1.vr)-exp(-vr1.vr))
                                   /(exp(vr1.vr)+exp(-vr1.vr)));

{----------------------------------------------------------------------------}
{	    FUNCTIONS RETURNING INFORMATION ABOUT FILES AND DISKS	     }
{----------------------------------------------------------------------------}
{-->} OP_DIR: begin
        if (Sn=0)
{$IFDEF DEBUG}{$i-}{$ENDIF}
	  then getdir(0,z1)
          else getdir(str2drive(vr1.vs),z1);
{$IFDEF DEBUG}{$i+}{$ENDIF}
        if (ioresult<>0) then f_generic := '?'
        		 else f_generic := z1
      end;
{-->} OP_DISKFREE,OP_DFREE,
      OP_DISKSIZE,OP_DSIZE,
      OP_LABEL,OP_VOLUME: begin
        if (Sn=0) then vr1.vs := getdrive;
        diskinfo(vr1.vs[1],z1,i1,i2,w1);
        if (i1<0) or (i2<0) then f_generic := '?'
	else case fn of
          OP_DISKFREE,OP_DFREE: f_generic := numstr(i2);
          OP_DISKSIZE,OP_DSIZE: f_generic := numstr(i1);
          OP_LABEL,OP_VOLUME:   f_generic := z1
        end
      end;
{-->} OP_DOSPATH: begin
        z1 := fexpand(FSearch(vr1.vs,GetEnv('PATH')));
        if (z1='') or (z1[length(z1)]='\') then f_generic := '?'
        	   			   else f_generic := z1
      end;
{-->} OP_FILEATTR,OP_FATTR,
      OP_FILEDATE,OP_FDATE,
      OP_FILESIZE,OP_FSIZE,
      OP_FILETIME,OP_FTIME: begin
        fileinfo(vr1.vs,i1,i2,w1,w2);
        if (w2<>0) then f_generic := '?'
        else case fn of
	  OP_FILEATTR,OP_FATTR: f_generic := attr2str(w1);
          OP_FILESIZE,OP_FSIZE: f_generic := numstr(i1);
          OP_FILEDATE,OP_FDATE: begin
            unpacktime(i2,dt);
            f_generic := date2str(dt.day,dt.month,dt.year)
          end;
          OP_FILETIME,OP_FTIME: begin
            unpacktime(i2,dt);
            f_generic := time2sstr(dt.hour,dt.min,dt.sec)
          end
        end
      end;
{-->} OP_FILEDIR,OP_FDIR,
      OP_FILEDRIVE,OP_FDRIVE,
      OP_FILEPATH,OP_FPATH,
      OP_FILEEXT,OP_FEXT,
      OP_FILENAME,OP_FNAME,
      OP_FILENAMEX,OP_FNAMEX: begin
{$IFDEF DEBUG}{$i-}{$ENDIF}
        { the case Sn=0 is only allowed for part of the functions, for the
          others it is avoided by the call of the check procedure }
        if (Sn=0) then getdir(0,vr1.vs);
{$IFDEF DEBUG}{$i+}{$ENDIF}
	if (ioresult<>0) then f_generic := '?'
        else begin
          fsplit(vr1.vs,vr2.vs,vr3.vs,vr4.vs);
          case fn of
            OP_FILEDIR,OP_FDIR: begin
              i1 := length(vr2.vs);
              while (i1>0) and (vr2.vs[i1]='\') do dec(i1);
              i2 := i1;
              while (i2>0) and (vr2.vs[i2]<>'\') do dec(i2);
              if (i2-i1=0) then                       f_generic := ''
              else if (i2=0) and (vr2.vs[2]=':') then f_generic := ''
              else                                    f_generic :=
                                                        copy(vr2.vs,i2+1,i1-i2)
            end;
            OP_FILEDRIVE,OP_FDRIVE: begin
              s1 := str2drive(vr2.vs);
              if (s1=255) then f_generic := '?'
            		else f_generic := chr(s1+ord('A')-1)+':'
            end;
            OP_FILEPATH,OP_FPATH:   f_generic := vr2.vs;
            OP_FILEEXT,OP_FEXT:     f_generic := vr4.vs;
	    OP_FILENAME,OP_FNAME:   f_generic := vr3.vs;
            OP_FILENAMEX,OP_FNAMEX: f_generic := vr3.vs+vr4.vs;
          end
        end
      end;
{-->} OP_FEXPAND,OP_FULLPATH: f_generic := fexpand(vr1.vs);
{-->} OP_ISDIR: f_generic := boochar[isdir(vr1.vs)];
{-->} OP_UNIQUE,OP_TMPNAME: begin
        if (Sn=0) then vr1.vs := '';
        f_generic := uniquename(vr1.vs)
      end;

{----------------------------------------------------------------------------}
{	    		FUNCTIONS ACCESSING CONFIG.SYS			     }
{----------------------------------------------------------------------------}
{-->} OP_BUFFERS: begin
        config_sys('BUFFERS=',vr1.vs);
        { if no BUFFERS line found, search for HIBUFFERS }
        if (vr1.vs='') then config_sys('HIBUFFERS=',vr1.vs);
        if (vr1.vs='') then f_generic := '15' { DOS standard guess }
                       else f_generic := vr1.vs
      end;
{-->} OP_COUNTRY: begin
        config_sys('COUNTRY=',vr1.vs);
        if (vr1.vs='') then f_generic := '001' { DOS standard }
        else begin
          w1 := pos(',',vr1.vs); if (w1=0) then w1 := 1+length(vr1.vs);
          f_generic := copy(vr1.vs,1,w1-1)
        end
      end;
{-->} OP_DEVICE: f_generic := numstr(config_search('DEVICE=',vr1.vs));
{-->} OP_FCBSX: begin
        config_sys('FCBS=',vr1.vs);
        if (vr1.vs='') then f_generic := '4' { DOS standard }
        else begin
          w1 := pos(',',vr1.vs);
          if (w1>1) then f_generic := copy(vr1.vs,1,w1-1)
                    else f_generic := '4' { DOS standard }
        end
      end;
{-->} OP_FCBSY: begin
        config_sys('FCBS=',vr1.vs);
        if (vr1.vs='') then f_generic := '0' { DOS standard }
        else begin
          w1 := pos(',',vr1.vs);
          if (w1>1) then f_generic := copy(vr1.vs,1+w1,255)
                    else f_generic := '0' { DOS standard }
        end
      end;
{-->} OP_FILES: begin
        config_sys('FILES=',vr1.vs);
        if (vr1.vs='') then f_generic := '8' { DOS standard }
                       else f_generic := vr1.vs
      end;
{-->} OP_LASTDRIVE,OP_LASTDRV: begin
        config_sys('LASTDRIVE=',vr1.vs);
        if (vr1.vs='') then f_generic := 'E' { DOS standard }
                       else f_generic := upcase(vr1.vs[1])
      end;
{-->} OP_SHELL: begin
        config_sys('SHELL=',vr1.vs);
        if (vr1.vs='') then begin
          c1 := upcase(bootdrfn);
          if (c1<'A') or (c1>'Z') then c1 := '?';
          f_generic := c1+':\COMMAND.COM'
        end else begin
          w1 := minpos(['/',' ',#9],vr1.vs);
	  if (w1=0) then w1 := 1+length(vr1.vs);
          f_generic := copy(vr1.vs,1,w1-1)
        end
      end;
{-->} OP_STACKX: begin
        config_sys('STACKS=',vr1.vs);
        if (vr1.vs='') then f_generic := '9' { DOS standard }
        else begin
          w1 := pos(',',vr1.vs);
          if (w1>1) then f_generic := copy(vr1.vs,1,w1-1)
                    else f_generic := '9' { DOS standard }
        end
      end;
{-->} OP_STACKY: begin
        config_sys('STACKS=',vr1.vs);
        if (vr1.vs='') then f_generic := '128' { DOS standard }
        else begin
          w1 := pos(',',vr1.vs);
          if (w1>1) then f_generic := copy(vr1.vs,w1+1,255)
                    else f_generic := '128' { DOS standard }
        end
      end;

{----------------------------------------------------------------------------}
{	    			STRING HANDLING				     }
{----------------------------------------------------------------------------}
{-->} OP_CHR,OP_CHAR: begin
        if (vr1.vi<0) or (vr1.vr>255) then f_generic := '?'
	                              else f_generic := chr(vr1.vi)
      end;
{-->} OP_COPY,OP_MID:
      if (vr2.vi<1) or (vr1.vi<0) then f_generic := '?'
                                  else f_generic := copy(vr3.vs,vr2.vi,vr1.vi);
{-->} OP_CONCAT: begin
        z1 := '';
        for i1:=1 to Sn do z1 := z1+Sget(i1);
        f_generic := z1
      end;
{-->} OP_DELETE: if (vr2.vi<1) or (vr1.vi<0) then f_generic := '?'
      else begin
        delete(vr3.vs,vr2.vi,vr1.vi);
        f_generic := vr3.vs
      end;
{-->} OP_INSTR: f_generic := numstr(pos(vr1.vs,vr2.vs));
{-->} OP_LEFT,OP_LEFTSTR:
      if (vr1.vi<0) then f_generic := '?'
                    else f_generic := copy(vr2.vs,1,vr1.vi);
{-->} OP_LEN,OP_LENGTH: if (Sn=0) then f_generic := '0'
				  else f_generic := numstr(length(vr1.vs));
{-->} OP_LOCASE,OP_LOWER: if (Sn=0) then f_generic := ''
				    else f_generic := strlowcase(vr1.vs);
{-->} OP_NTH,OP_PICK: begin
        if (vr2.vi<1) then f_generic := ''
                      else f_generic := pickword(vr1.vs,vr2.vi)
      end;
{-->} OP_ORD,OP_ASC: f_generic := numstr(ord(vr1.vs[1]));
{-->} OP_POS: f_generic := numstr(pos(vr2.vs,vr1.vs));
{-->} OP_QUOTE: begin
        if (Sn=0) then f_generic := ''''
        else begin
          substall('''','''''',vr1.vs);
          f_generic := ''''+vr1.vs+''''
        end
      end;
{-->} OP_RIGHT,OP_RIGHTSTR:
      if (vr1.vi<0) then                   f_generic := '?'
      else if (length(vr2.vs)>vr1.vi) then f_generic :=
        copy(vr2.vs,length(vr2.vs)+1-vr1.vi,vr1.vi)
                                      else f_generic := vr2.vs;
{-->} OP_SUBALL,OP_SUBSTALL: begin
        substall(vr3.vs,vr2.vs,vr1.vs);
        f_generic := vr1.vs
      end;
{-->} OP_SUBST,OP_SUBSTONE: begin
        substone(vr3.vs,vr2.vs,vr1.vs);
        f_generic := vr1.vs
      end;
{-->} OP_UNQUOTE: if (Sn=0) then f_generic := ''
      else begin
        substall('''''','''',vr1.vs);
        if (length(vr1.vs)>0) and (vr1.vs[1]='''') then
          delete(vr1.vs,1,1);
        if (length(vr1.vs)>0) and (vr1.vs[length(vr1.vs)]='''') then
          delete(vr1.vs,length(vr1.vs),1);
        f_generic := vr1.vs
      end;
{-->} OP_UPCASE,OP_UPPER: if (Sn=0) then f_generic := ''
				    else f_generic := strupcase(vr1.vs);
{-->} OP_WORDS,OP_COUNT: if (Sn=0) then f_generic := '0'
      else begin
        w1 := 0;
        for i1 := 1 to Sn do inc(w1,words(Sget(i1)));
        f_generic := numstr(w1)
      end;

{----------------------------------------------------------------------------}
{	    	   USER AND FILE INTERACTION FUNCTIONS			     }
{----------------------------------------------------------------------------}
{-->} OP_GETKEY,OP_KEY: begin
        if (Sn=0) then vr1.vs := allchars;
        repeat c1 := readkey until (pos(c1,vr1.vs)>0);
	f_generic := c1
      end;
{-->} OP_GETNUM,OP_GETNUMBER: begin
        case Sn of
          0: begin { [79]   ['']    [y] [x] }
            vr4.vi := 79; vr3.vs := '';
            vr2.vi := wherey; vr1.vi := wherex
          end;
          1: begin { maxlen ['']    [y] [x] }
            vr4.vi := vr1.vi; vr3.vs := '';
            vr2.vi := wherey; vr1.vi := wherex
          end;
          2: begin { maxlen default [y] [x] }
            vr4.vi := vr2.vi; vr3.vs := vr1.vs;
            vr2.vi := wherey; vr1.vi := wherex
          end;
          3: begin { maxlen default row [x] }
            vr4.vi := vr3.vi; vr3.vs := vr2.vs;
            vr2.vi := vr1.vi; vr1.vi := wherex
          end;
          4: begin { maxlen default row col }
          end
        end;
        if (vr2.vi<1) or (vr1.vi<1) or (vr4.vi<1) then f_generic := '?'
        else begin
          z1 := vr3.vs;
          repeat
            readstring(vr2.vi,vr1.vi,vr4.vi,'',z1,b1);
            if (not b1) then begin
              val(z1,r1,d1);
              b1 := (d1<>0)
            end
          until (not b1);
          f_generic := z1
        end
      end;
{-->} OP_GETSTR,OP_GETSTRING: begin
        case Sn of
          0: begin { [79]   ['']    [y] [x] }
            vr4.vi := 79; vr3.vs := '';
            vr2.vi := wherey; vr1.vi := wherex
          end;
          1: begin { maxlen ['']    [y] [x] }
            vr4.vi := vr1.vi; vr3.vs := '';
            vr2.vi := wherey; vr1.vi := wherex
          end;
          2: begin { maxlen default [y] [x] }
            vr4.vi := vr2.vi; vr3.vs := vr1.vs;
            vr2.vi := wherey; vr1.vi := wherex
          end;
          3: begin { maxlen default row [x] }
            vr4.vi := vr3.vi; vr3.vs := vr2.vs;
            vr2.vi := vr1.vi; vr1.vi := wherex
          end;
          4: begin { maxlen default row col }
          end
        end;
        if (vr2.vi<1) or (vr1.vi<1) or (vr4.vi<1) then f_generic := '?'
        else begin
          z1 := vr3.vs;
          repeat readstring(vr2.vi,vr1.vi,vr4.vi,'',z1,b1) until (not b1);
          f_generic := z1
        end
      end;
{-->} OP_LINE,OP_GETLINE: begin
        if (Sn=0) then begin i1 := 1; z1 := '' end
        else if (Sn=1) then begin i1 := vr1.vi; z1 := '' end
        else if (Sn=2) then begin i1 := vr2.vi; z1 := vr1.vs end;
        if (i1<1) then f_generic := '?'
	else begin
{$IFDEF DEBUG}{$i-}{$ENDIF}
      	  assign(f1,z1); reset(f1);
{$IFDEF DEBUG}{$i+}{$ENDIF}
          if (ioresult<>0) then f_generic := '?'
          else begin
            z1 := '?';
	    while (i1>0) and (not eof(f1)) do begin
	      readln(f1,z1); dec(i1)
	    end;
            if (i1>0) then f_generic := '?'
                      else f_generic := z1;
            close(f1)
          end
	end
      end;

{----------------------------------------------------------------------------}
{	    	   	       TIME/DATE HANDLING 			     }
{----------------------------------------------------------------------------}
{-->} OP_DATE,OP_TODAY: f_generic := curdate;
{-->} OP_DAY,OP_MONTH,OP_YEAR,OP_DOY,OP_DAYOFYEAR,OP_WDAY: begin
        b1 := true;
        if (Sn=0)
	  then getdate(w1,w2,w3,w4)
	  else scandate(vr1.vs,w3,w2,w1,b1);
        if (not b1) then f_generic := '?'
        else case fn of
          OP_DAY:               f_generic := numstr(w3);
          OP_MONTH:	 	f_generic := numstr(w2);
          OP_YEAR:  		f_generic := numstr(w1);
          OP_DOY,OP_DAYOFYEAR:  f_generic := numstr(dayinyear(w3,w2,w1));
          OP_WDAY:		f_generic := numstr(1+dayinweek(w3,w2,w1))
        end
      end;
{-->} OP_HOUR,OP_MINUTE,OP_SECOND,OP_TIME: begin
        gettime(w1,w2,w3,w4);
        case fn of
          OP_HOUR:   f_generic := numstr(w1);
	  OP_MINUTE: f_generic := numstr(w2);
	  OP_SECOND: f_generic := numstr(w3);
	  OP_TIME:   f_generic := time2sstr(w1,w2,w3)
        end
      end;
{-->} OP_LEAP,OP_LEAPYEAR: begin
        if (Sn=0) then getdate(w1,w2,w3,w4)
                  else w3 := vr1.vi;
        f_generic := boochar[leapyear(w3)]
      end;
{-->} OP_MONTHN,OP_MONTHNAME: begin
        if (Sn=0) then begin
          getdate(w1,w2,w3,w4);
          f_generic := monthstr(w2)
        end else begin
          if (Sn=1) then vr2.vs := 'A';
          scandate(vr1.vs,w3,w2,w1,b1);
          if (not b1) then f_generic := '?'
          else case upcase(vr2.vs[1]) of
            'G': f_generic := gmonthstr(w2);
            else f_generic := monthstr(w2)
          end
        end
      end;
{-->} OP_WDAYN,OP_WDAYNAME: begin
        if (Sn=0) then begin
          getdate(w1,w2,w3,w4);
          f_generic := daystr(w4)
        end else begin
          if (Sn=1) then vr2.vs := 'A';
          scandate(vr1.vs,w3,w2,w1,b1);
          if (not b1) then f_generic := '?'
          else case upcase(vr2.vs[1]) of
            'G': f_generic := gdaystr(dayinweek(w3,w2,w1));
            else f_generic := daystr(dayinweek(w3,w2,w1))
          end
        end
      end;

{----------------------------------------------------------------------------}
{	    	   	    MISCELLANOUS FUNCTIONS			     }
{----------------------------------------------------------------------------}
{-->} OP_AIF,OP_ARITHIF: if (eq(vr4.vr,0.0)) then  f_generic := vr2.vs
			 else if (vr4.vr<0.0) then f_generic := vr3.vs
                         		      else f_generic := vr1.vs;
{-->} OP_ARGS: f_generic := numstr(Sn);
{-->} OP_BOOTDRIVE,OP_BOOTDRV: begin
        c1 := upcase(bootdrfn);
        if (c1<'A') or (c1>'Z') then f_generic := '?'
                                else f_generic := c1+':'
      end;
{-->} OP_DOSVER: begin
        str(lo(dosversion),vr1.vs);
        str(hi(dosversion),vr2.vs);
        f_generic := vr1.vs+'.'+vr1.vs
      end;
{-->} OP_ENVCNT,OP_ENVCOUNT: f_generic := numstr(envcount);
{-->} OP_ENVUSED: f_generic := numstr(ENVUSEFN);
{-->} OP_IF: if (vr3.vb) then f_generic := vr2.vs
			 else f_generic := vr1.vs;
{-->} OP_MAX,OP_MIN: begin
        { process reals }
        r1 := -1.7e38;
        r2 := 1.7e38;
        b1 := true;
        i1 := 1; while (i1<=Sn) and (b1) do begin
          if (vtype(Sget(i1),vr1)=t_string) then b1 := false     { number? }
          else begin
            if (vr1.vr>r1) then r1 := vr1.vr;
            if (vr1.vr<r2) then r2 := vr1.vr;
            inc(i1)
          end
        end;
        { exit, if reals were ok }
        if (b1) then case fn of
	  OP_MAX: f_generic := numrstr(r1);
          OP_MIN: f_generic := numrstr(r2)
        end
	else begin
          { process strings }
          vr2.vs := '';
          vr3.vs[0] := #255;
          fillchar(vr3.vs[1],255,#255);
          i1 := 1; while (i1<=Sn) do begin
            if (vtype(Sget(i1),vr1)=t_string) then ;     { string }
            if (vr1.vs>vr2.vs) then vr2.vs := vr1.vs;
            if (vr1.vs<vr3.vs) then vr3.vs := vr1.vs;
            inc(i1)
          end;
          case fn of
	    OP_MAX: f_generic := vr2.vs;
            OP_MIN: f_generic := vr3.vs
          end
        end
      end;
{-->} OP_NTHARG,OP_PICKARG: begin
        if (vtype(Sget(1),vr1)=t_string) then ; { arg number }
        if (vr1.vi<1) or (vr1.vi>Sn-1) then f_generic := ''
                                       else f_generic := Sget(1+vr1.vi)
      end;
{-->} OP_RAMFREE,OP_MEMFREE: f_generic := numstr(memavail);
{-->} OP_TYPE: begin
        if (Sn=0) then f_generic := 'Null'
        else case vtype(Spop,vr1) of
          t_string:  f_generic := 'String';
          t_real:    f_generic := 'Real';
          t_integer: f_generic := 'Integer';
          t_boolean: f_generic := 'Boolean'
        end
      end;

{-->} else
        err('Unknown function code. Contact Ricki')
    end;

    { kill the stack for the next function }
    Skill
  end;

  {$I asetl.pas} { lexical analyser }
  {$I asety.pas} { syntactical analyser }

begin
  { reset all string pointers }
  for i:=1 to yymaxdepth do yyvals[i].strg := nil;
  for i:=1 to pmax do stack[i] := nil;

  pre_op;
  proc_op;
  post_op;

  Sn := 0; 

  { the following hack removes the options from the complete command line }
  cmd := cmline;
  if (debug) then begin substone('-*','',cmd); substone('/*','',cmd) end;
  if (opt_n) then begin substone('-n','',cmd); substone('/n','',cmd) end;
  if (opt_p) then begin substone('-p','',cmd); substone('/p','',cmd) end;
  if (opt_r) then begin substone('-r','',cmd); substone('/r','',cmd) end;
  if (opt_e) then begin substone('-e','',cmd); substone('/e','',cmd) end;

  lineno := 0;
  excode := 0;

  if (opt_f) then begin
{$IFDEF DEBUG}{$i-}{$ENDIF}
    { read commands from file }
    assign(f,fname); reset(f);
    if (ioresult<>0) then err('Cannot open "'+fname+'" for reading');
    while (not eof(f)) do begin
      readln(f,cmd); inc(lineno);
      { delete all leading white spaces from the line }
      cmd := headtrim(cmd,whitespace);
      { parse the current line }
      Skill; p := 0;
      if (opt_r) then writeln(stdout,rprompt,cmd);
      if (yyparse=0) then ;
    end;
    close(f)
{$IFDEF DEBUG}{$i+}{$ENDIF}
  end else begin
    { delete all leading white spaces from the command line }
    cmd := headtrim(cmd,whitespace);
    { parse the command line }
    p := 0;
    if (opt_r) then writeln(stdout,rprompt,cmd);
    if (yyparse=0) then ;
  end;

  stop(excode)
end.
@


1.3
log
@update to new email address
@
text
@d2 1
a2 1
{ $Id: aset.pas 1.2 1993/03/19 17:15:58 Ricki Exp $ }
d26 3
d61 2
@


1.2
log
@*** empty log message ***
@
text
@d2 1
a2 1
{ $Id: aset.pas 1.1 1993/03/09 12:43:16 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d26 3
@


1.1
log
@Initial revision
@
text
@d2 1
a2 1
{ $Id$ }
d25 3
a27 1
        $Log$
@

