head	1.1;
access;
symbols
	rutils40:1.1;
locks;
comment	@        @;


1.1
date	93.03.09.13.05.25;	author Ricki;	state Rel;
branches;
next	;


desc
@code and documentation generator for ASET
@

1.1
log
@Initial revision
@
text
@{ $Id$ }
program aseto;
{ Code and documentation generator for ASET }

uses
  textfmt,
  standard,
  strings,
  crt,
  dos;

const
  max_n = 200;
  maxl = 79;
  maxcat = 10;
  pmax = 64;
  minus = '----------------------------------------------------------------------------------';

type
  pf_array = array [0..20] of integer;
  str1  = string[1];
  str5  = string[5];
  str10 = string[10];
  str20 = string[20];
  str30 = string[30];
  str180 = string[180]; pstr180 = ^str180;

var
  l1: array [1..max_n] of str10;  {opcode}
  l2: array [1..max_n] of str5;   {mina}
  l3: array [1..max_n] of str5;   {maxa}
  l4: array [1..max_n] of str10;  {atyp}
  l5: array [1..max_n] of str1;   {rtyp}
  l6: array [1..max_n] of pstr180;{desc}
  l7: array [1..max_n] of str20;  {einp}
  l8: array [1..max_n] of str20;  {eout}
  l9: array [1..max_n] of str30;  {alias}
  la: array [1..max_n] of str30;  {seealso}
  lc: array [1..max_n] of byte;   {cat-index}
  al: array [1..max_n] of boolean;{is it an alias(true) or a primary(false)? }

  max_l1: integer;
  max_l2: integer;
  max_l3: integer;
  max_l4: integer;
  max_l5: integer;
  max_l6: integer;
  max_l7: integer;
  max_l8: integer;
  max_l9: integer;
  max_la: integer;
  max_l78: integer;

  cat: array [0..maxcat] of string; { 0 --> preset with [none] }
  ncat: integer;

  p,i,j,l,n: integer;
  f,o1,o2,o3,o4: text;
  line: string;
  cnt,lineno: integer;
  pf: pf_array;
  npf: integer;
  first: boolean;

  procedure allpos(line: string; delimiter: char;
  	           var pf: pf_array; var n: integer);

  begin
    n := 0; pf[0] := 0;
    p := pos(delimiter,line);
    while (p>0) do begin
      inc(n);
      pf[n] := pf[n-1]+p;
      delete(line,1,p);
      p := pos(delimiter,line)
    end;
    pf[n+1] := length(line)+pf[n]+1
  end;

  procedure sort;
    procedure qsort(l,r: Integer);
    var
      i,j,k: Integer;
      help1,help2: string;
      help3: pstr180;
      b: byte;
      bo: boolean;
    begin
      if (l>=r) then exit;
      i := L;
      j := R;
      help1 := L1[(i+j) div 2];
      repeat
        while (l1[i]<help1) do inc(i);
        while (help1<l1[j]) do dec(j);
        if (i<=j) then begin
          help2 := l1[i]; l1[i] := l1[j]; l1[j] := help2;
          help2 := l2[i]; l2[i] := l2[j]; l2[j] := help2;
          help2 := l3[i]; l3[i] := l3[j]; l3[j] := help2;
          help2 := l4[i]; l4[i] := l4[j]; l4[j] := help2;
          help2 := l5[i]; l5[i] := l5[j]; l5[j] := help2;
          help3 := l6[i]; l6[i] := l6[j]; l6[j] := help3;
          help2 := l7[i]; l7[i] := l7[j]; l7[j] := help2;
          help2 := l8[i]; l8[i] := l8[j]; l8[j] := help2;
          help2 := l9[i]; l9[i] := l9[j]; l9[j] := help2;
          help2 := la[i]; la[i] := la[j]; la[j] := help2;
          b     := lc[i]; lc[i] := lc[j]; lc[j] :=     b;
          bo    := al[i]; al[i] := al[j]; al[j] :=    bo;
          inc(i);
          dec(j);
        end;
      until (i>j);
      if (l<j) then qSort(l,j);
      if (r>i) then qSort(i,r);
    end;
  begin
    qsort(1,n)
  end;

  function type2str(s: str10): string;
  var
    ts: string;
  begin
    ts := s;

    substall('s','#s',ts);
    substall('r','#r',ts);
    substall('i','#i',ts);
    substall('b','#b',ts);
    substall('-','#-',ts);

    substall('#s','String ',ts);
    substall('#r','Real ',ts);
    substall('#i','Integer ',ts);
    substall('#b','Boolean ',ts);
    substall('#-','None ',ts);

    type2str := ts
  end;

  function str2heap(s: string): pointer;
  var p: ^string;
  begin
    getmem(p,1+length(s)); p^ := s; str2heap := p
  end;

begin
  assign(f, 'aseto.lst'); reset(f);
  assign(o1,'aseto.def'); rewrite(o1);
  assign(o2,'aseto.inf'); rewrite(o2);
  assign(o3,'aseto.doc'); rewrite(o3);
  assign(o4,'aseto.qck'); rewrite(o4);

  { read aseto.lst ----------------------------------------------------------}
  n := 0; lineno := 0; ncat := 0; cat[0] := '[none]';

  max_l1 := 1;
  max_l2 := 1;
  max_l3 := 1;
  max_l4 := 1;
  max_l5 := 1;
  max_l6 := 1;
  max_l7 := 1;
  max_l8 := 1;
  max_l9 := 1;
  max_la := 1;
  max_l78 := 1;

  while (not eof(f)) do begin
    readln(f,line); inc(lineno); write(lineno:4);
    if (line<>'') and (line[1]<>'#') then begin

      inc(n); if (n>max_n) then err('Too many opcodes');
      write(n:4);
      allpos(line,#9,pf,npf);
      if (npf<7) then err('Illegal line in OPCODES (too few TABs)');

      l1[n] := copy(line,pf[0]+1,pf[1]-pf[0]-1);
      l2[n] := copy(line,pf[1]+1,pf[2]-pf[1]-1);
      l3[n] := copy(line,pf[2]+1,pf[3]-pf[2]-1);
      l4[n] := copy(line,pf[3]+1,pf[4]-pf[3]-1);
      l5[n] := copy(line,pf[4]+1,pf[5]-pf[4]-1);
      l6[n] := pstr180(str2heap(copy(line,pf[5]+1,pf[6]-pf[5]-1)));
      l7[n] := copy(line,pf[6]+1,pf[7]-pf[6]-1);
      l8[n] := copy(line,pf[7]+1,pf[8]-pf[7]-1);
      if (npf>7) then l9[n] := copy(line,pf[8]+1,pf[9]-pf[8]-1)
      		 else l9[n] := '';
      if (npf>8) then la[n] := copy(line,pf[9]+1,pf[10]-pf[9]-1)
      		 else la[n] := '';
      lc[n] := ncat;
      al[n] := false; { a primary }

      if (length(l1[n])>max_l1) then max_l1 := length(l1[n]);
      if (length(l2[n])>max_l2) then max_l2 := length(l2[n]);
      if (length(l3[n])>max_l3) then max_l3 := length(l3[n]);
      if (length(l4[n])>max_l4) then max_l4 := length(l4[n]);
      if (length(l5[n])>max_l5) then max_l5 := length(l5[n]);
      if (length(l6[n]^)>max_l6) then max_l6 := length(l6[n]^);
      if (length(l7[n])>max_l7) then max_l7 := length(l7[n]);
      if (length(l8[n])>max_l8) then max_l8 := length(l8[n]);
      if (length(l9[n])>max_l9) then max_l9 := length(l9[n]);
      if (length(la[n])>max_la) then max_la := length(la[n]);

      if (length(l7[n]+l8[n])>max_l78)
        then max_l78 := length(l7[n]+l8[n]);

      { process the alias, if necessary }
      if (l9[n]<>'') then begin
        inc(n); if (n>max_n) then err('Too many opcodes');
        write(' +alias');

        l1[n] := l9[n-1];
        l2[n] := l2[n-1];
        l3[n] := l3[n-1];
        l4[n] := l4[n-1];
        l5[n] := l5[n-1];
        l6[n] := l6[n-1];
        l7[n] := l7[n-1];
        l8[n] := l8[n-1];
        l9[n] := l1[n-1];	{ alias vice versa }
	la[n] := la[n-1];
        lc[n] := ncat;
        al[n] := true; { an alias }

        { only max_l1 and max_l9 may have changed }
        if (length(l1[n])>max_l1) then max_l1 := length(l1[n]);
        if (length(l9[n])>max_l9) then max_l9 := length(l9[n])
      end

    end else if (length(line)>1) and (copy(line,1,2)='##') then begin
      { get the category }
      line := headtrim(copy(line,3,255),whitespace);
      inc(ncat); if (ncat>maxcat) then err('Too many categories');
      cat[ncat] := line
    end;
    writeln
  end;
  sort;

  { aseto.def ---------------------------------------------------------------}
  writeln('Function definitions');

  writeln(o1,'  { This file is automatically created! Do not edit! }');
  writeln(o1);
  writeln(o1,'  const');
  for i:=1 to n do begin
    write(o1,'    OP_',copy(l1[i]+blanks,1,max_l1+2),'= ',i:3,';');
    if (i=1) then writeln(o1,' {gen...}') else writeln(o1)
  end;
  writeln(o1);
  writeln(o1,'    pmax     = ',pmax:3 ,'; { max arg count } {fix}');
  writeln(o1,'    maxoplen = ',max_l1:3 ,'; { max opcode length } {gen}');
  writeln(o1,'    maxitlen = ',max_l4:3 ,'; { max arg type length }');
  (*
  writeln(o1,'    maxotlen = ',max_l5:3 ,'; { max res type length }');
  writeln(o1,'    maxcmlen = ',max_l6:3 ,'; { max descr length }');
  writeln(o1,'    maxeilen = ',max_l7:3 ,'; { max example arg length }');
  writeln(o1,'    maxeolen = ',max_l8:3 ,'; { max example out length }');
  writeln(o1,'    maxexlen = ',max_l78:3,'; { max example arg+out length }');
  *)
  writeln(o1,'    maxopnum = ',n:3,'; { number of opcodes }');
  writeln(o1);
  writeln(o1,'  type');
  writeln(o1,'    op_str = string[maxoplen];');
  writeln(o1,'    it_str = string[maxitlen];');
  {
  writeln(o1,'    ot_str = string[maxotlen];');
  writeln(o1,'    cm_str = string[maxcmlen];');
  writeln(o1,'    ei_str = string[maxeilen];');
  writeln(o1,'    eo_str = string[maxeolen];');
  }
  writeln(o1);
  writeln(o1,'    Topc = record {fix}');
  writeln(o1,'      name: op_str;');
  writeln(o1,'      mina: byte;');
  writeln(o1,'      maxa: byte;');
  writeln(o1,'      atyp: it_str;');
  writeln(o1,'    end;');
  writeln(o1);
  writeln(o1,'  const');
  writeln(o1,'    ops: array [1..maxopnum] of Topc = ( {gen...}');
  for i:=1 to n do begin
    write(o1,'      (name: ',copy(''''+l1[i]+''''+blanks,1,max_l1+2),'; ',
                    'mina: ',l2[i]:max_l2,'; ',
                    'maxa: ',l3[i]:max_l3,'; ',
                    'atyp: ',copy(''''+l4[i]+''''+blanks,1,max_l4+2),')'
                    );
    if (i<>n) then writeln(o1,',') else writeln(o1)
  end;
  writeln(o1,'    );');

  { aseto.inc ---------------------------------------------------------------}
  writeln('Info calls');

  writeln(o2,'{ This file is automatically created! Don''t edit! }');
  writeln(o2);
  writeln(o2,'procedure op_info(code: integer);');
  writeln(o2,'begin case code of');
  for i:=1 to n do begin
    writeln(o2,'  OP_',copy(l1[i]+blanks,1,max_l1+2),': ');
    writeln(o2,'    info(');
    writeln(o2,'         ''',l1[i],''',');
    writeln(o2,'         ',l2[i],',');
    writeln(o2,'         ',l3[i],',');
    writeln(o2,'         ''',l4[i],''',');
    writeln(o2,'         ''',l5[i],''',');
    writeln(o2,'         ''',l6[i]^,''',');
    writeln(o2,'         ''',l7[i],''',');
    writeln(o2,'         ''',l8[i],''',');
    writeln(o2,'         ''',l9[i],''',');
    writeln(o2,'         ''',la[i],'''');
    writeln(o2,'        );');
  end;
  writeln(o2,'end end;');

  { aseto.doc ---------------------------------------------------------------}
  writeln('Overview');

  writeln(o3,'7   Overview over ASETs functions');
  writeln(o3,'=================================');
  writeln(o3);
  writeln(o3,'7.1   Alphabetic list of ASETs functions');
  writeln(o3,'----------------------------------------');
  findent(o3,3); fwidth(o3,76); fwrite(o3,'   ');
  for i:=1 to n do fwrite(o3,strlowcase(l1[i]));
  fwriteln(o3,'');
  writeln(o3);

  writeln(o3,'7.2   List of ASETs functions, sorted by categories');
  writeln(o3,'---------------------------------------------------');
  for i:=0 to ncat do begin
    first := true;
    for j:=1 to n do if (lc[j]=i) then begin
      if (first) then begin
        writeln(o3,cat[i]+':');
        fwrite(o3,'   ');
        first := false
      end;
      fwrite(o3,strlowcase(l1[j]))
    end;
    if (not first) then fwriteln(o3,'')
  end;

  writeln('Documentation');

  writeln(o3);
  writeln(o3);
  writeln(o3);
  writeln(o3,'8   Documentation of ASETs functions');
  writeln(o3,'====================================');
  writeln(o3);

  for i:=1 to n do if (not al[i]) then begin
    writeln(o3,copy(minus,1,79));
    fwidth(o3,79); findent(o3,3+length(l1[i]));
    fwr1teln(o3,l1[i]+' - '+l6[i]^);
    writeln(o3,copy(minus,1,79));
    write(o3,'   Argument(s): ');
    if (l2[i]=l3[i]) then begin
      if (l2[i]='0') then writeln(o3,'None')
      		     else writeln(o3,l2[i],', ',type2str(l4[i]))
    end else
      if (l3[i]='pmax') then writeln(o3,'from ',l2[i],' to ',pmax,', ',type2str(l4[i]))
      			else writeln(o3,'from ',l2[i],' to ',l3[i],', ',type2str(l4[i]));
    writeln(o3,'   Result type: ',type2str(l5[i]));
    if (l9[i]<>'') then writeln(o3,'   Aliases    : ',l9[i]);
    if (la[i]<>'') then writeln(o3,'   See also   : ',la[i]);
    writeln(o3,'   Category   : ',cat[lc[i]]);

    writeln(o3);
    writeln(o3,'   Example: ');
    write(o3,'     C:> ASET -p X := ',l1[i]);
    if (l4[i]<>'-') then writeln(o3,'(',l7[i],')')
    		    else writeln(o3);
    writeln(o3,'     X=',l8[i]);

    writeln(o3);
    writeln(o3);
  end;

  { aseto.qck ---------------------------------------------------------------}
  writeln('Quick reference');

  writeln(o4);
  writeln(o4,'Quick reference');
  writeln(o4,'===============');
  writeln(o4);

  for i:=0 to ncat do begin
    first := true;
    for j:=1 to n do if (lc[j]=i) and (not al[j]) then begin
      if (first) then begin
        writeln(o4,cat[i]+':');
        first := false
      end;
      l := max_l1+max_l78;
      write(o4,'   ',l1[j]); dec(l,length(l1[j]));
      if (l4[j]<>'-') then begin
        write(o4,'(',l7[j],')'); dec(l,2+length(l7[j]))
      end;
      write(o4,' = ',l8[j]); dec(l,length(l8[j]));
      if (l9[j]<>'') then
        write(o4,copy(blanks,1,l),'alias ',l9[j]);
      writeln(o4)
    end;
    if (not first) then fwriteln(o4,'')
  end;

  close(o1); close(o2); close(o3); close(o4);
  close(f);
  stop(0)
end.
@

