head	1.1;
access;
symbols
	rutils40:1.1;
locks;
comment	@        @;


1.1
date	93.03.09.13.07.56;	author Ricki;	state Rel;
branches;
next	;


desc
@ASET yacc specification for TPLY 2.0
@

1.1
log
@Initial revision
@
text
@%{
{ $Id$ }
{ ASET yacc specification for TPLY 2.0 }

{
        $Log$
}
%}

%union 	{
         case boolean of
           false: (func: integer);
           true : (strg: Pstrg);
  	}

%token <strg> T_VALUE
%type  <strg> expr
%type  <strg> optexpr
%token <func> T_FUNCTION
%token T_ASSIGN
%left  T_AND T_OR T_NAND T_NOR T_XOR
%left  '=' T_NE '<' T_LE '>' T_GE
%left  '+' '-'
%left  '^' '*' '/' '%' T_DIV
%right T_UMINUS T_UNOT
%token T_NOT

%%

input   : /* empty */
        | T_VALUE assop expr            { if (debug) then rep2('[Assignment]',$1^,$3^);
                                          setenv($1^,$3^);
                                          yyaccept; }
        | T_VALUE assop                 { if (debug) then rep1('[Deletion]',$1^);
                                          setenv($1^,'');
                                          yyaccept; }
        | T_VALUE                       { writeln(strupcase($1^),'=',getenv($1^));
                                          yyaccept; }
        | error                         { yyaccept; }
        ;

assop	: T_ASSIGN
	| '='
        ;

expr    : expr '+' expr                 { Passign($$,f_add($1^,$3^)) }
        | expr '-' expr                 { Passign($$,f_sub($1^,$3^)) }
        | expr '*' expr                 { Passign($$,f_mult($1^,$3^)) }
        | expr '/' expr                 { Passign($$,f_rdiv($1^,$3^)) }
        | expr '%' expr                 { Passign($$,f_mod($1^,$3^)) }
        | expr '^' expr                 { Passign($$,f_pot($1^,$3^)) }
        | expr T_DIV expr               { Passign($$,f_div($1^,$3^)) }
        | expr '=' expr                 { Passign($$,f_compare($1^,$3^,cmp_eq)) }
        | expr '<' expr                 { Passign($$,f_compare($1^,$3^,cmp_lt)) }
        | expr '>' expr                 { Passign($$,f_compare($1^,$3^,cmp_gt)) }
        | expr T_NE expr                { Passign($$,f_compare($1^,$3^,cmp_ne)) }
        | expr T_LE expr                { Passign($$,f_compare($1^,$3^,cmp_le)) }
        | expr T_GE expr                { Passign($$,f_compare($1^,$3^,cmp_ge)) }
        | expr T_AND expr               { Passign($$,f_boolean($1^,$3^,boo_and)) }
        | expr T_OR expr                { Passign($$,f_boolean($1^,$3^,boo_or)) }
        | expr T_NAND expr              { Passign($$,f_boolean($1^,$3^,boo_nand)) }
        | expr T_NOR expr               { Passign($$,f_boolean($1^,$3^,boo_nor)) }
        | expr T_XOR expr               { Passign($$,f_boolean($1^,$3^,boo_xor)) }
        | '(' expr ')'                  { Passign($$,$2^) }
        | T_NOT expr %prec T_UNOT       { Passign($$,f_not($2^)) }
        | '-' expr %prec T_UMINUS       { Passign($$,f_minus($2^)) }
        | T_VALUE                       { Passign($$,$1^) }
        | T_VALUE T_VALUE               { Passign($$,$1^+$2^) }
        | T_FUNCTION optpars            { Passign($$,f_generic($1)) }
	;

optpars : /* empty */
        | '(' parlist ')'
        ;

parlist : optexpr                       { Spush($1^) }
        | parlist ',' optexpr           { Spush($3^) }
        ;

optexpr : /* empty */                   { Passign($$,''); }
        | expr                          { Passign($$,$1^); }
        ;

%%
@

