head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.21.24;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.10.21.51.02;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.21.21.39.57;	author Ricki;	state Exp;
branches;
next	;


desc
@Display a string in large letters
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: banner.pas 1.2 1993/02/10 21:51:02 Ricki Exp $ }
program banner;
{ Display a string in large letters }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: banner.pas $
        Revision 1.2  1993/02/10  21:51:02  Ricki
        new option -C
        modified -v page

        Revision 1.1  1993/01/21  21:39:57  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  strings,
  numbers,
  standard,
  options,
  outcon,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id: banner.pas 1.2 1993/02/10 21:51:02 Ricki Exp $';

  func = 'Display a string in large letters';
  year = '1992,1993';
  desn = 'BANNER/2';
  desv = '1.0';
  opts = 'c:C:hHsSuv*'; ropt = opts;

  max_len   = 32;
  max_len_s = 31;

  each_different: char = #0;

type
  strtype = string[max_len];

var
  fbuf: pointer;
  debug: boolean;
  i,nopt,nnam: byte;
  width: longint;
  usechar: char;
  str: strtype;
  opt_c,opt_s,opt_gs: boolean;

  {$i banner.inc}
  {$i banner.i1}
  {$i banner.i2}

  procedure help1;
  begin
    header(desv,year,func);
    banneri1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    banneri2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  procedure pre_op;
  begin
    usechar := design_char;
    opt_s := false; opt_gs := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  procedure proc_op;
  var
    i: byte;
    dummy: word;
    code: integer;
  begin
    parse(ropt,nopt,nnam);
    if (nopt+nnam=0) then help1;
    for i:=1 to nopt do begin
      case getopt(i) of
        'c': if (length(optarg)>1) then err('Illegal -c argument')
        else if (length(optarg)=1) then usechar := optarg[1]
        else usechar := each_different;
        'C': begin
          opt_c := true;
          if (optarg='') then width := 80
          else if (not ival(optarg,width))
	       or (width<0) or (width>255) then err('Illegal width')
        end;
        's': opt_s := true;
        'S': opt_gs := true;

        'h': help1;
        'H': help2;
        'v': version;
        '*': debug := true
      end
    end
  end;

  procedure post_op;
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    if (opt_s) and (opt_gs) then err('-s and -S are mutually exclusive');
    if (nnam=0) then err('Nothing to do')
  end;

  procedure doit(s: strtype);
  const
    offset: array [boolean,boolean] of integer = ((1,-font_row),(-font_row,1));
  var
    r,c,i,l,ind: byte;
    pre: string;
  begin
    { determine how many spaces must preceed the string }
    l := length(s);
    { center? }
    if (opt_c) and (l*(font_col+1)+offset[opt_s,opt_gs]<width) then
      pre := copy(blanks,1,(width-l*(font_col+1)+offset[opt_s,opt_gs]) div 2)
    else
      pre := '';

    { loop over the font_row rows }
    for r:=1 to font_row do begin
      { process slanted mode actions }
      if (opt_s)       then write(stdout,copy(blanks,1,font_row-r))
      else if (opt_gs) then write(stdout,copy(blanks,1,r-1));

      { loop over the characters in s }
      for i:=1 to l do begin
        { get the character index }
        ind := idx[s[i]];
        { draw 7 characters }
        if (i>1) then write(stdout,' ')
        	 else write(stdout,pre);
        if (usechar=design_char) then write(stdout,ban[ind][r])
        else for c:=1 to font_col do begin
          if (ban[ind][r,c]=design_char) then begin
            if (usechar<>each_different) then write(stdout,usechar)
                                         else write(stdout,s[i])
          end else write(stdout,' ')
        end
      end;

      { linefeed }
      writeln(stdout)
    end;

    { linefeed }
    writeln(stdout);
  end;

begin
  pre_op;
  proc_op;
  post_op;

  { loop over all strings }
  for i:=1 to nnam do begin
    str := getname(i);
    if (opt_s) or (opt_gs) then str := copy(str,1,max_len_s)
               		   else str := copy(str,1,max_len);
    if (str<>'') then doit(str)
  end;

  stop(0)
end.
@


1.2
log
@new option -C
modified -v page
@
text
@d2 1
a2 1
{ $Id: BANNER.PAS 1.1 1993/01/21 21:39:57 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 5
a29 1
        $Log: BANNER.PAS $
d50 1
a50 1
  pversion = '$Id: BANNER.PAS 1.1 1993/01/21 21:39:57 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: BANNER.PAS 1.1 1993/01/21 21:21:16 Ricki Exp $ }
d26 2
a27 3
 * Revision 1.1  1993/01/21  21:21:16  Ricki
 * Initial revision
 *
d37 1
d46 1
a46 1
  pversion = '$Id: BANNER.PAS 1.1 1993/01/21 21:21:16 Ricki Exp $';
d51 2
a52 1
  opts = 'c:hHsSuv*'; ropt = opts;
d66 1
d69 1
a69 1
  opt_s,opt_gs: boolean;
d77 1
a77 1
    header(year,func);
d84 1
a84 1
    header(year,func);
d91 1
a91 1
    header(year,func);
d93 1
a93 1
    revision(desn,'$Revision: 1.1 $');
d123 6
d145 1
d150 2
d153 2
a154 1
    r,c,i,ind: byte;
d156 8
d171 1
a171 1
      for i:=1 to length(s) do begin
d175 2
a176 1
        if (i>1) then write(stdout,' ');
d201 3
a203 2
    if (opt_s) or (opt_gs) then str := copy(getname(i),1,max_len_s)
                           else str := copy(getname(i),1,max_len);
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program banner;
{ Display a string in large letters }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  strings,
  standard,
  options,
  outcon,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id$';

  func = 'Display a string in large letters';
  year = '1992,1993';
  desn = 'BANNER/2';
  opts = 'c:hHsSuv*'; ropt = opts;

  max_len   = 32;
  max_len_s = 31;

  each_different: char = #0;

type
  strtype = string[max_len];

var
  fbuf: pointer;
  debug: boolean;
  i,nopt,nnam: byte;
  usechar: char;
  str: strtype;
  opt_s,opt_gs: boolean;

  {$i banner.inc}
  {$i banner.i1}
  {$i banner.i2}

  procedure help1;
  begin
    header(year,func);
    banneri1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    banneri2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 4.3 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  procedure pre_op;
  begin
    usechar := design_char;
    opt_s := false; opt_gs := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  procedure proc_op;
  var
    i: byte;
    dummy: word;
    code: integer;
  begin
    parse(ropt,nopt,nnam);
    if (nopt+nnam=0) then help1;
    for i:=1 to nopt do begin
      case getopt(i) of
        'c': if (length(optarg)>1) then err('Illegal -c argument')
        else if (length(optarg)=1) then usechar := optarg[1]
        else usechar := each_different;
        's': opt_s := true;
        'S': opt_gs := true;

        'h': help1;
        'H': help2;
        'v': version;
        '*': debug := true
      end
    end
  end;

  procedure post_op;
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    if (nnam=0) then err('Nothing to do')
  end;

  procedure doit(s: strtype);
  var
    r,c,i,ind: byte;
  begin
    { loop over the font_row rows }
    for r:=1 to font_row do begin
      { process slanted mode actions }
      if (opt_s)       then write(stdout,copy(blanks,1,font_row-r))
      else if (opt_gs) then write(stdout,copy(blanks,1,r-1));

      { loop over the characters in s }
      for i:=1 to length(s) do begin
        { get the character index }
        ind := idx[s[i]];
        { draw 7 characters }
        if (i>1) then write(stdout,' ');
        if (usechar=design_char) then write(stdout,ban[ind][r])
        else for c:=1 to font_col do begin
          if (ban[ind][r,c]=design_char) then begin
            if (usechar<>each_different) then write(stdout,usechar)
                                         else write(stdout,s[i])
          end else write(stdout,' ')
        end
      end;

      { linefeed }
      writeln(stdout)
    end;

    { linefeed }
    writeln(stdout);
  end;

begin
  pre_op;
  proc_op;
  post_op;

  { loop over all strings }
  for i:=1 to nnam do begin
    if (opt_s) or (opt_gs) then str := copy(getname(i),1,max_len_s)
                           else str := copy(getname(i),1,max_len);
    if (str<>'') then doit(str)
  end;

  stop(0)
end.
@

