head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.21.31;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.10.21.57.54;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.21.21.40.00;	author Ricki;	state Exp;
branches;
next	;


desc
@Display a calender
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: cal.pas 1.2 1993/02/10 21:57:54 Ricki Exp $ }
program cal;
{ Display a calendar }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: cal.pas $
        Revision 1.2  1993/02/10  21:57:54  Ricki
        modified -v page

        Revision 1.1  1993/01/21  21:40:00  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  dates,
  numbers,
  strings,
  standard,
  options,
  outcon,
  cmdline,
  outstd,
  dos;

type
  str3 = string[3];

const
  pversion = '$Id: cal.pas 1.2 1993/02/10 21:57:54 Ricki Exp $';

  func = 'Display a calendar';
  year = '1992,1993';
  desn = 'CAL/2';
  desv = '1.0';
  opts = 'hHv*'; ropt = opts;

  days = 'Su Mo Tu We Th Fr Sa';
  m3str: array [1..12] of str3 =
    ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

type
  Tfield = array [1..8] of string[20];

var
  fbuf: pointer;
  debug: boolean;
  ayear,month: word;
  nopt,nnam: byte;
  mf: array [1..3] of Tfield;
  i,j,k: integer;

  {$i cal.i1}
  {$i cal.i2}

  procedure help1;
  begin
    header(desv,year,func);
    cali1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    cali2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  function center20(s: string): string;
  var
    ls: byte;
  begin
    ls := 20-length(s);
    center20 := copy(blanks,1,ls div 2)+s+copy(blanks,1,(ls+1) div 2)
  end;

  function center20n(s: string): string;
  var
    ls: byte;
  begin
    ls := 20-length(s);
    center20n := copy(blanks,1,ls div 2)+s
  end;

  function findmonth(s: string): byte;
  { returns 1..12, if found; 0, if not found; 13, if ambigous }
  const
    mn: array [1..12] of monthstring =
      ('JANUARY','FEBRUARY','MARCH','APRIL','MAY','JUNE','JULY',
       'AUGUST','SEPTEMBER','OCTOBER','NOVEMBER','DECEMBER');
  var
    idx,i: byte;
  begin
    s := strupcase(s);
    idx := 0;
    for i:=1 to 12 do begin
      if (copy(mn[i],1,length(s))=s) then begin
        if (idx<>0) then begin findmonth := 13; exit end;
        idx := i
      end
    end;
    findmonth := idx
  end;

  procedure pre_op;
  begin
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  procedure proc_op;
  var
    i: byte;
    dummy: word;
    code: integer;
  begin
    parse(ropt,nopt,nnam);
    for i:=1 to nopt do begin
      case getopt(i) of
        'h': help1;
        'H': help2;
        'v': version;
        '*': debug := true
      end
    end;

    { get the parameters }
    if (nnam=0) then getdate(ayear,month,dummy,dummy)
    else if (nnam=1) then begin
      val(getname(1),ayear,code);
      if (code<>0) or (not validdate(1,1,ayear)) then err('Illegal year');
      month := 0 { means: all months }
    end else if (nnam=2) then begin
      val(getname(1),month,code);
      if (code<>0) then begin
        month := findmonth(getname(1));
        if (month=0) then err('Illegal month')
        else if (month=13) then err('Ambigous month')
      end;
      val(getname(2),ayear,code);
      if (code<>0) or (not validdate(1,1,ayear)) then err('Illegal year')
    end else err('Too many parameters')
  end;

  procedure post_op;
  begin
    if (debug) then startdbg;
    report(ropt,pversion);
  end;

  procedure table(month,year: word; var mf: Tfield);
  { fills lines 3..8 of mf with the calender days }
  var
    line: byte;
    day: word;
    p,i,md: byte;
  begin
    for line:=3 to 8 do mf[line] := '';
    line := 3;
    if (year<>1752) or (month<>9) then begin
      { get the weekday of 1.month.year }
      day := dayinweek(1,month,year);

      { output table }
      p:=0; while (p<day) do begin inc(p); mf[line] := mf[line]+'   ' end;
      md := daysinmonth(month,year);
      for i:=1 to md do begin
        inc(p); mf[line] := mf[line]+lnumstr(i,2);
        if (p mod 7=0) then inc(line) else mf[line] := mf[line]+' '
      end;
      if (p mod 7<>0) then mf[line] := copy(mf[line]+blanks,1,20);

      while (line<8) do begin
        inc(line); mf[line] := '                    '
      end
    end else begin
      mf[3] := '       1  2 14 15 16';
      mf[4] := '17 18 19 20 21 22 23';
      mf[5] := '24 25 26 27 28 29 30';
      mf[6] := '                    ';
      mf[7] := '                    ';
      mf[8] := '                    ';
    end
  end;

  procedure proc_1month(month,year: integer; var mf: Tfield);
  begin
    { header }
    mf[1] := center20n(monthstr(month)+' '+numstr(year));
    mf[2] := days;
    table(month,year,mf)
  end;

  procedure proc_3months(start,year: integer; var m1,m2,m3: Tfield);
  { m1 <-- start.year ... m3 <-- start+2.year }
  begin
    { header }
    m1[1] := center20(m3str[start]);
    m2[1] := center20(m3str[start+1]);
    m3[1] := center20n(m3str[start+2]);

    m1[2] := days;
    m2[2] := m1[2];
    m3[2] := m1[2];

    table(start,year,m1);
    table(start+1,year,m2);
    table(start+2,year,m3);
  end;

begin
  pre_op;
  proc_op;
  post_op;

  { loop over the months or one single month? }
  if (month=0) then begin
    writeln(stdout,#9#9#9#9,ayear);
    writeln(stdout);

    { header }
    for i:=0 to 3 do begin
      proc_3months(i*3+1,ayear,mf[1],mf[2],mf[3]);
      for k:=1 to 8 do begin
        for j:=1 to 3 do begin
          write(stdout,mf[j][k]);
          if (j<3) then write(stdout,'    ')
        end;
        writeln(stdout)
      end;
      writeln(stdout)
    end
  end else begin
    proc_1month(month,ayear,mf[1]);
    for k:=1 to 8 do writeln(stdout,mf[1][k]);
    writeln(stdout)
  end;

  stop(0)
end.
@


1.2
log
@modified -v page
@
text
@d2 1
a2 1
{ $Id: CAL.PAS 1.1 1993/01/21 21:40:00 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 4
a28 1
        $Log: CAL.PAS $
d53 1
a53 1
  pversion = '$Id: CAL.PAS 1.1 1993/01/21 21:40:00 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: CAL.PAS 1.1 1993/01/21 21:21:26 Ricki Exp $ }
d26 2
a27 3
 * Revision 1.1  1993/01/21  21:21:26  Ricki
 * Initial revision
 *
d50 1
a50 1
  pversion = '$Id: CAL.PAS 1.1 1993/01/21 21:21:26 Ricki Exp $';
d55 1
d78 1
a78 1
    header(year,func);
d85 1
a85 1
    header(year,func);
d92 1
a92 1
    header(year,func);
d94 1
a94 1
    revision(desn,'$Revision: 1.1 $');
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program cal;
{ Display a calendar }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  dates,
  numbers,
  strings,
  standard,
  options,
  outcon,
  cmdline,
  outstd,
  dos;

type
  str3 = string[3];

const
  pversion = '$Id$';

  func = 'Display a calendar';
  year = '1992,1993';
  desn = 'CAL/2';
  opts = 'hHv*'; ropt = opts;

  days = 'Su Mo Tu We Th Fr Sa';
  m3str: array [1..12] of str3 =
    ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

type
  Tfield = array [1..8] of string[20];

var
  fbuf: pointer;
  debug: boolean;
  ayear,month: word;
  nopt,nnam: byte;
  mf: array [1..3] of Tfield;
  i,j,k: integer;

  {$i cal.i1}
  {$i cal.i2}

  procedure help1;
  begin
    header(year,func);
    cali1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    cali2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 4.3 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  function center20(s: string): string;
  var
    ls: byte;
  begin
    ls := 20-length(s);
    center20 := copy(blanks,1,ls div 2)+s+copy(blanks,1,(ls+1) div 2)
  end;

  function center20n(s: string): string;
  var
    ls: byte;
  begin
    ls := 20-length(s);
    center20n := copy(blanks,1,ls div 2)+s
  end;

  function findmonth(s: string): byte;
  { returns 1..12, if found; 0, if not found; 13, if ambigous }
  const
    mn: array [1..12] of monthstring =
      ('JANUARY','FEBRUARY','MARCH','APRIL','MAY','JUNE','JULY',
       'AUGUST','SEPTEMBER','OCTOBER','NOVEMBER','DECEMBER');
  var
    idx,i: byte;
  begin
    s := strupcase(s);
    idx := 0;
    for i:=1 to 12 do begin
      if (copy(mn[i],1,length(s))=s) then begin
        if (idx<>0) then begin findmonth := 13; exit end;
        idx := i
      end
    end;
    findmonth := idx
  end;

  procedure pre_op;
  begin
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  procedure proc_op;
  var
    i: byte;
    dummy: word;
    code: integer;
  begin
    parse(ropt,nopt,nnam);
    for i:=1 to nopt do begin
      case getopt(i) of
        'h': help1;
        'H': help2;
        'v': version;
        '*': debug := true
      end
    end;

    { get the parameters }
    if (nnam=0) then getdate(ayear,month,dummy,dummy)
    else if (nnam=1) then begin
      val(getname(1),ayear,code);
      if (code<>0) or (not validdate(1,1,ayear)) then err('Illegal year');
      month := 0 { means: all months }
    end else if (nnam=2) then begin
      val(getname(1),month,code);
      if (code<>0) then begin
        month := findmonth(getname(1));
        if (month=0) then err('Illegal month')
        else if (month=13) then err('Ambigous month')
      end;
      val(getname(2),ayear,code);
      if (code<>0) or (not validdate(1,1,ayear)) then err('Illegal year')
    end else err('Too many parameters')
  end;

  procedure post_op;
  begin
    if (debug) then startdbg;
    report(ropt,pversion);
  end;

  procedure table(month,year: word; var mf: Tfield);
  { fills lines 3..8 of mf with the calender days }
  var
    line: byte;
    day: word;
    p,i,md: byte;
  begin
    for line:=3 to 8 do mf[line] := '';
    line := 3;
    if (year<>1752) or (month<>9) then begin
      { get the weekday of 1.month.year }
      day := dayinweek(1,month,year);

      { output table }
      p:=0; while (p<day) do begin inc(p); mf[line] := mf[line]+'   ' end;
      md := daysinmonth(month,year);
      for i:=1 to md do begin
        inc(p); mf[line] := mf[line]+lnumstr(i,2);
        if (p mod 7=0) then inc(line) else mf[line] := mf[line]+' '
      end;
      if (p mod 7<>0) then mf[line] := copy(mf[line]+blanks,1,20);

      while (line<8) do begin
        inc(line); mf[line] := '                    '
      end
    end else begin
      mf[3] := '       1  2 14 15 16';
      mf[4] := '17 18 19 20 21 22 23';
      mf[5] := '24 25 26 27 28 29 30';
      mf[6] := '                    ';
      mf[7] := '                    ';
      mf[8] := '                    ';
    end
  end;

  procedure proc_1month(month,year: integer; var mf: Tfield);
  begin
    { header }
    mf[1] := center20n(monthstr(month)+' '+numstr(year));
    mf[2] := days;
    table(month,year,mf)
  end;

  procedure proc_3months(start,year: integer; var m1,m2,m3: Tfield);
  { m1 <-- start.year ... m3 <-- start+2.year }
  begin
    { header }
    m1[1] := center20(m3str[start]);
    m2[1] := center20(m3str[start+1]);
    m3[1] := center20n(m3str[start+2]);

    m1[2] := days;
    m2[2] := m1[2];
    m3[2] := m1[2];

    table(start,year,m1);
    table(start+1,year,m2);
    table(start+2,year,m3);
  end;

begin
  pre_op;
  proc_op;
  post_op;

  { loop over the months or one single month? }
  if (month=0) then begin
    writeln(stdout,#9#9#9#9,ayear);
    writeln(stdout);

    { header }
    for i:=0 to 3 do begin
      proc_3months(i*3+1,ayear,mf[1],mf[2],mf[3]);
      for k:=1 to 8 do begin
        for j:=1 to 3 do begin
          write(stdout,mf[j][k]);
          if (j<3) then write(stdout,'    ')
        end;
        writeln(stdout)
      end;
      writeln(stdout)
    end
  end else begin
    proc_1month(month,ayear,mf[1]);
    for k:=1 to 8 do writeln(stdout,mf[1][k]);
    writeln(stdout)
  end;

  stop(0)
end.
@

