head	1.4;
access;
symbols
	rutils40:1.3;
locks;
comment	@        @;


1.4
date	93.03.31.19.21.38;	author Ricki;	state Exp;
branches;
next	1.3;

1.3
date	93.02.12.14.32.41;	author Ricki;	state Rel;
branches;
next	1.2;

1.2
date	93.02.10.21.59.29;	author Ricki;	state Exp;
branches;
next	1.1;

1.1
date	93.01.21.21.40.08;	author Ricki;	state Exp;
branches;
next	;


desc
@Copy files to stdout
@

1.4
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: cat.pas 1.3 1993/02/12 14:32:41 Ricki Exp $ }
program cat;
{ Copy files to stdout }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: cat.pas $
        Revision 1.3  1993/02/12  14:32:41  Ricki
        replaced -a by -c and -C; introduced new rules for distinguishing
          between binary and text mode

        Revision 1.2  1993/02/10  21:59:29  Ricki
        modified -v page

        Revision 1.1  1993/01/21  21:40:08  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  options,
  files,
  strings,
  standard,
  cmdline,
  outstd,
  outcon,
  dostools,
  dos;

const
  pversion = '$Id: cat.pas 1.3 1993/02/12 14:32:41 Ricki Exp $';

  func = 'Copy files to stdout';
  year = '1992,1993';
  desn = 'CAT/2';
  desv = '1.0';
  opts = 'bcCehHnstv*'; ropt = opts;

var
  debug: boolean;
  fbuf: pointer;

  opt_c,opt_cc,opt_n,opt_b,opt_s,opt_e,opt_t: boolean;
  line_no: longint;
  asciimode: boolean;
  nopt,nnam: byte;

  {$i cat.i1}
  {$i cat.i2}

  procedure help1;
  begin
    header(desv,year,func);
    cati1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    cati2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    line_no := 0;
    opt_e := false; opt_t := false;
    opt_n := false; opt_b := false;
    opt_c := false; opt_cc := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'b': opt_b := true;
      'c': opt_c := true;
      'C': opt_cc := true;
      'n': opt_n := true;
      'e': opt_e := true;
      't': opt_t := true;
      's': ; { already done }

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    { -n overrides -b }
    if (opt_b) and (opt_n) then opt_b := false;

    { -c excludes -bCent }
    if (opt_c) then begin
      if (opt_cc) or (opt_b) or (opt_e) or (opt_n) or (opt_t) then
        err('-c excludes -b, -C, -e, -n, and -t');
      asciimode := false
    end else begin
      { text file mode? }
      asciimode := (opt_cc) or (opt_b) or (opt_e) or (opt_n) or (opt_t)
                or (not outredirected)
    end
  end;

  procedure doit(var line: string);
  begin
    if (opt_b) then begin
      inc(line_no);
      if (line<>'') then begin
        if (not opt_t) then write(stdout,line_no:6,'  ',line)
                       else write(stdout,line_no:6,'  ',printable(line))
      end
    end else if (opt_n) then begin
      inc(line_no);
      if (not opt_t) then write(stdout,line_no:6,'  ',line)
                     else write(stdout,line_no:6,'  ',printable(line));
    end else begin
      if (not opt_t) then write(stdout,line)
                     else write(stdout,printable(line));
    end;
    if (opt_e) then write(stdout,'$');
    writeln(stdout)
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,stdbufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    tf: text;      { ascii }
    line: string;  {       }
    f,stdo: file;  { non-ascii }
    rlr,rlw: word; {           }
  begin
    { distinguish between ascii and nonascii mode }
    if (not asciimode) then begin
      bininp(f,p+s.name);
      binout(stdo,'');

      if (debug) then begin
        if (s.name<>'') then writeln(conout,'       Bin-Reading ',p+s.name)
                        else writeln(conout,'       Bin-Reading stdin');
      end;

      { copy f to stdo }
      rlr := stdbufsize;
      while (not eof(f)) and (rlr=stdbufsize) do begin
        blockread(f,fbuf^,stdbufsize,rlr);

        if (debug) then
          writeln(conout,'       Read  ',rlr,
                         '/',stdbufsize,' bytes from ',p+s.name);

        if (rlr>0) then begin
          blockwrite(stdo,fbuf^,rlr,rlw);

          if (debug) then
            writeln(conout,'       Wrote ',rlw,
                           '/',rlr,' bytes to stdout');

	  if (rlr<>rlw) then
            err('Error writing to stdout');
        end
      end;

      close(f);
      close(stdo)
    end else begin
      txtinp(tf,p+s.name);
      settextbuf(tf,fbuf^,stdbufsize);
      if (debug) then begin
        if (s.name<>'') then writeln(conout,'       Asc-Reading ',p+s.name)
                        else writeln(conout,'       Asc-Reading stdin');
      end;

      while (not eof(tf)) do begin
        readln(tf,line);
        doit(line)
      end;

      close(tf)
    end
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  { check for the occurence of -s }
  opt_s := false;
  parse(ropt,nopt,nnam);
  while (nopt>0) do begin
    if (getopt(nopt)='s') then begin
      opt_s := true;
      nopt := 0
    end else inc(nopt)
  end;

  { quiet or not? }
  if (opt_s) then process(ropt,
                          pre_op,proc_op,post_op,
                          pre_fn,proc_fn,post_fn,
                          m_stdin or m_pipe or m_quiet)
             else process(ropt,
                          pre_op,proc_op,post_op,
                          pre_fn,proc_fn,post_fn,
                          m_stdin or m_pipe);
  stop(0)
end.
@


1.3
log
@replaced -a by -c and -C; introduced new rules for distinguishing
  between binary and text mode
@
text
@d2 1
a2 1
{ $Id: cat.pas 1.2 1993/02/10 21:59:29 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d26 4
d54 1
a54 1
  pversion = '$Id: cat.pas 1.2 1993/02/10 21:59:29 Ricki Exp $';
@


1.2
log
@modified -v page
@
text
@d2 1
a2 1
{ $Id: CAT.PAS 1.1 1993/01/21 21:40:08 Ricki Exp $ }
d25 4
a28 1
        $Log: CAT.PAS $
d46 1
d50 1
a50 1
  pversion = '$Id: CAT.PAS 1.1 1993/01/21 21:40:08 Ricki Exp $';
d56 1
a56 1
  opts = 'abehHnstv*'; ropt = opts;
d62 1
a62 1
  opt_a,opt_n,opt_b,opt_s,opt_e,opt_t: boolean;
d98 2
a99 1
    opt_n := false; opt_b := false; opt_a := false;
a109 1
      'a': opt_a := true;
d111 2
d133 11
a143 2
    { text file mode ? }
    asciimode := opt_a or opt_b or opt_e or opt_n or opt_t
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: CAT.PAS 1.1 1993/01/21 21:21:45 Ricki Exp $ }
d26 2
a27 3
 * Revision 1.1  1993/01/21  21:21:45  Ricki
 * Initial revision
 *
d46 1
a46 1
  pversion = '$Id: CAT.PAS 1.1 1993/01/21 21:21:45 Ricki Exp $';
d51 1
d68 1
a68 1
    header(year,func);
d75 1
a75 1
    header(year,func);
d82 1
a82 1
    header(year,func);
d84 1
a84 1
    revision(desn,'$Revision: 1.1 $');
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program cat;
{ Copy files to stdout }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  options,
  files,
  strings,
  standard,
  cmdline,
  outstd,
  outcon,
  dos;

const
  pversion = '$Id$';

  func = 'Copy files to stdout';
  year = '1992,1993';
  desn = 'CAT/2';
  opts = 'abehHnstv*'; ropt = opts;

var
  debug: boolean;
  fbuf: pointer;

  opt_a,opt_n,opt_b,opt_s,opt_e,opt_t: boolean;
  line_no: longint;
  asciimode: boolean;
  nopt,nnam: byte;

  {$i cat.i1}
  {$i cat.i2}

  procedure help1;
  begin
    header(year,func);
    cati1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    cati2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 4.5 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    line_no := 0;
    opt_e := false; opt_t := false;
    opt_n := false; opt_b := false; opt_a := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'a': opt_a := true;
      'b': opt_b := true;
      'n': opt_n := true;
      'e': opt_e := true;
      't': opt_t := true;
      's': ; { already done }

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    { -n overrides -b }
    if (opt_b) and (opt_n) then opt_b := false;
    { text file mode ? }
    asciimode := opt_a or opt_b or opt_e or opt_n or opt_t
  end;

  procedure doit(var line: string);
  begin
    if (opt_b) then begin
      inc(line_no);
      if (line<>'') then begin
        if (not opt_t) then write(stdout,line_no:6,'  ',line)
                       else write(stdout,line_no:6,'  ',printable(line))
      end
    end else if (opt_n) then begin
      inc(line_no);
      if (not opt_t) then write(stdout,line_no:6,'  ',line)
                     else write(stdout,line_no:6,'  ',printable(line));
    end else begin
      if (not opt_t) then write(stdout,line)
                     else write(stdout,printable(line));
    end;
    if (opt_e) then write(stdout,'$');
    writeln(stdout)
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,stdbufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    tf: text;      { ascii }
    line: string;  {       }
    f,stdo: file;  { non-ascii }
    rlr,rlw: word; {           }
  begin
    { distinguish between ascii and nonascii mode }
    if (not asciimode) then begin
      bininp(f,p+s.name);
      binout(stdo,'');

      if (debug) then begin
        if (s.name<>'') then writeln(conout,'       Bin-Reading ',p+s.name)
                        else writeln(conout,'       Bin-Reading stdin');
      end;

      { copy f to stdo }
      rlr := stdbufsize;
      while (not eof(f)) and (rlr=stdbufsize) do begin
        blockread(f,fbuf^,stdbufsize,rlr);

        if (debug) then
          writeln(conout,'       Read  ',rlr,
                         '/',stdbufsize,' bytes from ',p+s.name);

        if (rlr>0) then begin
          blockwrite(stdo,fbuf^,rlr,rlw);

          if (debug) then
            writeln(conout,'       Wrote ',rlw,
                           '/',rlr,' bytes to stdout');

	  if (rlr<>rlw) then
            err('Error writing to stdout');
        end
      end;

      close(f);
      close(stdo)
    end else begin
      txtinp(tf,p+s.name);
      settextbuf(tf,fbuf^,stdbufsize);
      if (debug) then begin
        if (s.name<>'') then writeln(conout,'       Asc-Reading ',p+s.name)
                        else writeln(conout,'       Asc-Reading stdin');
      end;

      while (not eof(tf)) do begin
        readln(tf,line);
        doit(line)
      end;

      close(tf)
    end
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  { check for the occurence of -s }
  opt_s := false;
  parse(ropt,nopt,nnam);
  while (nopt>0) do begin
    if (getopt(nopt)='s') then begin
      opt_s := true;
      nopt := 0
    end else inc(nopt)
  end;

  { quiet or not? }
  if (opt_s) then process(ropt,
                          pre_op,proc_op,post_op,
                          pre_fn,proc_fn,post_fn,
                          m_stdin or m_pipe or m_quiet)
             else process(ropt,
                          pre_op,proc_op,post_op,
                          pre_fn,proc_fn,post_fn,
                          m_stdin or m_pipe);
  stop(0)
end.
@

