head	1.6;
access;
symbols
	rutils40:1.3;
locks;
comment	@        @;


1.6
date	93.04.05.19.45.36;	author Ricki;	state Exp;
branches;
next	1.5;

1.5
date	93.03.31.19.22.12;	author Ricki;	state Exp;
branches;
next	1.4;

1.4
date	93.03.26.19.40.14;	author Ricki;	state Exp;
branches;
next	1.3;

1.3
date	93.03.16.16.08.12;	author Ricki;	state Rel;
branches;
next	1.2;

1.2
date	93.02.10.22.01.58;	author Ricki;	state Exp;
branches;
next	1.1;

1.1
date	93.01.25.12.42.09;	author Ricki;	state Exp;
branches;
next	;


desc
@Change and display file attributes
@

1.6
log
@bugfix for directory parameters
chmod -R, chmod -D, chmod -d now work
@
text
@{$I SWITCHES.INC}
{ $Id: chmod.pas 1.5 1993/03/31 19:22:12 Ricki Exp $ }
program chmod;
{ Change and display file and directory attributes }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: chmod.pas $
        Revision 1.5  1993/03/31  19:22:12  Ricki
        update to new email address

        Revision 1.4  1993/03/26  19:40:14  Ricki
        modified the procedure 'process'
        CHMOD, when called alone, processes '*.*', not '.'

        Revision 1.3  1993/03/16  16:08:12  Ricki
        built in directory support

        Revision 1.2  1993/02/10  22:01:58  Ricki
        new switch -f
        modified -v page
        use s.attr in proc_fn, instead of a call to fgetattr

        Revision 1.1  1993/01/25  12:42:09  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  cmdline, { only for the mode constants }
  files,
  standard,
  numbers,
  outcon,
  cmscan,
  outstd,
  options,
  dostools,
  dos;

const
  pversion = '$Id: chmod.pas 1.5 1993/03/31 19:22:12 Ricki Exp $';

  func = 'Change and display file and directory attributes';
  year = '1992,1993';
  desn = 'CHMOD/2';
  desv = '1.0';
  opts = 'cdDfhHnRv*'; { not used for parse! }

  modes = 'sahrA';  { valid attributes }

  mark = '>';

  max_names = 20;
  max_opt = 10;

var
  debug: boolean;
  nopt,nnam: byte;
  namf: array [1..max_names] of comstr;
  optf: array [1..max_opt] of char;
  savmode,oldmode,addmode,submode,absmode: word;
  tog_s,tog_a,tog_h,tog_r: boolean;
  opt_d,opt_dd,opt_f,opt_n,opt_c,opt_R: boolean;
  procmode: word;

  {$i chmod.i1}
  {$i chmod.i2}

  procedure help1;
  begin
    header(desv,year,func);
    chmodi1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    chmodi2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln;
    revision(desn,desv);
    writeln;
    author;
    stop(1)
  end;

  procedure scan_mode(m: pathstr);
  type
    statetype = (s_start,s_add,s_sub,s_tog,s_abs);
  var
    i,l: byte;
    s: statetype;
  begin
    l := length(m); s := s_start;
    for i:=1 to l do case s of
      s_start: case m[i] of
        '-': s := s_sub;
        '+': s := s_add;
        '~': s := s_tog;
        '=': s := s_abs;
        else err('Illegal mode "'+m+'"');
      end;
      s_add: case m[i] of
        '+': ;
        's': addmode := addmode or SysFile;
        'r': addmode := addmode or ReadOnly;
        'a': addmode := addmode or Archive;
        'h': addmode := addmode or Hidden;
        'A': addmode := SysFile or ReadOnly or Archive or Hidden;
        ',': s := s_start;
        '-': s := s_sub;
        '~': s := s_tog;
        '=': s := s_abs;
        else err('Illegal mode "'+m+'"');
      end;
      s_sub: case m[i] of
        '-': ;
        's': submode := submode or SysFile;
        'r': submode := submode or ReadOnly;
        'a': submode := submode or Archive;
        'h': submode := submode or Hidden;
        'A': submode := SysFile or ReadOnly or Archive or Hidden;
        ',': s := s_start;
        '+': s := s_add;
        '~': s := s_tog;
        '=': s := s_abs;
        else err('Illegal mode "'+m+'"');
      end;
      s_tog: case m[i] of
        '~': ;
        's': tog_s := not tog_s;
        'r': tog_r := not tog_r;
        'a': tog_a := not tog_a;
        'h': tog_h := not tog_h;
        'A': begin
          tog_s := not tog_s;
          tog_r := not tog_r;
          tog_a := not tog_a;
          tog_h := not tog_h;
        end;
        ',': s := s_start;
        '+': s := s_add;
        '-': s := s_sub;
        '=': s := s_abs;
        else err('Illegal mode "'+m+'"');
      end;
      s_abs: case m[i] of
        '=': ;
        's': absmode := absmode or SysFile;
        'r': absmode := absmode or ReadOnly;
        'a': absmode := absmode or Archive;
        'h': absmode := absmode or Hidden;
        'A': absmode := SysFile or ReadOnly or Archive or Hidden;
        ',': s := s_start;
        '+': s := s_add;
        '-': s := s_sub;
        '~': s := s_tog;
        else err('Illegal mode "'+m+'"');
      end;
    end
  end;

  {$f+} procedure pre_op; {$f-}
  begin
    nnam := 0; nopt := 0;
    addmode := 0; submode := 0; absmode := 0;
    tog_a := false; tog_s := false; tog_r := false; tog_h := false;
    opt_n := false; opt_c := false; opt_R := false; opt_f := false;
    		    opt_d := false; opt_dd := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op; {$f-}
  var
    i,j: byte;
    c: comstr;
  begin
    { help? }
    if (cmcount=1) and ((cmstr(1)='-h') or (cmstr(1)='/h')) then help1;

    { loop over all arguments }
    for i:=1 to cmcount do begin
      c := cmstr(i); if (c='') then err('No input from stdin allowed');

      { option / neg.mode? }
      if (c[1]='-') or (c[1]='/') then begin
        { if c[1]='-' then c[2] determines whether a mode is here (if it's in
          modes) or an option (else) }
        if (c[1]='-') then begin
          if (pos(c[2],modes)>0) then begin scan_mode(c); c := '' end
        end;
        for j:=2 to length(c) do case c[j] of
          'c': opt_c := true;
          'd': opt_d := true;
          'D': opt_dd := true;
          'f': opt_f := true;
          'n': opt_n := true;
          'H': help2;
          'R': opt_r := true;
          'v': version;
          '*': debug := true;
          else err('Illegal option -'+c[j])
        end

      { pos.mode/tog.mode/abs.mode? }
      end else if (c[1]='+') or (c[1]='=') or (c[1]='~') then scan_mode(c)

      { name }
      else begin
        inc(nnam); if (nnam>max_names) then err('Too many arguments');
        namf[nnam] := c
      end
    end;

    { default is 'chmod *.*' }
    if (nnam=0) then begin
      nnam := 1;
      namf[nnam] := '*.*'
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(opts,pversion);

    if (nnam=0) then err('Nothing to do')
  end;

  procedure show(fn: pathstr; nm,om: word);
  { format: arhs  filename
        or: arhs >filename, if mode has changed }
  begin
    if (opt_c) and (nm=om) then exit;
    write(stdout,attr2str(nm),' ');
    if (nm=om) then writeln(stdout,' ',fn)
               else writeln(stdout,mark,fn)
  end;

  procedure apply_mode(var m: word);
  { applies the changes to m }
  begin
    { (1) sets, (2) adds, (3) subs, (4) toggles }
    if (absmode<>0) then m := absmode;
    m := (m or addmode) and not submode;
    if (tog_a) then begin
      if (m and archive>0) then m := m and not archive
                           else m := m or archive
    end;
    if (tog_r) then begin
      if (m and readonly>0) then m := m and not readonly
                            else m := m or readonly
    end;
    if (tog_s) then begin
      if (m and sysfile>0) then m := m and not sysfile
                           else m := m or sysfile
    end;
    if (tog_h) then begin
      if (m and hidden>0) then m := m and not hidden
                          else m := m or hidden
    end
  end;

  {local} procedure assign_dir(var sr: searchrec; n: namestring);
  { fills sr with the appropriate values for a directory }
  begin
    sr.name := n;
    sr.attr := directory;
    sr.size := 0;
    sr.time := 0;
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    ok: boolean;
  begin
    { skip . and .. }
    if (s.name='.') or (s.name='..') then exit;

    { get the old file mode }
    getfileatt(p+s.name,oldmode,ok);

    { leave, if -D and no directory }
    if (opt_dd) and (oldmode and directory=0) then exit;

    { apply the changes to oldmode }
    savmode := oldmode;
    apply_mode(oldmode);

    { display a warning for system files w/o -f }
    if (savmode and sysfile>0) and (oldmode<>savmode)
    and (not opt_f) and (not opt_n) then begin
      warn('Refuse to modify '+p+s.name);
      exit
    end;

    if (debug) then
      writeln(conout,'       ',fillname(p+s.name),': ',attr2str(savmode),
                               ' --> ',attr2str(oldmode));

    { if mode is unchanged or -n is specified, just display the file with
      its attributes }
    if (oldmode=savmode) or (opt_n) then
      show(p+s.name,oldmode,savmode)
    { otherwise apply and show it }
    else begin
      setfileatt(p+s.name,oldmode);
      show(p+s.name,oldmode,savmode)
    end
  end;

  procedure process(proc_fn: TfnProc; mode: word);
  var
    i,code: byte;
    fn: namestring;
    redirected: boolean;
    sr: searchrec;
    mask: word;
    fdir: dirstr;
    fnam: namestr;
    fext: extstr;
    codeline: longint;
  begin
    { determine whether the input has been redirected }
    redirected := InpRedirected;

    { setup the appropriate file mask }
    mask := archive;
    if (mode and m_sysfile=m_sysfile) then mask := mask or hidden or sysfile;
    if (mode and m_readonly=m_readonly) then mask := mask or readonly;
    if (mode and m_dir=m_dir) then mask := mask or directory;

    { loop over the names }
    for i:=1 to nnam do begin
      fn := namf[i];

      { handle directory names }
      if (isdir(fn)) then begin
        if (mode and m_dir=0) then begin
          { a directory name means dir\*.* }
          if (mode and m_recurse=m_recurse) then begin
            forallrec(fn,'*.*',mask,proc_fn,code)
          end else begin
            if (fn[length(fn)]='\') then fn := fn+'*.*'
                                    else fn := fn+'\*.*';
            forall(fn,mask,proc_fn,code)
          end
        end else begin { mode and m_dir<>0 }
          assign_dir(sr,fn);
          proc_fn(sr,'');
          { recurse here, too }
          if (mode and m_recurse=m_recurse) then begin
            forallrec(fn,'*.*',mask or directory,proc_fn,code)
          end else code := 0
        end;
        if (code<>0) then begin
          err('Directory loop failed for '+fn+': '+fileerrstr(code))
        end
      end else begin { not isdir(fn) }
        { handle listfile names }
        if (fn='') then
          err('Standard input is not allowed')
	else if (fn[1]='@@') then begin
	  forlistfile(copy(fn,2,255),mask,proc_fn,code,codeline);
          if (code<>0) then begin
            err('Listfile loop failed for '+fn+': '+fileerrstr(code)+
            ' (detected in line '+numstr(codeline)+')')
          end
        end
        else begin { not stdin }
          { try to start a loop over fn }
          if (mode and m_recurse=0) then begin
            forall(fn,mask,proc_fn,code)
          end
          else begin
            { split name+extension from fn, because they are the mask;
              the directory component is the path }
            fsplit(fn,fdir,fnam,fext);
            forallrec(fdir,fnam+fext,mask,proc_fn,code)
          end;
          if (code<>0) then begin
            err('Filename loop failed for '+fn+': '+fileerrstr(code))
          end
        end
      end
    end
  end;

begin
  setlazy(true);

  pre_op;
  proc_op;
  post_op;

  { determine the process mode from the options }
  procmode := m_sysfile or m_readonly;
  if (opt_R) then procmode := procmode or m_recurse;
  if (opt_d) or (opt_dd) then procmode := procmode or m_dir;

  process(proc_fn,procmode);

  stop(0)
end.
@


1.5
log
@update to new email address
@
text
@d2 1
a2 1
{ $Id: chmod.pas 1.4 1993/03/26 19:40:14 Ricki Exp $ }
d26 3
d58 1
d63 1
a63 1
  pversion = '$Id: chmod.pas 1.4 1993/03/26 19:40:14 Ricki Exp $';
a209 7
    { default is 'chmod .' }
    if (cmcount=0) then begin
      nnam := 1;
      namf[nnam] := '*.*';
      exit
    end;

d245 6
d375 1
a375 2
          end
          else begin
d380 1
a380 2
        end
        else begin { mode and m_dir<>0 }
d386 1
a386 1
          end
d422 2
@


1.4
log
@modified the procedure 'process'
CHMOD, when called alone, processes '*.*', not '.'
@
text
@d2 1
a2 1
{ $Id: chmod.pas 1.3 1993/03/16 16:08:12 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d26 4
d59 1
a59 1
  pversion = '$Id: chmod.pas 1.3 1993/03/16 16:08:12 Ricki Exp $';
@


1.3
log
@built in directory support
@
text
@d2 1
a2 1
{ $Id: chmod.pas 1.2 1993/02/10 22:01:58 Ricki Exp $ }
d26 3
d55 1
a55 1
  pversion = '$Id: chmod.pas 1.2 1993/02/10 22:01:58 Ricki Exp $';
d205 1
a205 1
      namf[nnam] := '.';
a288 9
  {local} procedure assign_stdin(var sr: searchrec);
  { fills sr with the appropriate values for stdin }
  begin
    sr.name := '';
    sr.attr := archive;
    sr.size := 0;
    sr.time := 0;
  end;

a357 14
    { special case: no names, input redirected }
    if (nnam=0) and (redirected) then begin
      if (mode and m_pipe=m_pipe) then begin
        assign_stdin(sr);
        proc_fn(sr,'')
      end else begin
        if (mode and m_quiet=m_none) then warn('Piping is not allowed')
      end

    { no names? no pipe? no job! }
    end else if (nnam=0) then begin
      if (mode and m_quiet=0) then warn('Nothing to do')
    end

d359 1
a359 1
    else for i:=1 to nnam do begin
d381 1
a381 1
          end;
d384 1
a384 3
          if (mode and m_quiet=0) then begin
            err('Directory loop failed for '+fn+': '+fileerrstr(code))
          end
a386 12
        { stdin? }
        if (fn='') then begin
          if (mode and m_stdin=m_stdin) then begin
            assign_stdin(sr);
            proc_fn(sr,'')
          end
          else begin
            if (mode and m_quiet=0) then begin
              err('Standard input is not allowed')
            end
          end
        end
d388 3
a390 1
        else if (fn[1]='@@') then begin
d393 2
a394 4
            if (mode and m_quiet=0) then begin
              err('Listfile loop failed for '+fn+': '+fileerrstr(code)+
              ' (detected in line '+numstr(codeline)+')')
            end
d409 1
a409 3
            if (mode and m_quiet=0) then begin
              err('Filename loop failed for '+fn+': '+fileerrstr(code))
            end
d422 1
a422 1
  procmode := m_sysfile or m_readonly or m_quiet;
@


1.2
log
@new switch -f
modified -v page
use s.attr in proc_fn, instead of a call to fgetattr
@
text
@d2 1
a2 1
{ $Id: chmod.pas 1.1 1993/01/25 12:42:09 Ricki Exp $ }
d4 1
a4 1
{ Change and display file attributes }
d26 5
d44 1
d52 1
a52 1
  pversion = '$Id: chmod.pas 1.1 1993/01/25 12:42:09 Ricki Exp $';
d54 1
a54 1
  func = 'Change and display file attributes';
d58 1
a58 1
  opts = 'cfhHnRv*'; { not used for parse! }
d74 2
a75 1
  opt_f,opt_n,opt_c,opt_R: boolean;
d186 1
d199 6
a204 1
    if (cmcount=0) then help1;
d222 2
d306 1
a306 1
    f: file;
d308 3
d312 6
a317 2
    assign(f,p+s.name);
    oldmode := s.attr;
d319 1
d321 6
a326 4
    { apply the changes to oldmode }
    if (oldmode and sysfile>0) and (not opt_f) then
      warn('Refuse to modify '+p+s.name)
    else apply_mode(oldmode);
d338 1
a338 2
      setfattr(f,oldmode);
      if (ioresult<>0) then warn('Failed to change '+p+s.name);
d353 1
d362 1
a392 5
          end;
          if (code<>0) then begin
            if (mode and m_quiet=0) then begin
              err('Directory loop failed for '+fn+': '+fileerrstr(code))
            end
d397 10
a406 1
          proc_fn(sr,'')
d408 1
a408 2
      end
      else begin { not isdir(fn) }
d421 10
d457 6
a462 4
  if (opt_R) then
    process(proc_fn,m_recurse or m_sysfile or m_readonly)
  else
    process(proc_fn,m_sysfile or m_readonly);
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id$ }
d25 3
a27 1
        $Log$
d46 1
a46 1
  pversion = '$Id$';
d51 2
a52 1
  opts = 'chHnv*'; { not used for parse! }
d68 1
a68 1
  opt_n,opt_c,opt_R: boolean;
d75 1
a75 1
    header(year,func);
d82 1
a82 1
    header(year,func);
d89 1
a89 1
    header(year,func);
d91 1
a91 1
    revision(desn,'$Revision: 4.3 $');
d178 1
a178 1
    opt_n := false; opt_c := false; opt_R := false;
d209 1
d294 2
a295 2
    {$i-} assign(f,p+s.name); getfattr(f,oldmode); {$i+}
    if (ioresult<>0) then err('Cannot process "'+p+s.name+'"');
d299 3
a301 1
    apply_mode(oldmode);
d304 1
a304 1
      writeln(conout,'       ',p+s.name,#9,': ',attr2str(savmode),
d314 1
d418 5
a422 2
  if (opt_R) then process(proc_fn,m_sysfile or m_readonly or m_recurse)
             else process(proc_fn,m_sysfile or m_readonly);
@

