head	1.4;
access;
symbols
	rutils40:1.3;
locks;
comment	@        @;


1.4
date	93.04.18.19.18.40;	author Ricki;	state Exp;
branches;
next	1.3;

1.3
date	93.02.10.22.14.17;	author Ricki;	state Rel;
branches;
next	1.2;

1.2
date	93.01.22.08.10.39;	author Ricki;	state Exp;
branches;
next	1.1;

1.1
date	93.01.04.17.28.54;	author ricki;	state Exp;
branches;
next	;


desc
@extract comments from binary files, if possible
@

1.4
log
@update to new mail address
@
text
@{$I SWITCHES.INC}
{ $Id: comments.pas 1.3 1993/02/10 22:14:17 Ricki Exp $ }
unit comments;
{ extract comments from binary files, if possible }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: comments.pas $
        Revision 1.3  1993/02/10  22:14:17  Ricki
        new function hascomment

        Revision 1.2  1993/01/22  08:10:39  Ricki
        speedup for ZIP file comments (BUT: not a 100% solution anymore)

        Revision 1.1  1993/01/04  17:28:54  ricki
        Initial revision
}

interface

  uses
    dos;

  const
    supported_ext = '.ZIP.ZOO.ARJ';

  type
    supported = (f_NOT,f_zip,f_zoo,f_arj{,f_arc,f_lzh,f_gif...});

  procedure getcomment(var f: file; var ftype: supported;
                       var comment: string);
  { returns up to 255 characters from the first line of the comment
    included in file f, if f is of one of the supported file types -
    comment may (of course) be empty. if f is not identified, ftype
    is set to f_NOT and comment='' is returned }

  function hascomment(ext: extstr): boolean;
  { returns true, if ext is a filename extension of one of the supported
    file types, ie. ZIP, ZOO, or so. ext may or may not contain a
    leading '.' }

implementation

  {$i-} { turn off IO checking for all procedures }

  var
    rl: word;

  {local} procedure line1(var s: string);
  { cut s after the first CR or LF }
  var
    p,q: byte;
  begin
    p := pos(#10,s); if (p=0) then p := length(s)+1;
    q := pos(#13,s); if (q=0) then q := length(s)+1;
    if (p<q) then s[0] := chr(p-1)
    else if (q<p) then s[0] := chr(q-1)
  end;

  {local} function identify(var f: file): supported;
  var
    magic: longint;
    magicw: array [1..2] of word absolute magic;
  begin
    identify := f_NOT;

    { read magic number for ZIP, ARJ }
    seek(f,0);
    blockread(f,magic,sizeof(magic),rl); if (rl<sizeof(magic)) then exit;

    { check it }
    if (magic=$04034b50) then begin
      identify := f_zip;
      exit
    end else if (magicw[1]=$ea60) then begin
      identify := f_arj;
      exit
    end;

    { read magic number for ZOO }
    seek(f,20);
    blockread(f,magic,sizeof(magic),rl); if (rl<sizeof(magic)) then exit;

    { check it }
    if (magic=$fdc4a7dc) then begin
      identify := f_zoo;
      exit
    end;

  end;

  {local} procedure getzip(var f: file; var comment: string);
  { speedup: read the last size bytes and try to find the beginning of
    the end-of-central-directory-record }
  label
    free;
  const
    size = 1024;
  type
    buftype = array [1..size] of byte;
  var
    i,p: longint;
    fbuf: ^buftype;
    len,rl: word;
  begin
    comment := '';
    p := filesize(f);
    getmem(fbuf,size);
    if (p>size) then dec(p,size) else p := 0;
    seek(f,p);
    blockread(f,fbuf^,size,rl);

    { try to find $06054b50 }
    i := 1;
    while (i<rl-20) and ((fbuf^[i]<>$50)
                      or (fbuf^[i+1]<>$4b)
                      or (fbuf^[i+2]<>$05)
                      or (fbuf^[i+3]<>$06)) do inc(i);
    if (i>=rl-20) then goto free;

    len := fbuf^[i+20]+256*fbuf^[i+21];
    if (i+len+21<>rl) then goto free;

    if (len=0) then goto free;
    if (len>255) then len := 255;
    comment[0] := chr(len);
    move(fbuf^[i+22],comment[1],len);

    { cut after CR or LF }
    line1(comment);

    free: freemem(fbuf,size)
  end;

  {local} procedure getzoo(var f: file; var comment: string);
  { Nicer than getzip }
  var
    h: record { at pos 35 }
      cp: longint;
      cl: word
    end;

  begin
    comment := '';
    seek(f,35);

    blockread(f,h,sizeof(h),rl); if (rl<sizeof(h)) then exit;
    if (h.cl=0) then exit;

    seek(f,h.cp);
    if (h.cl>255) then comment[0] := #255
                  else comment[0] := chr(h.cl);
    blockread(f,comment[1],ord(comment[0]),rl);
      if (rl<ord(comment[0])) then exit;

    { cut after CR or LF }
    line1(comment)
  end;

  {local} procedure getarj(var f: file; var comment: string);
  { Not as nice as getzoo, but nicer than getzip anyway }
  var
    fl: byte; { at pos 9 }
    p: longint;
    s,e: word;
    st: array [1..8+1+3+1+255] of char;
              {   | | | |  +- max comment length interesting for us here
                  | | | +---- 0 terminating file name
                  | | +------ file name extension
                  | +-------- "."
                  +---------- file name }
  begin
    comment := '';
    seek(f,9);

    blockread(f,fl,sizeof(fl),rl); if (rl<sizeof(fl)) then exit;
    { if the EXTFILE_TAG flag $08 is set, the extra_data-longint is present }
    if (fl and $08=$08) then p := 39
                        else p := 35;

    { at p the filename (0-terminated) starts - skip it and get the comment }
    seek(f,p);
    blockread(f,st,sizeof(st),rl); if (rl<2) then exit; { at least #0#0 }

    { determine s=start and e=endposition of comment }
    s := 1;
    while (s<rl) and (st[s]<>#0) do inc(s);
    if (s=rl) then exit;
    e := s+1;
    while (e<=rl) and (st[e]<>#0) do inc(e);

    { get the comment }
    comment[0] := chr(e-s-1);
    move(st[s+1],comment[1],ord(comment[0]));

    { cut after CR or LF }
    line1(comment)
  end;

  procedure getcomment(var f: file; var ftype: supported;
                       var comment: string);
  begin
    ftype := identify(f);
    case ftype of
      f_NOT: begin
        comment := ''; exit
      end;
      f_zip: getzip(f,comment);
      f_zoo: getzoo(f,comment);
      f_arj: getarj(f,comment);
    end
  end;

  function hascomment(ext: extstr): boolean;
  begin
    ext[1] := upcase(ext[1]);
    ext[2] := upcase(ext[2]);
    ext[3] := upcase(ext[3]);
    ext[4] := upcase(ext[4]);
    hascomment := (pos(ext,supported_ext)>0)
  end;

end.
@


1.3
log
@new function hascomment
@
text
@d2 1
a2 1
{ $Id: COMMENTS.PAS 1.2 1993/01/22 08:10:39 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 4
a28 1
        $Log: COMMENTS.PAS $
@


1.2
log
@speedup for ZIP file comments (BUT: not a 100% solution anymore)
@
text
@d1 2
a2 1
{ $Id: COMMENTS.PAS 1.1 1993/01/04 17:28:54 ricki Exp $ }
d26 3
d35 6
d51 5
d228 8
a235 1
  {$i+}
@


1.1
log
@Initial revision
@
text
@d1 1
a1 1
{ $Id$ }
d24 3
a26 1
        $Log$
d43 2
d92 8
a99 1
  { I never said it's nice... }
d101 3
a103 21
    si: longint;
    h1: record
      d1: array [1..7] of word;
      cs: longint;
      d2: array [1..2] of word;
      fn: word;
      ef: word
    end;
    h2: record
      d1: array [1..12] of word;
      fn: word;
      ef: word;
      fc: word;
      d2: array [1..6] of word
    end;
    h3: record
      d1: array [1..8] of word;
      zc: word
    end;
    p: longint;

d106 5
a110 1
    seek(f,0); p := 0;
d112 15
a126 27
    { skip local file headers and file data }
    repeat
      blockread(f,si,sizeof(si),rl); if (rl<sizeof(si)) then exit;
      if (si=$04034b50) then begin
        blockread(f,h1,sizeof(h1),rl); if (rl<sizeof(h1)) then exit;
        inc(p,sizeof(si)+sizeof(h1)+h1.cs+h1.fn+h1.ef);
        seek(f,p)
      end
    until (si<>$04034b50);
    if (si<>$02014b50) then exit;

    { skip file headers in central directory }
    repeat
      blockread(f,h2,sizeof(h2),rl); if (rl<sizeof(h2)) then exit;
      inc(p,sizeof(si)+sizeof(h2)+h2.fn+h2.ef);
      seek(f,p);

      blockread(f,si,sizeof(si),rl); if (rl<sizeof(si)) then exit;
    until (si<>$02014b50);
    if (si<>$06054b50) then exit;

    { read end-of-central-dir record containing the comment }
    blockread(f,h3,sizeof(h3),rl); if (rl<sizeof(h3)) then exit;
    if (h3.zc>255) then comment[0] := #255
                   else comment[0] := chr(h3.zc);
    blockread(f,comment[1],ord(comment[0]),rl);
      if (rl<ord(comment[0])) then exit;
d129 3
a131 1
    line1(comment)
d212 2
@

