head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.21.45;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.10.22.05.12;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.21.21.40.12;	author Ricki;	state Exp;
branches;
next	;


desc
@Remove selected fields from each line of a file
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: cut.pas 1.2 1993/02/10 22:05:12 Ricki Exp $ }
program cut;
{ Remove selected fields from each line of a file }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: cut.pas $
        Revision 1.2  1993/02/10  22:05:12  Ricki
        bugfix: -s did not work correctly
        modified -v page

        Revision 1.1  1993/01/21  21:40:12  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id: cut.pas 1.2 1993/02/10 22:05:12 Ricki Exp $';

  func = 'Remove selected fields from each line of a file';
  year = '1992,1993';
  desn = 'CUT/2';
  desv = '1.0';
  opts = 'hHnuv*'; ropt = opts+'c:d:f:is';

  max_nc = 128;
  max_nf = 255;
  max_np = 128;

type
  remtype = record start,len: byte end;

var
  fbuf: pointer;
  debug: boolean;

  nc,nf,nl: byte;
  ac: array [1..max_nc] of remtype;
  af: array [1..max_nf] of byte;
  opt_s,opt_f,opt_c,opt_i: boolean;
  delimiter: char;
  arr: string;

  {$i cut.i1}
  {$i cut.i2}

  procedure help1;
  begin
    header(desv,year,func);
    cuti1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    cuti2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  procedure parse_list(s: comstr; var arr: string);

  type
    statetype = (s_start,s_first,s_second);
    parsetype = array [1..max_np] of record start,ende: byte end;

  var
    n,len,i,j,fpos: byte;
    f: parsetype;
    code: integer;
    state: statetype;

  begin
    { loop to parse list }
    state := s_start; n := 0; len := length(s);
    for i:=1 to len do case state of
      s_start: case s[i] of
        '0'..'9': begin inc(n); fpos := i; state := s_first end;
        '-': begin
          inc(n); f[n].start := 1;
          fpos := i+1; state := s_second
        end;
        else err('Illegal list argument')
      end;
      s_first: case s[i] of
        '0'..'9': ;
        '-': begin
          val(copy(s,fpos,i-fpos),f[n].start,code);
          if (code<>0) then err('Illegal start column');
          fpos := i+1;
          state := s_second
        end;
        ',': begin
          val(copy(s,fpos,i-fpos),f[n].start,code);
          if (code<>0) then err('Illegal start column');
          f[n].ende := f[n].start;
          state := s_start
        end;
        else err('Illegal list argument')
      end;
      s_second: case s[i] of
        '0'..'9': ;
        '-': err('Illegal list argument');
        ',': begin
          if (fpos=i) then f[n].ende := 255
          else begin
            val(copy(s,fpos,i-fpos),f[n].ende,code);
            if (code<>0) then err('Illegal end column');
            if (f[n].ende<f[n].start) then err('End column too small')
          end;
          state := s_start
        end;
        else err('Illegal list argument')
      end
    end;

    { check the end }
    case state of
      s_start: err('Illegal list argument');
               { never end in the start state! }
      s_first: begin
               { a single column }
        val(copy(s,fpos,len+1-fpos),f[n].start,code);
        if (code<>0) then err('Illegal column');
        f[n].ende := f[n].start
      end;
      s_second: begin
        if (fpos>len) then f[n].ende := 255 { sth. like 10- }
        else begin { 10-20 }
          val(copy(s,fpos,len+1-fpos),f[n].ende,code);
          if (code<>0) then err('Illegal end column');
          if (f[n].ende<f[n].start) then err('End column too small')
        end
      end
    end;

    { transfer start-ende list into a char array containing 'd' if field
      is to be deleted, ' ' otherwise }
    arr[0] := #255;
    fillchar(arr[1],255,' ');
    for i:=1 to n do begin
      for j:=f[i].start to f[i].ende do begin
        arr[j] := 'd'
      end
    end
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    opt_s := false; opt_f := false; opt_c := false; opt_i := false;
    nf := 0; nc := 0; delimiter := #9;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'i': opt_i := true;
      'f': begin
        opt_f := true;
        parse_list(optarg,arr)
      end;
      'c': begin
        opt_c := true;
        parse_list(optarg,arr)
      end;
      'd': if (length(optarg)<>1) then err('Illegal -d argument')
                                  else delimiter := optarg[1];
      's': opt_s := true;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  var
    k: integer;
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    { -f and -c are mutually exclusive, -s and -d are valid only with -f }
    if (not opt_c) and (not opt_f) then
      err('You must specify one of -f and -c');
    if (opt_c) and (opt_f) then
      err('-f and -c are mutually exclusive');
    if (opt_c) and ( (opt_s) or (delimiter<>#9) ) then
      warn('-s and -d are useful only with -f');

    { inverse arr, if necessary }
    if (opt_i) then for k:=1 to 255 do
      if (arr[k]='d') then arr[k] := ' ' else arr[k] := 'd';

    { transfer arr into lists }
    if (opt_f) then begin
      { transfer arr into field list }
      nf := 0;
      for k:=1 to 255 do if (arr[k]='d') then begin
        inc(nf); af[nf] := k
      end
    end else begin
      { transfer string into start-length list }
      k:=1; while (k<=255) do begin
        if (arr[k]='d') then begin
          inc(nc); ac[nc].start := k; ac[nc].len := 1;
          inc(k);
          while (k<=255) and (arr[k]='d') do begin
            inc(ac[nc].len); inc(k)
          end
        end else inc(k)
      end
    end
  end;

  procedure kill_columns(var s: string);
  var i: byte;
  begin for i := nc downto 1 do delete(s,ac[i].start,ac[i].len)
  end;

  procedure kill_fields(var s: string; var found: boolean);
  type
    pf_array = array [0..128] of integer;
  var
    len,npf,i: byte;
    pf: pf_array;

    procedure allpos(line: string; var pf: pf_array; var n: byte);
    { calculate the ending positions of delimiter blocks }
    var
      i,l,p: byte;
    begin
      n := 0; pf[0] := 0;
      l := length(line);
      for i:=2 to l do begin
        if (line[i]<>delimiter) and (line[i-1]=delimiter) then begin
          inc(n);
          pf[n] := i-1
        end
      end;
      inc(n); pf[n] := l+1
    end;

  begin
    { remove leading and trailing delimiters from s }
    {s := headtrim(s,[delimiter]);
    s := tailtrim(s,[delimiter]);}
    { calculate all delimiter end positions in s }
    allpos(s,pf,npf);
    found := (npf>1);
    {if (not found) then found := af[1]=1;}
    if (not found) then exit;
    { loop over the fields to be deleted }
    for i:=nf downto 1 do if (af[i]<=npf) then begin
      { delete field af[i], which lies between pf[i-1]+1 and pf[i] }
      len := pf[af[i]]-pf[af[i]-1];
      if (len>0) then delete(s,pf[af[i]-1]+1,len)
    end
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,stdbufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    line: string;
    found: boolean;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,stdbufsize);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    while (not eof(f)) do begin
      readln(f,line);
      found := true;
      if (line<>'') then begin
        if (nc>0) then kill_columns(line)
                  else kill_fields(line,found)
      end;
      if (found) or (not opt_s) then writeln(stdout,line)
    end;

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@


1.2
log
@bugfix: -s did not work correctly
modified -v page
@
text
@d2 1
a2 1
{ $Id: CUT.PAS 1.1 1993/01/21 21:40:12 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 5
a29 1
        $Log: CUT.PAS $
d49 1
a49 1
  pversion = '$Id: CUT.PAS 1.1 1993/01/21 21:40:12 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: CUT.PAS 1.1 1993/01/21 21:21:49 Ricki Exp $ }
d26 2
a27 3
 * Revision 1.1  1993/01/21  21:21:49  Ricki
 * Initial revision
 *
d45 1
a45 1
  pversion = '$Id: CUT.PAS 1.1 1993/01/21 21:21:49 Ricki Exp $';
d50 1
d76 1
a76 1
    header(year,func);
d83 1
a83 1
    header(year,func);
d90 1
a90 1
    header(year,func);
d92 1
a92 1
    revision(desn,'$Revision: 1.1 $');
d294 2
a295 2
    found := (npf>0);
    if (not found) then found := af[1]=1;
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program cut;
{ Remove selected fields from each line of a file }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id$';

  func = 'Remove selected fields from each line of a file';
  year = '1992,1993';
  desn = 'CUT/2';
  opts = 'hHnuv*'; ropt = opts+'c:d:f:is';

  max_nc = 128;
  max_nf = 255;
  max_np = 128;

type
  remtype = record start,len: byte end;

var
  fbuf: pointer;
  debug: boolean;

  nc,nf,nl: byte;
  ac: array [1..max_nc] of remtype;
  af: array [1..max_nf] of byte;
  opt_s,opt_f,opt_c,opt_i: boolean;
  delimiter: char;
  arr: string;

  {$i cut.i1}
  {$i cut.i2}

  procedure help1;
  begin
    header(year,func);
    cuti1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    cuti2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 4.3 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  procedure parse_list(s: comstr; var arr: string);

  type
    statetype = (s_start,s_first,s_second);
    parsetype = array [1..max_np] of record start,ende: byte end;

  var
    n,len,i,j,fpos: byte;
    f: parsetype;
    code: integer;
    state: statetype;

  begin
    { loop to parse list }
    state := s_start; n := 0; len := length(s);
    for i:=1 to len do case state of
      s_start: case s[i] of
        '0'..'9': begin inc(n); fpos := i; state := s_first end;
        '-': begin
          inc(n); f[n].start := 1;
          fpos := i+1; state := s_second
        end;
        else err('Illegal list argument')
      end;
      s_first: case s[i] of
        '0'..'9': ;
        '-': begin
          val(copy(s,fpos,i-fpos),f[n].start,code);
          if (code<>0) then err('Illegal start column');
          fpos := i+1;
          state := s_second
        end;
        ',': begin
          val(copy(s,fpos,i-fpos),f[n].start,code);
          if (code<>0) then err('Illegal start column');
          f[n].ende := f[n].start;
          state := s_start
        end;
        else err('Illegal list argument')
      end;
      s_second: case s[i] of
        '0'..'9': ;
        '-': err('Illegal list argument');
        ',': begin
          if (fpos=i) then f[n].ende := 255
          else begin
            val(copy(s,fpos,i-fpos),f[n].ende,code);
            if (code<>0) then err('Illegal end column');
            if (f[n].ende<f[n].start) then err('End column too small')
          end;
          state := s_start
        end;
        else err('Illegal list argument')
      end
    end;

    { check the end }
    case state of
      s_start: err('Illegal list argument');
               { never end in the start state! }
      s_first: begin
               { a single column }
        val(copy(s,fpos,len+1-fpos),f[n].start,code);
        if (code<>0) then err('Illegal column');
        f[n].ende := f[n].start
      end;
      s_second: begin
        if (fpos>len) then f[n].ende := 255 { sth. like 10- }
        else begin { 10-20 }
          val(copy(s,fpos,len+1-fpos),f[n].ende,code);
          if (code<>0) then err('Illegal end column');
          if (f[n].ende<f[n].start) then err('End column too small')
        end
      end
    end;

    { transfer start-ende list into a char array containing 'd' if field
      is to be deleted, ' ' otherwise }
    arr[0] := #255;
    fillchar(arr[1],255,' ');
    for i:=1 to n do begin
      for j:=f[i].start to f[i].ende do begin
        arr[j] := 'd'
      end
    end
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    opt_s := false; opt_f := false; opt_c := false; opt_i := false;
    nf := 0; nc := 0; delimiter := #9;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'i': opt_i := true;
      'f': begin
        opt_f := true;
        parse_list(optarg,arr)
      end;
      'c': begin
        opt_c := true;
        parse_list(optarg,arr)
      end;
      'd': if (length(optarg)<>1) then err('Illegal -d argument')
                                  else delimiter := optarg[1];
      's': opt_s := true;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  var
    k: integer;
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    { -f and -c are mutually exclusive, -s and -d are valid only with -f }
    if (not opt_c) and (not opt_f) then
      err('You must specify one of -f and -c');
    if (opt_c) and (opt_f) then
      err('-f and -c are mutually exclusive');
    if (opt_c) and ( (opt_s) or (delimiter<>#9) ) then
      warn('-s and -d are useful only with -f');

    { inverse arr, if necessary }
    if (opt_i) then for k:=1 to 255 do
      if (arr[k]='d') then arr[k] := ' ' else arr[k] := 'd';

    { transfer arr into lists }
    if (opt_f) then begin
      { transfer arr into field list }
      nf := 0;
      for k:=1 to 255 do if (arr[k]='d') then begin
        inc(nf); af[nf] := k
      end
    end else begin
      { transfer string into start-length list }
      k:=1; while (k<=255) do begin
        if (arr[k]='d') then begin
          inc(nc); ac[nc].start := k; ac[nc].len := 1;
          inc(k);
          while (k<=255) and (arr[k]='d') do begin
            inc(ac[nc].len); inc(k)
          end
        end else inc(k)
      end
    end
  end;

  procedure kill_columns(var s: string);
  var i: byte;
  begin for i := nc downto 1 do delete(s,ac[i].start,ac[i].len)
  end;

  procedure kill_fields(var s: string; var found: boolean);
  type
    pf_array = array [0..128] of integer;
  var
    len,npf,i: byte;
    pf: pf_array;

    procedure allpos(line: string; var pf: pf_array; var n: byte);
    { calculate the ending positions of delimiter blocks }
    var
      i,l,p: byte;
    begin
      n := 0; pf[0] := 0;
      l := length(line);
      for i:=2 to l do begin
        if (line[i]<>delimiter) and (line[i-1]=delimiter) then begin
          inc(n);
          pf[n] := i-1
        end
      end;
      inc(n); pf[n] := l+1
    end;

  begin
    { remove leading and trailing delimiters from s }
    {s := headtrim(s,[delimiter]);
    s := tailtrim(s,[delimiter]);}
    { calculate all delimiter end positions in s }
    allpos(s,pf,npf);
    found := (npf>0);
    if (not found) then found := af[1]=1;
    if (not found) then exit;
    { loop over the fields to be deleted }
    for i:=nf downto 1 do if (af[i]<=npf) then begin
      { delete field af[i], which lies between pf[i-1]+1 and pf[i] }
      len := pf[af[i]]-pf[af[i]-1];
      if (len>0) then delete(s,pf[af[i]-1]+1,len)
    end
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,stdbufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    line: string;
    found: boolean;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,stdbufsize);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    while (not eof(f)) do begin
      readln(f,line);
      found := true;
      if (line<>'') then begin
        if (nc>0) then kill_columns(line)
                  else kill_fields(line,found)
      end;
      if (found) or (not opt_s) then writeln(stdout,line)
    end;

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@

