head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.24.08;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.10.22.07.13;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.21.21.41.06;	author Ricki;	state Exp;
branches;
next	;


desc
@Date calculations
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: dcalc.pas 1.2 1993/02/10 22:07:13 Ricki Exp $ }
program dcalc;
{ Date calculations }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: dcalc.pas $
        Revision 1.2  1993/02/10  22:07:13  Ricki
        modified -v page

        Revision 1.1  1993/01/21  21:41:06  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  dates,
  numbers,
  strings,
  standard,
  options,
  outcon,
  cmscan,
  outstd,
  dos;

const
  pversion = '$Id: dcalc.pas 1.2 1993/02/10 22:07:13 Ricki Exp $';

  func = 'Date calculations';
  year = '1993';
  desn = 'DCALC/2';
  desv = '1.0';
  opts = 'hHv*'; ropt = '0:1:2:3:4:5:6:7:8:9: '+opts;

type
  str3 = string[3];

const
  d3str: array [0..6] of str3 =
    ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
  m3str: array [1..12] of str3 =
    ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

var
  s: string; { the command line }
  debug: boolean;
  l,p: byte;
  code: integer;
  diff,add,day1,day2,mon1,mon2,yea1,yea2: longint;
  dow1,dow2,iadd,iday1,iday2,imon1,imon2,iyea1,iyea2,itdd,itdm,itdy: integer;

  {$i dcalc.i1}
  {$i dcalc.i2}

  procedure help1;
  begin
    header(desv,year,func);
    dcalci1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    dcalci2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  procedure today;
  var
    d,m,y,w: word;
  begin
    getdate(y,m,d,w);
    itdd := d;
    itdm := m;
    itdy := y
  end;

  procedure proc_op;
  var
    i,nopt,nnam: byte;
  begin
{$IFDEF DEBUG}
    debug := true;
{$ELSE}
    debug := false;
{$ENDIF}
    parse(ropt,nopt,nnam);
    if (nopt+nnam=0) then help1;
    for i:=1 to nopt do begin
      case getopt(i) of
        'h': help1;
        'H': help2;
        'v': version;
        '*': debug := true
      end
    end;

    { get the whole command line }
    s := cmline;
    { if -* was specified, remove it from s }
    if (debug) then begin
      startdbg;
      substone('-*','',s);
      report(ropt,pversion)
    end
  end;

  function fm(s: string): longint;
  { returns 1..12, if found; 0, if not found; 13, if ambigous }
  const
    mn: array [1..12] of monthstring =
      ('JANUARY','FEBRUARY','MARCH','APRIL','MAY','JUNE','JULY',
       'AUGUST','SEPTEMBER','OCTOBER','NOVEMBER','DECEMBER');
  var
    idx,i: longint;
  begin
    s := strupcase(s);
    idx := 0;
    for i:=1 to 12 do begin
      if (copy(mn[i],1,length(s))=s) then begin
        if (idx<>0) then begin fm := 13; exit end;
        idx := i
      end
    end;
    fm := idx
  end;

  procedure sk;
  begin while (p<=l) and ( (s[p]=' ') or (s[p]=#9) ) do inc(p)
  end;

  function mnum(var num: longint): boolean;
  var
    start,q: byte;
  begin
    start := p;
    sk;
    q := p;
    while (q<=l) and (s[q]>='0') and (s[q]<='9') do inc(q);
    if (q>p) then begin
      val(copy(s,p,q-p),num,code);
      if (code=0) then begin
        mnum := true;
        p := q;
        exit
      end
    end;
    mnum := false;
    p := start
  end;

  function mc(c: char): boolean;
  var
    start,q: byte;
  begin
    start := p;
    if (c<>' ') and (c<>#9) then sk;
    if (p<=l) and (s[p]=c) then begin
      mc := true;
      inc(p)
    end else begin
      mc := false;
      p := start
    end
  end;

  function msmon(var num: longint): boolean;
  var
    start,q: byte;
  begin
    start := p;
    sk;
    q := p;
    while (q<=l) and ( (s[q]>='A') and (s[q]<='Z') )
                  or ( (s[q]>='a') and (s[q]<='z') ) do inc(q);
    if (q>p) then begin
      num := fm(copy(s,p,q-p));
      if (num>0) and (num<13) then begin
        msmon := true;
        p := q;
        exit
      end
    end;
    msmon := false;
    p := start
  end;

  function mdate(var day,month,year: longint): boolean;
  { scans (the beginning of) s for a date. year is todays, if omitted }
  label
    noyear,
    nomatch;
  var
    start: byte;
  begin
    start := p;
    if (mnum(month)) then begin
      if (mc('/')) then begin { mm/dd/yyyy }
        if (not mnum(day)) then goto nomatch;
        if (not mc('/')) then goto noyear;
        if (not mnum(year)) then goto nomatch;
      end else if (mc('.')) then begin
        day := month;
        if (mnum(month)) then begin { dd.mm.yyyy }
          if (not mc('.')) then goto nomatch;
          if (not mnum(year)) then goto noyear;
        end else if (msmon(month)) then begin { dd.MM yyyy }
          if (not mc(' ')) then goto noyear;
          if (not mnum(year)) then goto noyear;
        end else goto nomatch;
      end else if (mc(' ')) then begin { dd MM yyyy }
        day := month;
        if (not msmon(month)) then goto nomatch;
        if (not mc(' ')) then goto noyear;
        if (not mnum(year)) then goto noyear;
      end else goto nomatch;
    end else if (msmon(month)) then begin { MM dd yyyy }
      if (not mc(' ')) then goto nomatch;
      if (not mnum(day)) then goto nomatch;
      if (not mc(' ')) then goto noyear;
      if (not mnum(year)) then goto noyear;
    end else goto nomatch;

    { normal: all is specified }
    mdate := true;
    exit;

    { noyear: no year spec --> supply it }
    noyear:
    mdate := true;
    year := itdy;
    exit;

    { no date }
    nomatch:
    mdate := false;
    p := start {reset}
  end;

begin
  proc_op;

  l := length(s);
  p := 1;
  today;

  { distinguish the various cases }
  if (mdate(day1,mon1,yea1)) then begin
    iday1 := day1; imon1 := mon1; iyea1 := yea1;
    if (not validdate(iday1,imon1,iyea1)) then err('Illegal date');
    if (mc('-')) then begin
      if (mdate(day2,mon2,yea2)) then begin
        iday2 := day2; imon2 := mon2; iyea2 := yea2;
        if (not validdate(iday2,imon2,iyea2)) then err('Illegal date2');
        diff := daydiff(iday2,imon2,iyea2,iday1,imon1,iyea1);
        dow1 := dayinweek(iday1,imon1,iyea1);
        dow2 := dayinweek(iday2,imon2,iyea2);
        writeln(stdout,'Days between  ',
          d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,'  and  ',
          d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2,'  are ',
          diff)
      end else if (mnum(add)) then begin
        iday2 := iday1; imon2 := imon1; iyea2 := iyea1;
        adddays(iday2,imon2,iyea2,-add);
        dow1 := dayinweek(iday1,imon1,iyea1);
        dow2 := dayinweek(iday2,imon2,iyea2);
        writeln(stdout,d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,
                       '  minus ',add,' day(s) is  ',
                       d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2);
      end else begin
        iday2 := itdd; imon2 := itdm; iyea2 := itdy;
        diff := daydiff(iday2,imon2,iyea2,iday1,imon1,iyea1);
        dow1 := dayinweek(iday1,imon1,iyea1);
        dow2 := dayinweek(iday2,imon2,iyea2);
        writeln(stdout,'Days between  ',
                       d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,
                       '  and today,  ',
                       d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2,
                       '  are ',diff)
      end
    end else if (mc('+')) then begin
      if (mnum(add)) then begin
        iday2 := iday1; imon2 := imon1; iyea2 := iyea1;
        adddays(iday2,imon2,iyea2,add);
        dow1 := dayinweek(iday1,imon1,iyea1);
        dow2 := dayinweek(iday2,imon2,iyea2);
        writeln(stdout,d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,
                       '  plus ',add,' day(s) is  ',
                       d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2);
      end else err('Syntax error')
    end else begin
      dow1 := dayinweek(iday1,imon1,iyea1);
      writeln(stdout,'The  ',iday1,' ',m3str[imon1],' ',iyea1,
                     '  is a  ',daystr(dow1));
    end
  end else if (mc('-')) then begin
    iday1 := itdd; imon1 := itdm; iyea1 := itdy;
    if (mdate(day2,mon2,yea2)) then begin
      iday2 := day2; imon2 := mon2; iyea2 := yea2;
      if (not validdate(iday2,imon2,iyea2)) then err('Illegal date');
      diff := daydiff(iday2,imon2,iyea2,iday1,imon1,iyea1);
      dow1 := dayinweek(iday1,imon1,iyea1);
      dow2 := dayinweek(iday2,imon2,iyea2);
      writeln(stdout,'Days between today,  ',
                     d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,
                     '  and  ',
                     d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2,
                     '  are ',diff)
    end else if (mnum(add)) then begin
      iday2 := iday1; imon2 := imon1; iyea2 := iyea1;
      adddays(iday2,imon2,iyea2,-add);
      dow1 := dayinweek(iday1,imon1,iyea1);
      dow2 := dayinweek(iday2,imon2,iyea2);
      writeln(stdout,'Today,  ',d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,
                     '  minus ',add,' day(s) is  ',
                     d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2);
    end else err('Syntax error')
  end else if (mc('+')) then begin
    iday1 := itdd; imon1 := itdm; iyea1 := itdy;
    if (mnum(add)) then begin
      iday2 := iday1; imon2 := imon1; iyea2 := iyea1;
      adddays(iday2,imon2,iyea2,add);
      dow1 := dayinweek(iday1,imon1,iyea1);
      dow2 := dayinweek(iday2,imon2,iyea2);
      writeln(stdout,'Today,  ',d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,
                     '  plus ',add,' day(s) is  ',
                     d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2);
    end else err('Syntax error')
  end else err('Syntax error');

  stop(0)
end.
@


1.2
log
@modified -v page
@
text
@d2 1
a2 1
{ $Id: DCALC.PAS 1.1 1993/01/21 21:41:06 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 4
a28 1
        $Log: DCALC.PAS $
d50 1
a50 1
  pversion = '$Id: DCALC.PAS 1.1 1993/01/21 21:41:06 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: DCALC.PAS 1.1 1993/01/21 21:22:42 Ricki Exp $ }
d26 2
a27 3
 * Revision 1.1  1993/01/21  21:22:42  Ricki
 * Initial revision
 *
d47 1
a47 1
  pversion = '$Id: DCALC.PAS 1.1 1993/01/21 21:22:42 Ricki Exp $';
d52 1
d77 1
a77 1
    header(year,func);
d84 1
a84 1
    header(year,func);
d91 1
a91 1
    header(year,func);
d93 1
a93 1
    revision(desn,'$Revision: 1.1 $');
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program dcalc;
{ Date calculations }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  dates,
  numbers,
  strings,
  standard,
  options,
  outcon,
  cmscan,
  outstd,
  dos;

const
  pversion = '$Id$';

  func = 'Date calculations';
  year = '1993';
  desn = 'DCALC/2';
  opts = 'hHv*'; ropt = '0:1:2:3:4:5:6:7:8:9: '+opts;

type
  str3 = string[3];

const
  d3str: array [0..6] of str3 =
    ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
  m3str: array [1..12] of str3 =
    ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

var
  s: string; { the command line }
  debug: boolean;
  l,p: byte;
  code: integer;
  diff,add,day1,day2,mon1,mon2,yea1,yea2: longint;
  dow1,dow2,iadd,iday1,iday2,imon1,imon2,iyea1,iyea2,itdd,itdm,itdy: integer;

  {$i dcalc.i1}
  {$i dcalc.i2}

  procedure help1;
  begin
    header(year,func);
    dcalci1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    dcalci2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 0.99 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  procedure today;
  var
    d,m,y,w: word;
  begin
    getdate(y,m,d,w);
    itdd := d;
    itdm := m;
    itdy := y
  end;

  procedure proc_op;
  var
    i,nopt,nnam: byte;
  begin
{$IFDEF DEBUG}
    debug := true;
{$ELSE}
    debug := false;
{$ENDIF}
    parse(ropt,nopt,nnam);
    if (nopt+nnam=0) then help1;
    for i:=1 to nopt do begin
      case getopt(i) of
        'h': help1;
        'H': help2;
        'v': version;
        '*': debug := true
      end
    end;

    { get the whole command line }
    s := cmline;
    { if -* was specified, remove it from s }
    if (debug) then begin
      startdbg;
      substone('-*','',s);
      report(ropt,pversion)
    end
  end;

  function fm(s: string): longint;
  { returns 1..12, if found; 0, if not found; 13, if ambigous }
  const
    mn: array [1..12] of monthstring =
      ('JANUARY','FEBRUARY','MARCH','APRIL','MAY','JUNE','JULY',
       'AUGUST','SEPTEMBER','OCTOBER','NOVEMBER','DECEMBER');
  var
    idx,i: longint;
  begin
    s := strupcase(s);
    idx := 0;
    for i:=1 to 12 do begin
      if (copy(mn[i],1,length(s))=s) then begin
        if (idx<>0) then begin fm := 13; exit end;
        idx := i
      end
    end;
    fm := idx
  end;

  procedure sk;
  begin while (p<=l) and ( (s[p]=' ') or (s[p]=#9) ) do inc(p)
  end;

  function mnum(var num: longint): boolean;
  var
    start,q: byte;
  begin
    start := p;
    sk;
    q := p;
    while (q<=l) and (s[q]>='0') and (s[q]<='9') do inc(q);
    if (q>p) then begin
      val(copy(s,p,q-p),num,code);
      if (code=0) then begin
        mnum := true;
        p := q;
        exit
      end
    end;
    mnum := false;
    p := start
  end;

  function mc(c: char): boolean;
  var
    start,q: byte;
  begin
    start := p;
    if (c<>' ') and (c<>#9) then sk;
    if (p<=l) and (s[p]=c) then begin
      mc := true;
      inc(p)
    end else begin
      mc := false;
      p := start
    end
  end;

  function msmon(var num: longint): boolean;
  var
    start,q: byte;
  begin
    start := p;
    sk;
    q := p;
    while (q<=l) and ( (s[q]>='A') and (s[q]<='Z') )
                  or ( (s[q]>='a') and (s[q]<='z') ) do inc(q);
    if (q>p) then begin
      num := fm(copy(s,p,q-p));
      if (num>0) and (num<13) then begin
        msmon := true;
        p := q;
        exit
      end
    end;
    msmon := false;
    p := start
  end;

  function mdate(var day,month,year: longint): boolean;
  { scans (the beginning of) s for a date. year is todays, if omitted }
  label
    noyear,
    nomatch;
  var
    start: byte;
  begin
    start := p;
    if (mnum(month)) then begin
      if (mc('/')) then begin { mm/dd/yyyy }
        if (not mnum(day)) then goto nomatch;
        if (not mc('/')) then goto noyear;
        if (not mnum(year)) then goto nomatch;
      end else if (mc('.')) then begin
        day := month;
        if (mnum(month)) then begin { dd.mm.yyyy }
          if (not mc('.')) then goto nomatch;
          if (not mnum(year)) then goto noyear;
        end else if (msmon(month)) then begin { dd.MM yyyy }
          if (not mc(' ')) then goto noyear;
          if (not mnum(year)) then goto noyear;
        end else goto nomatch;
      end else if (mc(' ')) then begin { dd MM yyyy }
        day := month;
        if (not msmon(month)) then goto nomatch;
        if (not mc(' ')) then goto noyear;
        if (not mnum(year)) then goto noyear;
      end else goto nomatch;
    end else if (msmon(month)) then begin { MM dd yyyy }
      if (not mc(' ')) then goto nomatch;
      if (not mnum(day)) then goto nomatch;
      if (not mc(' ')) then goto noyear;
      if (not mnum(year)) then goto noyear;
    end else goto nomatch;

    { normal: all is specified }
    mdate := true;
    exit;

    { noyear: no year spec --> supply it }
    noyear:
    mdate := true;
    year := itdy;
    exit;

    { no date }
    nomatch:
    mdate := false;
    p := start {reset}
  end;

begin
  proc_op;

  l := length(s);
  p := 1;
  today;

  { distinguish the various cases }
  if (mdate(day1,mon1,yea1)) then begin
    iday1 := day1; imon1 := mon1; iyea1 := yea1;
    if (not validdate(iday1,imon1,iyea1)) then err('Illegal date');
    if (mc('-')) then begin
      if (mdate(day2,mon2,yea2)) then begin
        iday2 := day2; imon2 := mon2; iyea2 := yea2;
        if (not validdate(iday2,imon2,iyea2)) then err('Illegal date2');
        diff := daydiff(iday2,imon2,iyea2,iday1,imon1,iyea1);
        dow1 := dayinweek(iday1,imon1,iyea1);
        dow2 := dayinweek(iday2,imon2,iyea2);
        writeln(stdout,'Days between  ',
          d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,'  and  ',
          d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2,'  are ',
          diff)
      end else if (mnum(add)) then begin
        iday2 := iday1; imon2 := imon1; iyea2 := iyea1;
        adddays(iday2,imon2,iyea2,-add);
        dow1 := dayinweek(iday1,imon1,iyea1);
        dow2 := dayinweek(iday2,imon2,iyea2);
        writeln(stdout,d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,
                       '  minus ',add,' day(s) is  ',
                       d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2);
      end else begin
        iday2 := itdd; imon2 := itdm; iyea2 := itdy;
        diff := daydiff(iday2,imon2,iyea2,iday1,imon1,iyea1);
        dow1 := dayinweek(iday1,imon1,iyea1);
        dow2 := dayinweek(iday2,imon2,iyea2);
        writeln(stdout,'Days between  ',
                       d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,
                       '  and today,  ',
                       d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2,
                       '  are ',diff)
      end
    end else if (mc('+')) then begin
      if (mnum(add)) then begin
        iday2 := iday1; imon2 := imon1; iyea2 := iyea1;
        adddays(iday2,imon2,iyea2,add);
        dow1 := dayinweek(iday1,imon1,iyea1);
        dow2 := dayinweek(iday2,imon2,iyea2);
        writeln(stdout,d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,
                       '  plus ',add,' day(s) is  ',
                       d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2);
      end else err('Syntax error')
    end else begin
      dow1 := dayinweek(iday1,imon1,iyea1);
      writeln(stdout,'The  ',iday1,' ',m3str[imon1],' ',iyea1,
                     '  is a  ',daystr(dow1));
    end
  end else if (mc('-')) then begin
    iday1 := itdd; imon1 := itdm; iyea1 := itdy;
    if (mdate(day2,mon2,yea2)) then begin
      iday2 := day2; imon2 := mon2; iyea2 := yea2;
      if (not validdate(iday2,imon2,iyea2)) then err('Illegal date');
      diff := daydiff(iday2,imon2,iyea2,iday1,imon1,iyea1);
      dow1 := dayinweek(iday1,imon1,iyea1);
      dow2 := dayinweek(iday2,imon2,iyea2);
      writeln(stdout,'Days between today,  ',
                     d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,
                     '  and  ',
                     d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2,
                     '  are ',diff)
    end else if (mnum(add)) then begin
      iday2 := iday1; imon2 := imon1; iyea2 := iyea1;
      adddays(iday2,imon2,iyea2,-add);
      dow1 := dayinweek(iday1,imon1,iyea1);
      dow2 := dayinweek(iday2,imon2,iyea2);
      writeln(stdout,'Today,  ',d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,
                     '  minus ',add,' day(s) is  ',
                     d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2);
    end else err('Syntax error')
  end else if (mc('+')) then begin
    iday1 := itdd; imon1 := itdm; iyea1 := itdy;
    if (mnum(add)) then begin
      iday2 := iday1; imon2 := imon1; iyea2 := iyea1;
      adddays(iday2,imon2,iyea2,add);
      dow1 := dayinweek(iday1,imon1,iyea1);
      dow2 := dayinweek(iday2,imon2,iyea2);
      writeln(stdout,'Today,  ',d3str[dow1],', ',iday1,' ',m3str[imon1],' ',iyea1,
                     '  plus ',add,' day(s) is  ',
                     d3str[dow2],', ',iday2,' ',m3str[imon2],' ',iyea2);
    end else err('Syntax error')
  end else err('Syntax error');

  stop(0)
end.
@

