head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.21.53;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.11.12.03.28;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.21.21.42.29;	author Ricki;	state Exp;
branches;
next	;


desc
@Replace tabs with spaces in several files
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: detab.pas 1.2 1993/02/11 12:03:28 Ricki Exp $ }
program detab2;
{ Replace tabs with spaces in several files }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: detab.pas $
        Revision 1.2  1993/02/11  12:03:28  Ricki
        modified -v page

        Revision 1.1  1993/01/21  21:42:29  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id: detab.pas 1.2 1993/02/11 12:03:28 Ricki Exp $';

  func = 'Replace tabs with spaces in several files';
  year = '1992,1993';
  desn = 'DETAB/2';
  desv = '1.0';
  opts = 'hHlrt:uv*'; ropt = opts;

var
  fbuf: pointer;
  debug: boolean;

  itab: longint;
  fname: pathstr;
  opt_l,opt_r: boolean;

  {$i detab.i1}
  {$i detab.i2}

  procedure help1;
  begin
    header(desv,year,func);
    detabi1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    detabi2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    itab := 8; opt_r := false; opt_l := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'l': opt_l := true;
      'r': opt_r := true;
      't': if (not ival(optarg,itab)) or (itab>255) or (itab<1) then
        err('Illegal tab width');

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    if (opt_l) and (opt_r) then err('-l and -r are mutually exclusive')
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,stdbufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    line: string;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,stdbufsize);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    while (not eof(f)) do begin
      readln(f,line);
      if (opt_r) then      writeln(stdout,quoteddetab(line,itab))
      else if (opt_l) then writeln(stdout,headdetab(line,itab))
      else                 writeln(stdout,detab(line,itab))
    end;

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@


1.2
log
@modified -v page
@
text
@d2 1
a2 1
{ $Id: DETAB.PAS 1.1 1993/01/21 21:42:29 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 4
a28 1
        $Log: DETAB.PAS $
d48 1
a48 1
  pversion = '$Id: DETAB.PAS 1.1 1993/01/21 21:42:29 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: DETAB.PAS 1.1 1993/01/21 21:39:41 Ricki Exp $ }
d26 1
a26 1
        Revision 1.1  1993/01/21  21:39:41  Ricki
a27 7

 * Revision 1.1  1993/01/21  21:19:26  Ricki
 * Initial revision
 *
 * Revision 1.1  1993/01/21  21:03:13  Ricki
 * Initial revision
 *
d45 1
a45 1
  pversion = '$Id: DETAB.PAS 1.1 1993/01/21 21:39:41 Ricki Exp $';
d50 1
d66 1
a66 1
    header(year,func);
d73 1
a73 1
    header(year,func);
d80 1
a80 1
    header(year,func);
d82 1
a82 1
    revision(desn,'$Revision: 1.1 $');
@

