head	1.4;
access;
symbols
	rutils40:1.3;
locks;
comment	@        @;


1.4
date	93.03.31.19.23.48;	author Ricki;	state Exp;
branches;
next	1.3;

1.3
date	93.03.19.17.16.48;	author Ricki;	state Rel;
branches;
next	1.2;

1.2
date	93.03.11.14.43.10;	author Ricki;	state Exp;
branches;
next	1.1;

1.1
date	93.02.11.12.06.43;	author Ricki;	state Exp;
branches;
next	;


desc
@File type guesser
@

1.4
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: file2.pas 1.3 1993/03/19 17:16:48 Ricki Exp $ }
program file2;
{ File type guesser }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: file2.pas $
        Revision 1.3  1993/03/19  17:16:48  Ricki
        new switch -R for recursive operation
        added text file recognition by scanning the first 512 bytes

        Revision 1.2  1993/03/11  14:43:10  Ricki
        built in the 'any string' facility

        Revision 1.1  1993/02/11  12:06:43  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  files,
  numbers,
  strings,
  dates,
  times,
  standard,
  outcon,
  options,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id: file2.pas 1.3 1993/03/19 17:16:48 Ricki Exp $';

  func = 'File type guesser';
  year = '1993';
  desn = 'FILE/2';
  desv = '1.0';
  opts = '0123ahH:m:no:qRv*'; ropt = opts;

  maxlines = 2048; { maximum number of magic entries }

type
  keywstr = string[3];
  Tkwentry = record keyw: keywstr; code: word end;

const
  k_arc =   1;
  k_asc =   2;
  k_bin =   4;
  k_exe =   8;
  k_pic =  16;
  k_snd =  32;
  k_src =  64;
  k_txt = 128;

  nkeywords = 8;
  keywords: array [1..nkeywords] of Tkwentry =
  (
    (keyw: 'arc';code: k_arc),
    (keyw: 'asc';code: k_asc),
    (keyw: 'bin';code: k_bin),
    (keyw: 'exe';code: k_exe),
    (keyw: 'pic';code: k_pic),
    (keyw: 'snd';code: k_snd),
    (keyw: 'src';code: k_src),
    (keyw: 'txt';code: k_txt)
  );

  txtmsg = 'Text or source file (?)';
  txtlen = 512;
  txtchr = [#8..#10,#12,#13,#26,#32..#254];

type
  Tdtype = (t_byte,t_short,t_rshort,t_long,t_rlong,
            t_anystring,t_string,t_text);
  Toperator = (o_eq,o_ne,o_lt,o_gt,o_set,o_notset,o_any);

  linerec = record
    keyw: word;
    level: byte;
    offset: longint;
    dtype: Tdtype;
    op: Toperator;
    message: ^string;
    case boolean of
      false: (case Tdtype of
        t_byte     : (bv,bm: byte);	{ value, mask }
        t_short    : (sv,sm: integer);	{ value, mask }
        t_long     : (lv,lm: longint);	{ value, mask }
	t_anystring: (sl   : byte));	{ length }
      true: (st: ^string);		{ value }
  end;

  fbuftype = array [0..stdbufsize-1] of byte;

var
  fbuf: ^fbuftype;
  debug: boolean;

  table: array [1..maxlines] of linerec;
  verbose: byte;
  opt_R,opt_a,opt_n,opt_q: boolean;
  magic: string;
  nlmagic: integer;
  keymask: word;
  nopt,nnam: byte;

  {$i file2.i1}
  {$i file2.i2}

  {$i-} { turn off I/O checking for all procedures }

  procedure help1;
  begin
    header(desv,year,func);
    file2i1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    file2i2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  function str2key(s: keywstr): word;
  var
    i: byte;
  begin
    s := strlowcase(s);
    for i:=1 to nkeywords do begin
      if (s=keywords[i].keyw) then begin
        str2key := keywords[i].code; exit
      end
    end;
    str2key := 0
  end;

  function key2str(k: word): string;
  var
    i: byte;
    s: string;
  begin
    s := '';
    for i:=1 to nkeywords do begin
      if (k and keywords[i].code=keywords[i].code) then
        if (s<>'') then s := s+','+keywords[i].keyw
                   else s := keywords[i].keyw
    end;
    key2str := s
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    verbose := 1;
    magic := progpath+'MAGIC';
    opt_a := false; opt_n := false; opt_q := false;
    keymask := $FFFF;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  var
    m: word;
  begin
    case opt of
      '0'..'3': verbose := ord(opt)-ord('0');
      'm': magic := optarg;
      'a': opt_a := true;
      'n': opt_n := true;
      'q': opt_q := true;
      'R': ; { already processed before }
      'o': begin
        m := str2key(optarg);
        if (m=0) then err('Illegal key "'+optarg+'"');
        if (keymask=$FFFF) then keymask := m
                           else keymask := keymask or m
      end;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    if (opt_n) and (opt_q) then err('-n and -q are mutually exclusive');

    if (debug) then
      writeln(conout,'       Looking for one of [',key2str(keymask),']')
  end;

  procedure revnum(var n; len: byte);
  { reverse the bytes of n }
  var
    a: array [1..4] of byte absolute n;
    c,i: byte;
  begin
    for i:=1 to (len div 2) do begin
      c := a[i];
      a[i] := a[len-i+1];
      a[len-i+1] := c
    end
  end;

  procedure translate(s: string; var l: linerec; var ok: boolean);
  { translate one input line into a linerec record }
  const
    tabs: charset = [#9];
  var
    hs: string;
    p: byte;
    v: longint; vw: array [0..1] of word absolute v;

    function get_op(var s: string): Toperator;
    { determine the operator and remove it from s }
    begin case s[1] of
      '=': begin get_op := o_eq; delete(s,1,1) end;
      '!': begin get_op := o_ne; delete(s,1,1) end;
      '<': begin get_op := o_lt; delete(s,1,1) end;
      '>': begin get_op := o_gt; delete(s,1,1) end;
      '&': begin get_op := o_set; delete(s,1,1) end;
      '^': begin get_op := o_notset; delete(s,1,1) end;
      'x': begin get_op := o_any; delete(s,1,1) end;
      else get_op := o_eq
    end end;

  begin with l do begin
    ok := false;
    if (s='') then exit;

    { count the >'s to determine the level }
    level := 0;
    while (s[level+1]='>') and (level<length(s)) do inc(level);
    delete(s,1,level);
    if (s='') then exit;

    { get the (decimal) offset }
    p := pos(#9,s); if (p<2) then exit;
    if (not ival(copy(s,1,p-1),offset)) then exit;
    delete(s,1,p);
    s := headtrim(s,tabs);

    { get the type }
    if (strlowcase(copy(s,1,4))='byte') then begin
      dtype := t_byte;
      delete(s,1,4)
    end else if (strlowcase(copy(s,1,5))='short') then begin
      dtype := t_short;
      delete(s,1,5)
    end else if (strlowcase(copy(s,1,6))='rshort') then begin
      dtype := t_rshort;
      delete(s,1,6)
    end else if (strlowcase(copy(s,1,4))='long') then begin
      dtype := t_long;
      delete(s,1,4)
    end else if (strlowcase(copy(s,1,5))='rlong') then begin
      dtype := t_rlong;
      delete(s,1,5)
    end else if (strlowcase(copy(s,1,6))='string') then begin
      dtype := t_string;
      delete(s,1,6)
    end else exit;
    if (s='') then exit;

    { proceed after the data type }
    case dtype of
      t_byte: begin
        { get the optional &mask }
        if (s[1]='&') then begin
          { get the optional &mask }
          p := pos(#9,s); if (p<3) then exit;
          if (not cnumval(copy(s,2,p-2),v)) then exit;
          bm := lo(v);
          delete(s,1,p)
        end else begin
          bm := $FF;
          if (s[1]<>#9) then exit
        end;
        s := headtrim(s,tabs);

        { get the optional operator }
        op := get_op(s);
        if (s='') then exit;

        { get the value, if operator is not o_any }
        if (op<>o_any) then begin
          p := pos(#9,s); if (p<2) then p := 1+length(s);
          if (p=1) then exit;
          if (not cnumval(copy(s,1,p-1),v)) then exit;
          bv := lo(v);
          delete(s,1,p)
        end
      end;

      t_short,t_rshort: begin
        { get the optional &mask }
        if (s[1]='&') then begin
          p := pos(#9,s); if (p<3) then exit;
          if (not cnumval(copy(s,2,p-2),v)) then exit;
          revnum(v,2);
          sm := integer(vw[0]);
          delete(s,1,p)
        end else begin
          sm := integer($FFFF);
          if (s[1]<>#9) then exit
        end;
        s := headtrim(s,tabs);

        { get the optional operator }
        op := get_op(s);
        if (s='') then exit;

        { get the value, if operator is not o_any }
        if (op<>o_any) then begin
          p := pos(#9,s); if (p<2) then p := 1+length(s);
          if (p=1) then exit;
          if (not cnumval(copy(s,1,p-1),v)) then exit;
          revnum(v,2);
          sv := integer(vw[0]);
          delete(s,1,p)
        end
      end;

      t_long,t_rlong: begin
        { get the optional &mask }
        if (s[1]='&') then begin
          p := pos(#9,s); if (p<3) then exit;
          if (not cnumval(copy(s,2,p-2),v)) then exit;
          revnum(v,4);
          lm := v;
          delete(s,1,p)
        end else begin
          lm := $FFFFFFFF;
          if (s[1]<>#9) then exit
        end;
        s := headtrim(s,tabs);

        { get the optional operator }
        op := get_op(s);
        if (s='') then exit;

        { get the value, if operator is not o_any }
        if (op<>o_any) then begin
          p := pos(#9,s); if (p<2) then p := 1+length(s);
          if (p=1) then exit;
          if (not cnumval(copy(s,1,p-1),v)) then exit;
          revnum(v,4);
          lv := v;
          delete(s,1,p)
        end
      end;

      t_string: begin
        s := headtrim(s,tabs);
        { get the value }
        p := pos(#9,s); if (p=0) then p := 1+length(s);
        if (p=1) then exit;

        { check if t_anystring is meant }
	if (s[1]='x') then begin
          dtype := t_anystring;
          delete(s,1,1);
          dec(p);
          if (p=1) then sl := 255
          else begin
            if (not ival(copy(s,1,p-1),v)) then exit;
            if (v>255) then sl := 255
	    else if (v<=0) then exit
	    else sl := v
          end
        end else begin
          { transfer the C notation to 'real' characters }
          hs := copy(s,1,p-1);
          cspecial(hs);
          getmemory(st,1+length(hs));
          st^ := hs
        end;
        delete(s,1,p)
      end
    end;

    s := headtrim(s,tabs);

    { store the message }
    getmemory(message,length(s)+1);
    message^ := s;
    ok := true
  end end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  var
    f: text;
    line: string;
    ok: boolean;
    onekeyw,ckeyw: word;
    localnl: integer;
  begin
    if (nnam=0) then stop(0);

    { used (a) for settextbuf (b) as buffer for blockread }
    getmem(fbuf,stdbufsize);

    { read them into table }
    nlmagic := 0;
    ckeyw := $FFFF;

    assign(f,magic); reset(f);
    if (ioresult<>0) then err('Cannot read "'+magic+'"');
    settextbuf(f,fbuf^,stdbufsize);

    localnl := 0;
    while (not eof(f)) do begin
      inc(localnl); readln(f,line);

      { check for keyword lists }
      if (line[1]='#') and (line[2]='@@') then begin
        ckeyw := 0;
        { get the keyword list }
        line := copy(trim(line,whitespace),3,255);
        while (line<>'') do begin
          onekeyw := str2key(copy(line,1,3));
          if (onekeyw=0) then
            warn('Unknown keyword "'+copy(line,1,3)+'" in line '
                 +numstr(localnl)+' of '+magic)
          else ckeyw := ckeyw or onekeyw;
          delete(line,1,3)
        end
      end else if (line<>'') and (line[1]<>'#') then begin
        inc(nlmagic);
        if (nlmagic>maxlines-1) then err('Too many definitions');
        translate(line,table[nlmagic],ok);
        if (not ok) then warn('Syntax error in line '
                             +numstr(localnl)+' of '
                             +magic);
        if (nlmagic=1) and (table[nlmagic].level<>0) then
          err('The first definition must be level 0; detected in line '
              +numstr(localnl)+' of '+magic);
        table[nlmagic].keyw := ckeyw
      end
    end;

    if (debug) then begin
      writeln(conout,'       Read ',nlmagic,
                     ' (out of ',maxlines,' possible) patterns..');
      writeln(conout,'       from ',magic);
    end;

    { append the t_text check }
    inc(nlmagic);
    with table[nlmagic] do begin
      keyw     	:= k_asc;
      level    	:= 0;
      offset 	:= 0;
      dtype 	:= t_text;
      op 	:= o_any;
      getmemory(message,1+length(txtmsg));
      message^ 	:= txtmsg
    end;

    close(f)
  end;

  procedure check(var f: file; fn: string; var found: integer);
  label
    nextdef;
  var
    printname,match,firstmatch,foundmatch,delayed: boolean;
    off,fs,btop,bbot: longint;
    bsize: word;
    clevel: byte;
    len: word;
    i: integer;
    outline: string;
    d: byte; { dummy value for sprintf }
    rev: array [1..4] of byte; { for t_rshort, t_rlong reversing }

    function mbyte(op: Toperator; var x,y,m: byte): boolean;
    begin case op of
      o_eq    : mbyte := ((x and m)=y);
      o_ne    : mbyte := ((x and m)<>y);
      o_lt    : mbyte := ((x and m)<y);
      o_gt    : mbyte := ((x and m)>y);
      o_set   : mbyte := ((x and m) and y=(x and m));
      o_notset: mbyte := ((x and m) and y<>(x and m));
      o_any   : mbyte := true
    end end;

    function mshort(op: Toperator; var x; var y,m: integer): boolean;
    var
      xx: integer absolute x;
    begin case op of
      o_eq    : mshort := ((xx and m)=y);
      o_ne    : mshort := ((xx and m)<>y);
      o_lt    : mshort := ((xx and m)<y);
      o_gt    : mshort := ((xx and m)>y);
      o_set   : mshort := ((xx and m) and y=(xx and m));
      o_notset: mshort := ((xx and m) and y<>(xx and m));
      o_any   : mshort := true
    end end;

    function mlong(op: Toperator; var x; var y,m: longint): boolean;
    var
      xx: longint absolute x;
    begin case op of
      o_eq    : mlong := ((xx and m)=y);
      o_ne    : mlong := ((xx and m)<>y);
      o_lt    : mlong := ((xx and m)<y);
      o_gt    : mlong := ((xx and m)>y);
      o_set   : mlong := ((xx and m) and y=(xx and m));
      o_notset: mlong := ((xx and m) and y<>(xx and m));
      o_any   : mlong := true
    end end;

    function mstring(var x; var y: string): boolean;
    var
      i: byte;
      xx: array [1..255] of char absolute x;
    begin
      for i:=1 to length(y) do if (xx[i]<>y[i]) then begin
        mstring := false; exit
      end;
      mstring := true
    end;

    function mtext(var x; len: word): boolean;
    var
      i: word;
      xx: array [1..txtlen] of char absolute x;
    begin
      for i:=1 to len do if not (xx[i] in txtchr) then begin
        mtext := false; exit
      end;
      mtext := true
    end;

    procedure bupdate(offset: longint);
    begin
      seek(f,offset);
      blockread(f,fbuf^,stdbufsize,bsize);
      btop := offset; bbot := btop+bsize-1
    end;

    procedure m_action(n: integer; var x; what: Tdtype);
    var
      s: string;
    begin
      delayed := (table[n].message^='');
      if (not delayed) then begin
        foundmatch := true;
        if (firstmatch) then inc(found);
        if (verbose>0) and (not opt_n) then begin
          if (firstmatch) then begin
            case verbose of
              1: if (printname) then write(stdout,fillname(fn),'  ')
                                else write(stdout,' ':length(fillname(fn)),'  ');
              2,3: begin
                if (printname) then
                  writeln(stdout,fillname(fn),' [',key2str(table[n].keyw),']');
                write(stdout,'  --')
              end
            end;
            printname := false;
            firstmatch := false
          end;
          { distinguish according to the data type }
          case what of
            t_byte,t_short,t_rshort,t_long,t_rlong:
              sprintf(outline,table[n].message^,x,x,x,x,x);
            t_anystring,t_string: begin
              { create a 'real string' from fbuf (needed for sprintf) }
              s[0] := chr(len);
              move(fbuf^[off-btop],s[1],len);
              sprintf(outline,table[n].message^,s,d,d,d,d);
	    end;
	    t_text:
	      outline := table[n].message^;
          end;
          write(stdout,outline,' ')
        end
      end
    end;

  begin
    { initialize the read buffer }
    bupdate(0);

    fs := filesize(f);
    foundmatch := false;
    firstmatch := true;
    delayed := false;
    printname := true;
    found := 0;

    { loop over the definitions }
    i := 1;
    while (i<=nlmagic) do with table[i] do begin
      { do only consider definitions whose keywords match keymask, ie.
        which contain at least one key of keymask }
      if (keyw and keymask=0) then goto nextdef;

      { check if we arrived after a match at level 0 again }
      if (foundmatch) and (level=0) then begin
        firstmatch := true;
        if (verbose>0) and (not opt_n) then writeln(stdout);
        if (opt_a) then begin foundmatch := false; delayed := false end
                   else exit
      { goto the next level 0 definition, if the last did not match }
      end else if (not foundmatch)
              and (not delayed)
              and (level<>0) then goto nextdef;

      { determine the length of the section to be examined }
      case dtype of
        t_byte           : len := 1;
        t_short,t_rshort : len := 2;
        t_long,t_rlong   : len := 4;
        t_string         : len := length(st^);
        t_anystring	 : len := sl;
        t_text     	 : begin
	                     len := txtlen;
                             if (len>fs) then len := fs
        		   end
      end;

      { if offset<0, fs-|offset| is meant }
      off := offset;
      if (off<0) then inc(off,fs);

      { goto the offset. if necessary, read the appropriate section }
      if (off<btop) then bupdate(off)
      else if (off+len-1>bbot) then begin
        { if the desired position is beyond the file end, ignore it }
        if (off+len>=fs) then goto nextdef;
        bupdate(off)
      end;

      { check the definition }
      case dtype of
        t_byte: begin
          match := mbyte(op,fbuf^[off-btop],bv,bm);
          if (match) then m_action(i,fbuf^[off-btop],dtype)
        end;
        t_short: begin
          match := mshort(op,fbuf^[off-btop],sv,sm);
          if (match) then m_action(i,fbuf^[off-btop],dtype)
        end;
        t_rshort: begin
          move(fbuf^[off-btop],rev,2); revnum(rev,2);
          match := mshort(op,rev,sv,sm);
          if (match) then m_action(i,rev,dtype)
        end;
        t_long: begin
          match := mlong(op,fbuf^[off-btop],lv,lm);
          if (match) then m_action(i,fbuf^[off-btop],dtype)
        end;
        t_rlong: begin
          move(fbuf^[off-btop],rev,4); revnum(rev,4);
          match := mlong(op,rev,lv,lm);
          if (match) then m_action(i,rev,dtype)
        end;
        t_string: begin
          match := mstring(fbuf^[off-btop],st^);
          if (match) then m_action(i,i,dtype)
        end;
        t_anystring: begin
          match := true;
          m_action(i,i,dtype)
        end;
        t_text: begin
          match := mtext(fbuf^[off-btop],len);
          if (match) then m_action(i,i,dtype)
        end
      end;

      if (not match) then begin
        { goto the next level which is one the same or a smaller level }
        clevel := level;
        repeat inc(i) until (i>nlmagic) or (table[i].level<=clevel);
        dec(i) { inc'd again below }
      end;
      nextdef: inc(i)
    end;

    if (verbose>0) and (foundmatch) and (not opt_n) then writeln(stdout)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: file;
    line: string;
    found: integer;
    dt: datetime;
  begin
    bininp(f,p+s.name);

    { check f against the entries in table }
    check(f,s.name,found);

    if (found=0) then begin
      if (not opt_q) then
           writeln(stdout,fillname(s.name),'  ?')
    end else if (not opt_n) then begin
      case verbose of
        0: writeln(stdout,fillname(s.name),'  recognized');
        1: ;
        2: ;
        3: begin
          unpacktime(s.time,dt);
          writeln(stdout,'    Last modification date: ',
                         date2str(dt.day,dt.month,dt.year),', ',
                         time2str(dt.hour,dt.min,dt.sec,0));
          writeln(stdout,'    File size             : ',s.size,' bytes');
          writeln(stdout,'    File attributes       : ',attr2str(s.attr))
        end
      end
    end;

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  { check if -R was specified }
  parse(ropt,nopt,nnam);
  opt_R := false;
  while (nopt>0) do begin
    if (getopt(nopt)='R') then opt_R := true;
    dec(nopt)
  end;

  if (opt_R)
  then
    process(ropt,
            pre_op,proc_op,post_op,
            pre_fn,proc_fn,post_fn,
            m_recurse or m_sysfile or m_readonly)
  else
    process(ropt,
            pre_op,proc_op,post_op,
            pre_fn,proc_fn,post_fn,
            m_sysfile or m_readonly);

  stop(0)
end.
@


1.3
log
@new switch -R for recursive operation
added text file recognition by scanning the first 512 bytes
@
text
@d2 1
a2 1
{ $Id: file2.pas 1.2 1993/03/11 14:43:10 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d26 4
d56 1
a56 1
  pversion = '$Id: file2.pas 1.2 1993/03/11 14:43:10 Ricki Exp $';
@


1.2
log
@built in the 'any string' facility
@
text
@d2 1
a2 1
{ $Id: file2.pas 1.1 1993/02/11 12:06:43 Ricki Exp $ }
d26 3
a30 1

d46 1
d52 1
a52 1
  pversion = '$Id: file2.pas 1.1 1993/02/11 12:06:43 Ricki Exp $';
d58 1
a58 1
  opts = '0123ahH:m:no:qv*'; ropt = opts;
d89 4
d94 2
a95 1
  Tdtype = (t_byte,t_short,t_rshort,t_long,t_rlong,t_anystring,t_string);
d110 1
a110 1
	t_anystring: (sl   : byte));    { length }
d122 1
a122 1
  opt_a,opt_n,opt_q: boolean;
d126 1
d207 1
d472 1
a472 1
        if (nlmagic>maxlines) then err('Too many definitions');
d490 12
d510 1
a510 1
    fs,btop,bbot: longint;
d512 2
a513 1
    clevel,len: byte;
d567 11
d585 3
a587 1
    procedure m_action(n: integer; var x);
d607 12
a618 27
          sprintf(outline,table[n].message^,x,x,x,x,x);
          write(stdout,outline,' ')
        end
      end
    end;

    procedure m_st_action(n: integer);
    var
      a,s: string;
    begin
      delayed := (table[n].message^='');
      if (not delayed) then begin
        foundmatch := true;
        if (firstmatch) then inc(found);
        if (verbose>0) and (not opt_n) then begin
          if (firstmatch) then begin
            case verbose of
              1: if (printname) then write(stdout,fillname(fn),'  ')
                                else write(stdout,' ':length(fillname(fn)),'  ');
              2,3: begin
                if (printname) then
                  writeln(stdout,fillname(fn),' [',key2str(table[n].keyw),']');
                write(stdout,'  --')
              end
            end;
            printname := false;
            firstmatch := false
a619 4
          { create a 'real string' from fbuf (needed for sprintf) }
          s[0] := chr(len);
          move(fbuf^[table[n].offset-btop],s[1],len);
          sprintf(outline,table[n].message^,s,d,d,d,d);
d660 5
a664 1
        t_anystring	 : len := sl
d667 3
a669 2
      { if offset<0, fs-offset is meant }
      if (offset<0) then offset := fs+offset;
d672 2
a673 2
      if (offset<btop) then bupdate(offset)
      else if (offset+len>bbot) then begin
d675 2
a676 2
        if (offset+len>=fs) then goto nextdef;
        bupdate(offset)
d682 2
a683 2
          match := mbyte(op,fbuf^[offset-btop],bv,bm);
          if (match) then m_action(i,fbuf^[offset-btop])
d686 2
a687 2
          match := mshort(op,fbuf^[offset-btop],sv,sm);
          if (match) then m_action(i,fbuf^[offset-btop])
d690 1
a690 1
          move(fbuf^[offset-btop],rev,2); revnum(rev,2);
d692 1
a692 1
          if (match) then m_action(i,rev)
d695 2
a696 2
          match := mlong(op,fbuf^[offset-btop],lv,lm);
          if (match) then m_action(i,fbuf^[offset-btop])
d699 1
a699 1
          move(fbuf^[offset-btop],rev,4); revnum(rev,4);
d701 1
a701 1
          if (match) then m_action(i,rev)
d704 2
a705 2
          match := mstring(fbuf^[offset-btop],st^);
          if (match) then m_st_action(i)
d709 5
a713 1
          m_st_action(i)
d725 1
d739 1
a739 1
    check(f,p+s.name,found);
d743 1
a743 1
           writeln(stdout,fillname(p+s.name),'  ?')
d746 1
a746 1
        0: writeln(stdout,fillname(p+s.name),'  recognized');
d769 20
a788 4
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          0);
@


1.1
log
@Initial revision
@
text
@d2 1
a2 1
{ $Id$ }
d25 4
a28 1
        $Log$
d49 1
a49 1
  pversion = '$Id$';
d87 1
a87 1
  Tdtype = (t_byte,t_short,t_rshort,t_long,t_rlong,t_string);
d99 5
a103 4
        t_byte : (bv,bm: byte);
        t_short: (sv,sm: integer);
        t_long : (lv,lm: longint));
      true: (st: ^string);
d390 20
a409 5
        { transfer the C notation to 'real' characters }
        hs := copy(s,1,p-1);
        cspecial(hs);
        getmemory(st,1+length(hs));
        st^ := hs;
d411 1
a411 1
      end;
d579 1
a579 1
      s: string;
a585 1
{
a586 11
            if (printname) then begin
              if (verbose>1)
                then writeln(stdout,fn,'  [',key2str(table[n].keyw),']')
                else writeln(stdout,fn);
              printname := false
            end;
            write(stdout,'  --');
            firstmatch := false
          end;
}
          if (firstmatch) then begin
d642 2
a643 1
        t_string         : len := length(st^)
d684 4
@

