head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.22.05;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.11.12.26.14;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.21.21.40.20;	author Ricki;	state Exp;
branches;
next	;


desc
@ASCII text formatter
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: fmt.pas 1.2 1993/02/11 12:26:14 Ricki Exp $ }
program fmt;
{ ASCII text formatter }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: fmt.pas $
        Revision 1.2  1993/02/11  12:26:14  Ricki
        modified -v page

        Revision 1.1  1993/01/21  21:40:20  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  textfmt,
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id: fmt.pas 1.2 1993/02/11 12:26:14 Ricki Exp $';

  func = 'ASCII text formatter';
  year = '1992,1993';
  desn = 'FMT/2';
  desv = '1.0';
  opts = 'BcCfhHLnpRsv*'; ropt = opts+'0:1:2:3:4:5:6:7:8:9:';

type
  Tstate = (s_start,s_first,s_para);

var
  fbuf: pointer;
  debug: boolean;

  opt_c,opt_s,opt_n,opt_p,opt_f: boolean;
  width: longint;
  mode: Tfmtmode;

  {$i fmt.i1}
  {$i fmt.i2}

  procedure help1;
  begin
    header(desv,year,func);
    fmti1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    fmti2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    opt_c := false; opt_s := false; opt_n := false;
    opt_p := false; opt_f := false;
    width := 72; mode := m_left;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'B': mode := m_block;
      'C': mode := m_center;
      'L': mode := m_left;
      'R': mode := m_right;
      'c': opt_c := true;
      'f': opt_f := true;
      'n': opt_n := true;
      's': opt_s := true;
      'p': opt_p := true;
      '0'..'9': if (not ival(opt+optarg,width))
                or (width<1) or (width>255) then
                  err('Illegal width');

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);
  end;

  function first_nonwhite(s: string): byte;
  var
    i: byte;
  begin
    for i:=1 to length(s) do
    if (s[i]<>#32) and (s[i]<>#0) and (s[i]<>#9) and (s[i]<>#255) then begin
      first_nonwhite := i;
      exit
    end;
    first_nonwhite := 0
  end;

  procedure simplify_ws(var s: string; behind: byte);
  var
    i,l: byte;
  begin
    i := length(s); l := 0;
    while (i>1+behind) do begin
      { check if the end of a ws-range is reached }
      if (s[i]<>#32) and (s[i]<>#0) and (s[i]<>#9) and (s[i]<>#255) then begin
        if (l>0) then delete(s,i+1,l-1);
        l := 0
      end else inc(l);
      dec(i)
    end;
    if (l>0) then delete(s,i+1,l-1)
  end;

  procedure doit(var o: text; var line,fline: string; var state: Tstate;
                 var ffnw,fnw: byte; var oldind: byte);

  begin
    fnw := first_nonwhite(line);
    if (not opt_p) and (fnw>0) and (line[1]<>'.') then simplify_ws(line,fnw);
    case state of

      s_start: if (fnw=0) or (line[1]='.') then
        fignore(o,line)
      else if (opt_c) then begin
        fline := line; ffnw := fnw;
        state := s_first
      end else begin
        fflushln(o); { should be empty, anyway }
        findent(o,fnw-1);
        oldind := fnw-1;
        state := s_para;
        if (opt_s) then fwr1teln(o,line)
                   else fwr1te(o,line)
      end;

      { s_first can only happen for opt_c=true }
      s_first: if (fnw=0) or (line[1]='.') then begin
        findent(o,ffnw-1);
        fwr1teln(o,fline);
        fignore(o,line);
        state := s_start
      end else begin
        findent(o,fnw-1);
        oldind := fnw-1;
        state := s_para;
        fwr1teln(o,fline);
        if (opt_s) then fwr1teln(o,line)
                   else fwr1te(o,line)
      end;

      s_para: if (fnw=0) or (line[1]='.') then begin
        fignore(o,line);
        state := s_start
      end else begin
        if (not opt_n) and (oldind<>fnw-1) then begin
          if (not opt_f) then fflushln(o);
          findent(o,fnw-1);
          oldind := fnw-1
        end;
        if (opt_s) then fwriteln(o,line)
                   else fwrite(o,line)
      end

    end
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,stdbufsize);
    fmode(stdout,mode);
    fwidth(stdout,width)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    state: Tstate;
    fline,line: string;
    ffnw,fnw: byte;
    oldind: byte;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,stdbufsize);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    state := s_start;
    while (not eof(f)) do begin
      readln(f,line);
      doit(stdout,line,fline,state,ffnw,fnw,oldind)
    end;
    fflushln(stdout);

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@


1.2
log
@modified -v page
@
text
@d2 1
a2 1
{ $Id: FMT.PAS 1.1 1993/01/21 21:40:20 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 4
a28 1
        $Log: FMT.PAS $
d49 1
a49 1
  pversion = '$Id: FMT.PAS 1.1 1993/01/21 21:40:20 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: FMT.PAS 1.1 1993/01/21 21:21:56 Ricki Exp $ }
d26 2
a27 3
 * Revision 1.1  1993/01/21  21:21:56  Ricki
 * Initial revision
 *
d46 1
a46 1
  pversion = '$Id: FMT.PAS 1.1 1993/01/21 21:21:56 Ricki Exp $';
d51 1
d70 1
a70 1
    header(year,func);
d77 1
a77 1
    header(year,func);
d84 1
a84 1
    header(year,func);
d86 1
a86 1
    revision(desn,'$Revision: 1.1 $');
d116 3
a118 2
      '0'..'9': if (ival(opt+optarg,width)) or (width<1) or (width>255) then
        err('Illegal width');
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program fmt;
{ ASCII text formatter }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  textfmt,
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id$';

  func = 'ASCII text formatter';
  year = '1992,1993';
  desn = 'FMT/2';
  opts = 'BcCfhHLnpRsv*'; ropt = opts+'0:1:2:3:4:5:6:7:8:9:';

type
  Tstate = (s_start,s_first,s_para);

var
  fbuf: pointer;
  debug: boolean;

  opt_c,opt_s,opt_n,opt_p,opt_f: boolean;
  width: longint;
  mode: Tfmtmode;

  {$i fmt.i1}
  {$i fmt.i2}

  procedure help1;
  begin
    header(year,func);
    fmti1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    fmti2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 4.3 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    opt_c := false; opt_s := false; opt_n := false;
    opt_p := false; opt_f := false;
    width := 72; mode := m_left;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'B': mode := m_block;
      'C': mode := m_center;
      'L': mode := m_left;
      'R': mode := m_right;
      'c': opt_c := true;
      'f': opt_f := true;
      'n': opt_n := true;
      's': opt_s := true;
      'p': opt_p := true;
      '0'..'9': if (ival(opt+optarg,width)) or (width<1) or (width>255) then
        err('Illegal width');

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);
  end;

  function first_nonwhite(s: string): byte;
  var
    i: byte;
  begin
    for i:=1 to length(s) do
    if (s[i]<>#32) and (s[i]<>#0) and (s[i]<>#9) and (s[i]<>#255) then begin
      first_nonwhite := i;
      exit
    end;
    first_nonwhite := 0
  end;

  procedure simplify_ws(var s: string; behind: byte);
  var
    i,l: byte;
  begin
    i := length(s); l := 0;
    while (i>1+behind) do begin
      { check if the end of a ws-range is reached }
      if (s[i]<>#32) and (s[i]<>#0) and (s[i]<>#9) and (s[i]<>#255) then begin
        if (l>0) then delete(s,i+1,l-1);
        l := 0
      end else inc(l);
      dec(i)
    end;
    if (l>0) then delete(s,i+1,l-1)
  end;

  procedure doit(var o: text; var line,fline: string; var state: Tstate;
                 var ffnw,fnw: byte; var oldind: byte);

  begin
    fnw := first_nonwhite(line);
    if (not opt_p) and (fnw>0) and (line[1]<>'.') then simplify_ws(line,fnw);
    case state of

      s_start: if (fnw=0) or (line[1]='.') then
        fignore(o,line)
      else if (opt_c) then begin
        fline := line; ffnw := fnw;
        state := s_first
      end else begin
        fflushln(o); { should be empty, anyway }
        findent(o,fnw-1);
        oldind := fnw-1;
        state := s_para;
        if (opt_s) then fwr1teln(o,line)
                   else fwr1te(o,line)
      end;

      { s_first can only happen for opt_c=true }
      s_first: if (fnw=0) or (line[1]='.') then begin
        findent(o,ffnw-1);
        fwr1teln(o,fline);
        fignore(o,line);
        state := s_start
      end else begin
        findent(o,fnw-1);
        oldind := fnw-1;
        state := s_para;
        fwr1teln(o,fline);
        if (opt_s) then fwr1teln(o,line)
                   else fwr1te(o,line)
      end;

      s_para: if (fnw=0) or (line[1]='.') then begin
        fignore(o,line);
        state := s_start
      end else begin
        if (not opt_n) and (oldind<>fnw-1) then begin
          if (not opt_f) then fflushln(o);
          findent(o,fnw-1);
          oldind := fnw-1
        end;
        if (opt_s) then fwriteln(o,line)
                   else fwrite(o,line)
      end

    end
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,stdbufsize);
    fmode(stdout,mode);
    fwidth(stdout,width)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    state: Tstate;
    fline,line: string;
    ffnw,fnw: byte;
    oldind: byte;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,stdbufsize);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    state := s_start;
    while (not eof(f)) do begin
      readln(f,line);
      doit(stdout,line,fline,state,ffnw,fnw,oldind)
    end;
    fflushln(stdout);

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@

