head	1.5;
access;
symbols
	rutils40:1.3;
locks;
comment	@        @;


1.5
date	93.04.05.18.23.40;	author Ricki;	state Exp;
branches;
next	1.4;

1.4
date	93.03.31.19.21.15;	author Ricki;	state Exp;
branches;
next	1.3;

1.3
date	93.02.11.13.16.30;	author Ricki;	state Rel;
branches;
next	1.2;

1.2
date	93.02.11.12.28.09;	author Ricki;	state Exp;
branches;
next	1.1;

1.1
date	93.01.21.21.40.23;	author Ricki;	state Exp;
branches;
next	;


desc
@Generate program fragments for textual output from text files
@

1.5
log
@zcsh --> zsh
@
text
@{$I SWITCHES.INC}
{ $Id: genout.pas 1.4 1993/03/31 19:21:15 Ricki Exp $ }
program GENOUT;
{ Generate program fragments for textual output from text files }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: genout.pas $
        Revision 1.4  1993/03/31  19:21:15  Ricki
        update to new email address

        Revision 1.3  1993/02/11  13:16:30  Ricki
        added 4DOS support

        Revision 1.2  1993/02/11  12:28:09  Ricki
        modified -v page

        Revision 1.1  1993/01/21  21:40:23  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  dates,
  times,
  numbers,
  strings,
  outcon,
  standard,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id: genout.pas 1.4 1993/03/31 19:21:15 Ricki Exp $';

  func = 'Generate source code fragments from text files';
  year = '1992,1993';
  desn = 'GENOUT/2';
  desv = '1.0';
  opts = 'b:B:cC:d:D:e:E:fF:hHmM:pP:sS:v*'; ropt = opts;

  lang = 'BCDEFMPS'; { the languages }

  f_len = 50; { line length for FORTRAN output }
  min_shell = 1;
  max_shell = 4;

type
  langtype = (l_none,l_pascal,l_fortran,l_basic,
              l_echo,l_modula2,l_c,l_dos,l_4dos,l_cplusplus);

var
  debug: boolean;
  fbuf: pointer;

  foundone: boolean;
  language: langtype;
  declaration: boolean;
  gentxtout: pathstr;
  num,shell: longint;

  {$i genout.i1}
  {$i genout.i2}

  procedure help1;
  begin
    header(desv,year,func);
    genouti1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    genouti2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  function generated: string;
  { returns a string 'This code was...' }
  begin generated := 'This code was generated by '+desn+' v'+desv
                    +'. Do not edit!'
  end;

  function modified: string;
  { returns a string 'Last modified...' }
  begin modified := 'Last modified: '+curdate+'; '+curtime
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    num := 1; shell := 1;
    language := l_none; gentxtout := 'GenTxtOut';
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'b': begin
        language := l_basic; declaration := false;
        if (optarg<>'') then begin
          if (not ival(optarg,num)) or (num=0) then
            err('-b: Illegal line number')
        end
      end;
      'e': begin
        language := l_echo; declaration := false;
        if (optarg<>'') then begin
          if (not ival(optarg,shell)) or (shell<min_shell) or (shell>max_shell)
            then err('-e: Illegal shell number')
        end
      end;
      'd': if (optarg='4') then begin
        language := l_4dos; declaration := false
      end else if (optarg='') then begin
        language := l_dos; declaration := false
      end else err('Only -d4 is allowed');
      'c': begin language := l_c; declaration := false end;
      'f': begin language := l_fortran; declaration := false end;
      'm': begin language := l_modula2; declaration := false end;
      'p': begin language := l_pascal; declaration := false end;
      's': begin language := l_cplusplus; declaration := false end;

      'B': begin
        language := l_basic; declaration := true;
        if (optarg<>'') then begin
          if (not ival(optarg,num)) or (num=0) then
            err('-B: Illegal line number')
        end
      end;
      'E': begin
        language := l_echo; declaration := true;
        if (optarg<>'') then begin
          if (not ival(optarg,shell)) or (shell<min_shell) or (shell>max_shell)
            then err('-E: Illegal shell number')
        end
      end;
      'C': begin
        language := l_c; declaration := true;
        if (optarg<>'') then gentxtout := optarg
      end;
      'D': if (optarg='4') then begin
        language := l_4dos; declaration := true
      end else if (optarg='') then begin
        language := l_dos; declaration := true
      end else err('Only -D4 is allowed');
      'F': begin
        language := l_fortran; declaration := true;
        gentxtout := 'GENTXTO';
        if (optarg<>'') then gentxtout := optarg
      end;
      'M': begin
        language := l_modula2; declaration := true;
        if (optarg<>'') then gentxtout := optarg
      end;
      'P': begin
        language := l_pascal; declaration := true;
        if (optarg<>'') then gentxtout := optarg
      end;
      'S': begin
        language := l_cplusplus; declaration := true;
        if (optarg<>'') then gentxtout := optarg
      end;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (language=l_none) then begin
      language := l_pascal; declaration := true
    end;

    if (debug) then startdbg;
    report(ropt,pversion);
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,stdbufsize);
    if (declaration) then case language of
      l_pascal: begin
        writeln(stdout,'procedure ',gentxtout,';');
        writeln(stdout,'{ '+generated+' }');
        writeln(stdout,'{ '+modified+' }');
        writeln(stdout);
        writeln(stdout,'begin');
      end;
      l_fortran: begin
        writeln(stdout,'      SUBROUTINE ',gentxtout);
        writeln(stdout,'C');
        writeln(stdout,'C--- '+generated);
        writeln(stdout,'C--- '+modified);
        writeln(stdout,'C');
        writeln(stdout,'C--- Strings were split if they were longer than ',f_len,' characters');
        writeln(stdout,'C');
      end;
      l_basic: begin
        writeln(stdout,num,' REM ',generated);
        if (num<65535) then inc(num) else err('Number overflow in BASIC mode');
        writeln(stdout,num,' REM ',modified);
        if (num<65535) then inc(num) else num := 0
      end;
      l_dos: begin
        writeln(stdout,'@@ECHO OFF');
        writeln(stdout,'REM ',generated);
        writeln(stdout,'REM ',modified);
      end;
      l_4dos: begin
        writeln(stdout,'@@echo off');
        writeln(stdout,'rem ',generated);
        writeln(stdout,'rem ',modified);
      end;
      l_echo: begin
        case shell of
          1: writeln(stdout,'#!/bin/sh');
          2: writeln(stdout,'#!/bin/csh');
          3: writeln(stdout,'#!/bin/tcsh');
          4: writeln(stdout,'#!/bin/zsh');
        end;
        writeln(stdout,'# ',generated);
        writeln(stdout,'# ',modified);
      end;
      l_c: begin
        writeln(stdout,'void');
        writeln(stdout,gentxtout,'()');
        writeln(stdout,'/* ',generated,' */');
        writeln(stdout,'/* ',modified,' */');
        writeln(stdout);
        writeln(stdout,'{');
      end;
      l_modula2: begin
        writeln(stdout,'PROCEDURE ',gentxtout,';');
        writeln(stdout,'(* ',generated,' *)');
        writeln(stdout,'(* ',modified,' *)');
        writeln(stdout);
        writeln(stdout,'BEGIN');
      end;
      l_cplusplus: begin
        writeln(stdout,'void');
        writeln(stdout,gentxtout,'()');
        writeln(stdout,'// ',generated);
        writeln(stdout,'// ',modified);
        writeln(stdout);
        writeln(stdout,'{');
      end
    end
  end;

  procedure proc_line(var line: string);
  var
    p: byte;
  begin
    case language of
      l_pascal: begin
        substall('''','''''',line);
        writeln(stdout,'  writeln(''',line,''');')
      end;
      l_fortran: begin
        substall('''','''''',line);
        if (line='') then line := ' ';
        writeln(stdout,'      WRITE(*,*) ''',copy(line,1,f_len),'''');
        delete(line,1,f_len);
        while (length(line)>0) do begin
          writeln(stdout,'     +          ,''',copy(line,1,f_len),'''');
          delete(line,1,f_len)
        end
      end;
      l_basic: begin
        if (num=0) then err('Number overflow in BASIC mode');
        substall('"','"+chr$(34)+"',line);
        writeln(stdout,num,' PRINT "',line,'"');
        if (num<65535) then inc(num) else num := 0
      end;
      l_dos: if (line<>'') then begin
        substall('>','}',line);
        substall('<','{',line);
        substall('|','!',line);
        substall('%','%%',line);
        writeln(stdout,'ECHO ',line)
      end else
        writeln(stdout,'ECHO.');
      l_4dos: if (line<>'') then begin
        substall('`','''',line);
        substall('>','`>`',line);
        substall('<','`<`',line);
        substall('|','`|`',line);
        substall('%','`%`',line);
        substall('"','`"`',line);
        substall('^','`^`',line);
        writeln(stdout,'echo ',line)
      end else
        writeln(stdout,'echo.');
      l_echo: begin
        case shell of
          1,4: { sh, zsh } begin
            substall('''','''"''"''',line);
            substall('>','''">"''',line);
            substall('<','''"<"''',line);
            writeln(stdout,'echo ''',line,'''')
          end;
          2,3: { csh, tcsh } begin
            substall('''','''"''"''',line);
            substall('>','''">"''',line);
            substall('<','''"<"''',line);
            substall('!','\!',line);
            writeln(stdout,'echo ''',line,'''')
          end
        end
      end;
      l_c: begin
        substall('\','\\',line);
        substall('"','\"',line);
        writeln(stdout,'  puts("',line,'");');
      end;
      l_modula2: begin
        p := pos('"',line);
        while (p>0) do begin
          if (p>1) then write(stdout,'  WriteString("',copy(line,1,p-1),'"); ')
                   else write(stdout,'  ');
          writeln(stdout,'WriteString(''"'');');
          delete(line,1,p); p := pos('"',line);
        end;
        if (line<>'') then write(stdout,'  WriteString("',line,'"); ')
                      else write(stdout,'  ');
        writeln(stdout,'WriteLn;')
      end;
      l_cplusplus: begin
        substall('\','\\',line);
        substall('"','\"',line);
        writeln(stdout,'  cout << "',line,'\n";');
      end;
    end
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    line: string;
    d: longint;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,stdbufsize);
    if (debug) then
      writeln(conout,'       Reading ',p+s.name);

    while (not eof(f)) do begin
      readln(f,line);
      proc_line(line)
    end;

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    if (declaration) then case language of
      l_pascal: begin writeln(stdout,'end; {',gentxtout,'}') end;
      l_fortran: begin writeln(stdout,'      RETURN'); writeln(stdout,'      END') end;
      l_c: begin writeln(stdout,'}') end;
      l_modula2: begin writeln(stdout,'END ',gentxtout,';') end;
      l_cplusplus: begin writeln(stdout,'}') end;
      else ;
    end;
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@


1.4
log
@update to new email address
@
text
@d2 1
a2 1
{ $Id: genout.pas 1.3 1993/02/11 13:16:30 Ricki Exp $ }
d26 3
d56 1
a56 1
  pversion = '$Id: genout.pas 1.3 1993/02/11 13:16:30 Ricki Exp $';
d258 4
a261 4
          1: writeln(stdout,'#/bin/sh');
          2: writeln(stdout,'#/bin/csh');
          3: writeln(stdout,'#/bin/tcsh');
          4: writeln(stdout,'#/bin/zcsh');
@


1.3
log
@added 4DOS support
@
text
@d2 1
a2 1
{ $Id: genout.pas 1.2 1993/02/11 12:28:09 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d26 3
d53 1
a53 1
  pversion = '$Id: genout.pas 1.2 1993/02/11 12:28:09 Ricki Exp $';
@


1.2
log
@modified -v page
@
text
@d2 1
a2 1
{ $Id: GENOUT.PAS 1.1 1993/01/21 21:40:23 Ricki Exp $ }
d25 4
a28 1
        $Log: GENOUT.PAS $
d50 1
a50 1
  pversion = '$Id: GENOUT.PAS 1.1 1993/01/21 21:40:23 Ricki Exp $';
d56 1
a56 1
  opts = 'b:B:cC:dDe:E:fF:hHmM:pP:sS:v*'; ropt = opts;
d66 1
a66 1
              l_echo,l_modula2,l_c,l_dosecho,l_cplusplus);
d107 2
a108 2
  begin generated := 'This code was generated by '+desn+' '
                     +revno('$Revision: 1.1 $')+'. Do not edit!'
d144 5
a149 1
      'd': begin language := l_dosecho; declaration := false end;
d173 5
a177 1
      'D': begin language := l_dosecho; declaration := true end;
d231 1
a231 1
        writeln(stdout,'C---  Strings were split if they were longer than ',f_len,' characters');
d240 1
a240 1
      l_dosecho: begin
d245 5
d311 1
a311 1
      l_dosecho: begin
d315 12
a326 1
	substall('%','%%',line);
d328 2
a329 1
      end;
d350 1
a350 1
        writeln(stdout,'  printf("%s\n","',line,'");');
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: GENOUT.PAS 1.1 1993/01/21 21:22:00 Ricki Exp $ }
d26 2
a27 3
 * Revision 1.1  1993/01/21  21:22:00  Ricki
 * Initial revision
 *
d47 1
a47 1
  pversion = '$Id: GENOUT.PAS 1.1 1993/01/21 21:22:00 Ricki Exp $';
d52 1
d80 1
a80 1
    header(year,func);
d87 1
a87 1
    header(year,func);
d94 1
a94 1
    header(year,func);
d96 1
a96 1
    revision(desn,'$Revision: 1.1 $');
d104 1
a104 1
  begin generated := 'This code was generated by '+progname+' '
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program GENOUT;
{ Generate program fragments for textual output from text files }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  dates,
  times,
  numbers,
  strings,
  outcon,
  standard,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id$';

  func = 'Generate source code fragments from text files';
  year = '1992,1993';
  desn = 'GENOUT/2';
  opts = 'b:B:cC:dDe:E:fF:hHmM:pP:sS:v*'; ropt = opts;

  lang = 'BCDEFMPS'; { the languages }

  f_len = 50; { line length for FORTRAN output }
  min_shell = 1;
  max_shell = 4;

type
  langtype = (l_none,l_pascal,l_fortran,l_basic,
              l_echo,l_modula2,l_c,l_dosecho,l_cplusplus);

var
  debug: boolean;
  fbuf: pointer;

  foundone: boolean;
  language: langtype;
  declaration: boolean;
  gentxtout: pathstr;
  num,shell: longint;

  {$i genout.i1}
  {$i genout.i2}

  procedure help1;
  begin
    header(year,func);
    genouti1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    genouti2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 4.5 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  function generated: string;
  { returns a string 'This code was...' }
  begin generated := 'This code was generated by '+progname+' '
                     +revno('$Revision: 4.3 $')+'. Do not edit!'
  end;

  function modified: string;
  { returns a string 'Last modified...' }
  begin modified := 'Last modified: '+curdate+'; '+curtime
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    num := 1; shell := 1;
    language := l_none; gentxtout := 'GenTxtOut';
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'b': begin
        language := l_basic; declaration := false;
        if (optarg<>'') then begin
          if (not ival(optarg,num)) or (num=0) then
            err('-b: Illegal line number')
        end
      end;
      'e': begin
        language := l_echo; declaration := false;
        if (optarg<>'') then begin
          if (not ival(optarg,shell)) or (shell<min_shell) or (shell>max_shell)
            then err('-e: Illegal shell number')
        end
      end;
      'c': begin language := l_c; declaration := false end;
      'd': begin language := l_dosecho; declaration := false end;
      'f': begin language := l_fortran; declaration := false end;
      'm': begin language := l_modula2; declaration := false end;
      'p': begin language := l_pascal; declaration := false end;
      's': begin language := l_cplusplus; declaration := false end;

      'B': begin
        language := l_basic; declaration := true;
        if (optarg<>'') then begin
          if (not ival(optarg,num)) or (num=0) then
            err('-B: Illegal line number')
        end
      end;
      'E': begin
        language := l_echo; declaration := true;
        if (optarg<>'') then begin
          if (not ival(optarg,shell)) or (shell<min_shell) or (shell>max_shell)
            then err('-E: Illegal shell number')
        end
      end;
      'C': begin
        language := l_c; declaration := true;
        if (optarg<>'') then gentxtout := optarg
      end;
      'D': begin language := l_dosecho; declaration := true end;
      'F': begin
        language := l_fortran; declaration := true;
        gentxtout := 'GENTXTO';
        if (optarg<>'') then gentxtout := optarg
      end;
      'M': begin
        language := l_modula2; declaration := true;
        if (optarg<>'') then gentxtout := optarg
      end;
      'P': begin
        language := l_pascal; declaration := true;
        if (optarg<>'') then gentxtout := optarg
      end;
      'S': begin
        language := l_cplusplus; declaration := true;
        if (optarg<>'') then gentxtout := optarg
      end;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (language=l_none) then begin
      language := l_pascal; declaration := true
    end;

    if (debug) then startdbg;
    report(ropt,pversion);
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,stdbufsize);
    if (declaration) then case language of
      l_pascal: begin
        writeln(stdout,'procedure ',gentxtout,';');
        writeln(stdout,'{ '+generated+' }');
        writeln(stdout,'{ '+modified+' }');
        writeln(stdout);
        writeln(stdout,'begin');
      end;
      l_fortran: begin
        writeln(stdout,'      SUBROUTINE ',gentxtout);
        writeln(stdout,'C');
        writeln(stdout,'C--- '+generated);
        writeln(stdout,'C--- '+modified);
        writeln(stdout,'C');
        writeln(stdout,'C---  Strings were split if they were longer than ',f_len,' characters');
        writeln(stdout,'C');
      end;
      l_basic: begin
        writeln(stdout,num,' REM ',generated);
        if (num<65535) then inc(num) else err('Number overflow in BASIC mode');
        writeln(stdout,num,' REM ',modified);
        if (num<65535) then inc(num) else num := 0
      end;
      l_dosecho: begin
        writeln(stdout,'@@ECHO OFF');
        writeln(stdout,'REM ',generated);
        writeln(stdout,'REM ',modified);
      end;
      l_echo: begin
        case shell of
          1: writeln(stdout,'#/bin/sh');
          2: writeln(stdout,'#/bin/csh');
          3: writeln(stdout,'#/bin/tcsh');
          4: writeln(stdout,'#/bin/zcsh');
        end;
        writeln(stdout,'# ',generated);
        writeln(stdout,'# ',modified);
      end;
      l_c: begin
        writeln(stdout,'void');
        writeln(stdout,gentxtout,'()');
        writeln(stdout,'/* ',generated,' */');
        writeln(stdout,'/* ',modified,' */');
        writeln(stdout);
        writeln(stdout,'{');
      end;
      l_modula2: begin
        writeln(stdout,'PROCEDURE ',gentxtout,';');
        writeln(stdout,'(* ',generated,' *)');
        writeln(stdout,'(* ',modified,' *)');
        writeln(stdout);
        writeln(stdout,'BEGIN');
      end;
      l_cplusplus: begin
        writeln(stdout,'void');
        writeln(stdout,gentxtout,'()');
        writeln(stdout,'// ',generated);
        writeln(stdout,'// ',modified);
        writeln(stdout);
        writeln(stdout,'{');
      end
    end
  end;

  procedure proc_line(var line: string);
  var
    p: byte;
  begin
    case language of
      l_pascal: begin
        substall('''','''''',line);
        writeln(stdout,'  writeln(''',line,''');')
      end;
      l_fortran: begin
        substall('''','''''',line);
        if (line='') then line := ' ';
        writeln(stdout,'      WRITE(*,*) ''',copy(line,1,f_len),'''');
        delete(line,1,f_len);
        while (length(line)>0) do begin
          writeln(stdout,'     +          ,''',copy(line,1,f_len),'''');
          delete(line,1,f_len)
        end
      end;
      l_basic: begin
        if (num=0) then err('Number overflow in BASIC mode');
        substall('"','"+chr$(34)+"',line);
        writeln(stdout,num,' PRINT "',line,'"');
        if (num<65535) then inc(num) else num := 0
      end;
      l_dosecho: begin
        substall('>','}',line);
        substall('<','{',line);
        substall('|','!',line);
	substall('%','%%',line);
        writeln(stdout,'echo ',line)
      end;
      l_echo: begin
        case shell of
          1,4: { sh, zsh } begin
            substall('''','''"''"''',line);
            substall('>','''">"''',line);
            substall('<','''"<"''',line);
            writeln(stdout,'echo ''',line,'''')
          end;
          2,3: { csh, tcsh } begin
            substall('''','''"''"''',line);
            substall('>','''">"''',line);
            substall('<','''"<"''',line);
            substall('!','\!',line);
            writeln(stdout,'echo ''',line,'''')
          end
        end
      end;
      l_c: begin
        substall('\','\\',line);
        substall('"','\"',line);
        writeln(stdout,'  printf("%s\n","',line,'");');
      end;
      l_modula2: begin
        p := pos('"',line);
        while (p>0) do begin
          if (p>1) then write(stdout,'  WriteString("',copy(line,1,p-1),'"); ')
                   else write(stdout,'  ');
          writeln(stdout,'WriteString(''"'');');
          delete(line,1,p); p := pos('"',line);
        end;
        if (line<>'') then write(stdout,'  WriteString("',line,'"); ')
                      else write(stdout,'  ');
        writeln(stdout,'WriteLn;')
      end;
      l_cplusplus: begin
        substall('\','\\',line);
        substall('"','\"',line);
        writeln(stdout,'  cout << "',line,'\n";');
      end;
    end
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    line: string;
    d: longint;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,stdbufsize);
    if (debug) then
      writeln(conout,'       Reading ',p+s.name);

    while (not eof(f)) do begin
      readln(f,line);
      proc_line(line)
    end;

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    if (declaration) then case language of
      l_pascal: begin writeln(stdout,'end; {',gentxtout,'}') end;
      l_fortran: begin writeln(stdout,'      RETURN'); writeln(stdout,'      END') end;
      l_c: begin writeln(stdout,'}') end;
      l_modula2: begin writeln(stdout,'END ',gentxtout,';') end;
      l_cplusplus: begin writeln(stdout,'}') end;
      else ;
    end;
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@

