head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.22.22;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.11.13.29.27;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.21.21.40.28;	author Ricki;	state Exp;
branches;
next	;


desc
@Display hex dumps of binary files
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: hd.pas 1.2 1993/02/11 13:29:27 Ricki Exp $ }
program hd;
{ Display hex dumps of binary files }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: hd.pas $
        Revision 1.2  1993/02/11  13:29:27  Ricki
        modified -v page
        output 'Total:' only if the whole file was processed

        Revision 1.1  1993/01/21  21:40:28  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  tsuntb,
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id: hd.pas 1.2 1993/02/11 13:29:27 Ricki Exp $';

  func = 'Display hex dumps of binary files';
  year = '1992,1993';
  desn = 'HD/2';
  desv = '1.0';
  opts = 'hHl:o:qtxv*'; ropt = opts;

  default_lines = 20;
  bufsize = 16*(stdbufsize div 16);

type
  fbuftype = array [0..bufsize-1] of byte;

var
  debug: boolean;
  fbuf: ^fbuftype;

  optq,optx,optt: boolean;
  {a: array [0..bytes_per_line-1] of byte;}
  adr,lines,offset: longint;
  n: word;

  {$i hd.i1}
  {$i hd.i2}

  procedure help1;
  begin
    header(desv,year,func);
    hdi1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    hdi2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  procedure val16(hexstr: string; var val: longint; var code: integer);
  var
    i: byte;
  begin
    code := 1;
    { check if hexstr contains only 0-9A-Fa-f }
    for i:=1 to length(hexstr) do begin
      if  ( (hexstr[i]<'0') or (hexstr[i]>'9') )
      and ( (hexstr[i]<'A') or (hexstr[i]>'F') )
      and ( (hexstr[i]<'a') or (hexstr[i]>'f') )
      then exit
    end;
    { calc & return value }
    code := 0;
    val := hexdecfn(hexstr)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    optt := false; optx := false; optq := false;
    offset := 0; lines := maxlongint;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  var
    code: integer;
  begin
    case opt of
      'l': if (optarg<>'') then begin
        if (optarg[1]='$') then begin
          val16(copy(optarg,2,255),lines,code);
          if (code<>0) then err('Illegal hex length')
        end else begin
          val(optarg,lines,code);
          if (code<>0) then err('Illegal decimal length')
        end;
        if (lines<0) then err('Length must be greater or equal 0')
      end else lines := default_lines;
      'o': if (optarg<>'') then begin
        if (optarg[1]='$') then begin
          val16(copy(optarg,2,255),offset,code);
          if (code<>0) then err('Illegal hex offset')
        end else begin
          val(optarg,offset,code);
          if (code<>0) then err('Illegal decimal offset')
        end;
        if (offset<0) then err('Offset must be greater or equal 0')
      end;

      'x': optx := true;
      't': optt := true;
      'q': optq := true;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    { Nothing to do? }
    if (lines=0) then stop(0)
  end;

  procedure writeadr(adr: longint);
  var
    w: array [1..2] of word absolute adr;
  begin write(stdout,hexw(w[1])) end;

  procedure writehexa(start,len: word);
  var
    i: integer;
  begin
    for i:=0 to len-1 do write(stdout,hexb(fbuf^[start+i]),' ');
    for i:=len+1 to 16 do write(stdout,'   ');
  end;

  procedure writeasc(start,len: word);
  var
    i: integer;
  begin
    if (optx) then for i:=0 to len-1 do case fbuf^[start+i] of
      32..255: write(stdout,chr(fbuf^[start+i]));
      else write(stdout,'.')
    end else if (optt) then for i:=0 to len-1 do case fbuf^[start+i] of
      ord('0')..ord('9'),ord('A')..ord('Z'),ord('a')..ord('z'):
        write(stdout,chr(fbuf^[start+i]));
      else write(stdout,'.')
    end else for i:=0 to len-1 do case fbuf^[start+i] of
      32..126: write(stdout,chr(fbuf^[start+i]));
      else write(stdout,'.')
    end;
    for i:=len+1 to 16 do write(stdout,' ')
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,bufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  label
    endreached;
  var
    f: file;
    start: integer;
    tl,l,tb: longint;
    nl,nb: word;
  begin
    bininp(f,p+s.name);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    { output header lines }
    if (not optq) then begin
      writeln(stdout);
      if (s.name<>'') then writeln(stdout,'File: ',p+s.name)
                      else writeln(stdout,'File: standard input');
      Writeln(stdout,'Addr   0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F  0123456789ABCDEF');
      Writeln(stdout,'-----------------------------------------------------------------------');
    end;

    adr := offset;
    seek(f,offset);

    nb := bufsize;
    tl := 0; tb := 0;
    while (nb=bufsize) do begin
      blockread(f,fbuf^,bufsize,nb);
      start := 0;
      inc(tb,nb);

      { loop over the lines, each 16 bytes long }
      for l:=1 to nb div 16 do begin
        inc(tl); if (tl>lines) then goto endreached;
        writeadr(adr); write(stdout,'  ');
        writehexa(start,16); write(stdout,' ');
        writeasc(start,16); writeln(stdout);
        inc(adr,16); inc(start,16)
      end;

      { the last few bytes, if necessary }
      l := nb mod 16;
      if (l>0) then begin
        inc(tl); if (tl>lines) then goto endreached;
        writeadr(adr); write(stdout,'  ');
        writehexa(start,l); write(stdout,' ');
        writeasc(start,l); writeln(stdout);
        inc(adr,l); inc(start,l)
      end
    end;

    { output footer lines - only if the whole file was shown }
    if (not optq) and (offset=0) then begin
      writeln(stdout);
      writeln(stdout,'Total: ',tl,' lines with ',tb,' bytes.');
    end;

    endreached:
    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,bufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@


1.2
log
@modified -v page
output 'Total:' only if the whole file was processed
@
text
@d2 1
a2 1
{ $Id: HD.PAS 1.1 1993/01/21 21:40:28 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 5
a29 1
        $Log: HD.PAS $
d50 1
a50 1
  pversion = '$Id: HD.PAS 1.1 1993/01/21 21:40:28 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: HD.PAS 1.1 1993/01/21 21:22:05 Ricki Exp $ }
d26 2
a27 3
 * Revision 1.1  1993/01/21  21:22:05  Ricki
 * Initial revision
 *
d46 1
a46 1
  pversion = '$Id: HD.PAS 1.1 1993/01/21 21:22:05 Ricki Exp $';
d51 1
d74 1
a74 1
    header(year,func);
d81 1
a81 1
    header(year,func);
d88 1
a88 1
    header(year,func);
d90 1
a90 1
    revision(desn,'$Revision: 1.1 $');
d261 2
a262 2
    { output footer lines }
    if (not optq) then begin
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program hd;
{ Display hex dumps of binary files }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  tsuntb,
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id$';

  func = 'Display hex dumps of binary files';
  year = '1992,1993';
  desn = 'HD/2';
  opts = 'hHl:o:qtxv*'; ropt = opts;

  default_lines = 20;
  bufsize = 16*(stdbufsize div 16);

type
  fbuftype = array [0..bufsize-1] of byte;

var
  debug: boolean;
  fbuf: ^fbuftype;

  optq,optx,optt: boolean;
  {a: array [0..bytes_per_line-1] of byte;}
  adr,lines,offset: longint;
  n: word;

  {$i hd.i1}
  {$i hd.i2}

  procedure help1;
  begin
    header(year,func);
    hdi1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    hdi2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 4.3 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  procedure val16(hexstr: string; var val: longint; var code: integer);
  var
    i: byte;
  begin
    code := 1;
    { check if hexstr contains only 0-9A-Fa-f }
    for i:=1 to length(hexstr) do begin
      if  ( (hexstr[i]<'0') or (hexstr[i]>'9') )
      and ( (hexstr[i]<'A') or (hexstr[i]>'F') )
      and ( (hexstr[i]<'a') or (hexstr[i]>'f') )
      then exit
    end;
    { calc & return value }
    code := 0;
    val := hexdecfn(hexstr)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    optt := false; optx := false; optq := false;
    offset := 0; lines := maxlongint;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  var
    code: integer;
  begin
    case opt of
      'l': if (optarg<>'') then begin
        if (optarg[1]='$') then begin
          val16(copy(optarg,2,255),lines,code);
          if (code<>0) then err('Illegal hex length')
        end else begin
          val(optarg,lines,code);
          if (code<>0) then err('Illegal decimal length')
        end;
        if (lines<0) then err('Length must be greater or equal 0')
      end else lines := default_lines;
      'o': if (optarg<>'') then begin
        if (optarg[1]='$') then begin
          val16(copy(optarg,2,255),offset,code);
          if (code<>0) then err('Illegal hex offset')
        end else begin
          val(optarg,offset,code);
          if (code<>0) then err('Illegal decimal offset')
        end;
        if (offset<0) then err('Offset must be greater or equal 0')
      end;

      'x': optx := true;
      't': optt := true;
      'q': optq := true;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    { Nothing to do? }
    if (lines=0) then stop(0)
  end;

  procedure writeadr(adr: longint);
  var
    w: array [1..2] of word absolute adr;
  begin write(stdout,hexw(w[1])) end;

  procedure writehexa(start,len: word);
  var
    i: integer;
  begin
    for i:=0 to len-1 do write(stdout,hexb(fbuf^[start+i]),' ');
    for i:=len+1 to 16 do write(stdout,'   ');
  end;

  procedure writeasc(start,len: word);
  var
    i: integer;
  begin
    if (optx) then for i:=0 to len-1 do case fbuf^[start+i] of
      32..255: write(stdout,chr(fbuf^[start+i]));
      else write(stdout,'.')
    end else if (optt) then for i:=0 to len-1 do case fbuf^[start+i] of
      ord('0')..ord('9'),ord('A')..ord('Z'),ord('a')..ord('z'):
        write(stdout,chr(fbuf^[start+i]));
      else write(stdout,'.')
    end else for i:=0 to len-1 do case fbuf^[start+i] of
      32..126: write(stdout,chr(fbuf^[start+i]));
      else write(stdout,'.')
    end;
    for i:=len+1 to 16 do write(stdout,' ')
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,bufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  label
    endreached;
  var
    f: file;
    start: integer;
    tl,l,tb: longint;
    nl,nb: word;
  begin
    bininp(f,p+s.name);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    { output header lines }
    if (not optq) then begin
      writeln(stdout);
      if (s.name<>'') then writeln(stdout,'File: ',p+s.name)
                      else writeln(stdout,'File: standard input');
      Writeln(stdout,'Addr   0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F  0123456789ABCDEF');
      Writeln(stdout,'-----------------------------------------------------------------------');
    end;

    adr := offset;
    seek(f,offset);

    nb := bufsize;
    tl := 0; tb := 0;
    while (nb=bufsize) do begin
      blockread(f,fbuf^,bufsize,nb);
      start := 0;
      inc(tb,nb);

      { loop over the lines, each 16 bytes long }
      for l:=1 to nb div 16 do begin
        inc(tl); if (tl>lines) then goto endreached;
        writeadr(adr); write(stdout,'  ');
        writehexa(start,16); write(stdout,' ');
        writeasc(start,16); writeln(stdout);
        inc(adr,16); inc(start,16)
      end;

      { the last few bytes, if necessary }
      l := nb mod 16;
      if (l>0) then begin
        inc(tl); if (tl>lines) then goto endreached;
        writeadr(adr); write(stdout,'  ');
        writehexa(start,l); write(stdout,' ');
        writeasc(start,l); writeln(stdout);
        inc(adr,l); inc(start,l)
      end
    end;

    { output footer lines }
    if (not optq) then begin
      writeln(stdout);
      writeln(stdout,'Total: ',tl,' lines with ',tb,' bytes.');
    end;

    endreached:
    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,bufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@

