head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.22.29;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.11.13.33.57;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.21.21.40.32;	author Ricki;	state Exp;
branches;
next	;


desc
@Show the first lines of text files
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: head.pas 1.2 1993/02/11 13:33:57 Ricki Exp $ }
program head;
{ Show the first lines of text files }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: head.pas $
        Revision 1.2  1993/02/11  13:33:57  Ricki
        modified -v page

        Revision 1.1  1993/01/21  21:40:32  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  files,
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  options,
  outstd,
  dos;

const
  pversion = '$Id: head.pas 1.2 1993/02/11 13:33:57 Ricki Exp $';

  func = 'Show the first lines of text files';
  year = '1992,1993';
  desn = 'HEAD/2';
  desv = '1.0';
  opts = 'hHqv*'; ropt = '0:1:2:3:4:5:6:7:8:9:'+opts;

  minbufsize  = 255; { allocate at least these bytes }
  avglinesize = 80;  { allocate these*<n> bytes, but at most stdbufsize }

var
  fbuf: pointer;
  debug: boolean;

  bufsize: integer;
  nlines: longint;
  morefiles: boolean;
  optq: boolean;

  {$i head.i1}
  {$i head.i2}

  procedure help1;
  begin
    header(desv,year,func);
    headi1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    headi2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    nlines := 10;
    optq := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: cmdline.namestring); {$f-}
  begin
    case opt of
      '0'..'9': if (not ival(opt+optarg,nlines)) or (nlines<0) then
        err('Corrupt line count');
      'q': optq := true;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    { nothing to do? }
    if (nlines=0) then stop(0);
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    { determine whether there is more than one file to be processed }
    morefiles := (nnam>1);
    if (nnam=1) then
      morefiles := maybemany(getname(1));

    { calc desired buffer size }
    if (nlines>maxint div avglinesize) then bufsize := stdbufsize
    else begin
      bufsize := nlines*avglinesize;
      if (bufsize>stdbufsize) then bufsize := stdbufsize
      else if (bufsize<minbufsize) then bufsize := minbufsize
    end;

    getmem(fbuf,bufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    line: string;
    n: longint;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,bufsize);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    if (morefiles) and (not optq) then begin
      if (s.name='') then s.name := '(stdin)';
      writeln(stdout,'==> ',p+s.name,' <==')
    end;

    n := 0;
    while (n<nlines) and (not eof(f)) do begin
      readln(f,line);
      writeln(stdout,line);
      inc(n)
    end;

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,bufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@


1.2
log
@modified -v page
@
text
@d2 1
a2 1
{ $Id: HEAD.PAS 1.1 1993/01/21 21:40:32 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 4
a28 1
        $Log: HEAD.PAS $
d50 1
a50 1
  pversion = '$Id: HEAD.PAS 1.1 1993/01/21 21:40:32 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: HEAD.PAS 1.1 1993/01/21 21:22:09 Ricki Exp $ }
d26 2
a27 3
 * Revision 1.1  1993/01/21  21:22:09  Ricki
 * Initial revision
 *
d47 1
a47 1
  pversion = '$Id: HEAD.PAS 1.1 1993/01/21 21:22:09 Ricki Exp $';
d52 1
d72 1
a72 1
    header(year,func);
d79 1
a79 1
    header(year,func);
d86 1
a86 1
    header(year,func);
d88 1
a88 1
    revision(desn,'$Revision: 1.1 $');
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program head;
{ Show the first lines of text files }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  files,
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  options,
  outstd,
  dos;

const
  pversion = '$Id$';

  func = 'Show the first lines of text files';
  year = '1992,1993';
  desn = 'HEAD/2';
  opts = 'hHqv*'; ropt = '0:1:2:3:4:5:6:7:8:9:'+opts;

  minbufsize  = 255; { allocate at least these bytes }
  avglinesize = 80;  { allocate these*<n> bytes, but at most stdbufsize }

var
  fbuf: pointer;
  debug: boolean;

  bufsize: integer;
  nlines: longint;
  morefiles: boolean;
  optq: boolean;

  {$i head.i1}
  {$i head.i2}

  procedure help1;
  begin
    header(year,func);
    headi1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    headi2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 4.3 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    nlines := 10;
    optq := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: cmdline.namestring); {$f-}
  begin
    case opt of
      '0'..'9': if (not ival(opt+optarg,nlines)) or (nlines<0) then
        err('Corrupt line count');
      'q': optq := true;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    { nothing to do? }
    if (nlines=0) then stop(0);
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    { determine whether there is more than one file to be processed }
    morefiles := (nnam>1);
    if (nnam=1) then
      morefiles := maybemany(getname(1));

    { calc desired buffer size }
    if (nlines>maxint div avglinesize) then bufsize := stdbufsize
    else begin
      bufsize := nlines*avglinesize;
      if (bufsize>stdbufsize) then bufsize := stdbufsize
      else if (bufsize<minbufsize) then bufsize := minbufsize
    end;

    getmem(fbuf,bufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    line: string;
    n: longint;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,bufsize);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    if (morefiles) and (not optq) then begin
      if (s.name='') then s.name := '(stdin)';
      writeln(stdout,'==> ',p+s.name,' <==')
    end;

    n := 0;
    while (n<nlines) and (not eof(f)) do begin
      readln(f,line);
      writeln(stdout,line);
      inc(n)
    end;

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,bufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@

