head	1.11;
access;
symbols
	rutils40:1.7;
locks;
comment	@        @;


1.11
date	93.04.22.22.51.12;	author Ricki;	state Exp;
branches;
next	1.10;

1.10
date	93.04.21.19.42.31;	author Ricki;	state Exp;
branches;
next	1.9;

1.9
date	93.04.16.19.19.10;	author Ricki;	state Exp;
branches;
next	1.8;

1.8
date	93.03.31.19.24.42;	author Ricki;	state Exp;
branches;
next	1.7;

1.7
date	93.03.14.18.44.37;	author Ricki;	state Rel;
branches;
next	1.6;

1.6
date	93.02.23.18.14.51;	author Ricki;	state Exp;
branches;
next	1.5;

1.5
date	93.02.23.14.06.50;	author Ricki;	state Exp;
branches;
next	1.4;

1.4
date	93.02.11.17.10.50;	author Ricki;	state Exp;
branches;
next	1.3;

1.3
date	93.02.11.17.08.32;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.10.22.17.37;	author Ricki;	state Exp;
branches;
next	1.1;

1.1
date	93.02.04.18.02.53;	author Ricki;	state Exp;
branches;
next	;


desc
@Display information about files and directories
@

1.11
log
@Fixed the copyright message
@
text
@{$I SWITCHES.INC}
{ $Id: l.pas 1.10 1993/04/21 19:42:31 Ricki Exp $ }
program L;
{ Display information about files and directories }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: l.pas $
        Revision 1.10  1993/04/21  19:42:31  Ricki
        bugfix: l /f did sometimes delete the wrong '19'

        Revision 1.9  1993/04/16  19:19:10  Ricki
        bugfix: L killed colors if /x was specified and display
          was scrolled up

        Revision 1.8  1993/03/31  19:24:42  Ricki
        update to new email address

        Revision 1.7  1993/03/14  18:44:37  Ricki
        swapped -r and -R

        Revision 1.6  1993/02/23  18:14:51  Ricki
        the -r switch does now account for file number and sizes in the
          subdirectories by incrementing globalsize and globalnames

        Revision 1.5  1993/02/23  14:06:50  Ricki
        bugfix: filename sorting was sometimes wrong because #250 is greater
          than blank
        new option -m
        redesign of the procedure GT; new procedure fmtnames

        Revision 1.4  1993/02/11  17:10:50  Ricki
        corrected the year (the first version was 1988)

        Revision 1.3  1993/02/11  17:08:32  Ricki
        modified -v page
        bugfix for -1..-8: rounding was not applied everywhere
        modification for -x: executables are always marked with '*'
          (for monochrome displays)

        Revision 1.2  1993/02/10  22:17:37  Ricki
        lots of modifications

        Revision 1.1  1993/02/04  18:02:53  Ricki
        Initial revision
}

uses
  textfmt,
  files,
  options,
  strings,
  numbers,
  dates,
  times,
  outstd,
  outcon,
  standard,
  cmdline,
  dostools,
  crt,
  dos;

const
  pversion = '$Id: l.pas 1.10 1993/04/21 19:42:31 Ricki Exp $';

  func = 'Display information about files and directories';
  year = '1988-1993';
  desn = 'L/2';
  desv = '1.0';
  opts = '12458adefhHkKmnp:rRsuxvV'; ropt = opts;

  maxnames = 2048;
  network: word = $C0; { network attributes }

  sbase : array [boolean] of char = ('K','k'); { usage: sbase[base=1000] }
  fieldw: array [boolean] of byte = (19,39);   { usage: fieldw[opt_f] }

type
  namerec = record
    name: namexstr;
    size: longint;
    time: longint;
    attr: word
  end;

label
  ex;

var
  list: array [1..maxnames] of namerec;
  width,dfree,ssize,globalnames,globalsize,rvalue: longint;
  names,dirnames: integer;
  mask: pathstr;
  base,maxperpage: word;
  maxlines,maxchars: byte;
  p,lastpagestart,lastline,columns,colgap: integer;
  ch: char;
  change,warning: boolean;
  drive: byte;
  f: text;
  sr: searchrec;
  vol: namexstr;
  nopt,nnam: byte;
  what: string;

  opt_1,opt_2,opt_4,opt_5,opt_8,opt_a,opt_d,opt_rr,opt_p,opt_m,
    opt_e,opt_f,opt_r,opt_n,opt_s,opt_u,opt_v,opt_x: boolean;

  {$i L.i1}
  {$i L.i2}

  procedure header(desv,year,func: string);
  begin
    findent(stdout,length(progname)+6+length(desv));
    fwr1teln(stdout,progname+' v'+desv+' -- '+func);
    findent(stdout,9);
    fwr1teln(stdout,'Copr (c) '+year+' Albert Ramm & Richard Breuer. '+progname+' is freeware. No warranties.');
  end;

  procedure author;
  begin
    findent(stdout,0);
    fwr1teln(stdout,'Layout and portions of the code:');
    fwr1teln(stdout,'        Albert Ramm');
    fwr1teln(stdout,'        Konrad-Adenauer-Strasse 77');
    fwr1teln(stdout,'        5190 Stolberg/Bsbach');
    fwr1teln(stdout,'        Germany, Europe');
    fwr1teln(stdout,'Phone:  +49/2402/91054');
    fwr1teln(stdout,'');
    fwr1teln(stdout,'Re-Implementation and enhancements:');
    fwr1teln(stdout,'        Richard Breuer');
    fwr1teln(stdout,'        Brunssumstrasse 6');
    fwr1teln(stdout,'        5100 Aachen');
    fwr1teln(stdout,'        (after Jul 1, 1993: 52074 Aachen)');
    fwr1teln(stdout,'        Germany, Europe');
    fwr1teln(stdout,'Phone:  +49/241/85605');
    fwr1teln(stdout,'Fax:    +49/241/8021329');
    fwr1teln(stdout,'Email:  ricki@@pool.informatik.rwth-aachen.de (Preferred!)');
  end;

  procedure help1;
  begin
    header(desv,year,func);
    Li1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    Li2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  function maxx: byte;
  var
    m: byte;
  begin
    m := 0;
    repeat
      inc(m); gotoxy(m,1)
    until (wherex<>m);
    maxx := m-1
  end;

  function maxy: byte;
  var
    m: byte;
  begin
    m := 0;
    repeat
      inc(m); gotoxy(1,m)
    until (wherey<>m);
    maxy := m-1
  end;

  procedure pre_op;
  begin
    base := 1000;
    opt_1 := false; opt_2 := false; opt_4 := false;
                    opt_5 := false; opt_8 := false;
    opt_a := false; opt_d := false; opt_e := false;
                    opt_f := false; opt_r := false;
                    opt_n := false; opt_s := false;
                    opt_u := false; opt_v := false;
                    opt_x := false; opt_rr := false;
                    opt_p := false; opt_m := false;
  end;

  procedure proc_op;
  var
    i: byte;
  begin
    parse(ropt,nopt,nnam);

    for i:=1 to nopt do case getopt(i) of
      '1': opt_1 := true;
      '2': opt_2 := true;
      '4': opt_4 := true;
      '5': opt_5 := true;
      '8': opt_8 := true;
      'a': opt_a := true;
      'd': opt_d := true;
      'e': opt_e := true;
      'f': opt_f := true;
      'm': opt_m := true;
      'n': opt_n := true;
      'R': opt_r := true;
      'r': opt_rr := true;
      's': opt_s := true;
      'u': opt_u := true;
      'V': opt_v := true;
      'x': opt_x := true;
      'k': base := 1000;
      'K': base := 1024;
      'p': begin
        opt_p := true;
        if (optarg='') then width := 79
        else if (not ival(optarg,width)) then err('Illegal width')
      end;

      'h': help1;
      'H': help2;
      'v': version
    end;

    { create a string which contains all the names from the command line }
    what := '';
    if (nnam=0) then what := fexpand('*.*')
    else for i:=1 to nnam do what := what+fexpand(getname(i))+' '
  end;

  procedure post_op;
  const
    c: array [boolean] of byte = (0,1);
  begin
    { check the mutually exclusive options }
    if (c[opt_1]+c[opt_2]+c[opt_4]+c[opt_5]+c[opt_8]>1) then
      err('-1,-2,-4,-5, and -8 are mutually exclusive');
    if (c[opt_d]+c[opt_e]+c[opt_n]+c[opt_s]+c[opt_u]>1) then
      err('-d,-e,-n,-s, and -u are mutually exclusive');

    { calculate the rounding value for the -num options }
    if      (opt_1) then rvalue := 1024
    else if (opt_2) then rvalue := 2048
    else if (opt_4) then rvalue := 4096
    else if (opt_5) then rvalue :=  512
    else if (opt_8) then rvalue := 8192
    else                 rvalue :=    1;

    { if the output is redirected, opt_p is automagically set }
    if (outredirected) and (not opt_p) then begin
      opt_p := true;
      width  := 79
    end
  end;

  function GT(ent1,ent2: namerec): boolean;
  { returns true, iff ent1 > ent2 }
  var
    dummy: pathstr;
    S1,S2: string[4];
  begin
    { size }
    if (opt_s) then begin
      GT := (ent1.SIZE>ent2.SIZE);
      if (ent1.SIZE=ent2.SIZE) then GT := (ent1.NAME>ent2.NAME)
    { date }
    end else if (opt_d) then begin
      GT := (ent1.TIME>ent2.TIME);
      if (ent1.TIME=ent2.TIME) then GT := (ent1.NAME>ent2.NAME)
    { extension }
    end else if (opt_e) then begin
      fsplit(ent1.name,dummy,dummy,s1);
      fsplit(ent2.name,dummy,dummy,s2);
      GT := (s1>s2);
      if (s1=s2) then gt := (ent1.NAME>ent2.NAME)
    end else GT := (ent1.NAME>ent2.NAME)
  end;

  procedure qsort(l,r: Integer);
  { recurive qs implementation }
  var
    i,j,k: Integer;
    help1,help2: namerec;
  begin
    if (l>=r) then exit;
    i := L;
    j := R;
    help1 := List[(i+j) div 2];
    if (opt_rr) then repeat
      while (GT(List[i],help1)) do inc(i);
      while (GT(help1,List[j])) do dec(j);
      if (i<=j) then begin
        help2   := list[i];
        list[i] := list[j];
        list[j] := help2;
        inc(i);
        dec(j);
      end;
    until (i>j) else repeat
      while (GT(help1,List[i])) do inc(i);
      while (GT(List[j],help1)) do dec(j);
      if (i<=j) then begin
        help2   := list[i];
        list[i] := list[j];
        list[j] := help2;
        inc(i);
        dec(j);
      end;
    until (i>j);
    if (l<j) then qSort(l,j);
    if (r>i) then qSort(i,r);
  end;

  procedure sort;
  var
    help1,help2: namerec;
    lastd,i: Integer;
  begin
    if (not opt_m) then begin
      { move the directories to the top of the list }
      lastd := 0;
      for i:=1 to names do begin
        if (list[i].attr and directory<>0) then begin
          inc(lastd);
          if (lastd<i) then begin
            help1      := list[i];
            list[i]    := list[lastd];
            list[lastd]:= help1;
          end
        end
      end;
      { sort the directories and the files separately }
      if (not opt_u) then qsort(1,lastd);
      if (not opt_u) then qsort(lastd+1,names)
    { if -m is specified, everything is sorted together }
    end else qsort(1,names)
  end;

  procedure fmtnames;
  { fills the names with  for a nice output format }
  const
    s8 = '';
  var
    i: integer;
  begin
    for i:=1 to names do begin
      p := pos('.',list[i].NAME);
      if (p=0) then list[i].name := copy(list[i].name+s8,1,8)+' '
               else list[i].name := copy(copy(list[i].name,1,p-1)+s8,1,8)
                                   +' '
                                   +copy(copy(list[i].name,p+1,3)+s8,1,3)
    end;
  end;

  {$f+} procedure sum_size(var s: searchrec; p: pathstr); {$f-}
  begin
    inc(globalnames);
    { round size }
    if (s.size>0) and (rvalue>1)
      then inc(ssize,(1+((s.size-1) div rvalue))*rvalue)
      else inc(ssize,s.size)
  end;

  {$f+} procedure store_name(var s: searchrec; p: pathstr); {$f-}
  var
    bcode: byte;
  begin
    { do only store the name, if it is not hidden, or -v is specified }
    if (s.name<>'.') and (s.name<>'..')
    and ((opt_v) or (s.attr and hidden=0)) then begin
      inc(names);
      if (names>maxnames) then exit;
      with list[names] do begin
        { round size }
        if (s.size>0) and (rvalue>1) then
          s.size := (1+((s.size-1) div rvalue))*rvalue;

        name := s.name;
        size := s.size;
        time := s.time;
        attr := s.attr;
        if (attr and directory=0) then inc(globalnames) { 1 file }
        else begin
          inc(dirnames);
          ssize := 0;
          { sum all up file sizes recursivly, if wanted }
          if (opt_r) then
            forallrec(p+s.name,'*.*',anyfile and not directory,
                      sum_size,bcode);
          size := ssize
        end;
        inc(globalsize,size);
      end
    end
  end;

  procedure read_dirs;
  var
    i,code: byte;
  begin
    names := 0; dirnames := 0;
    globalnames := 0; globalsize := 0;
    drive := 255;

    if (nnam=0) then begin
      mask := fexpand('*.*');
      forall(mask,$ff and not volumeid,store_name,code);
      drive := ord(upcase(mask[1]))+1-ord('A')
    end else for i:=1 to nnam do begin
      { create the file mask }
      mask := fexpand(getname(i));
      if (mask='') then help1;
      if (isdir(mask)) then begin
        if (mask[length(mask)]<>'\') then mask := mask+'\';
        mask := mask+'*.*'
      end;
      forall(mask,$ff and not volumeid,store_name,code);
      { determine the drive number. if all are the same, it's it, otherwise,
        0 = different drives is set }
      if (drive<>0) then begin
        if (drive=255) then drive := ord(upcase(mask[1]))+1-ord('A')
        else if (drive<>ord(upcase(mask[1]))+1-ord('A')) then drive := 0
      end
    end
  end;

  {-------------------------------------------------------------------------------}
  procedure cwrite(s: string);
  begin
    if (length(s)<maxchars) then
      write(' ':(maxchars-length(s)) div 2,s,' ':(maxchars-length(s)-1) div 2)
    else
      write(copy(s,1,maxchars))
  end;

  procedure showheader;
  begin
    textcolor(lightgray);
    clrscr;
    GotoXY(1,1);
    textcolor(lightgray);
    Write('Directory of ');
    textcolor(white);
    if (length(what)<maxchars-26) then write(what)
                                  else write(copy(what,1,maxchars-31),'...');
    Gotoxy(1,2);
    textcolor(lightblue);
    cwrite('Copyright 1988-1993 by Albert Ramm & Richard Breuer')
  end;

  procedure showupdown;
  begin
    Gotoxy(1,2);
    textcolor(blink+lightgray);
    if (warning) then cwrite('--->  Warning: Too many files, some are not displayed!  <---')
                 else cwrite('--->  Back: '+#24+'  Forward: '+#25+'  Quit: <Esc>  <---')
  end;

  procedure showup;
  begin
    Gotoxy(1,2);
    textcolor(blink+lightgray);
    if (warning) then cwrite('--->  Warning: Too many files, some are not displayed!  <---')
                 else cwrite('--->  Back: '+#24+'  Quit: <Esc>  <---')
  end;

  procedure showdown;
  begin
    Gotoxy(1,2);
    textcolor(blink+lightgray);
    if (warning) then cwrite('--->  Warning: Too many files, some are not displayed!  <---')
                 else cwrite('--->  Forward: '+#25+'  Quit: <Esc>  <---')
  end;

  procedure showpage(p: integer);
  { show one page containing the entries from position p. Returns the number
    of names in the longest column in 'lastline' }
  var
    i,display,coldisplay: integer;
    att: char;
    dt: datetime;
    ds: datestring;
  begin
    showheader;

    { calculate some help values }
    display := maxperpage;
      if (p+display-1>names) then display := names+1-p;
    lastline := (display+columns-1) div columns;

    i := 0;
    while (p+i<=names) and (i<maxperpage) do with list[p+i] do begin
      { jump to the position }
      gotoxy((i div lastline)*(fieldw[opt_f]+colgap)+1,
             (i mod lastline)+3);

      { determine the attribute char to be displayed }
      att := #32;
      if (attr and archive>0) and (opt_a) then att := 'a';
      if (attr and network>0)             then att := 'n';
      if (attr and readonly>0)            then att := 'r';
      if (attr and hidden>0)              then att := 'h';
      if (attr and sysfile>0)             then att := 's';
      if (attr and directory>0)           then att := 'd';
      textcolor(lightgray); write(att);

      { output the name }
      if (opt_x) then begin
        if ( pos(' EXE',name)+pos(' BAT',name)
            +pos(' COM',name)+pos(' BTM',name)
            +pos('*EXE',name)+pos('*BAT',name)
            +pos('*COM',name)+pos('*BTM',name)
	    >0 ) then begin
          textcolor(yellow);
          { for monochrome displays we insert a '*' in the name }
          name[9] := '*'
        end else textcolor(white)
      end else textcolor(white);
      write(name);

      textcolor(lightgray);
      { normal format? }
      if (not opt_f) then begin
        { output the size, if necessary }
        if (attr and directory=0) or (opt_r) then begin
          if (size<1000)      then write('  .',zerostr(size,3))
          else if (size<base) then write(1:5)
                              else write(size div base:5)
        end
      end else begin { wide format }
        unpacktime(time,dt);
        ds := date2str(dt.day,dt.month,dt.year);
        delete(ds,length(ds)-3,2);
        if (attr and directory=0) or (opt_r)
          then write(size:8,' ',ds,' ',time2sstr(dt.hour,dt.min,dt.sec))
          else write(' ':9,ds,' ',time2sstr(dt.hour,dt.min,dt.sec))
      end;
      inc(i)
    end
  end;

  procedure showascii;
  { display the directory on stdout, suitable for redirection }
  var
    s: string;
    i,j,p,coldisplay,colwidth: integer;
    att: char;
    dt: datetime;
    ds: datestring;

    procedure acwrite(s: string);
    begin
      if (length(s)<maxchars) then
        writeln(stdout,' ':(maxchars-length(s)) div 2,s)
      else
        writeln(stdout,copy(s,1,maxchars))
    end;

    procedure ashowheader;
    begin
      s := 'Directory of ';
      if (length(what)<maxchars-26) then s := s+what
                                    else s := s+copy(what,1,maxchars-31)+'...';
      s := copy(s+blanks,1,maxchars-15);
      if (drive>0) then begin
        dfree := diskfree(drive);
        s := s+lnumstr(dfree div base,7)+' '+sbase[base=1000]+'B';
      end else s := s+'         ?';
      writeln(stdout,s,' free');

      s := numstr(globalnames)+' Files with a total of '
          +numstr(globalsize DIV base)+' '+sbase[base=1000]+'B disk space';

      if (drive<>0) then begin
        findfirst(chr(ord('A')-1+drive)+':\*.*',volumeid,sr);
        if (doserror=0) then begin
          vol := sr.name;
          substone('.','',vol);
          vol := copy(vol+blanks,1,11);
          substall(' ','',vol)
        end else vol := '[no vlabel]'
      end else vol := '[multi drv]';

      s := copy(s+blanks,1,maxchars-11);
      writeln(stdout,s,vol);

      if (warning) then
        acwrite('--->  Warning: Too many files, some are not displayed!  <---')
    end;

  begin
    ashowheader;

    coldisplay := (names+columns-1) div columns;

    for i:=1 to coldisplay do begin
      s := '';
      for j:=1 to columns do begin
        p := i+(j-1)*coldisplay;
        if (p<=names) then with list[p] do begin
          { determine the attribute char to be displayed }
          att := #32;
          if (attr and archive>0) and (opt_a) then att := 'a';
          if (attr and network>0)             then att := 'n';
          if (attr and readonly>0)            then att := 'r';
          if (attr and hidden>0)              then att := 'h';
          if (attr and sysfile>0)             then att := 's';
          if (attr and directory>0)           then att := 'd';
          s := s+att;

          { process the name }
          if (opt_x) then begin
            if ( pos(' EXE',name)+pos(' BAT',name)
                +pos(' COM',name)+pos(' BTM',name)>0 ) then name[9] := '*'
          end;
          s := s+name;

          { normal format? }
          if (not opt_f) then begin
            { output the size, if necessary }
            if (attr and directory=0) or (opt_r) then begin
              if (size<1000)      then s := s+'  .'+zerostr(size,3)
              else if (size<base) then s := s+'    1'
                                  else s := s+lnumstr(size div base,5)+' '
            end else s := s+'      '
          end else begin { wide format }
            unpacktime(time,dt);
            ds := date2str(dt.day,dt.month,dt.year);
            substone('/19','/',ds);
            if (attr and directory=0) or (opt_r)
              then s := s+lnumstr(size,8)+' '+ds+' '+time2sstr(dt.hour,dt.min,dt.sec)
              else s := s+'         '+ds+' '+time2sstr(dt.hour,dt.min,dt.sec)
          end;
          if (j<columns) then s := s+copy(blanks,1,colgap)
        end
      end;
      writeln(stdout,s)
    end;
  end;

begin
  pre_op;
  proc_op;
  post_op;

  { ASCII ? }
  if (opt_p) then begin

    { adjust width, if necessary }
    if (width>255) then maxchars := 254
    else if (width<fieldw[opt_f]) then maxchars := fieldw[opt_f]
    else maxchars := width;

    { determine the column number }
    columns := (maxchars+1) div (fieldw[opt_f]+1);
    if (columns>1) then
      colgap := (maxchars-columns*fieldw[opt_f]) div (columns-1);

    read_dirs;

    { detect: too many names }
    warning := (names>maxnames);
    if (warning) then names := maxnames;

    { sort according to thw switches }
    sort;

    { prepare the list for output }
    fmtnames;

    showascii
  end else begin
    maxlines := maxy;
    maxchars := maxx-1;

    { determine the column number }
    columns := (maxchars+1) div (fieldw[opt_f]+1);
    if (columns>1) then
      colgap := (maxchars-columns*fieldw[opt_f]) div (columns-1);

    assigncrt(f);
    textcolor(lightgray);
    showheader;
    read_dirs;

    { detect: too many names }
    warning := (names>maxnames);
    if (warning) then names := maxnames;

    { sort according to thw switches }
    sort;

    { prepare the list for output }
    fmtnames;

    maxperpage := (maxlines-3)*columns;
    lastpagestart := ((names-1) div maxperpage)*maxperpage+1;

    p := 1; change := true; ch := #32;

    repeat { goto ex to leave this loop }
      if (change) then showpage(p);
      if (p=lastpagestart) and ( (ch=#13) or (ch=#32) ) then goto ex;

      change := false;

      if (lastpagestart>1) then begin
        if (p=1)                  then showdown
        else if (p=lastpagestart) then showup
        else                         showupdown;

        ch := readkey;
        if (ch=#0) or (ch=#13) or (ch=#32) then begin
          if (ch=#0) then ch := readkey;
          if (ch=#73) or (ch=#72) then begin
            if (P>(MAXLINEs-3)*columns) then begin
              dec(P,MAXperpage); change := true
            end
          end else if (ch=#81) or (ch=#80) then begin
            if (P+(MAXLINEs-3)*columns<=names) then begin
              inc(P,maxperpage); change := true
            end
          end else if (ch=#13) or (ch=#32) then begin
            if (p+(maxlines-3)*columns<=names) then begin
              inc(P,maxperpage); change := true
            end
          end
        end else if (ch=#27) then goto ex
      end
    until false;

    ex:

    GotoXY(1,2);
    textcolor(lightgray);
    cwrite('');
    GotoXY(1,2);
    write(globalnames,' Files with a total of ',
          globalsize DIV base,' ',sbase[base=1000],'B disk space');

    gotoxy(maxchars-14,1);
    textcolor(white);
    if (drive>0) then begin
      dfree := diskfree(drive);
      write(dfree div base:7,' ',sbase[base=1000],'B')
    end else write('         ?');
    textcolor(lightgray);
    write(' free');

    if (drive<>0) then begin
      findfirst(chr(ord('A')-1+drive)+':\*.*',volumeid,sr);
      if (doserror=0) then begin
        vol := sr.name;
        substone('.','',vol);
        vol := copy(vol+blanks,1,11);
        substall(' ','',vol)
      end else vol := '[no vlabel]'
    end else vol := '[multi drv]';

    gotoxy(maxchars-10,2);
    textcolor(lightgray);
    write(vol);

    gotoxy(1,lastline+2);

    NormVideo
  end;

  stop(0)
end.
@


1.10
log
@bugfix: l /f did sometimes delete the wrong '19'
@
text
@d2 1
a2 1
{ $Id: l.pas 1.9 1993/04/16 19:19:10 Ricki Exp $ }
d26 3
d82 1
a82 1
  pversion = '$Id: l.pas 1.9 1993/04/16 19:19:10 Ricki Exp $';
d478 1
a478 1
    cwrite('Copyright 1991-1993 by Albert Ramm & Richard Breuer')
@


1.9
log
@bugfix: L killed colors if /x was specified and display
  was scrolled up
@
text
@d2 1
a2 1
{ $Id: l.pas 1.8 1993/03/31 19:24:42 Ricki Exp $ }
d26 4
d79 1
a79 1
  pversion = '$Id: l.pas 1.8 1993/03/31 19:24:42 Ricki Exp $';
d560 1
a560 1
        substone('/19','/',ds);
@


1.8
log
@update to new email address
@
text
@d2 1
a2 1
{ $Id: l.pas 1.7 1993/03/14 18:44:37 Ricki Exp $ }
d26 3
d75 1
a75 1
  pversion = '$Id: l.pas 1.7 1993/03/14 18:44:37 Ricki Exp $';
d533 4
a536 1
            +pos(' COM',name)+pos(' BTM',name)>0 ) then begin
@


1.7
log
@swapped -r and -R
@
text
@d2 1
a2 1
{ $Id: l.pas 1.6 1993/02/23 18:14:51 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d26 3
d72 1
a72 1
  pversion = '$Id: l.pas 1.6 1993/02/23 18:14:51 Ricki Exp $';
d135 1
a135 1
    fwr1teln(stdout,'        Germany');
d141 3
a143 2
    fwr1teln(stdout,'        5100 Aachen [from Jul 1, 1993: 52074 Aachen]');
    fwr1teln(stdout,'        Germany');
d146 1
a146 1
    fwr1teln(stdout,'Email:  ricki@@rwthi3.informatik.rwth-aachen.de');
@


1.6
log
@the -r switch does now account for file number and sizes in the
  subdirectories by incrementing globalsize and globalnames
@
text
@d2 1
a2 1
{ $Id: l.pas 1.5 1993/02/23 14:06:50 Ricki Exp $ }
d26 4
d69 1
a69 1
  pversion = '$Id: l.pas 1.5 1993/02/23 14:06:50 Ricki Exp $';
d222 2
a223 2
      'r': opt_r := true;
      'R': opt_rr := true;
@


1.5
log
@bugfix: filename sorting was sometimes wrong because #250 is greater
  than blank
new option -m
redesign of the procedure GT; new procedure fmtnames
@
text
@d2 1
a2 1
{ $Id: L.PAS 1.4 1993/02/11 17:10:50 Ricki Exp $ }
d25 7
a31 1
        $Log: L.PAS $
d65 1
a65 1
  pversion = '$Id: L.PAS 1.4 1993/02/11 17:10:50 Ricki Exp $';
d369 1
d394 2
a395 4
        if (attr and directory=0) then begin
          inc(globalsize,size);
          inc(globalnames)
        end else begin
d403 2
a404 1
        end
@


1.4
log
@corrected the year (the first version was 1988)
@
text
@d2 1
a2 1
{ $Id: l.pas 1.3 1993/02/11 17:08:32 Ricki Exp $ }
d25 4
a28 1
        $Log: l.pas $
d59 1
a59 1
  pversion = '$Id: l.pas 1.3 1993/02/11 17:08:32 Ricki Exp $';
d65 1
a65 1
  opts = '12458adefhHkKnp:rRsuxvV'; ropt = opts;
d101 1
a101 1
  opt_1,opt_2,opt_4,opt_5,opt_8,opt_a,opt_d,opt_rr,opt_p,
d191 1
a191 1
                    opt_p := false
d210 1
d263 1
d265 2
a266 2
    i,j: integer;
    S1,S2: string[14];
d268 1
a268 1
    GT := (ent1.NAME<ent2.NAME);
d271 2
a272 1
      if (ent1.SIZE=ent2.SIZE) then GT := (ent1.NAME<ent2.NAME)
d275 2
a276 1
      if (ent1.TIME=ent2.TIME) then GT := (ent1.NAME<ent2.NAME)
d278 5
a282 12
      j := 9;
      i := 9;
      if (j=0) then j := length(ent1.NAME);
      if (i=0) then i := length(ent2.NAME);
      S1 := copy(ent1.NAME,j+1,j+3)
           +copy ('          ',1,j+3-length(ent1.NAME))
           +copy(ent1.NAME,1,j);
      S2 := copy(ent2.NAME,i+1,i+3)
           +copy ('          ',1,i+3-length(ent2.NAME))
           +copy(ent2.NAME,1,i);
      GT := (S1<S2)
    end
d286 1
d295 1
a295 1
    if (not opt_rr) then repeat
d323 1
a323 2
    lastd,i,j,k: Integer;
    HNAME: namexstr;
d325 11
a335 8
    lastd := 0;
    for i:=1 to names do begin
      if (list[i].attr and directory<>0) then begin
        inc(lastd);
        if (lastd<i) then begin
          help1      := list[i];
          list[i]    := list[lastd];
          list[lastd]:= help1;
d337 15
a351 2
      end
    end;
d353 5
a357 11
      j := pos('.',list[i].NAME);
      if (j>0) then begin
        HNAME := list[i].NAME+'';
        list[i].NAME := list[i].NAME+'            ';
        for k:=j to 8 do list[i].NAME[k] := '';
        for k:=1 to 3 do list[i].NAME[k+9] := HNAME[j+k]
      end else begin
        for j:=length(list[i].NAME)+1 to 12 do
          list[i].NAME := list[i].NAME+''
      end;
      list[i].NAME[9] := ' '
a358 2
    if (not opt_u) then qsort(1,lastd);
    if (not opt_u) then qsort(lastd+1,names)
d671 3
d695 3
@


1.3
log
@modified -v page
bugfix for -1..-8: rounding was not applied everywhere
modification for -x: executables are always marked with '*'
  (for monochrome displays)
@
text
@d2 1
a2 1
{ $Id: l.pas 1.2 1993/02/10 22:17:37 Ricki Exp $ }
d26 6
d56 1
a56 1
  pversion = '$Id: l.pas 1.2 1993/02/10 22:17:37 Ricki Exp $';
d59 1
a59 1
  year = '1990-1993';
@


1.2
log
@lots of modifications
@
text
@d2 1
a2 1
{ $Id: L.PAS 1.1 1993/02/04 18:02:53 Ricki Exp $ }
d25 4
a28 1
        $Log: L.PAS $
d50 1
a50 1
  pversion = '$Id: L.PAS 1.1 1993/02/04 18:02:53 Ricki Exp $';
d56 1
a56 1
  opts = '123458adefhHkKnp:rRsuxvV'; ropt = opts;
d100 2
a101 2
    findent(stdout,length(progname)+4);
    fwr1teln(stdout,progname+' -- '+func);
d142 1
a142 1
    header(year,func);
d246 4
a249 1
    if (outredirected) then opt_p := true
d348 5
a352 1
  begin inc(ssize,s.size)
d365 4
d384 1
a384 4
        end;
        { round size }
        if (size>0) and (rvalue>1) then
          size := (1+((size-1) div rvalue))*rvalue
d502 5
a506 2
            +pos(' COM',name)+pos(' BTM',name)>0 ) then textcolor(yellow)
                                                   else textcolor(white)
@


1.1
log
@Initial revision
@
text
@d2 1
a2 1
{ $Id: L.PAS 1.1 1993/02/04 18:01:34 Ricki Exp $ }
d25 3
a27 1
	$Log$
a29 5
{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

d42 1
d47 1
a47 1
  pversion = '$Id: L.PAS 1.1 1993/02/04 18:01:34 Ricki Exp $';
d52 2
a53 1
  opts = '123458adefhHnrsuxv*'; ropt = opts;
d55 2
a56 2
  maxnames = 1024;
  na: word = $C0; {???}
d58 3
a72 2
  debug: boolean;

d74 1
a74 2
  columns: byte;
  ssize,globalnames,globalsize,rvalue: longint;
d77 1
a77 1
  maxperpage: word;
d79 1
a79 1
  p,lastpagestart,lastline: integer;
d81 1
a81 1
  change: boolean;
d86 2
d89 1
a89 1
  opt_1,opt_2,opt_4,opt_5,opt_8,opt_a,opt_d,
d95 1
a95 1
  procedure header(year,func: string);
d106 6
a111 1
    fwr1teln(stdout,'Authors: Albert Ramm                 Richard Breuer');
d113 8
a120 8
    fwr1teln(stdout,'Mail:    Konrad-Adenauer-Strasse 77  Brunssumstrasse 6');
    fwr1teln(stdout,'         5190 Stolberg/Buesbach      5100 Aachen');
    fwr1teln(stdout,'         Germany');
    fwr1teln(stdout,'');
    fwr1teln(stdout,'Phone:   +49/2402/91054              +49/241/85605');
    fwr1teln(stdout,'Fax:                                 +49/241/8021329');
    fwr1teln(stdout,'');
    fwr1teln(stdout,'Email:                               ricki@@rwthi3.informatik.rwth-aachen.de');
d125 1
a125 1
    header(year,func);
d132 1
a132 1
    header(year,func);
d141 1
a141 1
    revision(desn,'$Revision: 1.1 $');
d171 1
d173 1
a173 1
    	            opt_5 := false; opt_8 := false;
d175 5
a179 9
    		    opt_f := false; opt_r := false;
		    opt_n := false; opt_s := false;
		    opt_u := false; opt_v := false;
		    opt_x := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
d184 1
a184 1
    i,nopt,nnam: byte;
d200 1
d203 1
d205 7
d215 1
a215 2
      'v': version;
      '*': debug := true;
d218 4
a221 9
    { create the file mask }
    if (nnam>0) then begin
      mask := fexpand(getname(1));
      if (mask='') then help1;
      if (isdir(mask)) then begin
        if (mask[length(mask)]<>'\') then mask := mask+'\';
        mask := mask+'*.*'
      end
    end else mask := fexpand('*.*')
a227 3
    if (debug) then startdbg;
    report(ropt,pversion);

a232 2
    if (c[opt_a]+c[opt_x]>1) then
      err('-a and -x are mutually exclusive');
d240 4
a243 1
    else		 rvalue :=    1;
d265 1
a265 1
	   +copy(ent1.NAME,1,j);
d268 1
a268 1
	   +copy(ent2.NAME,1,i);
d282 1
a282 1
    repeat
d292 10
d360 1
a360 1
	  inc(globalsize,size);
d363 2
a364 2
	  inc(dirnames);
	  ssize := 0;
d367 2
a368 2
	    forallrec(p+s.name,'*.*',anyfile and not directory,
	              sum_size,bcode);
d370 1
a370 1
	end;
d372 2
a373 1
        if (size>0) and (rvalue>1) then size := (size div rvalue+1)*rvalue
d378 1
a378 1
  procedure read_dir;
d380 1
a380 1
    code: byte;
d384 1
d386 20
a405 1
    forall(mask,$ff and not volumeid,store_name,code)
d410 5
a414 1
  begin write(' ':(maxchars-length(s)) div 2,s,' ':(maxchars-length(s)-1) div 2)
d425 2
a426 1
    write(mask);
d436 2
a437 1
    cwrite('--->  Back: '+#24+'  Forward: '+#25+'  Quit: <Esc>  <---')
d444 2
a445 1
    cwrite('--->  Back: '+#24+'  Quit: <Esc>  <---')
d452 2
a453 1
    cwrite('--->  Forward: '+#25+'  Quit: <Esc>  <---')
d460 1
a460 1
    i,display,coldisplay,colwidth: integer;
a470 1
    colwidth := maxchars div columns;
d475 1
a475 1
      gotoxy((i div lastline)*colwidth+1,
d481 5
a485 4
      if (attr and readonly>0) 		  then att := 'r';
      if (attr and hidden>0)  		  then att := 'h';
      if (attr and sysfile>0) 		  then att := 's';
      if (attr and directory>0) 	  then att := 'd';
d492 1
a492 1
            				 	   else textcolor(white)
d501 3
a503 2
          if (size<1000) then write('  .',zerostr(size,3))
          		 else write(size div 1024:5)
d509 3
a511 1
	write(size:8,' ',ds,' ',time2sstr(dt.hour,dt.min,dt.sec))
d517 99
d621 36
a656 2
  maxlines := maxy;
  maxchars := maxx;
d658 38
a695 32
  { determine the column number }
  if (opt_f) then columns := maxchars div 40
             else columns := maxchars div 20;

  assigncrt(f);
  textcolor(lightgray);
  showheader;
  read_dir;
  sort;

  maxperpage := (maxlines-3)*columns;
  lastpagestart := ((names-1) div maxperpage)*maxperpage+1;

  p := 1; change := true; ch := #32;

  repeat { goto ex to leave this loop }
    if (change) then showpage(p);
    if (p=lastpagestart) and ( (ch=#13) or (ch=#32) ) then goto ex;

    change := false;

    if (lastpagestart>1) then begin
      if (p=1)                  then showdown
      else if (p=lastpagestart) then showup
      else 			     showupdown;

      ch := readkey;
      if (ch=#0) or (ch=#13) or (ch=#32) then begin
        if (ch=#0) then ch := readkey;
        if (ch=#73) or (ch=#72) then begin
          if (P>(MAXLINEs-3)*columns) then begin
	    dec(P,MAXperpage); change := true
d697 12
a708 12
        end else if (ch=#81) or (ch=#80) then begin
          if (P+(MAXLINEs-3)*columns<=names) then begin
	    inc(P,maxperpage); change := true
          end
        end else if (ch=#13) or (ch=#32) then begin
          if (p+(maxlines-3)*columns<=names) then begin
	    inc(P,maxperpage); change := true
          end
        end
      end else if (ch=#27) then goto ex
    end
  until false;
d710 8
a717 1
  ex:
d719 9
a727 28
  GotoXY(1,2);
  textcolor(lightgray);
  cwrite('');
  GotoXY(1,2);
  write(globalnames,' Files with a total of ',
        globalsize DIV 1024,' kB disk space');

  mask[1] := upcase(mask[1]);
  if (length(mask)>1) and (mask[2]=':')
  and ('A'<=mask[1]) and (mask[1]<='Z') then
    drive := ord(mask[1])+1-ord('A')
  else
    drive := 0;

  gotoxy(maxchars-15,1);
  textcolor(white);
  write(diskfree(drive) div 1024:7,' kB');
  textcolor(lightgray);
  write(' free');

  if (drive<>0) then begin
    findfirst(chr(ord('A')-1+drive)+':\*.*',volumeid,sr);
    if (doserror=0) then begin
      vol := sr.name;
      substone('.','',vol);
      vol := copy(vol+blanks,1,11);
      substall(' ','',vol)
    end else vol := '[no vlabel]';
d729 1
a729 1
    gotoxy(maxchars-11,2);
d731 1
a731 2
    write(vol)
  end;
d733 1
a733 1
  gotoxy(1,lastline+2);
d735 2
a736 1
  NormVideo;
@

