head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.22.35;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.11.13.35.33;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.21.21.40.35;	author Ricki;	state Exp;
branches;
next	;


desc
@Change characters in several files to lower case
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: locase.pas 1.2 1993/02/11 13:35:33 Ricki Exp $ }
program locase2;
{ Change characters in several files to lower case }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: locase.pas $
        Revision 1.2  1993/02/11  13:35:33  Ricki
        modified -v page

        Revision 1.1  1993/01/21  21:40:35  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id: locase.pas 1.2 1993/02/11 13:35:33 Ricki Exp $';

  func = 'Change characters in several files to lower case';
  year = '1992,1993';
  desn = 'LOCASE/2';
  desv = '1.0';
  opts = 'b:e:hHrv*'; ropt = opts;

var
  fbuf: pointer;
  debug: boolean;
  bcol,ecol: longint;
  optr: boolean;

  {$i locase.i1}
  {$i locase.i2}

  procedure help1;
  begin
    header(desv,year,func);
    locasei1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    locasei2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    bcol := 1; ecol := 0;
    optr := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'b': if (not ival(optarg,bcol)) then
        err('-b must be followed by an integer');
      'e': if (not ival(optarg,ecol)) then
        err('-e must be followed by an integer');
      'r': optr := true;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);
  end;

  procedure calc(var newline: string; var start,len: integer);
  begin
    { compute start and length of substring to be compared with the
      old one }
    if (bcol>0) then begin
      if (ecol>0) then begin
        start := bcol; len := ecol+1-start
      end else begin
        start := bcol; len := length(newline)+ecol+1-start
      end
    end else begin
      if (ecol>0) then begin
        start := length(newline)+bcol; len := ecol+1-start
      end else begin
        start := length(newline)+bcol; len := length(newline)+ecol+1-start
      end
    end;
    { correct start and length, if necessary }
    if (start<1) then start := 1;
    if (len<0) then len := 0;
  end;

  procedure doit(var line: string);
  const
    q1 = '''';
    q2 = '"';
  type
    statustype = (s_start,s_quote1,s_quote2);
  var
    i,start,len: integer;
    st: statustype;
  begin
    calc(line,start,len);
    { check if quotes '..' and ".." are to be respected }
    if (optr) then begin
      st := s_start;
      for i:=start to start+len-1 do case st of
        s_start: case line[i] of
          q1: st := s_quote1;
          q2: st := s_quote2;
          else line[i] := lowcase(line[i])
        end;
        s_quote1: if (line[i]=q1) then st := s_start;
        s_quote2: if (line[i]=q2) then st := s_start;
      end
    end else begin
      { make substring lowercase }
      for i:=start to start+len-1 do line[i] := lowcase(line[i])
    end
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,stdbufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    line: string;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,stdbufsize);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    while (not eof(f)) do begin
      readln(f,line);
      doit(line);
      writeln(stdout,line)
    end;

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@


1.2
log
@modified -v page
@
text
@d2 1
a2 1
{ $Id: LOCASE.PAS 1.1 1993/01/21 21:40:35 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 4
a28 1
        $Log: LOCASE.PAS $
d48 1
a48 1
  pversion = '$Id: LOCASE.PAS 1.1 1993/01/21 21:40:35 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: LOCASE.PAS 1.1 1993/01/21 21:22:12 Ricki Exp $ }
d26 2
a27 3
 * Revision 1.1  1993/01/21  21:22:12  Ricki
 * Initial revision
 *
d45 1
a45 1
  pversion = '$Id: LOCASE.PAS 1.1 1993/01/21 21:22:12 Ricki Exp $';
d50 1
d64 1
a64 1
    header(year,func);
d71 1
a71 1
    header(year,func);
d78 1
a78 1
    header(year,func);
d80 1
a80 1
    revision(desn,'$Revision: 1.1 $');
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program locase2;
{ Change characters in several files to lower case }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id$';

  func = 'Change characters in several files to lower case';
  year = '1992,1993';
  desn = 'LOCASE/2';
  opts = 'b:e:hHrv*'; ropt = opts;

var
  fbuf: pointer;
  debug: boolean;
  bcol,ecol: longint;
  optr: boolean;

  {$i locase.i1}
  {$i locase.i2}

  procedure help1;
  begin
    header(year,func);
    locasei1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    locasei2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 4.3 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    bcol := 1; ecol := 0;
    optr := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'b': if (not ival(optarg,bcol)) then
        err('-b must be followed by an integer');
      'e': if (not ival(optarg,ecol)) then
        err('-e must be followed by an integer');
      'r': optr := true;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);
  end;

  procedure calc(var newline: string; var start,len: integer);
  begin
    { compute start and length of substring to be compared with the
      old one }
    if (bcol>0) then begin
      if (ecol>0) then begin
        start := bcol; len := ecol+1-start
      end else begin
        start := bcol; len := length(newline)+ecol+1-start
      end
    end else begin
      if (ecol>0) then begin
        start := length(newline)+bcol; len := ecol+1-start
      end else begin
        start := length(newline)+bcol; len := length(newline)+ecol+1-start
      end
    end;
    { correct start and length, if necessary }
    if (start<1) then start := 1;
    if (len<0) then len := 0;
  end;

  procedure doit(var line: string);
  const
    q1 = '''';
    q2 = '"';
  type
    statustype = (s_start,s_quote1,s_quote2);
  var
    i,start,len: integer;
    st: statustype;
  begin
    calc(line,start,len);
    { check if quotes '..' and ".." are to be respected }
    if (optr) then begin
      st := s_start;
      for i:=start to start+len-1 do case st of
        s_start: case line[i] of
          q1: st := s_quote1;
          q2: st := s_quote2;
          else line[i] := lowcase(line[i])
        end;
        s_quote1: if (line[i]=q1) then st := s_start;
        s_quote2: if (line[i]=q2) then st := s_start;
      end
    end else begin
      { make substring lowercase }
      for i:=start to start+len-1 do line[i] := lowcase(line[i])
    end
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,stdbufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    line: string;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,stdbufsize);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    while (not eof(f)) do begin
      readln(f,line);
      doit(line);
      writeln(stdout,line)
    end;

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@

