head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.22.42;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.11.17.53.42;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.21.21.40.39;	author Ricki;	state Exp;
branches;
next	;


desc
@Arrange text in multiple columns
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: mcol.pas 1.2 1993/02/11 17:53:42 Ricki Exp $ }
program MCOL;
{ Arrange text in multiple columns }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: mcol.pas $
        Revision 1.2  1993/02/11  17:53:42  Ricki
        modified -v page

        Revision 1.1  1993/01/21  21:40:39  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id: mcol.pas 1.2 1993/02/11 17:53:42 Ricki Exp $';

  func = 'Arrange text in multiple columns';
  year = '1992,1993';
  desn = 'MCOL/2';
  desv = '1.0';
  opts = 'c:f:hHl:s:tv*'; ropt = opts;

  maxcol  = 128;
  meta    = '@@';

  maxplen = 128; cmaxplen = '128'; { max. lines / page }
  defw    =  78; cdefw    =  '78'; { default width for -c }
  defb    =   2; cdefb    =   '2'; { default blanks between columns for -c }
  defc    =   2; cdefc    =   '2'; { default columns }
  defp    =  66; cdefp    =  '66'; { default page length }

type
  Tcentry = record
    start,len: byte
  end;
  Tcfield = array [1..maxcol] of Tcentry;
  Tpbuf = array [1..maxplen] of string;

var
  fbuf: pointer;
  debug: boolean;

  columns: longint;
  separator,mask: string;
  opt_t,opt_f,opt_c: boolean;
  form: string;
  cfield: Tcfield;
  plen: longint;
  pbuf: Tpbuf;

  {$i mcol.i1}
  {$i mcol.i2}

  procedure help1;
  begin
    header(desv,year,func);
    mcoli1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    mcoli2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  procedure parse_field(s: string; var mask: string; var cf: Tcfield);
  type
    Tstate = (s_start,s_num);
  var
    i,l,nl,num: byte;
    code: integer;
    state: Tstate;
  begin
    mask := blanks;
    l := 0; columns := 0; state := s_start;

    { append a dummy character to s to make the end handling easier }
    s := s+meta;

    { loop over the characters in s }
    for i:=1 to length(s) do case state of
      { store the character or start reading a number }
      s_start: if (s[i]=meta) then begin
        nl := 0; state := s_num
      end else begin
        inc(l); mask[l] := s[i]
      end;

      { keep on reading the number, store meta, or get the number }
      s_num  : if (s[i]<'0') or (s[i]>'9') then begin
        if (nl=0) then begin
          inc(l); mask[l] := meta
        end else begin
          val(copy(s,i-nl,nl),num,code);
          if (word(num)+word(l)>255) then
            err('The output line may not be longer than 255 characters');
          inc(columns);
          cf[columns].start := l+1;
          cf[columns].len := num;
          inc(l,num)
        end;
        if (s[i]=meta) then begin
          nl := 0;
          state := s_num
        end else begin
          inc(l);
          mask[l] := s[i];
          state := s_start
        end
      end else inc(nl)
    end;
    mask[0] := chr(l)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    columns := defc; separator := ^L; plen := defp;
    opt_t := false; opt_f := false; opt_c := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'c': begin
        opt_c := true;
        if (not ival(optarg,columns)) then
          err('No numeric value after -c')
      end;
      'l': begin
        if (not ival(optarg,plen)) then
          err('No numeric value after -l');
        if (plen>maxplen) or (plen<1) then
          err('Illegal page length');
      end;
      'f': begin
        opt_f := true;
        parse_field(optarg,mask,cfield)
      end;
      's': separator := optarg;
      't': opt_t := true;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  var
    i: byte;
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    if (opt_c) and (opt_f) then
      err('-c and -f are mutually exclusive');

    { for opt_c an appropriate mask must be constructed }
    if (not opt_f) then begin
      if (columns=0) or (columns>defw div (defb+1)) then
        err('Too many columns');

      mask := copy(blanks,1,defw);
      cfield[1].len := (defw-(columns-1)*defb) div columns;
      cfield[1].start := 1;

      for i:=2 to columns do begin
        cfield[i].len := cfield[i-1].len;
        cfield[i].start := cfield[i-1].start+cfield[i].len+defb
      end
    end;
  end;

  procedure add(line: string; var nl,nc,ml: word);
  var
    i,l: word;
  begin
    { insert the first part or all of line into mask }
    repeat
      { check if the current page must be output or the next column must
        be started }
      if (nl=plen) then begin
        if (nc=columns) then begin
          for i:=1 to nl do begin
            writeln(stdout,pbuf[i]);
            pbuf[i] := mask
          end;
          write(stdout,separator);
          nl := 1;
          nc := 1;
          ml := 1
        end else begin
          inc(nc);
          nl := 1
        end
      end else inc(nl);

      { calc the maximum filled line }
      if (nl>ml) then ml := nl;

      { store the line into the output buffer }
      l := cfield[nc].len;
      if (l>length(line)) then l := length(line);
      for i:=1 to l do
        pbuf[nl][cfield[nc].start+i-1] := line[i];

      if (not opt_t) then delete(line,1,cfield[nc].len)
    until (opt_t) or (line='')
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,stdbufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    line: string;
    i,nl,nc,ml: word;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,stdbufsize);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    { fill the output buffer with the mask }
    for i:=1 to plen do pbuf[i] := mask;

    { loop over the input }
    nl := 0; nc := 1; ml := 0;
    while (not eof(f)) do begin
      readln(f,line);
      add(line,nl,nc,ml)
    end;

    { flush the buffer }
    for i:=1 to ml do writeln(stdout,pbuf[i]);

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@


1.2
log
@modified -v page
@
text
@d2 1
a2 1
{ $Id: MCOL.PAS 1.1 1993/01/21 21:40:39 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 4
a28 1
        $Log: MCOL.PAS $
d48 1
a48 1
  pversion = '$Id: MCOL.PAS 1.1 1993/01/21 21:40:39 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: MCOL.PAS 1.1 1993/01/21 21:22:16 Ricki Exp $ }
d26 2
a27 3
 * Revision 1.1  1993/01/21  21:22:16  Ricki
 * Initial revision
 *
d45 1
a45 1
  pversion = '$Id: MCOL.PAS 1.1 1993/01/21 21:22:16 Ricki Exp $';
d50 1
d86 1
a86 1
    header(year,func);
d93 1
a93 1
    header(year,func);
d100 1
a100 1
    header(year,func);
d102 1
a102 1
    revision(desn,'$Revision: 1.1 $');
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program MCOL;
{ Arrange text in multiple columns }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id$';

  func = 'Arrange text in multiple columns';
  year = '1992,1993';
  desn = 'MCOL/2';
  opts = 'c:f:hHl:s:tv*'; ropt = opts;

  maxcol  = 128;
  meta    = '@@';

  maxplen = 128; cmaxplen = '128'; { max. lines / page }
  defw    =  78; cdefw    =  '78'; { default width for -c }
  defb    =   2; cdefb    =   '2'; { default blanks between columns for -c }
  defc    =   2; cdefc    =   '2'; { default columns }
  defp    =  66; cdefp    =  '66'; { default page length }

type
  Tcentry = record
    start,len: byte
  end;
  Tcfield = array [1..maxcol] of Tcentry;
  Tpbuf = array [1..maxplen] of string;

var
  fbuf: pointer;
  debug: boolean;

  columns: longint;
  separator,mask: string;
  opt_t,opt_f,opt_c: boolean;
  form: string;
  cfield: Tcfield;
  plen: longint;
  pbuf: Tpbuf;

  {$i mcol.i1}
  {$i mcol.i2}

  procedure help1;
  begin
    header(year,func);
    mcoli1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    mcoli2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 4.3 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  procedure parse_field(s: string; var mask: string; var cf: Tcfield);
  type
    Tstate = (s_start,s_num);
  var
    i,l,nl,num: byte;
    code: integer;
    state: Tstate;
  begin
    mask := blanks;
    l := 0; columns := 0; state := s_start;

    { append a dummy character to s to make the end handling easier }
    s := s+meta;

    { loop over the characters in s }
    for i:=1 to length(s) do case state of
      { store the character or start reading a number }
      s_start: if (s[i]=meta) then begin
        nl := 0; state := s_num
      end else begin
        inc(l); mask[l] := s[i]
      end;

      { keep on reading the number, store meta, or get the number }
      s_num  : if (s[i]<'0') or (s[i]>'9') then begin
        if (nl=0) then begin
          inc(l); mask[l] := meta
        end else begin
          val(copy(s,i-nl,nl),num,code);
          if (word(num)+word(l)>255) then
            err('The output line may not be longer than 255 characters');
          inc(columns);
          cf[columns].start := l+1;
          cf[columns].len := num;
          inc(l,num)
        end;
        if (s[i]=meta) then begin
          nl := 0;
          state := s_num
        end else begin
          inc(l);
          mask[l] := s[i];
          state := s_start
        end
      end else inc(nl)
    end;
    mask[0] := chr(l)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    columns := defc; separator := ^L; plen := defp;
    opt_t := false; opt_f := false; opt_c := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'c': begin
        opt_c := true;
        if (not ival(optarg,columns)) then
          err('No numeric value after -c')
      end;
      'l': begin
        if (not ival(optarg,plen)) then
          err('No numeric value after -l');
        if (plen>maxplen) or (plen<1) then
          err('Illegal page length');
      end;
      'f': begin
        opt_f := true;
        parse_field(optarg,mask,cfield)
      end;
      's': separator := optarg;
      't': opt_t := true;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  var
    i: byte;
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    if (opt_c) and (opt_f) then
      err('-c and -f are mutually exclusive');

    { for opt_c an appropriate mask must be constructed }
    if (not opt_f) then begin
      if (columns=0) or (columns>defw div (defb+1)) then
        err('Too many columns');

      mask := copy(blanks,1,defw);
      cfield[1].len := (defw-(columns-1)*defb) div columns;
      cfield[1].start := 1;

      for i:=2 to columns do begin
        cfield[i].len := cfield[i-1].len;
        cfield[i].start := cfield[i-1].start+cfield[i].len+defb
      end
    end;
  end;

  procedure add(line: string; var nl,nc,ml: word);
  var
    i,l: word;
  begin
    { insert the first part or all of line into mask }
    repeat
      { check if the current page must be output or the next column must
        be started }
      if (nl=plen) then begin
        if (nc=columns) then begin
          for i:=1 to nl do begin
            writeln(stdout,pbuf[i]);
            pbuf[i] := mask
          end;
          write(stdout,separator);
          nl := 1;
          nc := 1;
          ml := 1
        end else begin
          inc(nc);
          nl := 1
        end
      end else inc(nl);

      { calc the maximum filled line }
      if (nl>ml) then ml := nl;

      { store the line into the output buffer }
      l := cfield[nc].len;
      if (l>length(line)) then l := length(line);
      for i:=1 to l do
        pbuf[nl][cfield[nc].start+i-1] := line[i];

      if (not opt_t) then delete(line,1,cfield[nc].len)
    until (opt_t) or (line='')
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    getmem(fbuf,stdbufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    line: string;
    i,nl,nc,ml: word;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,stdbufsize);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    { fill the output buffer with the mask }
    for i:=1 to plen do pbuf[i] := mask;

    { loop over the input }
    nl := 0; nc := 1; ml := 0;
    while (not eof(f)) do begin
      readln(f,line);
      add(line,nl,nc,ml)
    end;

    { flush the buffer }
    for i:=1 to ml do writeln(stdout,pbuf[i]);

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@

