head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.22.49;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.11.18.10.57;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.21.21.40.43;	author Ricki;	state Exp;
branches;
next	;


desc
@Convert numbers between several bases
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: nconv.pas 1.2 1993/02/11 18:10:57 Ricki Exp $ }
program NCONV;
{ Convert numbers between several bases }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: nconv.pas $
        Revision 1.2  1993/02/11  18:10:57  Ricki
        renamed NC to NCONV
        modified -v page

        Revision 1.1  1993/01/21  21:40:43  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  numbers,
  strings,
  standard,
  outcon,
  options,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id: nconv.pas 1.2 1993/02/11 18:10:57 Ricki Exp $';

  func = 'Convert numbers between several bases';
  year = '1992,1993';
  desn = 'NCONV/2';
  desv = '1.0';
  opts = 'ahHv*'; ropt = opts;

  maxbase = 11+ord('Z')-ord('A');
    { use all characters as numbers, if necessary }
  minbase = 2;

type
  basetype = minbase..maxbase;
  baseset = set of basetype;

const
  default_tobases: baseset = [2,8,10,16];
  all_tobases: baseset = [minbase..maxbase];

var
  debug: boolean;
  frombase: integer;
  tobases: set of basetype;
  tovalue,value: comstr;
  strnum: array [1..255] of integer; { value }
  num: longint;
  strlen: integer;
  opta: boolean;
  nopt,nnam: byte;

  {$i nconv.i1}
  {$i nconv.i2}

  procedure help1;
  begin
    header(desv,year,func);
    nconvi1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    nconvi2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  procedure pre_op;
  begin
    opta := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  procedure proc_op;
  var
    i: byte;
    s: comstr;

    procedure checknums;
    var
      optbase,calcbase,code,tobase: integer;
      i: byte;

      function getdecimal(i: byte; var d: integer): boolean;
      begin
        s := getname(i); val(s,d,code);
        if (code<>0) then getdecimal := false
        else if (d<minbase) or (d>maxbase) then getdecimal := false
        else getdecimal := true
      end;

      function getvalue(i: byte; var calcbase,optbase: integer): boolean;
      var
        foundbase: integer;
      begin
        foundbase := 0; calcbase := minbase; optbase := minbase;
        value := getname(i); value := strupcase(value);
        { recognize $ and 0 }
        if (value[1]='$') then begin
          foundbase := 16; delete(value,1,1);
          if (value='') then err('Value must be specified');
        end else if (value[1]='0') then begin
          foundbase := 8; delete(value,1,1);
          if (value='') then begin value := '0'; foundbase := 10 end
        end else if (value='') then err('Value must be specified');
        strlen := length(value);
        { transfer characters to integer array }
        for i:=1 to strlen do begin
          if ('0'<=value[i]) and (value[i]<='9') then
            strnum[i] := ord(value[i])-ord('0')
          else if ('A'<=value[i]) and (value[i]<='Z') then
            strnum[i] := 10+ord(value[i])-ord('A')
          else
            err('Illegal "digit" in value');
          { store maximum base }
          if (1+strnum[i]>calcbase) then calcbase := 1+strnum[i];
          { for foundbase=16 base may not become greater than 16 }
          if (foundbase=16) and (calcbase>foundbase) then
            err('Illegal hex number')
        end;
        { try to recognize the correct base }
        getvalue := true;
        if (foundbase<>0) and (calcbase<=foundbase) then optbase := foundbase
        else if (calcbase<=10) then optbase := 10
        else if (calcbase<=16) then optbase := 16
        else if (calcbase<=32) then optbase := 32
        else if (calcbase<=maxbase) then optbase := maxbase;
      end;

    begin
      if (nnam<1) then err('Value must be specified');
      case nnam of
        1: { value } begin
          {----- value }
          if (not getvalue(1,calcbase,optbase)) then err('Illegal value');
          frombase := optbase;
          tobases := default_tobases
        end;
        2: { from value  or  value to } begin
          {----- source_base ? }
          if (getdecimal(1,frombase)) then begin
            { from value }
            {----- value }
            if (not getvalue(2,calcbase,optbase)) then err('Illegal value');
            if (calcbase>frombase) then
              err('Conflict between source_base and value');
            {----- default target_bases }
            tobases := default_tobases
          end else begin
            { value to }
            {----- value }
            if (not getvalue(1,calcbase,optbase)) then err('Illegal value');
            frombase := optbase;
            {----- target_base }
            if (not getdecimal(2,tobase)) then err('Illegal target_base');
            tobases := [tobase]
          end
        end;
        else { from value to... } begin
          {----- source_base }
          if (not getdecimal(1,frombase)) then err('Illegal source_base');
          {----- value }
          if (not getvalue(2,calcbase,optbase)) then err('Illegal value');
          if (calcbase>frombase) then
            err('Conflict between source_base and value');
          {----- to... }
          for i:=3 to nnam do begin
            if (not getdecimal(i,tobase)) then err('Illegal target_base');
            tobases := tobases+[tobase]
          end;
          { detect conflict to -a option }
          if (opta) then err('-a allows no target_base')
        end
      end;
      if (not opta) then begin
        { remove source_base from to_bases and check if something is left }
        tobases := tobases-[frombase];
        if (tobases=[]) then err('Nothing to do')
      end else tobases := all_tobases
    end;

  begin
    parse(ropt,nopt,nnam);
    if (nopt+nnam=0) then help1;
    for i:=1 to nopt do begin
      case getopt(i) of
        'a': opta := true;

        'h': help1;
        'H': help2;
        'v': version;
        '*': debug := true;
      end
    end;
    checknums
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);
  end;

  procedure output;
  const
    maxnum: real = maxlongint;
  var
    checknum: real;
    s,factor: longint;
    tobase,maxdigits: integer;
    i: byte;
  begin
    { transfer strnum to internal representation num }
    num := strnum[1];
    for i:=2 to strlen do begin
      { check for overflow }
      checknum := (frombase+0.0)*(0.0+num)+strnum[i];
      if (checknum>maxnum) then err('Arithmetic overflow');
      num := frombase*num+strnum[i]
    end;
    { transfer num to all the target bases. maxdigits holds the maximum
      number of digits in the output. the loop must begin with the smallest
      tobase, because this base will produce the longest output }
    maxdigits := 0;
    for tobase:=minbase to maxbase do if (tobase in tobases) then begin
      { calculate representation of num in base tobase }
      s := num; strlen := 0;
      while (s>0) do begin
        inc(strlen);
        strnum[strlen] := s mod tobase;
        s := s div tobase
      end;
      { special case: num=0 }
      if (strlen=0) then begin
        strlen := 1;
        strnum[1] := 0
      end;
      { store maximal output length }
      if (strlen>maxdigits) then maxdigits := strlen;
      { output }
      write(stdout,value,'/',frombase,' is ');
      for i:=1 to maxdigits-strlen do write(stdout,' ');
      for i:=strlen downto 1 do begin
        if (strnum[i]<10) then write(stdout,chr(ord('0')+strnum[i]))
                          else write(stdout,chr(ord('A')-10+strnum[i]))
      end;
      writeln(stdout,'/',tobase)
    end
  end;

begin
  frombase := 10;
  tobases := [];
  pre_op;
  proc_op;
  post_op;
  output;
  stop(0)
end.
@


1.2
log
@renamed NC to NCONV
modified -v page
@
text
@d2 1
a2 1
{ $Id: NCONV.PAS 1.1 1993/01/21 21:40:43 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 5
a29 1
        $Log: NCONV.PAS $
d50 1
a50 1
  pversion = '$Id: NCONV.PAS 1.1 1993/01/21 21:40:43 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 3
a3 2
{ $Id: NC.PAS 1.1 1993/01/21 21:22:20 Ricki Exp $ }
program NC;
d25 3
a27 4
        $Log: NC.PAS $
 * Revision 1.1  1993/01/21  21:22:20  Ricki
 * Initial revision
 *
d46 1
a46 1
  pversion = '$Id: NC.PAS 1.1 1993/01/21 21:22:20 Ricki Exp $';
d50 2
a51 1
  desn = 'NC/2';
d77 2
a78 2
  {$i nc.i1}
  {$i nc.i2}
d82 2
a83 2
    header(year,func);
    nci1;
d89 2
a90 2
    header(year,func);
    nci2;
d96 1
a96 1
    header(year,func);
d98 1
a98 1
    revision(desn,'$Revision: 1.1 $');
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program NC;
{ Convert numbers between several bases }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  numbers,
  strings,
  standard,
  outcon,
  options,
  cmdline,
  outstd,
  dos;

const
  pversion = '$Id$';

  func = 'Convert numbers between several bases';
  year = '1992,1993';
  desn = 'NC/2';
  opts = 'ahHv*'; ropt = opts;

  maxbase = 11+ord('Z')-ord('A');
    { use all characters as numbers, if necessary }
  minbase = 2;

type
  basetype = minbase..maxbase;
  baseset = set of basetype;

const
  default_tobases: baseset = [2,8,10,16];
  all_tobases: baseset = [minbase..maxbase];

var
  debug: boolean;
  frombase: integer;
  tobases: set of basetype;
  tovalue,value: comstr;
  strnum: array [1..255] of integer; { value }
  num: longint;
  strlen: integer;
  opta: boolean;
  nopt,nnam: byte;

  {$i nc.i1}
  {$i nc.i2}

  procedure help1;
  begin
    header(year,func);
    nci1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    nci2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 4.3 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  procedure pre_op;
  begin
    opta := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  procedure proc_op;
  var
    i: byte;
    s: comstr;

    procedure checknums;
    var
      optbase,calcbase,code,tobase: integer;
      i: byte;

      function getdecimal(i: byte; var d: integer): boolean;
      begin
        s := getname(i); val(s,d,code);
        if (code<>0) then getdecimal := false
        else if (d<minbase) or (d>maxbase) then getdecimal := false
        else getdecimal := true
      end;

      function getvalue(i: byte; var calcbase,optbase: integer): boolean;
      var
        foundbase: integer;
      begin
        foundbase := 0; calcbase := minbase; optbase := minbase;
        value := getname(i); value := strupcase(value);
        { recognize $ and 0 }
        if (value[1]='$') then begin
          foundbase := 16; delete(value,1,1);
          if (value='') then err('Value must be specified');
        end else if (value[1]='0') then begin
          foundbase := 8; delete(value,1,1);
          if (value='') then begin value := '0'; foundbase := 10 end
        end else if (value='') then err('Value must be specified');
        strlen := length(value);
        { transfer characters to integer array }
        for i:=1 to strlen do begin
          if ('0'<=value[i]) and (value[i]<='9') then
            strnum[i] := ord(value[i])-ord('0')
          else if ('A'<=value[i]) and (value[i]<='Z') then
            strnum[i] := 10+ord(value[i])-ord('A')
          else
            err('Illegal "digit" in value');
          { store maximum base }
          if (1+strnum[i]>calcbase) then calcbase := 1+strnum[i];
          { for foundbase=16 base may not become greater than 16 }
          if (foundbase=16) and (calcbase>foundbase) then
            err('Illegal hex number')
        end;
        { try to recognize the correct base }
        getvalue := true;
        if (foundbase<>0) and (calcbase<=foundbase) then optbase := foundbase
        else if (calcbase<=10) then optbase := 10
        else if (calcbase<=16) then optbase := 16
        else if (calcbase<=32) then optbase := 32
        else if (calcbase<=maxbase) then optbase := maxbase;
      end;

    begin
      if (nnam<1) then err('Value must be specified');
      case nnam of
        1: { value } begin
          {----- value }
          if (not getvalue(1,calcbase,optbase)) then err('Illegal value');
          frombase := optbase;
          tobases := default_tobases
        end;
        2: { from value  or  value to } begin
          {----- source_base ? }
          if (getdecimal(1,frombase)) then begin
            { from value }
            {----- value }
            if (not getvalue(2,calcbase,optbase)) then err('Illegal value');
            if (calcbase>frombase) then
              err('Conflict between source_base and value');
            {----- default target_bases }
            tobases := default_tobases
          end else begin
            { value to }
            {----- value }
            if (not getvalue(1,calcbase,optbase)) then err('Illegal value');
            frombase := optbase;
            {----- target_base }
            if (not getdecimal(2,tobase)) then err('Illegal target_base');
            tobases := [tobase]
          end
        end;
        else { from value to... } begin
          {----- source_base }
          if (not getdecimal(1,frombase)) then err('Illegal source_base');
          {----- value }
          if (not getvalue(2,calcbase,optbase)) then err('Illegal value');
          if (calcbase>frombase) then
            err('Conflict between source_base and value');
          {----- to... }
          for i:=3 to nnam do begin
            if (not getdecimal(i,tobase)) then err('Illegal target_base');
            tobases := tobases+[tobase]
          end;
          { detect conflict to -a option }
          if (opta) then err('-a allows no target_base')
        end
      end;
      if (not opta) then begin
        { remove source_base from to_bases and check if something is left }
        tobases := tobases-[frombase];
        if (tobases=[]) then err('Nothing to do')
      end else tobases := all_tobases
    end;

  begin
    parse(ropt,nopt,nnam);
    if (nopt+nnam=0) then help1;
    for i:=1 to nopt do begin
      case getopt(i) of
        'a': opta := true;

        'h': help1;
        'H': help2;
        'v': version;
        '*': debug := true;
      end
    end;
    checknums
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);
  end;

  procedure output;
  const
    maxnum: real = maxlongint;
  var
    checknum: real;
    s,factor: longint;
    tobase,maxdigits: integer;
    i: byte;
  begin
    { transfer strnum to internal representation num }
    num := strnum[1];
    for i:=2 to strlen do begin
      { check for overflow }
      checknum := (frombase+0.0)*(0.0+num)+strnum[i];
      if (checknum>maxnum) then err('Arithmetic overflow');
      num := frombase*num+strnum[i]
    end;
    { transfer num to all the target bases. maxdigits holds the maximum
      number of digits in the output. the loop must begin with the smallest
      tobase, because this base will produce the longest output }
    maxdigits := 0;
    for tobase:=minbase to maxbase do if (tobase in tobases) then begin
      { calculate representation of num in base tobase }
      s := num; strlen := 0;
      while (s>0) do begin
        inc(strlen);
        strnum[strlen] := s mod tobase;
        s := s div tobase
      end;
      { special case: num=0 }
      if (strlen=0) then begin
        strlen := 1;
        strnum[1] := 0
      end;
      { store maximal output length }
      if (strlen>maxdigits) then maxdigits := strlen;
      { output }
      write(stdout,value,'/',frombase,' is ');
      for i:=1 to maxdigits-strlen do write(stdout,' ');
      for i:=strlen downto 1 do begin
        if (strnum[i]<10) then write(stdout,chr(ord('0')+strnum[i]))
                          else write(stdout,chr(ord('A')-10+strnum[i]))
      end;
      writeln(stdout,'/',tobase)
    end
  end;

begin
  frombase := 10;
  tobases := [];
  pre_op;
  proc_op;
  post_op;
  output;
  stop(0)
end.
@

