head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.23.04;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.11.19.50.32;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.21.21.40.51;	author Ricki;	state Exp;
branches;
next	;


desc
@Find printable strings in binary files
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: strings2.pas 1.2 1993/02/11 19:50:32 Ricki Exp $ }
program strings2;
{ Find printable strings in binary files }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: strings2.pas $
        Revision 1.2  1993/02/11  19:50:32  Ricki
        modified -v page
        decimal offsets have leading zeroes, as the others

        Revision 1.1  1993/01/21  21:40:51  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  numbers,
  standard,
  files,
  options,
  cmdline,
  outstd,
  outcon,
  dos;

const
  pversion = '$Id: strings2.pas 1.2 1993/02/11 19:50:32 Ricki Exp $';

  func = 'Find printable strings in binary files';
  year = '1992,1993';
  desn = 'STRINGS/2';
  desv = '1.0';
  opts = 'ahHo:txv*'; ropt = '0:1:2:3:4:5:6:7:8:9:'+opts;

  maxl = 255;

  d_charset: set of char = [#9,#32..#126,#128..#168];
  x_charset: set of char = [#9,#32..#254];
  t_charset: set of char = [#9,#32,'0'..'9','A'..'Z','a'..'z',#128..#168];

type
  fbuftype = array [1..stdbufsize] of char;
  Tobase = (b2,b8,b10,b16);

var
  debug: boolean;
  fbuf: ^fbuftype;

  opto,opta: boolean;
  accl: longint;
  obase: Tobase;
  cs: set of char;
  morefiles: boolean;

  {$i strings2.i1}
  {$i strings2.i2}

  procedure help1;
  begin
    header(desv,year,func);
    strings2i1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    strings2i2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    opto := false; opta := false;
    cs := d_charset; accl := 4;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'o': begin
        opto := true;
        if (optarg='') or (optarg= 'd')
                       or (optarg= 'D') then obase := b10
        else           if (optarg= 'o')
                       or (optarg= 'O')
                       or (optarg= '8') then obase := b8
        else           if (optarg= 'x')
                       or (optarg= 'X')
                       or (optarg= '$')
                       or (optarg='16') then obase := b16
        else           if (optarg= 'b')
                       or (optarg= 'B')
                       or (optarg= '2') then obase := b2
        else err('Illegal offset base')
      end;
      'a': opta := true;
      'x': cs := x_charset;
      't': cs := t_charset;
      '0'..'9': if (not ival(opt+optarg,accl)) or (accl<1) or (accl>255) then
        err('Illegal minimum string length');

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    { determine whether there is more than one file to be processed }
    morefiles := (nnam>1);
    if (not morefiles) and (nnam=1) then
      morefiles := maybemany(getname(1));

    getmem(fbuf,stdbufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: file;

    i: longint;
    j: word;
    fsize: longint;
    bpos,bend: word;
    fpos: longint;

    l: word;
    line: string;
  begin
    bininp(f,p+s.name);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    if (morefiles) then begin
      if (s.name='') then s.name := '(stdin)';
      writeln(stdout,'==> ',p+s.name,' <==')
    end;

    { init variables for the algorithm }
    l := 0;

    { determine the size of f in bytes }
    fsize := filesize(f);
    if (debug) then
      writeln(conout,'       Filesize ',fsize,' bytes');

    { fill the first maxl bytes with #0 }
    for j:=1 to maxl do fbuf^[j] := #0;

    { initialize buffer and file positions }
    bpos := maxl+1;

    { read the first block of bytes }
    blockread(f,fbuf^[bpos],stdbufsize+1-bpos,bend);
    if (debug) then
      writeln(conout,'       Read ',bend,' bytes at position 0');
    fpos := bend;
    inc(bend,maxl);

    { loop over all bytes of the file }
    i := 1; while (i<=fsize) do begin

      { read next block, if one is nearly totally processed }
      if (bpos=bend-maxl) then begin
        { go maxl bytes backwards and read the next block. thus the last
          maxl bytes are still in the buffer }
        dec(fpos,maxl+maxl);
        seek(f,fpos);
        blockread(f,fbuf^[1],stdbufsize,bend);
        if (debug) then
          writeln(conout,'       Read ',bend,' bytes at position ',fpos);

        { if the end of the file is reached, fill maxl buffer bytes with #0 }
        if (bend<stdbufsize) then begin
          fbuf^[bend+1] := ^Z;
          j := bend+2;
          while (j<=stdbufsize) and (j<=bend+maxl) do begin
            fbuf^[j] := #0; inc(j)
          end
        end;

        bpos := maxl;
        inc(fpos,bend)
      end;

      { examine fbuf^[bpos] with the knowledge that the characters in
        fbuf^[bpos-maxl]..fbuf^[bpos+maxl] are also in the buffer }
      if (fbuf^[bpos] in cs) then begin
        inc(l);
        if (l=maxl) then begin
          move(fbuf^[bpos+1-l],line[1],l);
          line[0] := chr(l);
          if (opto) then case obase of
            b2: write(stdout,binL(i-l-1):16,'  ');
            b8: write(stdout,octL(i-l-1): 8,'  ');
           b10: write(stdout,zerostr(i-l-1,6),'  ');
           b16: write(stdout,hexL(i-l-1): 4,'  ');
          end;
          write(stdout,line);
          if (opta) then writeln(stdout,' #',ord(fbuf^[bpos]))
                    else writeln(stdout);
          l := 0
        end
      end else begin
        { if l is acceptable, restrict it, and display string }
        if (l>=accl) then begin
          if (l>maxl) then l := maxl;
          move(fbuf^[bpos-l],line[1],l);
          line[0] := chr(l);
          if (opto) then case obase of
            b2: write(stdout,binL(i-l-1):16,'  ');
            b8: write(stdout,octL(i-l-1): 8,'  ');
           b10: write(stdout,zerostr(i-l-1,6),'  ');
           b16: write(stdout,hexL(i-l-1): 4,'  ');
          end;
          write(stdout,line);
          if (opta) then writeln(stdout,' #',ord(fbuf^[bpos]))
                    else writeln(stdout)
        end;
        l := 0
      end;

      inc(i); inc(bpos)
    end;

    close(f);
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@


1.2
log
@modified -v page
decimal offsets have leading zeroes, as the others
@
text
@d2 1
a2 1
{ $Id: STRINGS2.PAS 1.1 1993/01/21 21:40:51 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 5
a29 1
        $Log: STRINGS2.PAS $
d50 1
a50 1
  pversion = '$Id: STRINGS2.PAS 1.1 1993/01/21 21:40:51 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: STRINGS2.PAS 1.1 1993/01/21 21:22:28 Ricki Exp $ }
d26 2
a27 3
 * Revision 1.1  1993/01/21  21:22:28  Ricki
 * Initial revision
 *
d46 1
a46 1
  pversion = '$Id: STRINGS2.PAS 1.1 1993/01/21 21:22:28 Ricki Exp $';
d51 1
d79 1
a79 1
    header(year,func);
d86 1
a86 1
    header(year,func);
d93 1
a93 1
    header(year,func);
d95 1
a95 1
    revision(desn,'$Revision: 1.1 $');
d242 1
a242 1
           b10: write(stdout,i-l-1      : 6,'  ');
d259 1
a259 1
           b10: write(stdout,i-l-1      : 6,'  ');
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program strings2;
{ Find printable strings in binary files }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  numbers,
  standard,
  files,
  options,
  cmdline,
  outstd,
  outcon,
  dos;

const
  pversion = '$Id$';

  func = 'Find printable strings in binary files';
  year = '1992,1993';
  desn = 'STRINGS/2';
  opts = 'ahHo:txv*'; ropt = '0:1:2:3:4:5:6:7:8:9:'+opts;

  maxl = 255;

  d_charset: set of char = [#9,#32..#126,#128..#168];
  x_charset: set of char = [#9,#32..#254];
  t_charset: set of char = [#9,#32,'0'..'9','A'..'Z','a'..'z',#128..#168];

type
  fbuftype = array [1..stdbufsize] of char;
  Tobase = (b2,b8,b10,b16);

var
  debug: boolean;
  fbuf: ^fbuftype;

  opto,opta: boolean;
  accl: longint;
  obase: Tobase;
  cs: set of char;
  morefiles: boolean;

  {$i strings2.i1}
  {$i strings2.i2}

  procedure help1;
  begin
    header(year,func);
    strings2i1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    strings2i2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 4.5 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    opto := false; opta := false;
    cs := d_charset; accl := 4;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'o': begin
        opto := true;
        if (optarg='') or (optarg= 'd')
                       or (optarg= 'D') then obase := b10
        else           if (optarg= 'o')
                       or (optarg= 'O')
                       or (optarg= '8') then obase := b8
        else           if (optarg= 'x')
                       or (optarg= 'X')
                       or (optarg= '$')
                       or (optarg='16') then obase := b16
        else           if (optarg= 'b')
                       or (optarg= 'B')
                       or (optarg= '2') then obase := b2
        else err('Illegal offset base')
      end;
      'a': opta := true;
      'x': cs := x_charset;
      't': cs := t_charset;
      '0'..'9': if (not ival(opt+optarg,accl)) or (accl<1) or (accl>255) then
        err('Illegal minimum string length');

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    { determine whether there is more than one file to be processed }
    morefiles := (nnam>1);
    if (not morefiles) and (nnam=1) then
      morefiles := maybemany(getname(1));

    getmem(fbuf,stdbufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: file;

    i: longint;
    j: word;
    fsize: longint;
    bpos,bend: word;
    fpos: longint;

    l: word;
    line: string;
  begin
    bininp(f,p+s.name);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    if (morefiles) then begin
      if (s.name='') then s.name := '(stdin)';
      writeln(stdout,'==> ',p+s.name,' <==')
    end;

    { init variables for the algorithm }
    l := 0;

    { determine the size of f in bytes }
    fsize := filesize(f);
    if (debug) then
      writeln(conout,'       Filesize ',fsize,' bytes');

    { fill the first maxl bytes with #0 }
    for j:=1 to maxl do fbuf^[j] := #0;

    { initialize buffer and file positions }
    bpos := maxl+1;

    { read the first block of bytes }
    blockread(f,fbuf^[bpos],stdbufsize+1-bpos,bend);
    if (debug) then
      writeln(conout,'       Read ',bend,' bytes at position 0');
    fpos := bend;
    inc(bend,maxl);

    { loop over all bytes of the file }
    i := 1; while (i<=fsize) do begin

      { read next block, if one is nearly totally processed }
      if (bpos=bend-maxl) then begin
        { go maxl bytes backwards and read the next block. thus the last
          maxl bytes are still in the buffer }
        dec(fpos,maxl+maxl);
        seek(f,fpos);
        blockread(f,fbuf^[1],stdbufsize,bend);
        if (debug) then
          writeln(conout,'       Read ',bend,' bytes at position ',fpos);

        { if the end of the file is reached, fill maxl buffer bytes with #0 }
        if (bend<stdbufsize) then begin
          fbuf^[bend+1] := ^Z;
          j := bend+2;
          while (j<=stdbufsize) and (j<=bend+maxl) do begin
            fbuf^[j] := #0; inc(j)
          end
        end;

        bpos := maxl;
        inc(fpos,bend)
      end;

      { examine fbuf^[bpos] with the knowledge that the characters in
        fbuf^[bpos-maxl]..fbuf^[bpos+maxl] are also in the buffer }
      if (fbuf^[bpos] in cs) then begin
        inc(l);
        if (l=maxl) then begin
          move(fbuf^[bpos+1-l],line[1],l);
          line[0] := chr(l);
          if (opto) then case obase of
            b2: write(stdout,binL(i-l-1):16,'  ');
            b8: write(stdout,octL(i-l-1): 8,'  ');
           b10: write(stdout,i-l-1      : 6,'  ');
           b16: write(stdout,hexL(i-l-1): 4,'  ');
          end;
          write(stdout,line);
          if (opta) then writeln(stdout,' #',ord(fbuf^[bpos]))
                    else writeln(stdout);
          l := 0
        end
      end else begin
        { if l is acceptable, restrict it, and display string }
        if (l>=accl) then begin
          if (l>maxl) then l := maxl;
          move(fbuf^[bpos-l],line[1],l);
          line[0] := chr(l);
          if (opto) then case obase of
            b2: write(stdout,binL(i-l-1):16,'  ');
            b8: write(stdout,octL(i-l-1): 8,'  ');
           b10: write(stdout,i-l-1      : 6,'  ');
           b16: write(stdout,hexL(i-l-1): 4,'  ');
          end;
          write(stdout,line);
          if (opta) then writeln(stdout,' #',ord(fbuf^[bpos]))
                    else writeln(stdout)
        end;
        l := 0
      end;

      inc(i); inc(bpos)
    end;

    close(f);
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@

