head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.24.35;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.03.19.17.17.41;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.03.19.15.47.39;	author Ricki;	state Exp;
branches;
next	;


desc
@Display the last lines of text files
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: tail.pas 1.2 1993/03/19 17:17:41 Ricki Exp $ }
program tail;
{ Show the last lines of text files }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: tail.pas $
        Revision 1.2  1993/03/19  17:17:41  Ricki
        *** empty log message ***

        Revision 1.1  1993/03/19  15:47:39  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  files,
  numbers,
  strings,
  standard,
  outcon,
  cmdline,
  options,
  outstd,
  dostools,
  dos;

const
  pversion = '$Id: tail.pas 1.2 1993/03/19 17:17:41 Ricki Exp $';

  func = 'Show the last lines of text files';
  year = '1992,1993';
  desn = 'TAIL/2';
  desv = '1.0';
  opts = 'hHqv*'; ropt = '0:1:2:3:4:5:6:7:8:9:'+opts;

type
  fbuftype = array [0..stdbufsize-1] of char;

var
  fbuf: ^fbuftype;
  debug: boolean;

  btop,bbot: longint;
  bsize: word;
  nl,lf: longint;
  asciimode,morefiles: boolean;
  optq: boolean;
  stdo: file;

  {$i tail.i1}
  {$i tail.i2}

  procedure help1;
  begin
    header(desv,year,func);
    taili1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    taili2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    nl := 10;
    optq := false;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: cmdline.namestring); {$f-}
  begin
    case opt of
      '0'..'9': if (not ival(opt+optarg,nl)) or (nl<0) then
        err('Corrupt line count');
      'q': optq := true;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);

    { nothing to do? }
    if (nl=0) then stop(0);
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    { determine whether there is more than one file to be processed }
    morefiles := (nnam>1);
    if (nnam=1) then
      morefiles := maybemany(getname(1));

    { determine whether the output may be binary }
    asciimode := not outredirected;
    if (not asciimode) then begin
      assign(stdo,''); rewrite(stdo,1)
    end;

    new(fbuf)
  end;

  {$f+} procedure proc_fn(var s: searchrec; ps: pathstr); {$f-}
  label
    ex;
  var
    f: file;
    p,fs: longint;

    procedure bupdate(offset: longint);
    begin
      if (offset<0) then offset := 0;
      seek(f,offset);
      blockread(f,fbuf^,stdbufsize,bsize);
      btop := offset; bbot := btop+bsize-1
    end;

  begin
    bininp(f,ps+s.name);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',ps+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    if (morefiles) and (not optq) then begin
      if (s.name='') then s.name := '(stdin)';
      writeln(stdout,'==> ',ps+s.name,' <==')
    end;

    fs := filesize(f);
    if (fs=0) then goto ex;

    { go back one lf too much }
    bupdate(fs-stdbufsize);
    p := fs-1; lf := 0;
    while (p>0) and (lf<=nl) do begin
      if (fbuf^[p-btop]=#10) then inc(lf);
      dec(p); if (p<btop) then bupdate(btop-stdbufsize)
    end;

    { skip the current #10 }
    if (p>0) then inc(p,2);

    { forward }
    if (p>bbot) then bupdate(btop+stdbufsize);
    if (asciimode) then begin
      while (p<fs) do begin
        write(fbuf^[p-btop]);
        inc(p);
        if (p>bbot) then bupdate(btop+stdbufsize)
      end
    end else begin
      while (p<fs) do begin
        blockwrite(stdo,fbuf^[p-btop],bsize+btop-p);
        p := 1+bbot;
        bupdate(btop+stdbufsize)
      end
    end;

    ex:
    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    dispose(fbuf)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_pipe);
  stop(0)
end.
@


1.2
log
@*** empty log message ***
@
text
@d2 1
a2 1
{ $Id: tail.pas 1.1 1993/03/19 15:47:39 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d26 3
d51 1
a51 1
  pversion = '$Id: tail.pas 1.1 1993/03/19 15:47:39 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d2 1
a2 1
{ $Id: tail.pas 1.2 1993/02/11 13:33:57 Ricki Exp $ }
d25 3
a27 1
        $Log$
d48 1
a48 1
  pversion = '$Id: tail.pas 1.2 1993/02/11 13:33:57 Ricki Exp $';
@

