head	1.3;
access;
symbols
	rutils40:1.2;
locks;
comment	@        @;


1.3
date	93.03.31.19.24.01;	author Ricki;	state Exp;
branches;
next	1.2;

1.2
date	93.02.11.19.55.59;	author Ricki;	state Rel;
branches;
next	1.1;

1.1
date	93.01.21.21.41.02;	author Ricki;	state Exp;
branches;
next	;


desc
@Count words, lines, and characters in several text files
@

1.3
log
@update to new email address
@
text
@{$I SWITCHES.INC}
{ $Id: wc.pas 1.2 1993/02/11 19:55:59 Ricki Exp $ }
program WC;
{ Count words, lines, and characters in several text files }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@pool.informatik.rwth-aachen.de
}

{
        $Log: wc.pas $
        Revision 1.2  1993/02/11  19:55:59  Ricki
        modified -v page

        Revision 1.1  1993/01/21  21:41:02  Ricki
        Initial revision
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  standard,
  cmdline,
  outstd,
  outcon,
  dos;

const
  pversion = '$Id: wc.pas 1.2 1993/02/11 19:55:59 Ricki Exp $';

  func = 'Count words, lines, and characters in several text files';
  year = '1992,1993';
  desn = 'WC/2';
  desv = '1.0';
  opts = 'clhHmnuvwx*'; ropt = opts;

type
  Tcharset = (c_normal,c_unix,c_extended);

var
  debug: boolean;
  cs: Tcharset;
  mcount,tmcount: byte;
  wcount,lcount,bcount: longint;
  twcount,tlcount,tbcount: longint;
  counted: integer;
  countw,countl,countb,countm: boolean;
  fbuf: pointer;

  {$i wc.i1}
  {$i wc.i2}

  procedure help1;
  begin
    header(desv,year,func);
    wci1;
    stop(1)
  end;

  procedure help2;
  begin
    header(desv,year,func);
    wci2;
    stop(1)
  end;

  procedure version;
  begin
    header(desv,year,func);
    writeln(stdout);
    revision(desn,desv);
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    countl := false;
    countb := false;
    countw := false;
    countm := false;
    cs := c_unix;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'm': countm := true;
      'c': countb := true;
      'w': countw := true;
      'l': countl := true;

      'x': cs := c_extended;
      'u': cs := c_unix;
      'n': cs := c_normal;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);
    if not (countb or countl or countw or countm) then begin
      countw := true;
      countl := true;
      countb := true
    end
  end;

  function words(l: string): word;
  var
    i,len: integer;
    w: word;
  begin
    i := 1; len := 0; w := 0;
    while (i<=length(l)) do begin
      case cs of
        c_unix: begin
          if (l[i]=' ') or (l[i]=#9) then begin
            if (len>0) then begin inc(w); len := 0 end
          end else inc(len)
        end;
        c_extended: begin
          if ( (l[i]>='0') and (l[i]<='9') )
          or ( (l[i]>='A') and (l[i]<='Z') )
          or ( (l[i]>='a') and (l[i]<='z') )
          or   (l[i]='$')
          or   (l[i]='_') then inc(len)
          else begin
            if (len>0) then begin inc(w); len := 0 end
          end
        end;
        c_normal: begin
          if ( (l[i]>='0') and (l[i]<='9') )
          or ( (l[i]>='A') and (l[i]<='Z') )
          or ( (l[i]>='a') and (l[i]<='z') ) then inc(len)
          else begin
            if (len>0) then begin inc(w); len := 0 end
          end
        end
      end;
      inc(i)
    end;
    if (len>0) then inc(w);
    words := w
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    counted := 0;
    tmcount := 0; tlcount := 0; twcount := 0; tbcount := 0;
    getmem(fbuf,stdbufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    line: string;
    d: longint;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,stdbufsize);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    inc(counted);
    lcount := 0;
    bcount := 0;
    wcount := 0;
    mcount := 0;

    while (not eof(f)) do begin
      readln(f,line);
      inc(lcount); inc(tlcount);
      if (countw) then begin
        d := words(line);
        inc(wcount,d);
        inc(twcount,d)
      end;
      d := length(line);
      if (d>mcount) then mcount := d;
      if (d>tmcount) then tmcount := d;
      inc(bcount,d);
      inc(tbcount,d)
    end;
    if (countl) then write(stdout,lcount:8);
    if (countw) then write(stdout,wcount:8);
    if (countb) then write(stdout,bcount:8);
    if (countm) then write(stdout,mcount:8);
    if (s.name='') then writeln(stdout,'  stdin')
                   else writeln(stdout,'  ',p+s.name);

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    if (counted>1) then begin
      if (countl) then write(stdout,tlcount:8);
      if (countw) then write(stdout,twcount:8);
      if (countb) then write(stdout,tbcount:8);
      if (countm) then write(stdout,tmcount:8);
      writeln(stdout,'  total')
    end;
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@


1.2
log
@modified -v page
@
text
@d2 1
a2 1
{ $Id: WC.PAS 1.1 1993/01/21 21:41:02 Ricki Exp $ }
d21 1
a21 1
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
d25 4
a28 1
        $Log: WC.PAS $
d46 1
a46 1
  pversion = '$Id: WC.PAS 1.1 1993/01/21 21:41:02 Ricki Exp $';
@


1.1
log
@Initial revision
@
text
@d1 2
a2 1
{ $Id: WC.PAS 1.1 1993/01/21 21:22:39 Ricki Exp $ }
d26 2
a27 3
 * Revision 1.1  1993/01/21  21:22:39  Ricki
 * Initial revision
 *
d43 1
a43 1
  pversion = '$Id: WC.PAS 1.1 1993/01/21 21:22:39 Ricki Exp $';
d48 1
d69 1
a69 1
    header(year,func);
d76 1
a76 1
    header(year,func);
d83 1
a83 1
    header(year,func);
d85 1
a85 1
    revision(desn,'$Revision: 1.1 $');
@


1.1
log
@Initial revision
@
text
@{ $Id$ }
program WC;
{ Count words, lines, and characters in several text files }

{
  This code is in the public domain. You may use it freely.
  There are no guarantees, either expressed or implied,
  as to either merchantability or fitness for a particular
  purpose. The author's liability is limited to the amount
  you paid for it.

  Richard Breuer

  Brunssumstrasse 6
  5100 Aachen
  Germany

  Phone:  +49/241/85605
  Fax:    +49/241/8021329
  Email:  ricki@@rwthi3.informatik.rwth-aachen.de
}

{
        $Log$
}

{
        Conditional defines
          DEBUG     Enables debugging mode. Sets debug := true
}

uses
  standard,
  cmdline,
  outstd,
  outcon,
  dos;

const
  pversion = '$Id$';

  func = 'Count words, lines, and characters in several text files';
  year = '1992,1993';
  desn = 'WC/2';
  opts = 'clhHmnuvwx*'; ropt = opts;

type
  Tcharset = (c_normal,c_unix,c_extended);

var
  debug: boolean;
  cs: Tcharset;
  mcount,tmcount: byte;
  wcount,lcount,bcount: longint;
  twcount,tlcount,tbcount: longint;
  counted: integer;
  countw,countl,countb,countm: boolean;
  fbuf: pointer;

  {$i wc.i1}
  {$i wc.i2}

  procedure help1;
  begin
    header(year,func);
    wci1;
    stop(1)
  end;

  procedure help2;
  begin
    header(year,func);
    wci2;
    stop(1)
  end;

  procedure version;
  begin
    header(year,func);
    writeln(stdout);
    revision(desn,'$Revision: 4.5 $');
    writeln(stdout);
    author;
    stop(1)
  end;

  {$f+} procedure pre_op(nopt: byte); {$f-}
  begin
    countl := false;
    countb := false;
    countw := false;
    countm := false;
    cs := c_unix;
{$IFDEF DEBUG}
    debug := true
{$ELSE}
    debug := false
{$ENDIF}
  end;

  {$f+} procedure proc_op(opt: char; optarg: namestring); {$f-}
  begin
    case opt of
      'm': countm := true;
      'c': countb := true;
      'w': countw := true;
      'l': countl := true;

      'x': cs := c_extended;
      'u': cs := c_unix;
      'n': cs := c_normal;

      #0 : help1;
      'h': help1;
      'H': help2;
      'v': version;
      '*': debug := true;
    end
  end;

  {$f+} procedure post_op; {$f-}
  begin
    if (debug) then startdbg;
    report(ropt,pversion);
    if not (countb or countl or countw or countm) then begin
      countw := true;
      countl := true;
      countb := true
    end
  end;

  function words(l: string): word;
  var
    i,len: integer;
    w: word;
  begin
    i := 1; len := 0; w := 0;
    while (i<=length(l)) do begin
      case cs of
        c_unix: begin
          if (l[i]=' ') or (l[i]=#9) then begin
            if (len>0) then begin inc(w); len := 0 end
          end else inc(len)
        end;
        c_extended: begin
          if ( (l[i]>='0') and (l[i]<='9') )
          or ( (l[i]>='A') and (l[i]<='Z') )
          or ( (l[i]>='a') and (l[i]<='z') )
          or   (l[i]='$')
          or   (l[i]='_') then inc(len)
          else begin
            if (len>0) then begin inc(w); len := 0 end
          end
        end;
        c_normal: begin
          if ( (l[i]>='0') and (l[i]<='9') )
          or ( (l[i]>='A') and (l[i]<='Z') )
          or ( (l[i]>='a') and (l[i]<='z') ) then inc(len)
          else begin
            if (len>0) then begin inc(w); len := 0 end
          end
        end
      end;
      inc(i)
    end;
    if (len>0) then inc(w);
    words := w
  end;

  {$f+} procedure pre_fn(nnam: byte); {$f-}
  begin
    counted := 0;
    tmcount := 0; tlcount := 0; twcount := 0; tbcount := 0;
    getmem(fbuf,stdbufsize)
  end;

  {$f+} procedure proc_fn(var s: searchrec; p: pathstr); {$f-}
  var
    f: text;
    line: string;
    d: longint;
  begin
    txtinp(f,p+s.name);
    settextbuf(f,fbuf^,stdbufsize);
    if (debug) then begin
      if (s.name<>'') then writeln(conout,'       Reading ',p+s.name)
                      else writeln(conout,'       Reading stdin');
    end;

    inc(counted);
    lcount := 0;
    bcount := 0;
    wcount := 0;
    mcount := 0;

    while (not eof(f)) do begin
      readln(f,line);
      inc(lcount); inc(tlcount);
      if (countw) then begin
        d := words(line);
        inc(wcount,d);
        inc(twcount,d)
      end;
      d := length(line);
      if (d>mcount) then mcount := d;
      if (d>tmcount) then tmcount := d;
      inc(bcount,d);
      inc(tbcount,d)
    end;
    if (countl) then write(stdout,lcount:8);
    if (countw) then write(stdout,wcount:8);
    if (countb) then write(stdout,bcount:8);
    if (countm) then write(stdout,mcount:8);
    if (s.name='') then writeln(stdout,'  stdin')
                   else writeln(stdout,'  ',p+s.name);

    close(f)
  end;

  {$f+} procedure post_fn; {$f-}
  begin
    if (counted>1) then begin
      if (countl) then write(stdout,tlcount:8);
      if (countw) then write(stdout,twcount:8);
      if (countb) then write(stdout,tbcount:8);
      if (countm) then write(stdout,tmcount:8);
      writeln(stdout,'  total')
    end;
    freemem(fbuf,stdbufsize)
  end;

begin
  process(ropt,
          pre_op,proc_op,post_op,
          pre_fn,proc_fn,post_fn,
          m_stdin or m_pipe);
  stop(0)
end.
@

